<?php

/**
 * Blocks Initializer
 *
 * Enqueue CSS/JS of all the blocks.
 *
 * @since   1.0.0
 * @package Affiliate Booster
 */
// Exit if accessed directly.
if (!defined('ABSPATH')) {
    exit;
}

/**
 * PHP version fail error
 *
 * @since 1.0.0
 * @package Affiliate Booster
 */
function affiliate_booster_fail_php_version() {
    /* translators: %s: PHP version */
    $message = sprintf(esc_html__('Affiliate Booster for Gutenberg requires PHP version %s+, plugin is currently NOT RUNNING.', AFB_DOMAIN), '5.6');
    $html_message = sprintf('<div class="error">%s</div>', wpautop($message));
    echo wp_kses_post($html_message);
}

add_filter( 'should_load_separate_core_block_assets', '__return_true' );

/**
 * Enqueue assets for frontend and backend
 *
 * @since 1.0.0
 * @package Affiliate Booster
 */
function affiliate_booster_block_assets() {

    if (is_singular()) {
      $id = get_the_ID();

      if (has_block('affiliate-booster/ab-advance-button', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-button_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-btn/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-coupon', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-coupon_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-coupon/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-coupon1', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-coupon1_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-coupon1/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-coupon2', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-coupon2_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-coupon2/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-coupon3', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-coupon3_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-coupon3/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-coupon4', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-coupon4_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-coupon4/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-callto-action', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-cta_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-cta/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-dynamic-block', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-dynamic-block_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-dynamic-block/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-icon-list', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-icon-list_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-icon-list/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-key-points', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-key-points_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-key-points/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-notice-box', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-notice_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-notice/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-notification-box', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-notification_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-notification/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-product-rating-bar', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-product-rating-bar_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-product-rating-bar/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-product-review', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-product-review_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-product-review/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-product-table-1', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-product-table1_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-product-table-1/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-product-table-2', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-product-table2_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-product-table-2/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-product-table-3', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-product-table3_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-product-table-3/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-ratingbar', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-ratingbar_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-ratingbar/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-single-product', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-single-product_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-single-product/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-single-product-pros-cons', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-single-product-pros-cons_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-single-product-pros-cons/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-single-product-specs', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-single-product-specs_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-single-product-specs/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-star-rating', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-star-rating_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-star-rating/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-star-review', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-star-review_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-star-review/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-tableof-content', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-table-content_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-table-content/style.css', dirname(__FILE__) ),
          );

          wp_enqueue_script('affiliate-table-of-contents', plugins_url('dist/assets/js/toc.js', dirname(__FILE__)), array( 'jquery' ));
      }

      if (has_block('affiliate-booster/ab-title-block', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-title-block_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-title-block/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-toppick-box', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-top-pick_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-top-pick/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-top-pick-specs', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-top-pick-specs_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/ab-top-pick-specs/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/ab-comparison-table', $id)) {
          wp_enqueue_style(
            'affiliate-block-ab-comparison-table_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/comparison-table/style.css', dirname(__FILE__) ),
          );
      }

      if (has_block('affiliate-booster/propsandcons', $id)) {
          wp_enqueue_style(
            'affiliate-block-propsandcons_blocks-cgb-style-css',
            plugins_url( 'assets/blocks/propsandcons/style.css', dirname(__FILE__) ),
          );
      }
    }

    // Load the FontAwesome icon library
    wp_enqueue_style('affiliate-block-fontawesome', plugins_url('dist/assets/fontawesome/css/all.min.css', dirname(__FILE__)), array(), filemtime(plugin_dir_path(__FILE__) . 'assets/fontawesome/css/all.min.css'));
}

add_action('enqueue_block_assets', 'affiliate_booster_block_assets');

/**
 * Enqueue assets for backend editor
 *
 * @since 1.0.0
 * @package Affiliate Booster
 */
function affiliate_booster_block_editor_assets() {
    // Load the compiled blocks into the editor
    wp_enqueue_script('affiliate-block-js', plugins_url('/dist/blocks.build.js', dirname(__FILE__)), array( 'wp-blocks', 'wp-i18n', 'wp-element', 'wp-components', 'wp-editor', 'wp-api-fetch' ));

    // Load the compiled styles
    wp_enqueue_style('affiliate-block-style-css', plugins_url('dist/blocks.style.build.css', dirname(__FILE__)), array(), filemtime(plugin_dir_path(__FILE__) . 'blocks.style.build.css'));

    // Load the compiled styles into the editor
    wp_enqueue_style('affiliate-block-editor-css', plugins_url('dist/blocks.editor.build.css', dirname(__FILE__)), array('wp-edit-blocks'), filemtime(plugin_dir_path(__FILE__) . 'blocks.editor.build.css'));
}

add_action('enqueue_block_editor_assets', 'affiliate_booster_block_editor_assets');

/**
 * Enqueue assets for backend editor
 *
 * @since 1.0.0
 * @package Affiliate Booster
 */
function affiliate_admin_assets() {

    // Load admin css
    wp_enqueue_style('affiliate-admin-css', plugins_url('dist/assets/admin-style.css', dirname(__FILE__)));
}
add_action('admin_enqueue_scripts', 'affiliate_admin_assets');

/**
 * Load the plugin textdomain
 */
function affiliate_booster_blocks_init() {

    load_plugin_textdomain('affiliate-booster-textdomain', false, basename(dirname(__FILE__)) . '/src/languages');
}

add_action('init', 'affiliate_booster_blocks_init');

// Add custom block category
function affiliate_register_category( $categories, $post ) {
    return array_merge(
        $categories, array(
            array(
                'slug' => 'affiliate-booster',
                'title' => __('Affiliate Booster', AFB_DOMAIN),
            ),
        )
    );
}

//PHP version compare
if ( ! version_compare( PHP_VERSION, '5.6', '>=' ) ) {
    add_action('admin_notices', 'affiliate_booster_fail_php_version');
} else {
    require_once ( AFB_DIR . 'src/affiliate-helpers/class-affiliate-loader.php');
}


//remove noreferrer on the frontend, *will still show up in the editor.*
function afffiliate_formatter($content) {
    $replace = array("noreferrer " => "" );
    $new_content = strtr($content, $replace);
    return $new_content;
}

//remove noopener on the frontend, *will still show up in the editor.*
function afffiliate_noopener_formatter($content) {
    $replace = array("noopener " => "" );
    $new_content = strtr($content, $replace);
    return $new_content;
}

// add_filter('the_content', 'afffiliate_noopener_formatter', 999);
// add_filter('the_content', 'afffiliate_formatter', 999);