const { Component } = wp.element;
import classnames from "classnames"
import ReviewImageTop from "./reviewImageTop.js"
import ReviewImage from "./reviewImage.js"
import ReviewImageBottom from "./reviewImageBottom.js"
import { EmptyStar, FullStar, HalfStar } from "./icons";
const { RichText,InnerBlocks } = wp.blockEditor;
const NEW_TAB_REL = 'noopener noreferrer';
class Save extends Component {
    renderListItems = () => {
        const { attributes: { listItems, listItemsTwo } } = this.props

        return listItems.map(item => <li>{item}</li>)
    
    }
    renderListItemsTwo = () => {
        const { attributes: {listItemsTwo } } = this.props

        return listItemsTwo.map(item => <li>{item}</li>)
    
    }



    render() {
        const { highlightedStars,attributes: { uniqueId,btnRel,className,couponStyle,flagStyle,showRatings,designType,boxBgColor,titleTag1,titleTag2,image,imageTop,imageBottom,listTextItems,listTextItemsTwo,couponMainTitle,minRate,maxRate,block_id,spBtnHref,bntRounded,btnSize,buttonWidth,buttonIcon,iconPosition, alignment,titlefontWeight,spBtnText,btn_Htarget, progressText,bulletStyle, bulletStyleTwo, listType, animation, interaction, priceBox1,priceBox2,priceBox3, couponContent, starAligment, starAligmentMobile, starAligmentTable, starsSize, starsSizeMobile, starsSizeTablet, ratings, ratingsColor, selectedStars, ratingAlignemt } } = this.props
        // const interactionClass = IsInteraction(interaction) ? 'qubley-block-interaction' : '';
        const ListTag = listType == 'ordered' ? 'ol' : 'ul'
        const Tag1  = titleTag1
        const Tag2  = titleTag2
        let newrel;
        if( !btn_Htarget){
            newrel = btnRel
        } else  if( !btn_Htarget && btnRel === NEW_TAB_REL){
            newrel = btnRel
        } else if ( btn_Htarget && !btnRel ) {
          newrel = NEW_TAB_REL
        } else {
          newrel = NEW_TAB_REL + ' ' + btnRel
        }

        function removeDuplicateWords (s) {
            var str = s.split(" ");
            var result = [];
            for(var i =0; i < str.length ; i++){
                if(result.indexOf(str[i]) === -1){
                  result.push(str[i]);
                } 
            }
             return result.join(" ");
            }
            
        newrel = removeDuplicateWords(newrel).trim()

        let couponMainTitleSlug = couponMainTitle.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-");

        return (
            <div id={`affiliate-style-${block_id}`} className={`affiliate-block-${block_id}${className ? ` ${className}` : ''} affiliate-coupon-wrapper  ${couponStyle}`}>
                <div className={`affiliate-coupon-inner`}>                        
                        <div className={`affiliate-coupon-content-wrapper`}>
                        { couponStyle && couponStyle == 'style1' &&      
                            <div className={`affiliate-coupon-content-inner`}>
                                <div className={`affiliate-col firstcol`}>
                                    { designType && designType == 'ab-fixed-design' &&
                                        <ReviewImageTop attributes={this.props.attributes} />
                                    }
                                    { designType && designType == 'ab-fixed-design' &&
                                        <ReviewImage attributes={this.props.attributes} />
                                    }
                                    { designType && designType == 'ab-fixed-design' &&
                                        <ReviewImageBottom attributes={this.props.attributes} />
                                    }
                                    { designType && designType == 'ab-dynamic-design' &&
                                        <div className={`aff-inner-block`}>
                                            <InnerBlocks.Content/>
                                        </div>    
                                    }
                                </div>
                                <div className={`affiliate-col seccol`}>

                                    <RichText.Content
                                        tagName={Tag1}
                                        value={couponMainTitle}
                                        className="affiliate-coupon-maintitle"
                                        id={couponMainTitleSlug}
                                    />     

                                    <div
                                        className="affiliate-coupon-starrating"
                                        onMouseLeave={() => this.setState({ highlightedStars: 0 })} >
                                        {[...Array(ratings)].map((e, i) => (
                                          <div className={`affiliate-star-item`} key={i}>
                                                {i < (highlightedStars ? highlightedStars : selectedStars) ? (
                                                    highlightedStars ? (
                                                        highlightedStars - 1 === i ? (
                                                            selectedStars % 1 > 0 ? (
                                                                highlightedStars - selectedStars - 0.5 !== 0 ? (
                                                                    <HalfStar fillColor={ratingsColor} />
                                                                ) : (
                                                                    <FullStar fillColor={ratingsColor} />
                                                                )
                                                            ) : highlightedStars - selectedStars !== 0 ? (
                                                                <FullStar fillColor={ratingsColor} />
                                                            ) : (
                                                                <HalfStar fillColor={ratingsColor} />
                                                            )
                                                        ) : (
                                                            <FullStar fillColor={ratingsColor} />
                                                        )
                                                    ) : selectedStars - i >= 1 ? (
                                                        <FullStar fillColor={ratingsColor} />
                                                    ) : (
                                                        <HalfStar fillColor={ratingsColor} />
                                                    )
                                                ) : (
                                                    <EmptyStar fillColor={ratingsColor} />
                                                )}
                                            </div>
                                        ))}
                                    </div>

                                    <div className={`affiliate-coupon-content`}>
                                        <RichText.Content
                                            value={couponContent} 
                                            className="affiliate-coupon-content"
                                        />
                                    </div>
                                   
                                     <div className={`affiliate-block-advanced-list affiliate-coupon-list-one affiliate-alignment-${alignment}`}>
                                            <RichText.Content
                                              tagName="ul"
                                              multiline="li"
                                              className={`affiliate-list first affiliate-list-type-unordered affiliate-list-bullet-${bulletStyle.name}`}
                                              value={ listTextItems }
                                            />                                 
                                     </div> 
                                     <div className={`affiliate-block-advanced-list affiliate-coupon-list-two affiliate-alignment-${alignment}`}>
                                        <div className={`affiliate-block-${uniqueId}${className ? ` ${className}` : ''} affiliate-list-two-wrspper`}>
                                            <RichText.Content
                                              tagName="ul"
                                              multiline="li"
                                              className={`affiliate-list second affiliate-list-type-unordered affiliate-list-bullet-${bulletStyleTwo.name}`}
                                              value={ listTextItemsTwo }
                                            />
                                        </div> 
                                    </div>
                                </div>
                                <div className={`affiliate-col thirdcol`}>

                                    <div className={`affiliate-coupon-priceBox1`}>
                                        <RichText.Content
                                            value={priceBox1} 
                                            className={`affiliate-coupon-priceBox1`}
                                        />
                                    </div>
                                    <div className={`affiliate-coupon-priceBox2`}>
                                        <RichText.Content
                                            value={priceBox2} 
                                            className={`affiliate-coupon-priceBox2`}
                                        />
                                    </div>
                                    <div className={`affiliate-coupon-priceBox3`}>
                                        <RichText.Content
                                            value={priceBox3} 
                                            className={`affiliate-coupon-priceBox3`}
                                        />
                                    </div>
                                    <div className={`affiliate-coupon-btn`}>
                                            <div className={`affiliate-coupon-btn-wrapper`}>
                                            <a href = {spBtnHref} className={classnames(`affiliate-btn  btn-is-${btnSize} ${buttonWidth === "full"? "btn-is-fullw": buttonWidth === "flex"? `btn-is-flex-${btnSize}`: ""} ${bntRounded ? 'btn-is-rounded' : ''}`).trim()}  
                                                    {...(btn_Htarget ? {...btn_Htarget && { rel: newrel }} : { rel: newrel }  )}
                                                    {...(btn_Htarget ? { target: '_blank' } : '' )}
                                                    >
                                                    { iconPosition && iconPosition == 'af-icon-is-left' &&
                                                        <i className={`affiliate-abbtn-icon ${buttonIcon} ${iconPosition}`}></i>
                                                    }
                                                    <RichText.Content value={spBtnText} />
                                                    { iconPosition && iconPosition == 'af-icon-is-right' &&
                                                        <i className={`affiliate-abbtn-icon ${buttonIcon} ${iconPosition}`}></i>
                                                    }
                                                </a>
                                            </div>
                                        </div> 
                                </div>
                            </div>
                        }
                        { couponStyle && couponStyle == 'style2' &&      
                            <div className={`affiliate-coupon-content-inner style2`}>
                                
                                <div className={`affiliate-col singlecol`}>

                                    { flagStyle && flagStyle != '' && 
                                      <div className={`triangle ${flagStyle}`}></div>
                                    }

                                    <div
                                        className="affiliate-coupon-starrating"
                                        onMouseLeave={() => this.setState({ highlightedStars: 0 })} >
                                        {[...Array(ratings)].map((e, i) => (
                                          <div className={`affiliate-star-item`} key={i}>
                                                {i < (highlightedStars ? highlightedStars : selectedStars) ? (
                                                    highlightedStars ? (
                                                        highlightedStars - 1 === i ? (
                                                            selectedStars % 1 > 0 ? (
                                                                highlightedStars - selectedStars - 0.5 !== 0 ? (
                                                                    <HalfStar fillColor={ratingsColor} />
                                                                ) : (
                                                                    <FullStar fillColor={ratingsColor} />
                                                                )
                                                            ) : highlightedStars - selectedStars !== 0 ? (
                                                                <FullStar fillColor={ratingsColor} />
                                                            ) : (
                                                                <HalfStar fillColor={ratingsColor} />
                                                            )
                                                        ) : (
                                                            <FullStar fillColor={ratingsColor} />
                                                        )
                                                    ) : selectedStars - i >= 1 ? (
                                                        <FullStar fillColor={ratingsColor} />
                                                    ) : (
                                                        <HalfStar fillColor={ratingsColor} />
                                                    )
                                                ) : (
                                                    <EmptyStar fillColor={ratingsColor} />
                                                )}
                                            </div>
                                        ))}
                                    </div>

                                     <RichText.Content
                                        tagName={Tag1}
                                        value={couponMainTitle}
                                        className="affiliate-coupon-maintitle"
                                        id={couponMainTitleSlug}
                                    />     

                                    { designType && designType == 'ab-fixed-design' &&
                                        <ReviewImage attributes={this.props.attributes} />
                                    }
                                    
                                    { designType && designType == 'ab-dynamic-design' &&
                                        <div className={`aff-inner-block`}>
                                            <InnerBlocks.Content/>
                                        </div>    
                                    }
                 
                                     <div className={`affiliate-block-advanced-list affiliate-coupon-list-one affiliate-alignment-${alignment}`}>
                                            <RichText.Content
                                              tagName="ul"
                                              multiline="li"
                                              className={`affiliate-list first affiliate-list-type-unordered affiliate-list-bullet-${bulletStyle.name}`}
                                              value={ listTextItems }
                                            />                                 
                                     </div> 

                                     <div className={`affiliate-coupon-btn`}>
                                        <div className={`affiliate-coupon-btn-wrapper`}>
                                            <a href = {spBtnHref} className={classnames(`affiliate-btn  btn-is-${btnSize} ${buttonWidth === "full"? "btn-is-fullw": buttonWidth === "flex"? `btn-is-flex-${btnSize}`: ""} ${bntRounded ? 'btn-is-rounded' : ''}`).trim()}  
                                                {...(btn_Htarget ? {...btn_Htarget && { rel: newrel }} : { rel: newrel }  )}
                                                {...(btn_Htarget ? { target: '_blank' } : '' )}
                                                >
                                                { iconPosition && iconPosition == 'af-icon-is-left' &&
                                                    <i className={`affiliate-abbtn-icon ${buttonIcon} ${iconPosition}`}></i>
                                                }
                                                <RichText.Content value={spBtnText} />
                                                { iconPosition && iconPosition == 'af-icon-is-right' &&
                                                    <i className={`affiliate-abbtn-icon ${buttonIcon} ${iconPosition}`}></i>
                                                }
                                            </a>
                                        </div>
                                    </div> 
                                    
                                </div>
                                
                            </div>
                        }
                        { couponStyle && couponStyle == 'style3' &&      
                            <div className={`affiliate-coupon-content-inner style3`}>
                                <div className={`affiliate-col leftcol`}>                                    
                                    { designType && designType == 'ab-fixed-design' &&
                                        <ReviewImage attributes={this.props.attributes} />
                                    }
                                    { designType && designType == 'ab-dynamic-design' &&
                                        <div className={`aff-inner-block`}>
                                            <InnerBlocks.Content/>
                                        </div>    
                                    }
                                </div>
                                <div className={`affiliate-col rightcol`}>

                                    <RichText.Content
                                        tagName={Tag1}
                                        value={couponMainTitle}
                                        className="affiliate-coupon-maintitle"
                                        id={couponMainTitleSlug}
                                    />     

                                    <div
                                        className="affiliate-coupon-starrating"
                                        onMouseLeave={() => this.setState({ highlightedStars: 0 })} >
                                        {[...Array(ratings)].map((e, i) => (
                                          <div className={`affiliate-star-item`} key={i}>
                                                {i < (highlightedStars ? highlightedStars : selectedStars) ? (
                                                    highlightedStars ? (
                                                        highlightedStars - 1 === i ? (
                                                            selectedStars % 1 > 0 ? (
                                                                highlightedStars - selectedStars - 0.5 !== 0 ? (
                                                                    <HalfStar fillColor={ratingsColor} />
                                                                ) : (
                                                                    <FullStar fillColor={ratingsColor} />
                                                                )
                                                            ) : highlightedStars - selectedStars !== 0 ? (
                                                                <FullStar fillColor={ratingsColor} />
                                                            ) : (
                                                                <HalfStar fillColor={ratingsColor} />
                                                            )
                                                        ) : (
                                                            <FullStar fillColor={ratingsColor} />
                                                        )
                                                    ) : selectedStars - i >= 1 ? (
                                                        <FullStar fillColor={ratingsColor} />
                                                    ) : (
                                                        <HalfStar fillColor={ratingsColor} />
                                                    )
                                                ) : (
                                                    <EmptyStar fillColor={ratingsColor} />
                                                )}
                                            </div>
                                        ))}
                                    </div>

                                    <div className={`footerpricebox`}>
                                        <div className={`affiliate-priceBox`}>
                                            <div className={`affiliate-coupon-priceBox1`}>
                                                <RichText.Content
                                                    value={priceBox1} 
                                                    className={`affiliate-coupon-priceBox1`}
                                                />
                                            </div>
                                            <div className={`affiliate-coupon-priceBox2`}>
                                                <RichText.Content
                                                    value={priceBox2} 
                                                    className={`affiliate-coupon-priceBox2`}
                                                />
                                            </div>
                                            <div className={`affiliate-coupon-priceBox3`}>
                                                <RichText.Content
                                                    value={priceBox3} 
                                                    className={`affiliate-coupon-priceBox3`}
                                                />
                                            </div>
                                        </div>
                                        <div className={`affiliate-coupon-btn`}>
                                            <div className={`affiliate-coupon-btn-wrapper`}>
                                                <a href = {spBtnHref} className={classnames(`affiliate-btn  btn-is-${btnSize} ${buttonWidth === "full"? "btn-is-fullw": buttonWidth === "flex"? `btn-is-flex-${btnSize}`: ""} ${bntRounded ? 'btn-is-rounded' : ''}`).trim()}  
                                                    {...(btn_Htarget ? {...btn_Htarget && { rel: newrel }} : { rel: newrel }  )}
                                                    {...(btn_Htarget ? { target: '_blank' } : '' )}
                                                    >
                                                    { iconPosition && iconPosition == 'af-icon-is-left' &&
                                                        <i className={`affiliate-abbtn-icon ${buttonIcon} ${iconPosition}`}></i>
                                                    }
                                                    <RichText.Content value={spBtnText} />
                                                    { iconPosition && iconPosition == 'af-icon-is-right' &&
                                                        <i className={`affiliate-abbtn-icon ${buttonIcon} ${iconPosition}`}></i>
                                                    }
                                                </a>
                                            </div>
                                        </div> 
                                    </div>
                                     
                                </div> 

                            </div>
                        }
                        </div>        
                </div>
            </div>
        );
    }
}

export default Save;