import RadioAdvanced from '../../components/fields/RadioAdvanced.js';
import BorderTypes from '../../components/fields/BorderTypes.js';
import Alignment from '../../components/fields/Alignment.js';
import Dimension from '../../components/fields/Dimension/Dimension.js';
import IconSelector from '../../components/fields/IconSelector/IconSelector.js';
import TypographyControl from '../components/typography/index.js';
import WebfontLoader from "../components/typography/fontloader"
import Range from '../../components/fields/Range/Range.js';
import Color  from '../../components/fields/Color/Color.js';
import affiliate_styling  from './styling.js';
import Background  from './../../components/fields/Background/Background.js';
import Media  from '../../components/fields/Media/Media.js';
import IconList from '../../components/fields/IconList/IconList.js';
import BoxShadow  from './../../components/fields/BoxShadow.js';
import Tabs from '../../components/fields/Tabs/Tabs.js';
import Tab from '../../components/fields/Tab/Tab.js';
import ReviewImageTop from "./reviewImageTop.js"
import ReviewImage from "./reviewImage.js"
import ReviewImageBottom from "./reviewImageBottom.js"
import Toggle from '../../components/fields/Toggle.js';
import { EmptyStar, FullStar, HalfStar } from "./icons";
import getIcon from '../../icons/get-icon';

const { __ } = wp.i18n;

const {
	withSelect,
	useDispatch,
	withDispatch
} = wp.data

const {
	compose,
} = wp.compose

const {
    InspectorControls,
    BlockControls,
    MediaUpload,
    URLInput,
    URLInputButton,
    RichText,
    InnerB,
    InnerBlocks
} = wp.blockEditor;

const {
    Component,
    Fragment
} = wp.element;

const {
    PanelBody,
    Toolbar,
    Tooltip,
    TextControl,
    TextareaControl,
    ToggleControl,
    TabPanel,
    Dashicon,
    Button,
    IconButton,
    Popover,
    RangeControl,
    Dropdown,
    SelectControl,
    withNotices
} = wp.components;

let imageSizeOptions = [
	{ value: "thumbnail", label: __( "Thumbnail" ) },
	{ value: "medium", label: __( "Medium" ) },
	{ value: "full", label: __( "Large" ) }
]

$ = jQuery;
const NEW_TAB_REL = 'noopener noreferrer';
class Edit extends Component {

    constructor(props) {
        super(props)
        this.state = {
            removeItemViaBackSpace: 999,
            isVisible:false,
            focusedItem: this.props.attributes.listItems.length - 1,
            focusedItemTwo: this.props.attributes.listItemsTwo.length - 1,
            highlightedStars : 0
        }

        this.onSelectImage    = this.onSelectImage.bind(this)
        this.onSelectImageTop    = this.onSelectImageTop.bind(this)
        this.onSelectImageBottom    = this.onSelectImageBottom.bind(this)
        this.getImageSize  	  = this.getImageSize.bind(this)
        this.getTopImageSize     = this.getTopImageSize.bind(this)
        this.getBottomImageSize     = this.getBottomImageSize.bind(this)
        this.getSlug     = this.getSlug.bind(this)
    }

      /*
	 * Event to set Image as while adding.
	 */
	onSelectImage( media ) {
		const { image } = this.props.attributes
		const { setAttributes } = this.props

		if ( ! media || ! media.url ) {
			setAttributes( { image: null } )
			return
		}

		if ( ! media.type || "image" !== media.type ) {
			setAttributes( { image: null } )
			return
		}
		// if ( media["sizes"] ) {
		// 	var new_img = this.getImageSize(media["sizes"])
		// 	imageSizeOptions = new_img
		// }
		setAttributes( { image: media } )
	}

    onSelectImageTop( media ) {
        const { imageTop } = this.props.attributes
        const { setAttributes } = this.props

        if ( ! media || ! media.url ) {
            setAttributes( { imageTop: null } )
            return
        }

        if ( ! media.type || "image" !== media.type ) {
            setAttributes( { imageTop: null } )
            return
        }
        // if ( media["sizes"] ) {
        //  var new_img = this.getImageSize(media["sizes"])
        //  imageSizeOptions = new_img
        // }
        setAttributes( { imageTop: media } )
    }

    onSelectImageBottom( media ) {
        const { imageBottom } = this.props.attributes
        const { setAttributes } = this.props

        if ( ! media || ! media.url ) {
            setAttributes( { imageBottom: null } )
            return
        }

        if ( ! media.type || "image" !== media.type ) {
            setAttributes( { imageBottom: null } )
            return
        }
        // if ( media["sizes"] ) {
        //  var new_img = this.getImageSize(media["sizes"])
        //  imageSizeOptions = new_img
        // }
        setAttributes( { imageBottom: media } )
    }

	getImageSize( sizes ) {
		var size_arr = []
		$.each(sizes, function (index, item) {
		  var name = index
		  	var p = { "value" : name, "label": name }
		  	size_arr.push(p)
		})
		return(size_arr)
	}

    getTopImageSize( sizes ) {
        var size_arr = []
        $.each(sizes, function (index, item) {
          var name = index
            var p = { "value" : name, "label": name }
            size_arr.push(p)
        })
        return(size_arr)
    }

    getBottomImageSize( sizes ) {
        var size_arr = []
        $.each(sizes, function (index, item) {
          var name = index
            var p = { "value" : name, "label": name }
            size_arr.push(p)
        })
        return(size_arr)
    }
    
    getSlug( title ) {
      return title.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-");
    }

    componentDidMount() {
        const {
            clientId,
            isSelected,
            setAttributes,
            attributes: {
                uniqueId,
                block_id
            }
        } = this.props;
        const _client = clientId.substr(0, 6);

        if (!uniqueId) {
            setAttributes({ uniqueId: _client });
        } else if (uniqueId && uniqueId != _client) {
            setAttributes({ uniqueId: _client });
        }
    
        this.props.setAttributes({ block_id: this.props.clientId })
        const $style = document.createElement("style")
        $style.setAttribute("id", "affiliate-style-" + this.props.clientId)
        document.head.appendChild($style)
    
    }

      /*
      * Event to set Image as null while removing.
      */
      onRemoveImage() {
        const { image } = this.props.attributes
        const { setAttributes } = this.props
  
        setAttributes( { image: null } )
      }
  
      removeImage( url ){
        const { multiple, onChangem,setAttributes } = this.props
        const { image } = this.props.attributes
          setAttributes( { image: {} } )
  
      }

      onRemoveImageTop() {
        const { image } = this.props.attributes
        const { setAttributes } = this.props
  
        setAttributes( { imageTop: null } )
      }
  
      removeImageTop( url ){
        const { multiple, onChangem,setAttributes } = this.props
        const { imageTop } = this.props.attributes
          setAttributes( { imageTop: {} } )
  
      }


      onRemoveImageBottom() {
        const { image } = this.props.attributes
        const { setAttributes } = this.props
  
        setAttributes( { imageBottom: null } )
      }
  
      removeImageBottom( url ){
        const { multiple, onChangem,setAttributes } = this.props
        const { imageBottom } = this.props.attributes
          setAttributes( { imageBottom: {} } )
  
      }

      
      isUrl(url){
        if( ['wbm','jpg','jpeg','gif','png', 'svg'].indexOf( url.split('.').pop().toLowerCase() ) != -1 ){
          return url;
        }
      }

      

    render() {
        const {
            name,
            clientId,
            isSelected,
            attributes,
            setAttributes,
            highlightedStars,
            hasInnerBlocks,
            attributes: {
                uniqueId,
                block_id,
                couponStyle,
                flagStyle,
                titleLoadGoogleFonts,
                listLoadGoogleFonts,
                list2LoadGoogleFonts,
                actualPriceLoadGoogleFonts,
                discountPriceLoadGoogleFonts,
                savingPriceLoadGoogleFonts,
                couponContent,
                priceBox1,
                priceBox2,
                priceBox3,
                className,
                recreateStyles,
                alignment,
                listType,
                bulletStyle,
                bulletStyleTwo,
                numberCorner,
                numberFontSize,
                numberBgSize,
                useNumberBg,
                numberBg,
                numberBgHover,
                boxBgColor,
                titleTextColor,
                titlefontFamily,
                titlefontWeight,
                titlefontSubset,
                titlefontSizeType,
                titlefontSizeTypeMobile,
                titlefontSizeTypeTablet,
                titlefontSizeDesktop,
                titlefontSizeMobile,
                titlefontSizeTablet,
                titlelineHeight,
                titlelineHeightMobile,
                titlelineHeightTablet,
                titleletterSpacing,
                titleletterSpacingMobile,
                titleletterSpacingTablet,
                titleletterSpacingType,
                titleletterSpacingTypeTablet,
                titleletterSpacingTypeMobile,
                titletextTransform,
                titletextDecoration,
                titlefontStyle,
                // 
                listfontFamily,
                listfontWeight,
                listfontSubset,
                listfontSizeType,
                listfontSizeTypeMobile,
                listfontSizeTypeTablet,
                listfontSizeDesktop,
                listfontSizeMobile,
                listfontSizeTablet,
                listlineHeight,
                listlineHeightMobile,
                listlineHeightTablet,
                listletterSpacing,
                listletterSpacingMobile,
                listletterSpacingTablet,
                listletterSpacingType,
                listletterSpacingTypeTablet,
                listletterSpacingTypeMobile,
                listtextTransform,
                listtextDecoration,
                listfontStyle,
                listTextColor,

                // 
                list2fontFamily,
                list2fontWeight,
                list2fontSubset,
                list2fontSizeType,
                list2fontSizeTypeMobile,
                list2fontSizeTypeTablet,
                list2fontSizeDesktop,
                list2fontSizeMobile,
                list2fontSizeTablet,
                list2lineHeight,
                list2lineHeightMobile,
                list2lineHeightTablet,
                list2letterSpacing,
                list2letterSpacingMobile,
                list2letterSpacingTablet,
                list2letterSpacingType,
                list2letterSpacingTypeTablet,
                list2letterSpacingTypeMobile,
                list2textTransform,
                list2textDecoration,
                list2fontStyle,
                list2TextColor,

                // 
                actualPricefontFamily,
                actualPricefontWeight,
                actualPricefontSubset,
                actualPricefontSizeType,
                actualPricefontSizeTypeMobile,
                actualPricefontSizeTypeTablet,
                actualPricefontSizeDesktop,
                actualPricefontSizeMobile,
                actualPricefontSizeTablet,
                actualPricelineHeight,
                actualPricelineHeightMobile,
                actualPricelineHeightTablet,
                actualPriceletterSpacing,
                actualPriceletterSpacingMobile,
                actualPriceletterSpacingTablet,
                actualPriceletterSpacingType,
                actualPriceletterSpacingTypeTablet,
                actualPriceletterSpacingTypeMobile,
                actualPricetextTransform,
                actualPricetextDecoration,
                actualPricefontStyle,
                actualPriceTextColor,


                // 
                discountPricefontFamily,
                discountPricefontWeight,
                discountPricefontSubset,
                discountPricefontSizeType,
                discountPricefontSizeTypeMobile,
                discountPricefontSizeTypeTablet,
                discountPricefontSizeDesktop,
                discountPricefontSizeMobile,
                discountPricefontSizeTablet,
                discountPricelineHeight,
                discountPricelineHeightMobile,
                discountPricelineHeightTablet,
                discountPriceletterSpacing,
                discountPriceletterSpacingMobile,
                discountPriceletterSpacingTablet,
                discountPriceletterSpacingType,
                discountPriceletterSpacingTypeTablet,
                discountPriceletterSpacingTypeMobile,
                discountPricetextTransform,
                discountPricetextDecoration,
                discountPricefontStyle,
                discountPriceTextColor,


                // 
                savingPricefontFamily,
                savingPricefontWeight,
                savingPricefontSubset,
                savingPricefontSizeType,
                savingPricefontSizeTypeMobile,
                savingPricefontSizeTypeTablet,
                savingPricefontSizeDesktop,
                savingPricefontSizeMobile,
                savingPricefontSizeTablet,
                savingPricelineHeight,
                savingPricelineHeightMobile,
                savingPricelineHeightTablet,
                savingPriceletterSpacing,
                savingPriceletterSpacingMobile,
                savingPriceletterSpacingTablet,
                savingPriceletterSpacingType,
                savingPriceletterSpacingTypeTablet,
                savingPriceletterSpacingTypeMobile,
                savingPricetextTransform,
                savingPricetextDecoration,
                savingPricefontStyle,
                savingPriceTextColor,

                couponBgColor,
                couponTextColor,
                couponIconColor,
                couponBgColor1,
                couponTextColor2,
                couponIconColor2,
                couponListColor1,
                couponListColor,
                image,
                imageTop,
                imageBottom,
                minRate,
                maxRate,
                progressBgColor,
                 // CTA BUTTON
                btnLoadGoogleFonts,
                btnfontFamily,
                btnfontWeight,
                listItems,
                btnfontSubset,
                btnfontSizeType,
                btnfontSizeTypeMobile,
                btnfontSizeTypeTablet,
                btnfontSizeDesktop,
                btnfontSizeMobile,
                btnfontSizeTablet,
                btnlineHeight,
                btnlineHeightMobile,
                btnlineHeightTablet,
                btnletterSpacing,
                btnletterSpacingMobile,
                btnletterSpacingTablet,
                btnletterSpacingType,
                btnletterSpacingTypeTablet,
                btnletterSpacingTypeMobile,
                btntextTransform,
                btntextDecoration,
                btnfontStyle,
                btnBgColor,
                btnHoverBgColor,
                btnTextColor,
                btnTextHoverColor,
                btnBorderColor,
                btnBorderHoverColor,
                btn_Htarget,
                spBtnText,
                spBtnHref,
                progressText,
                opPickMainTitle,
                btnPadding,
                btnPaddingMobile,
                btnPaddingTablet,
                btnMargin,
                btnMarginMobile,
                btnMarginTablet,
                btnAlignment,
                btnAlignmentMobile,
                btnAlignmentTablet,
                btnBorder,
                btnBorderType,
                btnBorderMobile,
                btnBorderTablet,
                btnBorderRadius,
                btnBorderRadiusMobile,
                btnBorderRadiusTablet,
                enableGlimmerEffect,
                // Sub Title
                contentLoadGoogleFonts,
                contentTextColor,
                contentfontFamily,
                contentfontWeight,
                contentfontSubset,
                contentfontSizeType,
                contentfontSizeTypeMobile,
                contentfontSizeTypeTablet,
                contentfontSizeDesktop,
                contentfontSizeMobile,
                contentfontSizeTablet,
                contentlineHeight,
                contentlineHeightMobile,
                contentlineHeightTablet,
                contentletterSpacing,
                contentletterSpacingMobile,
                contentletterSpacingTablet,
                contentletterSpacingType,
                contentletterSpacingTypeTablet,
                contentletterSpacingTypeMobile,
                contenttextTransform,
                contenttextDecoration,
                contentfontStyle,
                contentAlignment,
                contentAlignmentMobile,
                contentAlignmentTablet,
                couponMainTitle,
                progressHeight,
                progressWidth,
                progressLoadGoogleFonts,
                progressColor,
                progressfontFamily,
                progressfontWeight,
                progressfontSubset,
                progressfontSizeType,
                progressfontSizeTypeMobile,
                progressfontSizeTypeTablet,
                progressfontSizeDesktop,
                progressfontSizeMobile,
                progressfontSizeTablet,
                progresslineHeight,
                progresslineHeightMobile,
                progresslineHeightTablet,
                progressletterSpacing,
                progressletterSpacingMobile,
                progressletterSpacingTablet,
                progressletterSpacingType,
                progressletterSpacingTypeTablet,
                progressletterSpacingTypeMobile,
                progresstextTransform,
                progresstextDecoration,
                progressfontStyle,
                progressTextColor,
                rateSize,
                rateColor,
                iconPosition,
                btnSize,
                buttonIcon,
                buttonWidth,
                bntRounded,
                boxShadow,

                imageSize,
                imagePadding,
                imagePaddingMobile,
                imagePaddingTablet,

                imageTopSize,
                imageTopPadding,
                imageTopPaddingMobile,
                imageTopPaddingTablet,

                imageBottomSize,
                imageBottomPadding,
                imageBottomPaddingMobile,
                imageBottomPaddingTablet,

                customImgWidth,
                customImgWidthMobile,
                customImgWidthTablet,

                customTopImgWidth,
                customTopImgWidthMobile,
                customTopImgWidthTablet,

                customBottomImgWidth,
                customBottomImgWidthMobile,
                customBottomImgWidthTablet,

                designType,
                listTextItems,
                listTextItemsTwo,
                showRatings,
                titleTag1,
                titleTag2,
                btnRel,

                //Star Rating
                ratings,
                ratingsColor,
                ratingsSpacing,
                ratingsSize,
                selectedStars,
                ratingAlignemt,
                ratingAlignemtMobile,
                ratingAlignemtTablet,
                starsSize,
                starsSizeMobile,
                starsSizeTablet,


                externalImage,
                externalImageSrc,

                showTitle,
                showRating,
                showContent, 
                showPrice,
                showButton,

                btnBg,
                btnBgHover,

            }
        } = this.props;
        const { isVisible } = this.state
        
        var element = document.getElementById("affiliate-style-" + this.props.clientId)
        if (null != element && "undefined" != typeof element) {
             element.innerHTML = affiliate_styling(this.props, "affiliate-style")
        }

        // imageSizeOptions = this.getImageSize(image["sizes"]

        let loadtitleGoogleFonts
        let loadlistGoogleFonts
        let load2listGoogleFonts
        let loadActualPriceGoogleFonts
        let loadDiscountPriceGoogleFonts
        let loadSavingPriceGoogleFonts
        let loadsubTitleGoogleFonts
        let loadbtnGoogleFotns
        let loadprogressGoogleFonts

        if( titleLoadGoogleFonts == true ) {
					
			const titleconfig = {
				google: {
					families: [ titlefontFamily + ( titlefontWeight ? ":" + titlefontWeight : "" ) ],
				},
			}

			loadtitleGoogleFonts = (
				<WebfontLoader config={ titleconfig }>
				</WebfontLoader>
			)
        }
        
        if( contentLoadGoogleFonts == true ) {
					
			const contentconfig = {
				google: {
					families: [ contentfontFamily + ( contentfontWeight ? ":" + contentfontWeight : "" ) ],
				},
			}

			loadsubTitleGoogleFonts = (
				<WebfontLoader config={ contentconfig }>
				</WebfontLoader>
			)
        }

        if( btnLoadGoogleFonts == true ) {
					
			const btnconfig = {
				google: {
					families: [ btnfontFamily + ( btnfontWeight ? ":" + btnfontWeight : "" ) ],
				},
			}

			loadbtnGoogleFotns = (
				<WebfontLoader config={ btnconfig }>
				</WebfontLoader>
			)
        }


        if( progressLoadGoogleFonts == true ) {
					
			const progressconfig = {
				google: {
					families: [ progressfontFamily + ( progressfontWeight ? ":" + progressfontWeight : "" ) ],
				},
			}

			loadprogressGoogleFonts = (
				<WebfontLoader config={ progressconfig }>
				</WebfontLoader>
			)
        }

        if( listLoadGoogleFonts == true ) {
					
			const listconfig = {
				google: {
					families: [ listfontFamily + ( listfontWeight ? ":" + listfontWeight : "" ) ],
				},
			}

			loadlistGoogleFonts = (
				<WebfontLoader config={ listconfig }>
				</WebfontLoader>
			)
        }

        if( list2LoadGoogleFonts == true ) {
                    
            const list2config = {
                google: {
                    families: [ list2fontFamily + ( list2fontWeight ? ":" + list2fontWeight : "" ) ],
                },
            }

            load2listGoogleFonts = (
                <WebfontLoader config={ list2config }>
                </WebfontLoader>
            )
        }


        if( actualPriceLoadGoogleFonts == true ) {
                    
            const actualPriceconfig = {
                google: {
                    families: [ actualPricefontFamily + ( actualPricefontWeight ? ":" + actualPricefontWeight : "" ) ],
                },
            }

            loadActualPriceGoogleFonts = (
                <WebfontLoader config={ actualPriceconfig }>
                </WebfontLoader>
            )
        }


        if( discountPriceLoadGoogleFonts == true ) {
                    
            const discountPriceconfig = {
                google: {
                    families: [ discountPricefontFamily + ( discountPricefontWeight ? ":" + discountPricefontWeight : "" ) ],
                },
            }

            loadDiscountPriceGoogleFonts = (
                <WebfontLoader config={ discountPriceconfig }>
                </WebfontLoader>
            )
        }


        if( savingPriceLoadGoogleFonts == true ) {
                    
            const savingPriceconfig = {
                google: {
                    families: [ savingPricefontFamily + ( savingPricefontWeight ? ":" + savingPricefontWeight : "" ) ],
                },
            }

            loadSavingPriceGoogleFonts = (
                <WebfontLoader config={ savingPriceconfig }>
                </WebfontLoader>
            )
        }

        const Tag1  = titleTag1
        const Tag2  = titleTag2

        let newrel;
        if( !btn_Htarget){
            newrel = btnRel
        } else  if( !btn_Htarget && btnRel === NEW_TAB_REL){
            newrel = btnRel
        } else if ( btn_Htarget && !btnRel ) {
          newrel = NEW_TAB_REL
        } else {
          newrel = NEW_TAB_REL + ' ' + btnRel
        }

        function removeDuplicateWords (s) {
          var str = s.split(" ");
          var result = [];
          for(var i =0; i < str.length ; i++){
              if(result.indexOf(str[i]) === -1){
                result.push(str[i]);
              } 
          }
           return result.join(" ");
          }
          
           newrel = removeDuplicateWords(newrel).trim()
        
        return (
            <Fragment>
                <InspectorControls key="inspector">


                <PanelBody title={`General Settings`} initialOpen={false}  icon={ getIcon( 'documentation' ) } className={ 'abblocks-panel-label' }>

                    <ToggleControl
                        label={ __( 'Show Title' ) }                        
                        checked={ showTitle }                                      
                        onChange={ ( ) => setAttributes( { showTitle: ! showTitle } ) }
                    />

                    <ToggleControl
                        label={ __( 'Show Rating' ) }                        
                        checked={ showRating }                                      
                        onChange={ ( ) => setAttributes( { showRating: ! showRating } ) }
                    />

                    <ToggleControl
                        label={ __( 'Show Content' ) }                        
                        checked={ showContent }                                      
                        onChange={ ( ) => setAttributes( { showContent: ! showContent } ) }
                    /> 

                    <ToggleControl
                        label={ __( 'Show Price' ) }                        
                        checked={ showPrice }                                      
                        onChange={ ( ) => setAttributes( { showPrice: ! showPrice } ) }
                    /> 
                                          
                    <RadioAdvanced
                        label={__('Design Type')}
                        options={[
                            { label: 'Fixed', value: 'ab-fixed-design', title: 'Fixed' },
                            { label: 'Dynamic', value: 'ab-dynamic-design', title: 'Dynamic' },
                        ]}
                        value={designType}
                        onChange={(value) => setAttributes({ designType: value })} />	


                    <ToggleControl
                            label={ __( 'External Image?' ) }                        
                            checked={ externalImage }                                      
                            onChange={ ( ) => setAttributes( { externalImage: ! externalImage } ) }
                        />

                      { designType && designType == 'ab-fixed-design' &&  !externalImage && !externalImage == true &&
                          <Media label={__('Image')} multiple={false} type={['image']} panel={true} value={image} onChange={val => setAttributes({ image: val })} />
                      }

                      { designType && designType == 'ab-fixed-design' &&  externalImage && externalImage == true &&
                        <TextareaControl              
                            label={ __( 'External Image Src' ) }         
                            value={ externalImageSrc }                       
                            onChange={ ( value ) => setAttributes( { externalImageSrc: value } ) }
                        />
                      }    

                    
                    <RangeControl
                        label={__("Number of stars")}
                        value={ratings}
                        onChange={value =>
                            setAttributes({
                                ratings: value,
                                selectedStars: value < selectedStars ? value : selectedStars
                            })
                        }
                        min={5}
                        step={1}
                        max={10}
                        // beforeIcon="star-empty"
                        allowReset
                    />
                     <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                            activeClass="active-tab"
                            tabs={[
                              {
                                name: 'boxdesk',
                                title: <Dashicon icon="desktop" />,
                                className: 'affiliate-responsive-tabs',
                              },
                              {
                                name: 'boxtablet',
                                title: <Dashicon icon="tablet" />,
                                className: 'affiliate-responsive-tabs',
                              },
                              {
                                name: 'boxmobile',
                                title: <Dashicon icon="smartphone" />,
                                className: 'affiliate-responsive-tabs',
                              },
                            ]}>
                            {
                              (radiustab) => {
                                let tabout;
                                if (radiustab.name) {
                                  if ('boxmobile' === radiustab.name) {
                                    tabout = (
                                        <Range
                                            label={__('Stars Size')}
                                            value={starsSizeMobile} 
                                            onChange={(value) => setAttributes({ starsSizeMobile: value })}
                                            unit={[]}
                                            min={10}
                                            step={1}
                                            max={60}
                                        />
                                    );
                                  } else if ('boxtablet' === radiustab.name) {
                                    tabout = (
                                        <Range
                                            label={__('Stars Size')}
                                            value={starsSizeTablet} 
                                            onChange={(value) => setAttributes({ starsSizeTablet: value })}
                                            unit={[]}
                                            min={10}
                                            step={1}
                                            max={60}
                                        />
                                    );
                                  } else {
                                    tabout = (
                                        <Range
                                            label={__('Stars Size')}
                                            value={starsSize} 
                                            onChange={(value) => setAttributes({ starsSize: value })}
                                            unit={[]}
                                            min={10}
                                            step={1}
                                            max={60}
                                        />
                                    );
                                  }
                                }
                                return <div>{tabout}</div>;
                              }
                            }
                          </TabPanel>
               
                
                        <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                            activeClass="active-tab"
                            tabs={[
                              {
                                name: 'boxdesk',
                                title: <Dashicon icon="desktop" />,
                                className: 'affiliate-responsive-tabs',
                              },
                              {
                                name: 'boxtablet',
                                title: <Dashicon icon="tablet" />,
                                className: 'affiliate-responsive-tabs',
                              },
                              {
                                name: 'boxmobile',
                                title: <Dashicon icon="smartphone" />,
                                className: 'affiliate-responsive-tabs',
                              },
                            ]}>
                            {
                              (radiustab) => {
                                let tabout;
                                if (radiustab.name) {
                                  if ('boxmobile' === radiustab.name) {
                                    tabout = (
                                    <Alignment
                                        label = {__('Star Alignment')}
                                        disableJustify
                                        alignmentType='content'
                                        flex
                                        value={ratingAlignemtMobile}
                                        onChange={(value) => setAttributes({ ratingAlignemtMobile: value })}/>
                                    );
                                  } else if ('boxtablet' === radiustab.name) {
                                    tabout = (
                                        <Alignment
                                            label = {__('Star Alignment')}
                                            disableJustify
                                            alignmentType='content'
                                            flex
                                            value={ratingAlignemtTablet}
                                            onChange={(value) => setAttributes({ ratingAlignemtTablet: value })}/>
                                    );
                                  } else {
                                    tabout = (
                                    <Alignment
                                        label = {__('Star Alignment')}
                                        disableJustify
                                        alignmentType='content'
                                        flex
                                        value={ratingAlignemt}
                                        onChange={(value) => setAttributes({ ratingAlignemt: value })}/>
                                    );
                                  }
                                }
                                return <div>{tabout}</div>;
                              }
                            }
                          </TabPanel>
                                        
                    <BoxShadow label={__('Box-Shadow')} value={boxShadow} onChange={(value) => setAttributes({ boxShadow: value })} />
                </PanelBody>

                <PanelBody title={ __( 'Typography' ) } initialOpen={false}  icon={ getIcon( 'typography' ) } className={ 'abblocks-panel-label' }>

                    <SelectControl
                        label={ __( 'Title Heading Tag' ) }
                        value={ titleTag1 }
                        options= {[
                                { value: 'h2', label: 'Heading 2 (h2)' },
                                { value: 'h3', label: 'Heading 3 (h3)' },
                                { value: 'h4', label: 'Heading 4 (h4)' },
                                { value: 'h5', label: 'Heading 5 (h5)' },
                                { value: 'h6', label: 'Heading 6 (h6)' },
                                { value: 'p', label: 'Paragraph (p)' },
                            ]}
                            onChange={ ( value ) => setAttributes( { titleTag1: value } ) }
                     />

                    <TypographyControl
                        label={__("Title Typography")}
                        attributes={attributes}
                        setAttributes={setAttributes}
                        loadGoogleFonts={{ value:titleLoadGoogleFonts, label: __("titleLoadGoogleFonts") }}
                        fontFamily={{ value: titlefontFamily, label: __("titlefontFamily") }}
                        fontWeight={{ value: titlefontWeight, label: __("titlefontWeight") }}
                        fontSubset={{ value: titlefontSubset, label: __("titlefontSubset") }}
                        fontSizeType={{ value: titlefontSizeType, label: __("titlefontSizeType") }}
                        fontSizeTypeMobile={{ value: titlefontSizeTypeMobile, label: __("titlefontSizeTypeMobile") }}
                        fontSizeTypeTablet={{ value: titlefontSizeTypeTablet, label: __("titlefontSizeTypeTablet") }}
                        fontSize={{ value: titlefontSizeDesktop, label: __("titlefontSizeDesktop") }}
                        fontSizeMobile={{ value: titlefontSizeMobile, label: __("titlefontSizeMobile") }}
                        fontSizeTablet={{ value: titlefontSizeTablet, label: __("titlefontSizeTablet") }}
                        lineHeightType={{ value: '', label: __(" ") }}
                        lineHeight={{ value: titlelineHeight, label: __("titlelineHeight") }}
                        lineHeightMobile={{ value: titlelineHeightMobile, label: __("titlelineHeightMobile") }}
                        lineHeightTablet={{ value: titlelineHeightTablet, label: __("titlelineHeightTablet") }}
                        letterSpacing={{ value: titleletterSpacing, label: __("titleletterSpacing") }}
                        letterSpacingMobile={{ value: titleletterSpacingMobile, label: __("titleletterSpacingMobile") }}
                        letterSpacingTablet={{ value: titleletterSpacingTablet, label: __("titleletterSpacingTablet") }}
                        letterSpacingType={{ value: titleletterSpacingType, label: __("titleletterSpacingType") }}
                        letterSpacingTypeTablet={{ value: titleletterSpacingTypeTablet, label: __("titleletterSpacingTypeTablet") }}
                        letterSpacingTypeMobile={{ value: titleletterSpacingTypeMobile, label: __("titleletterSpacingTypeMobile") }}
                        textTransform={titletextTransform}
                        onTextTransform={(value) => setAttributes({ titletextTransform: value })}
                        textDecoration={titletextDecoration}
                        onTextDecoration={(value) => setAttributes({ titletextDecoration: value })}
                        fontStyle={titlefontStyle}
                        onFontStyle={(value) => setAttributes({ titlefontStyle: value })}
                    />

                    <TypographyControl
                        label={__("Content Typography")}
                        attributes={attributes}
                        setAttributes={setAttributes}
                        loadGoogleFonts={{ value:contentLoadGoogleFonts, label: __("contentLoadGoogleFonts") }}
                        fontFamily={{ value: contentfontFamily, label: __("contentfontFamily") }}
                        fontWeight={{ value: contentfontWeight, label: __("contentfontWeight") }}
                        fontSubset={{ value: contentfontSubset, label: __("contentfontSubset") }}
                        fontSizeType={{ value: contentfontSizeType, label: __("contentfontSizeType") }}
                        fontSizeTypeMobile={{ value: contentfontSizeTypeMobile, label: __("contentfontSizeTypeMobile") }}
                        fontSizeTypeTablet={{ value: contentfontSizeTypeTablet, label: __("contentfontSizeTypeTablet") }}
                        fontSize={{ value: contentfontSizeDesktop, label: __("contentfontSizeDesktop") }}
                        fontSizeMobile={{ value: contentfontSizeMobile, label: __("contentfontSizeMobile") }}
                        fontSizeTablet={{ value: contentfontSizeTablet, label: __("contentfontSizeTablet") }}
                        lineHeightType={{ value: '', label: __(" ") }}
                        lineHeight={{ value: contentlineHeight, label: __("contentlineHeight") }}
                        lineHeightMobile={{ value: contentlineHeightMobile, label: __("contentlineHeightMobile") }}
                        lineHeightTablet={{ value: contentlineHeightTablet, label: __("contentlineHeightTablet") }}
                        letterSpacing={{ value: contentletterSpacing, label: __("contentletterSpacing") }}
                        letterSpacingMobile={{ value: contentletterSpacingMobile, label: __("contentletterSpacingMobile") }}
                        letterSpacingTablet={{ value: contentletterSpacingTablet, label: __("contentletterSpacingTablet") }}
                        letterSpacingType={{ value: contentletterSpacingType, label: __("contentletterSpacingType") }}
                        letterSpacingTypeTablet={{ value: contentletterSpacingTypeTablet, label: __("contentletterSpacingTypeTablet") }}
                        letterSpacingTypeMobile={{ value: contentletterSpacingTypeMobile, label: __("contentletterSpacingTypeMobile") }}
                        textTransform={contenttextTransform}
                        onTextTransform={(value) => setAttributes({ contenttextTransform: value })}
                        textDecoration={contenttextDecoration}
                        onTextDecoration={(value) => setAttributes({ contenttextDecoration: value })}
                        fontStyle={contentfontStyle}
                        onFontStyle={(value) => setAttributes({ contentfontStyle: value })}
                    />  
                    

                    <TypographyControl
                        label={__("Actual Price Typography")}
                        attributes={attributes}
                        setAttributes={setAttributes}
                        loadGoogleFonts={{ value:actualPriceLoadGoogleFonts, label: __("actualPriceLoadGoogleFonts") }}
                        fontFamily={{ value: actualPricefontFamily, label: __("actualPricefontFamily") }}
                        fontWeight={{ value: actualPricefontWeight, label: __("actualPricefontWeight") }}
                        fontSubset={{ value: actualPricefontSubset, label: __("actualPricefontSubset") }}
                        fontSizeType={{ value: actualPricefontSizeType, label: __("actualPricefontSizeType") }}
                        fontSizeTypeMobile={{ value: actualPricefontSizeTypeMobile, label: __("actualPricefontSizeTypeMobile") }}
                        fontSizeTypeTablet={{ value: actualPricefontSizeTypeTablet, label: __("actualPricefontSizeTypeTablet") }}
                        fontSize={{ value: actualPricefontSizeDesktop, label: __("actualPricefontSizeDesktop") }}
                        fontSizeMobile={{ value: actualPricefontSizeMobile, label: __("actualPricefontSizeMobile") }}
                        fontSizeTablet={{ value: actualPricefontSizeTablet, label: __("actualPricefontSizeTablet") }}
                        lineHeightType={{ value: '', label: __(" ") }}
                        lineHeight={{ value: actualPricelineHeight, label: __("actualPricelineHeight") }}
                        lineHeightMobile={{ value: actualPricelineHeightMobile, label: __("actualPricelineHeightMobile") }}
                        lineHeightTablet={{ value: actualPricelineHeightTablet, label: __("actualPricelineHeightTablet") }}
                        letterSpacing={{ value: actualPriceletterSpacing, label: __("actualPriceletterSpacing") }}
                        letterSpacingMobile={{ value: actualPriceletterSpacingMobile, label: __("actualPriceletterSpacingMobile") }}
                        letterSpacingTablet={{ value: actualPriceletterSpacingTablet, label: __("actualPriceletterSpacingTablet") }}
                        letterSpacingType={{ value: actualPriceletterSpacingType, label: __("actualPriceletterSpacingType") }}
                        letterSpacingTypeTablet={{ value: actualPriceletterSpacingTypeTablet, label: __("actualPriceletterSpacingTypeTablet") }}
                        letterSpacingTypeMobile={{ value: actualPriceletterSpacingTypeMobile, label: __("actualPriceletterSpacingTypeMobile") }}
                        textTransform={actualPricetextTransform}
                        onTextTransform={(value) => setAttributes({ actualPricetextTransform: value })}
                        textDecoration={actualPricetextDecoration}
                        onTextDecoration={(value) => setAttributes({ actualPricetextDecoration: value })}
                        fontStyle={actualPricefontStyle}
                        onFontStyle={(value) => setAttributes({ actualPricefontStyle: value })}
                    />


                    <TypographyControl
                        label={__("Discount Price Typography")}
                        attributes={attributes}
                        setAttributes={setAttributes}
                        loadGoogleFonts={{ value:discountPriceLoadGoogleFonts, label: __("discountPriceLoadGoogleFonts") }}
                        fontFamily={{ value: discountPricefontFamily, label: __("discountPricefontFamily") }}
                        fontWeight={{ value: discountPricefontWeight, label: __("discountPricefontWeight") }}
                        fontSubset={{ value: discountPricefontSubset, label: __("discountPricefontSubset") }}
                        fontSizeType={{ value: discountPricefontSizeType, label: __("discountPricefontSizeType") }}
                        fontSizeTypeMobile={{ value: discountPricefontSizeTypeMobile, label: __("discountPricefontSizeTypeMobile") }}
                        fontSizeTypeTablet={{ value: discountPricefontSizeTypeTablet, label: __("discountPricefontSizeTypeTablet") }}
                        fontSize={{ value: discountPricefontSizeDesktop, label: __("discountPricefontSizeDesktop") }}
                        fontSizeMobile={{ value: discountPricefontSizeMobile, label: __("discountPricefontSizeMobile") }}
                        fontSizeTablet={{ value: discountPricefontSizeTablet, label: __("discountPricefontSizeTablet") }}
                        lineHeightType={{ value: '', label: __(" ") }}
                        lineHeight={{ value: discountPricelineHeight, label: __("discountPricelineHeight") }}
                        lineHeightMobile={{ value: discountPricelineHeightMobile, label: __("discountPricelineHeightMobile") }}
                        lineHeightTablet={{ value: discountPricelineHeightTablet, label: __("discountPricelineHeightTablet") }}
                        letterSpacing={{ value: discountPriceletterSpacing, label: __("discountPriceletterSpacing") }}
                        letterSpacingMobile={{ value: discountPriceletterSpacingMobile, label: __("discountPriceletterSpacingMobile") }}
                        letterSpacingTablet={{ value: discountPriceletterSpacingTablet, label: __("discountPriceletterSpacingTablet") }}
                        letterSpacingType={{ value: discountPriceletterSpacingType, label: __("discountPriceletterSpacingType") }}
                        letterSpacingTypeTablet={{ value: discountPriceletterSpacingTypeTablet, label: __("discountPriceletterSpacingTypeTablet") }}
                        letterSpacingTypeMobile={{ value: discountPriceletterSpacingTypeMobile, label: __("discountPriceletterSpacingTypeMobile") }}
                        textTransform={discountPricetextTransform}
                        onTextTransform={(value) => setAttributes({ discountPricetextTransform: value })}
                        textDecoration={discountPricetextDecoration}
                        onTextDecoration={(value) => setAttributes({ discountPricetextDecoration: value })}
                        fontStyle={discountPricefontStyle}
                        onFontStyle={(value) => setAttributes({ discountPricefontStyle: value })}
                    />


                    <TypographyControl
                        label={__("Saving Price Typography")}
                        attributes={attributes}
                        setAttributes={setAttributes}
                        loadGoogleFonts={{ value:savingPriceLoadGoogleFonts, label: __("savingPriceLoadGoogleFonts") }}
                        fontFamily={{ value: savingPricefontFamily, label: __("savingPricefontFamily") }}
                        fontWeight={{ value: savingPricefontWeight, label: __("savingPricefontWeight") }}
                        fontSubset={{ value: savingPricefontSubset, label: __("savingPricefontSubset") }}
                        fontSizeType={{ value: savingPricefontSizeType, label: __("savingPricefontSizeType") }}
                        fontSizeTypeMobile={{ value: savingPricefontSizeTypeMobile, label: __("savingPricefontSizeTypeMobile") }}
                        fontSizeTypeTablet={{ value: savingPricefontSizeTypeTablet, label: __("savingPricefontSizeTypeTablet") }}
                        fontSize={{ value: savingPricefontSizeDesktop, label: __("savingPricefontSizeDesktop") }}
                        fontSizeMobile={{ value: savingPricefontSizeMobile, label: __("savingPricefontSizeMobile") }}
                        fontSizeTablet={{ value: savingPricefontSizeTablet, label: __("savingPricefontSizeTablet") }}
                        lineHeightType={{ value: '', label: __(" ") }}
                        lineHeight={{ value: savingPricelineHeight, label: __("savingPricelineHeight") }}
                        lineHeightMobile={{ value: savingPricelineHeightMobile, label: __("savingPricelineHeightMobile") }}
                        lineHeightTablet={{ value: savingPricelineHeightTablet, label: __("savingPricelineHeightTablet") }}
                        letterSpacing={{ value: savingPriceletterSpacing, label: __("savingPriceletterSpacing") }}
                        letterSpacingMobile={{ value: savingPriceletterSpacingMobile, label: __("savingPriceletterSpacingMobile") }}
                        letterSpacingTablet={{ value: savingPriceletterSpacingTablet, label: __("savingPriceletterSpacingTablet") }}
                        letterSpacingType={{ value: savingPriceletterSpacingType, label: __("savingPriceletterSpacingType") }}
                        letterSpacingTypeTablet={{ value: savingPriceletterSpacingTypeTablet, label: __("savingPriceletterSpacingTypeTablet") }}
                        letterSpacingTypeMobile={{ value: savingPriceletterSpacingTypeMobile, label: __("savingPriceletterSpacingTypeMobile") }}
                        textTransform={savingPricetextTransform}
                        onTextTransform={(value) => setAttributes({ savingPricetextTransform: value })}
                        textDecoration={savingPricetextDecoration}
                        onTextDecoration={(value) => setAttributes({ savingPricetextDecoration: value })}
                        fontStyle={savingPricefontStyle}
                        onFontStyle={(value) => setAttributes({ savingPricefontStyle: value })}
                    />
                </PanelBody>

                <PanelBody title={ __( 'Colors' ) } initialOpen={false}  icon={ getIcon( 'colors' ) } className={ 'abblocks-panel-label' }>
                    <Color label={__('Box Background Color')} disableAlpha value={boxBgColor} onChange={val => setAttributes({ boxBgColor: val })} />    
                    <Color label={__('Main Title Color')} disableAlpha value={titleTextColor} onChange={val => setAttributes({ titleTextColor: val })} />
                    <Color label={__('Rating Color')} value={ratingsColor} onChange={(value) => setAttributes({ ratingsColor: value })} /> 
                </PanelBody>

             
                <PanelBody title={ __( 'Button Settings' ) } initialOpen={false}  icon={ getIcon( 'button' ) } className={ 'abblocks-panel-label' }>	
                    
                        <ToggleControl
                            label={ __( 'Show Button' ) }                        
                            checked={ showButton }                                      
                            onChange={ ( ) => setAttributes( { showButton: ! showButton } ) }
                        />            

                            <Dropdown
                                className="affiliate-icon-popover"
                                contentClassName="my-popover-content-classname"
                                position="left"
                                renderToggle={ ( { isOpen, onToggle } ) => (
                                <Fragment>
                                    <h2>{__('Tag Icon')}</h2>
                                    <Button className="affiliate-size-btn"  onClick={ onToggle } aria-expanded={ isOpen }>
                                                <Dashicon icon="admin-tools" />
                                    </Button>
                                </Fragment> 
                                ) }
                                renderContent={ () => (
                                    <div className="affiliate-iconlist-popwrapper">
                                        <IconList value={buttonIcon} disableToggle onChange={val => setAttributes({ buttonIcon: val })} />
                                    </div>
                                ) }
                            />
                          <RadioAdvanced
                              label={__('Icon Position')}
                              options={[
                                  { label: 'Left', value: 'af-icon-is-left', title: 'Left' },
                                  { label: 'Right', value: 'af-icon-is-right', title: 'Right' },
                              ]}
                              value={iconPosition}
                              onChange={(value) => setAttributes({ iconPosition: value })} />					
                        <TextControl		
                            label = { __( 'Button Text' ) }				
                            value={ spBtnText }						
                            onChange={ ( value ) => setAttributes( { spBtnText: value } ) }
                        />
                        <TextControl
                            label = { __( 'Button URL' ) }						
                            value={ spBtnHref }						
                            onChange={ ( value ) => setAttributes( { spBtnHref: value } ) }
                        />
                        <TextControl
                            label = { __( 'Button Rel' ) }						
                            value={ btnRel }						
                            onChange={ ( value ) => setAttributes( { btnRel: value } ) }
                        />
                        <ToggleControl
                            label={ __( 'Open link in new Tab' ) }						
                            checked={ btn_Htarget }										
                            onChange={ ( ) => setAttributes( { btn_Htarget: ! btn_Htarget } ) }
                        />
                        <ToggleControl
                            label={ __( 'Rounded Button' ) }						
                            checked={ bntRounded }										
                            onChange={ ( ) => setAttributes( { bntRounded: ! bntRounded } ) }
                        />
                        <ToggleControl
                  label={ __( 'Enable Glimmer Effect' ) }            
                  checked={ enableGlimmerEffect }                    
                  onChange={ ( ) => setAttributes( { enableGlimmerEffect: ! enableGlimmerEffect } ) }
              />
                        <RadioAdvanced
                                label={__('Button Size')}
                                options={[
                                    { label: 'S', value: 'small', title: 'Small' },
                                    { label: 'M', value: 'medium', title: 'Medium' },
                                    { label: 'L', value: 'large', title: 'Large' },
                                    { label: 'XL', value: 'extra-large', title: 'Extra Large' },
                                ]}
                                value={btnSize}
                                onChange={(value) => setAttributes({ btnSize: value })} />
                        <RadioAdvanced
                                label={__('Button Width')}
                                options={[
                                    { label: 'Fixed', value: 'fixed', title: 'Fixed' },
                                    { label: 'Flexible', value: 'flex', title: 'Flexible' },
                                    { label: 'Full', value: 'full', title: 'Full' },
                                ]}
                                value={buttonWidth}
                                onChange={(value) => setAttributes({ buttonWidth: value })} />
                        <TypographyControl
                                label={__("Button Typography")}
                                attributes={attributes}
                                setAttributes={setAttributes}
                                loadGoogleFonts={{ value:btnLoadGoogleFonts, label: __("btnLoadGoogleFonts") }}
                                fontFamily={{ value: btnfontFamily, label: __("btnfontFamily") }}
                                fontWeight={{ value: btnfontWeight, label: __("btnfontWeight") }}
                                fontSubset={{ value: btnfontSubset, label: __("btnfontSubset") }}
                                fontSizeType={{ value: btnfontSizeType, label: __("btnfontSizeType") }}
                                fontSizeTypeMobile={{ value: btnfontSizeTypeMobile, label: __("btnfontSizeTypeMobile") }}
                                fontSizeTypeTablet={{ value: btnfontSizeTypeTablet, label: __("btnfontSizeTypeTablet") }}
                                fontSize={{ value: btnfontSizeDesktop, label: __("btnfontSizeDesktop") }}
                                fontSizeMobile={{ value: btnfontSizeMobile, label: __("btnfontSizeMobile") }}
                                fontSizeTablet={{ value: btnfontSizeTablet, label: __("btnfontSizeTablet") }}
                                lineHeightType={{ value: '', label: __(" ") }}
                                lineHeight={{ value: btnlineHeight, label: __("btnlineHeight") }}
                                lineHeightMobile={{ value: btnlineHeightMobile, label: __("btnlineHeightMobile") }}
                                lineHeightTablet={{ value: btnlineHeightTablet, label: __("btnlineHeightTablet") }}
                                letterSpacing={{ value: btnletterSpacing, label: __("btnletterSpacing") }}
                                letterSpacingMobile={{ value: btnletterSpacingMobile, label: __("btnletterSpacingMobile") }}
                                letterSpacingTablet={{ value: btnletterSpacingTablet, label: __("btnletterSpacingTablet") }}
                                letterSpacingType={{ value: btnletterSpacingType, label: __("btnletterSpacingType") }}
                                letterSpacingTypeTablet={{ value: btnletterSpacingTypeTablet, label: __("btnletterSpacingTypeTablet") }}
                                letterSpacingTypeMobile={{ value: btnletterSpacingTypeMobile, label: __("btnletterSpacingTypeMobile") }}
                                textTransform={btntextTransform}
                                onTextTransform={(value) => setAttributes({ btntextTransform: value })}
                                textDecoration={btntextDecoration}
                                onTextDecoration={(value) => setAttributes({ btntextDecoration: value })}
                                fontStyle={btnfontStyle}
                                onFontStyle={(value) => setAttributes({ btnfontStyle: value })}
                            />
                            <Tabs>
                                <Tab tabTitle={__('Normal')}>
                                  <Color label={__('Text Color')} disableAlpha value={btnTextColor} onChange={val => setAttributes({ btnTextColor: val })} />
                                  <Color label={__('Border Color')} disableAlpha value={btnBorderColor} onChange={val => setAttributes({ btnBorderColor: val })} />
                                  <Background
                                      parallax
                                      value={btnBg}
                                      label={__('Background')}
                                      externalImage
                                      sources={['color','gradient']}
                                      onChange={val => setAttributes({ btnBg: val })} 
                                  />
                                </Tab>
                                <Tab tabTitle={__('Hover')}>
                                  <Color label={__('Hover Text Color')} disableAlpha value={btnTextHoverColor} onChange={val => setAttributes({ btnTextHoverColor: val })} />
                                  <Color label={__('Border Hover Color')} disableAlpha value={btnBorderHoverColor} onChange={val => setAttributes({ btnBorderHoverColor: val })} />
                                  <Background
                                      parallax
                                      value={btnBgHover}
                                      label={__('Background')}
                                      externalImage
                                      sources={['color','gradient']}
                                      onChange={val => setAttributes({ btnBgHover: val })}
                                    />
                                </Tab>
                            </Tabs>
                            
                            <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Dimension
                                            label={__('Padding')} value={btnPaddingMobile}
                                            onChange={val => setAttributes({ btnPaddingMobile: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Dimension label={__('Padding')} value={btnPaddingTablet}
                                            onChange={val => setAttributes({ btnPaddingTablet: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Dimension
                                            label={__('Padding')} value={btnPadding}
                                            onChange={val => setAttributes({ btnPadding: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>
                              <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Dimension
                                            label={__('Margin')}
                                            value={btnMarginMobile}
                                            onChange={val => setAttributes({ btnMarginMobile: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Dimension label={__('Margin')} value={btnMarginTablet}
                                            onChange={val => setAttributes({ btnMarginMobile: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Dimension
                                            label={__('Margin')} value={btnMargin}
                                            onChange={val => setAttributes({ btnMargin: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>
                              <BorderTypes label={__('Border Type')} value={btnBorderType} onChange={(value) => setAttributes({ btnBorderType: value })} />
                              <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Dimension
                                            label={__('Border Width')} value={btnBorderMobile}
                                            onChange={val => setAttributes({ btnBorderMobile: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Dimension label={__('Border Width')} 
                                            value={btnBorderTablet}
                                            onChange={val => setAttributes({ btnBorderTablet: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Dimension
                                            label={__('Border Width')} value={btnBorder}
                                            onChange={val => setAttributes({ btnBorder: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>
                              <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Dimension
                                            label={__('Border Radius')} value={btnBorderRadiusMobile}
                                            onChange={val => setAttributes({ btnBorderRadiusMobile: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Dimension label={__('Border Radius')} 
                                            value={btnBorderRadiusTablet}
                                            onChange={val => setAttributes({ btnBorderRadiusTablet: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Dimension
                                            label={__('Border Radius')} value={btnBorderRadius}
                                            onChange={val => setAttributes({ btnBorderRadius: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>
                              <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Alignment
                                              label = {__('Alignment')}
                                              disableJustify
                                              alignmentType='content'
                                              flex
                                              value={btnAlignmentMobile}
                                              onChange={(value) => setAttributes({ btnAlignmentMobile: value })}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Alignment
                                              label = {__('Alignment')}
                                              disableJustify
                                              alignmentType='content'
                                              flex
                                              value={btnAlignmentTablet}
                                              onChange={(value) => setAttributes({ btnAlignmentTablet: value })}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Alignment
                                              label = {__('Alignment')}
                                              disableJustify
                                              alignmentType='content'
                                              flex
                                              value={btnAlignment}
                                              onChange={(value) => setAttributes({ btnAlignment: value })}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>     
                  </PanelBody>
                  
                  

                  <PanelBody title={`Spacing`} icon={ getIcon( 'spacing' ) } className={ 'abblocks-panel-label' } initialOpen={false}>
                    <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                      activeClass="active-tab"
                      tabs={[
                        {
                          name: 'boxdesk',
                          title: <Dashicon icon="desktop" />,
                          className: 'affiliate-responsive-tabs',
                        },
                        {
                          name: 'boxtablet',
                          title: <Dashicon icon="tablet" />,
                          className: 'affiliate-responsive-tabs',
                        },
                        {
                          name: 'boxmobile',
                          title: <Dashicon icon="smartphone" />,
                          className: 'affiliate-responsive-tabs',
                        },
                      ]}>
                      {
                        (radiustab) => {
                          let tabout;
                          if (radiustab.name) {
                            if ('boxmobile' === radiustab.name) {
                              tabout = (
                                <Range label={__('Custom Image Width')} value={customImgWidthMobile} onChange={(value) => setAttributes({ customImgWidthMobile: value })} min={0} max={1000} unit={['']} />
                              );
                            } else if ('boxtablet' === radiustab.name) {
                              tabout = (
                                <Range label={__('Custom Image Width')} value={customImgWidthTablet} onChange={(value) => setAttributes({ customImgWidthTablet: value })} min={0} max={1000} unit={['']} />
                              );
                            } else {
                              tabout = (
                                <Range label={__('Custom Image Width')} value={customImgWidth} onChange={(value) => setAttributes({ customImgWidth: value })} min={0} max={1000} unit={['']} />
                              );
                            }
                          }
                          return <div>{tabout}</div>;
                        }
                      }
                    </TabPanel>
                    <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Dimension
                                            label={__('Image Padding')} value={imagePaddingMobile}
                                            onChange={val => setAttributes({ imagePaddingMobile: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Dimension label={__('Image Padding')} value={imagePaddingTablet}
                                            onChange={val => setAttributes({ imagePaddingTablet: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Dimension
                                            label={__('Image Padding')} value={imagePadding}
                                            onChange={val => setAttributes({ imagePadding: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>        
                  </PanelBody>

               
                </InspectorControls>
                
                <div id={`affiliate-style-${block_id}`} className={`affiliate-block-${block_id}${className ? ` ${className}` : ''} affiliate-coupon-wrapper ${couponStyle}`}>
                    <div className={`affiliate-coupon-inner`}> 
                        <div className={`affiliate-coupon-content-wrapper`}>
                        
                       
                            <div className={`affiliate-coupon-content-inner style3`}>
                                <div className={`affiliate-col leftcol`}>
                                  <Fragment>
                                        { designType && designType == 'ab-dynamic-design' &&
                                           <div className={`aff-inner-block`}>
                                             <InnerBlocks
                                                renderAppender={ () => (
                                                  <InnerBlocks.ButtonBlockAppender />
                                                ) }
                                              />
                                           </div>   
                                        }
                                        
                                        { designType && designType == 'ab-fixed-design' &&  !externalImage && !externalImage == true && 
                                          <MediaUpload              
                                              onSelect={ this.onSelectImage }
                                              allowedTypes= { [ "image" ] }
                                              value={image}             
                                              render={ ( { open } ) => (                    
                                                <a className="block-editor-button" onClick={ open }>
                                                {/* <img  src={image.url} alt={image.url ? couponMainTitle : ''} />
                                                */}
                                                <ReviewImage attributes={attributes} />
                                                
                                                    {__("Add-Image")}                       
                                                </a>
                                              ) }
                                            />
                                        }

                                        { designType && designType == 'ab-fixed-design' &&  externalImage && externalImage == true &&
                                            <div className={`affiliate-coupon-image`}>
                                                <img src={externalImageSrc} />
                                            </div>
                                        }
                                        
                                  </Fragment>
                                </div>
                                <div className={`affiliate-col rightcol`}>

                                    { showTitle && showTitle == true &&
                                        <RichText
                                            tagName={Tag1}
                                            value={couponMainTitle} 
                                            className="affiliate-coupon-maintitle"
                                            id={`getSlug(${uniqueId})`}
                                            placeholder={__('Product Title')}
                                            onChange={couponMainTitle => setAttributes({ couponMainTitle })}
                                            keepPlaceholderOnFocus
                                        />    
                                    }

                                    { showRating && showRating == true &&
                                        <div className="affiliate-coupon-starrating"
                                            onMouseLeave={() => this.setState({ highlightedStars: 0 })} >
                                            {[...Array(ratings)].map((e, i) => (
                                               <div className={`affiliate-star-item`} key={i}
                                                    onMouseEnter={() => {
                                                        this.setState({ highlightedStars: i + 1 });
                                                    }}
                                                    onClick={() => {
                                                        if (selectedStars % 1 === 0) {
                                                            setAttributes({
                                                                selectedStars: i + (selectedStars - 1 === i ? 0.5 : 1)
                                                            });
                                                        } else {
                                                            setAttributes({
                                                                selectedStars: i + (selectedStars - 0.5 === i ? 1 : 0.5)
                                                            });
                                                        }
                                                    }}
                                                >
                                                    {i < (highlightedStars ? highlightedStars : selectedStars) ? (
                                                        highlightedStars ? (
                                                            highlightedStars - 1 === i ? (
                                                                selectedStars % 1 > 0 ? (
                                                                    highlightedStars - selectedStars - 0.5 !== 0 ? (
                                                                        <HalfStar fillColor={ratingsColor} />
                                                                    ) : (
                                                                        <FullStar fillColor={ratingsColor} />
                                                                    )
                                                                ) : highlightedStars - selectedStars !== 0 ? (
                                                                    <FullStar fillColor={ratingsColor} />
                                                                ) : (
                                                                    <HalfStar fillColor={ratingsColor} />
                                                                )
                                                            ) : (
                                                                <FullStar fillColor={ratingsColor} />
                                                            )
                                                        ) : selectedStars - i >= 1 ? (
                                                            <FullStar fillColor={ratingsColor} />
                                                        ) : (
                                                            <HalfStar fillColor={ratingsColor} />
                                                        )
                                                    ) : (
                                                        <EmptyStar fillColor={ratingsColor} />
                                                    )}
                                                </div>
                                            ))}
                                        </div>
                                    }

                                    { showContent && showContent == true &&
                                        <RichText                                    
                                            value={couponContent}
                                            className="affiliate-coupon-content"
                                            placeholder={__('Content')}
                                            onChange={couponContent => setAttributes({ couponContent })}
                                            keepPlaceholderOnFocus
                                        />
                                    }

                                    <div className={`footerpricebox`}>

                                        { showPrice && showPrice == true &&
                                          <div className={`affiliate-priceBox`}>
                                            <RichText
                                                tagName={Tag2}
                                                value={priceBox1}
                                                className="affiliate-coupon-priceBox1"
                                                placeholder={__('$24.99/m')}
                                                onChange={priceBox1 => setAttributes({ priceBox1 })}
                                                keepPlaceholderOnFocus
                                            />
                                            <RichText
                                                tagName={Tag2}
                                                value={priceBox2}
                                                className="affiliate-coupon-priceBox2"
                                                placeholder={__('$16.66/m')}
                                                onChange={priceBox2 => setAttributes({ priceBox2 })}
                                                keepPlaceholderOnFocus
                                            />
                                            <RichText
                                                tagName={Tag2}
                                                value={priceBox3}
                                                className="affiliate-coupon-priceBox3"
                                                placeholder={__('Save $75/year')}
                                                onChange={priceBox3 => setAttributes({ priceBox3 })}
                                                keepPlaceholderOnFocus
                                            />
                                        </div>
                                    }

                                        { showButton && showButton == true &&
                                            <div className={`affiliate-coupon-btn`}>
                                                <div className={`affiliate-coupon-btn-wrapper`}  onClick={() => { this.setState({ isVisible: !isVisible })}}>
                                                    <span className={`affiliate-btn  btn-is-${btnSize} ${
                                                              buttonWidth === "full" ? "btn-is-fullw" : buttonWidth === "flex" ? `btn-is-flex-${btnSize}` : "" } ${bntRounded ? 'btn-is-rounded' : ''}   ${enableGlimmerEffect ? 'glimmer-effect' : ''}`}>
                                                        { iconPosition && iconPosition == 'af-icon-is-left' &&
                                                              <i className={`affiliate-abbtn-icon ${buttonIcon} ${iconPosition}`}></i>
                                                        }
                                                        { iconPosition && iconPosition != 'af-icon-is-left' &&
                                                          <i className={`affiliate-abbtn-icon af-icon-is-left`}></i>
                                                        }
                                                        <RichText
                                                            value={spBtnText}
                                                            placeholder={__('Button text')}
                                                            onChange={spBtnText => setAttributes({ spBtnText })}
                                                            formattingControls={ ['bold', 'italic', 'underline'] }
                                                            href = {btn_Htarget}
                                                            {...(btn_Htarget ? {...btn_Htarget && { rel: newrel }} : { rel: newrel }  )}
                                                            {...(btn_Htarget ? { target: '_blank' } : '' )}
                                                        />
                                                        { iconPosition && iconPosition == 'af-icon-is-right' &&
                                                              <i className={`affiliate-abbtn-icon ${buttonIcon} ${iconPosition}`}></i>
                                                        }
                                                        { iconPosition && iconPosition != 'af-icon-is-right' &&
                                                          <i className={`affiliate-abbtn-icon af-icon-is-right`}></i>
                                                        }
                                                    </span>    
                                                </div>
                                            </div>
                                        }
                                        
                                    </div> 
                                </div>
                                
                                    
                                
                            </div>
                        
                        </div>
                    </div>
                </div>
                {loadtitleGoogleFonts}
                {loadlistGoogleFonts}
                {load2listGoogleFonts}
                {loadActualPriceGoogleFonts}
                {loadDiscountPriceGoogleFonts}
                {loadSavingPriceGoogleFonts}
                {loadbtnGoogleFotns}
                {loadsubTitleGoogleFonts}
                {loadprogressGoogleFonts}
            </Fragment>
        )
    }       
}

const applyWithSelect = withSelect( ( select, props ) => {
  const { getBlocks, getBlocksByClientId } = select( 'core/block-editor' );
	const innerBlocks = getBlocks( props.clientId );
    return {
      innerBlocks,
      hasInnerBlocks: select( 'core/block-editor' ).getBlocks( props.clientId ).length > 1,
    }
} );
export default compose( withNotices, applyWithSelect )( Edit );