import IconSelector from '../../components/fields/IconSelector/IconSelector.js';
import RadioAdvanced from '../../components/fields/RadioAdvanced.js';
import TypographyControl from '../components/typography/index.js';
import WebfontLoader from "../components/typography/fontloader"
import Alignment from '../../components/fields/Alignment.js';
import Color  from '../../components/fields/Color/Color.js';
import Dimension  from '../../components/fields/Dimension/Dimension.js';
import affiliate_styling  from './styling.js';
import Background  from './../../components/fields/Background/Background.js';
import IconList  from './../../components/fields/IconList/IconList.js';
import BorderTypes  from './../../components/fields/BorderTypes.js';
import Tabs from '../../components/fields/Tabs/Tabs.js';
import Tab from '../../components/fields/Tab/Tab.js';
import Url from '../../components/fields/Url/Url.js';
import getIcon from '../../icons/get-icon';

const { __ } = wp.i18n;
const {
    InspectorControls,
    BlockControls,
    RichText,
    InnerBlocks
} = wp.blockEditor;

const {
    Component,
    Fragment
} = wp.element;

const {
    PanelBody,
    Toolbar,
    Tooltip,
    TextControl,
    ToggleControl,
    TabPanel,
    Dashicon,
    Dropdown,
    Button,
    
} = wp.components;

class Edit extends Component {

    constructor(props) {
        super(props)
    }
    
    componentDidMount() {
        this.props.setAttributes({ block_id: this.props.clientId })
        const $style = document.createElement("style")
        $style.setAttribute("id", "affiliate-style-" + this.props.clientId)
        document.head.appendChild($style)
    
    }

    render() {
        const {
            name,
            clientId,
            isSelected,
            attributes,
            setAttributes,
            attributes: {
                block_id,
                btnTitle,
                btnTarget,
                titleLoadGoogleFonts,
                titleTextColor,
                titlefontFamily,
                titlefontWeight,
                titlefontSubset,
                titlefontSizeType,
                titlefontSizeTypeMobile,
                titlefontSizeTypeTablet,
                titlefontSizeDesktop,
                titlefontSizeMobile,
                titlefontSizeTablet,
                titlelineHeight,
                titlelineHeightMobile,
                titlelineHeightTablet,
                titleletterSpacing,
                titleletterSpacingMobile,
                titleletterSpacingTablet,
                titleletterSpacingType,
                titleletterSpacingTypeTablet,
                titleletterSpacingTypeMobile,
                titletextTransform,
                titletextDecoration,
                titlefontStyle,
                titlePadding,
                titlePaddingMobile,
                titlePaddingTablet,
                titleMargin,
                titleMarginMobile,
                titleMarginTablet,
                titleAlignment,
                titleAlignmentMobile,
                titleAlignmentTablet,
                titleBorder,
                titleBorderType,
                titleBorderMobile,
                titleBorderTablet,
                titleBorderRadius,
                titleBorderRadiusMobile,
                titleBorderRadiusTablet,
                titleBorderColor,
                btnBgColor,
                btnBgHoverColor,
                titleBorderHoverColor,
                titleTextHoverColor,
                btnHref,
                btn_Htarget,
                btnSize,
                buttonIcon,
                iconPosition,
                buttonWidth,
                bntRounded,
                bgColor
              }
        } = this.props;
        
        var element = document.getElementById("affiliate-style-" + this.props.clientId)
        if (null != element && "undefined" != typeof element) {
             element.innerHTML = affiliate_styling(this.props, "affiliate-style")
        }
        
        let loadtitleGoogleFonts
        let loadcntnGoogleFonts
   
        if( titleLoadGoogleFonts == true ) {
            
        const titleconfig = {
          google: {
            families: [ titlefontFamily + ( titlefontWeight ? ":" + titlefontWeight : "" ) ],
          },
        }

			loadtitleGoogleFonts = (
				<WebfontLoader config={ titleconfig }>
				</WebfontLoader>
			)
		} 
        return (
            <Fragment>
                <InspectorControls key="inspector">

                <PanelBody title={`General Settings`} initialOpen={false}  icon={ getIcon( 'documentation' ) } className={ 'abblocks-panel-label' }>
                  <BorderTypes label={__('Border Type')} value={titleBorderType} onChange={(value) => setAttributes({ titleBorderType: value })} />
                <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                  activeClass="active-tab"
                  tabs={[
                    {
                      name: 'boxdesk',
                      title: <Dashicon icon="desktop" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxtablet',
                      title: <Dashicon icon="tablet" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxmobile',
                      title: <Dashicon icon="smartphone" />,
                      className: 'affiliate-responsive-tabs',
                    },
                  ]}>
                  {
                    (radiustab) => {
                      let tabout;
                      if (radiustab.name) {
                        if ('boxmobile' === radiustab.name) {
                          tabout = (
                            <Dimension
                              label={__('Border')} value={titleBorderMobile}
                              onChange={val => setAttributes({ titleBorderMobile: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        } else if ('boxtablet' === radiustab.name) {
                          tabout = (
                            <Dimension label={__('Border')} 
                              value={titleBorderTablet}
                              onChange={val => setAttributes({ titleBorderTablet: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        } else {
                          tabout = (
                            <Dimension
                              label={__('Border')} value={titleBorder}
                              onChange={val => setAttributes({ titleBorder: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        }
                      }
                      return <div>{tabout}</div>;
                    }
                  }
                </TabPanel>
                <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                  activeClass="active-tab"
                  tabs={[
                    {
                      name: 'boxdesk',
                      title: <Dashicon icon="desktop" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxtablet',
                      title: <Dashicon icon="tablet" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxmobile',
                      title: <Dashicon icon="smartphone" />,
                      className: 'affiliate-responsive-tabs',
                    },
                  ]}>
                  {
                    (radiustab) => {
                      let tabout;
                      if (radiustab.name) {
                        if ('boxmobile' === radiustab.name) {
                          tabout = (
                            <Dimension
                              label={__('Border Radius')} value={titleBorderRadiusMobile}
                              onChange={val => setAttributes({ titleBorderRadiusMobile: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        } else if ('boxtablet' === radiustab.name) {
                          tabout = (
                            <Dimension label={__('Border Radius')} 
                              value={titleBorderRadiusTablet}
                              onChange={val => setAttributes({ titleBorderRadiusTablet: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        } else {
                          tabout = (
                            <Dimension
                              label={__('Border Radius')} value={titleBorderRadius}
                              onChange={val => setAttributes({ titleBorderRadius: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        }
                      }
                      return <div>{tabout}</div>;
                    }
                  }
                </TabPanel>
                </PanelBody>

             

                <PanelBody title={ __( 'Colors' ) } initialOpen={false}  icon={ getIcon( 'colors' ) } className={ 'abblocks-panel-label' }>
                  <Color label={__('Background Color')} disableAlpha value={bgColor} onChange={val => setAttributes({ bgColor: val })} /> 
                  <Color label={__('Border Color')} disableAlpha value={titleBorderColor} onChange={val => setAttributes({ titleBorderColor: val })} /> 
                </PanelBody>

                <PanelBody title={`Spacing`} icon={ getIcon( 'spacing' ) } className={ 'abblocks-panel-label' } initialOpen={false}>
                  <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                  activeClass="active-tab"
                  tabs={[
                    {
                      name: 'boxdesk',
                      title: <Dashicon icon="desktop" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxtablet',
                      title: <Dashicon icon="tablet" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxmobile',
                      title: <Dashicon icon="smartphone" />,
                      className: 'affiliate-responsive-tabs',
                    },
                  ]}>
                  {
                    (radiustab) => {
                      let tabout;
                      if (radiustab.name) {
                        if ('boxmobile' === radiustab.name) {
                          tabout = (
                            <Dimension
                              label={__('Padding')} value={titlePaddingMobile}
                              onChange={val => setAttributes({ titlePaddingMobile: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        } else if ('boxtablet' === radiustab.name) {
                          tabout = (
                            <Dimension label={__('Padding')} value={titlePaddingTablet}
                              onChange={val => setAttributes({ titlePaddingTablet: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        } else {
                          tabout = (
                            <Dimension
                              label={__('Padding')} value={titlePadding}
                              onChange={val => setAttributes({ titlePadding: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        }
                      }
                      return <div>{tabout}</div>;
                    }
                  }
                </TabPanel>
                <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                  activeClass="active-tab"
                  tabs={[
                    {
                      name: 'boxdesk',
                      title: <Dashicon icon="desktop" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxtablet',
                      title: <Dashicon icon="tablet" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxmobile',
                      title: <Dashicon icon="smartphone" />,
                      className: 'affiliate-responsive-tabs',
                    },
                  ]}>
                  {
                    (radiustab) => {
                      let tabout;
                      if (radiustab.name) {
                        if ('boxmobile' === radiustab.name) {
                          tabout = (
                            <Dimension
                              label={__('Margin')}
                              value={titleMarginMobile}
                              onChange={val => setAttributes({ titleMarginMobile: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        } else if ('boxtablet' === radiustab.name) {
                          tabout = (
                            <Dimension label={__('Margin')} value={titleMarginTablet}
                              onChange={val => setAttributes({ titleMarginMobile: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        } else {
                          tabout = (
                            <Dimension
                              label={__('Margin')} value={titleMargin}
                              onChange={val => setAttributes({ titleMargin: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        }
                      }
                      return <div>{tabout}</div>;
                    }
                  }
                </TabPanel>
                </PanelBody>

                   
                </InspectorControls>
                  <div id={`affiliate-style-${block_id}`} className={"affiliate-dynamic-wrapper"}>
                      <div className={`affiliate-dynamic-inner`}>
                        <InnerBlocks/>
                      </div>
                  </div>
            </Fragment>
        )
    }       
}

export default (Edit);