import TypographyControl from '../components/typography/index.js';
import WebfontLoader from "../components/typography/fontloader"
import Color  from '../../components/fields/Color/Color.js';
import affiliate_styling  from './styling.js';
import BorderTypes from '../../components/fields/BorderTypes.js';
import IconList from '../../components/fields/IconList/IconList.js';
import Media  from '../../components/fields/Media/Media.js';
import Dimension from '../../components/fields/Dimension/Dimension.js';
import Alignment from '../../components/fields/Alignment.js';
import Tabs from '../../components/fields/Tabs/Tabs.js';
import Tab from '../../components/fields/Tab/Tab.js';
import Select  from './../../components/fields/Select/Select.js';
import Background  from './../../components/fields/Background/Background.js';
import RadioAdvanced from '../../components/fields/RadioAdvanced.js';
import Range from '../../components/fields/Range/Range.js';
import BoxShadow from "../../components/fields/BoxShadow"
import attributes from './attributes';
import icons from '../../icons/icons';
import times from 'lodash/times';
import memoize from 'memize';
import { keyboardReturn } from '@wordpress/icons';
import { EmptyStar, FullStar, HalfStar } from "./icons";
import getIcon from '../../icons/get-icon';

import './editor.scss';
import './style.scss';
const { __ } = wp.i18n; 
const { registerBlockType } = wp.blocks; 
const { Component, Fragment } = wp.element;

const { withSelect, withDispatch } = wp.data
const { compose } = wp.compose

const getPanesTemplate = memoize( ( panes ) => {
    return '';
} );

const { 	
	InspectorControls,    
	AlignmentToolbar,
	BlockControls,
	PanelColorSettings,
	MediaUpload,
	RichText,
	URLInput,
	InnerBlocks,
	URLPopover,
	__experimentalLinkControl
} = wp.blockEditor;
// Register components
const {	    
	Button,
	PanelBody,
	IconButton,
	SelectControl,
	PanelRow,
	RangeControl,
	ToggleControl,
	TextControl,
	TextareaControl,
	Dashicon,
	Tooltip,
	Dropdown,
	Popover,
	TabPanel,
	ToolbarButton,
	ToolbarGroup
} = wp.components;

const NEW_TAB_REL = 'noopener noreferrer';
class Edit extends Component {
	constructor() {
	  super(...arguments);      

		this.onClickLinkSettings = this.onClickLinkSettings.bind(this)
		this.onChangeOpensInNewTab = this.onChangeOpensInNewTab.bind(this)
		this.state = { isURLPickerOpen : false,highlightedStars : 0, isVisible:false }
		this.state = { selectedBox : null, content:0,content1:0 }
		this.getSlug     = this.getSlug.bind(this)		
		this.onSelectImage    = this.onSelectImage.bind( this )
    }
    
	componentDidMount() {
	  const { attributes, setAttributes, clientId } = this.props;
	  if (!attributes.idtbl) {
		setAttributes({ idtbl: "fdtable-" + clientId });
	  } 
	  
	  this.props.setAttributes({ block_id: this.props.clientId })
        const $style = document.createElement("style")
        $style.setAttribute("id", "affiliate-style-" + this.props.clientId)
        document.head.appendChild($style)
	}

	getSlug( title ) {
      return title.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-");
    }

    /*
      * Event to set Image as while adding.
      */
     onSelectImage( media ) {
      // console.log(this.props)  
      const { schemaImage } = this.props.attributes
      const { setAttributes } = this.props

      if ( ! media || ! media.url ) {
        setAttributes( { schemaImage: {} } )
        return
      }

      if ( ! media.type || "image" !== media.type ) {
        setAttributes( { schemaImage: {} } )
        return
      }
      // if ( media["sizes"] ) {
      //   var new_img = this.getImageSize(media["sizes"])
      //     imageSizeOptions = new_img
      // }
      setAttributes( { schemaImage: media } )
    }

    /*
    * Event to set Image as null while removing.
    */
    onRemoveImage() {
      const { schemaImage } = this.props.attributes
      const { setAttributes } = this.props

      setAttributes( { schemaImage: null } )
    }

    removeImage( url ){
      const { multiple, onChangem,setAttributes } = this.props
      const { schemaImage } = this.props.attributes
        setAttributes( { schemaImage: {} } )

    }

	onClickLinkSettings (value,index) {
		
		const { attributes, setAttributes } = this.props
		const { target } = attributes 
		if ( "_self" === target ) {
			setAttributes( { opensInNewTab: false } )
		} else if ( "_blank" === target ) {
			setAttributes( { opensInNewTab: true } )
		}

		this.setState( {
			isURLPickerOpen: true
		}) 
	}

	onChangeOpensInNewTab ( value ) {
		if ( true === value ) {
			this.props.setAttributes( { target: '_blank' } )
		} else {
			this.props.setAttributes( { target: '_self' } )
		}
	}

	render() {
		const { idtbl } = this.props.attributes;
		const { isSelected ,realPaneCount, abcompareBlocks,setAttributes, clientId } = this.props;
		const { highlightedStars, attributes: { 	

			block_id,
		    boxShadow,
		    boxBgColor,

		    boxBorderType,
            boxBorderColor,
            boxBorderWidth,

		    // Title settings
		    titleInsideOutside,
		    titleLoadGoogleFonts,
		    titleBgColor,
		    titleTextColor,
		    titlefontFamily,
		    titlefontWeight,
		    titlefontSubset,
		    titlefontSizeType,
		    titlefontSizeTypeMobile,
		    titlefontSizeTypeTablet,
		    titlefontSizeDesktop,
		    titlefontSizeMobile,
		    titlefontSizeTablet,
		    titlelineHeight,
		    titlelineHeightMobile,
		    titlelineHeightTablet,
		    titleletterSpacing,
		    titleletterSpacingMobile,
		    titleletterSpacingTablet,
		    titleletterSpacingType,
		    titleletterSpacingTypeTablet,
		    titleletterSpacingTypeMobile,
		    titletextTransform,
		    titletextDecoration,
		    titlefontStyle,
		    titleTag,
		    titleText, 
		    titleShow,
		    subTitleTag,
		    
		    // Key Points 
		    keypoints,

		    // Key Points Label
		    kpLabelText,
		    kpLabelLoadGoogleFonts,
		    kpLabelColor,
		    kpLabelfontFamily,
		    kpLabelfontWeight,
		    kpLabelfontSubset,
		    kpLabelfontSizeType,
		    kpLabelfontSizeTypeMobile,
		    kpLabelfontSizeTypeTablet,
		    kpLabelfontSizeDesktop,
		    kpLabelfontSizeMobile,
		    kpLabelfontSizeTablet,
		    kpLabellineHeight,
		    kpLabellineHeightMobile,
		    kpLabellineHeightTablet,
		    kpLabelletterSpacing,
		    kpLabelletterSpacingMobile,
		    kpLabelletterSpacingTablet,
		    kpLabelletterSpacingType,
		    kpLabelletterSpacingTypeTablet,
		    kpLabelletterSpacingTypeMobile,
		    kpLabeltextTransform,
		    kpLabeltextDecoration,
		    kpLabelfontStyle,     
		    kpLabelAlignment,
		    kpLabelAlignmentMobile,
		    kpLabelAlignmentTablet,    
		    
		    // Key Points Content
		    kpContentText, 
		    kpContentLoadGoogleFonts,
		    kpContentColor,
		    kpContentfontFamily,
		    kpContentfontWeight,
		    kpContentfontSubset,
		    kpContentfontSizeType,
		    kpContentfontSizeTypeMobile,
		    kpContentfontSizeTypeTablet,
		    kpContentfontSizeDesktop,
		    kpContentfontSizeMobile,
		    kpContentfontSizeTablet,
		    kpContentlineHeight,
		    kpContentlineHeightMobile,
		    kpContentlineHeightTablet,
		    kpContentletterSpacing,
		    kpContentletterSpacingMobile,
		    kpContentletterSpacingTablet,
		    kpContentletterSpacingType,
		    kpContentletterSpacingTypeTablet,
		    kpContentletterSpacingTypeMobile,
		    kpContenttextTransform,
		    kpContenttextDecoration,
		    kpContentfontStyle, 
		    kpContentAlignment,
		    kpContentAlignmentMobile,
		    kpContentAlignmentTablet,
			
			//Star rating
			starRatingShow,
			starRatingCount,
		    starRatingColor,
		    starRatingSelectedStars,
		    starRatingSize,
		    starRatingSizeMobile,
		    starRatingSizeTablet,

		    //Btn 
		    btnShow,
		    btnText,
            btnHref,
            btnRel,
            btnLoadGoogleFonts,
            btnfontFamily,
            btnfontWeight,
            btnfontSubset,
            btnfontSizeType,
            btnfontSizeTypeMobile,
            btnfontSizeTypeTablet,
            btnfontSizeDesktop,
            btnfontSizeMobile,
            btnfontSizeTablet,
            btnlineHeight,
            btnlineHeightMobile,
            btnlineHeightTablet,
            btnletterSpacing,
            btnletterSpacingMobile,
            btnletterSpacingTablet,
            btnletterSpacingType,
            btnletterSpacingTypeTablet,
            btnletterSpacingTypeMobile,
            btntextTransform,
            btntextDecoration,
            btnfontStyle,
            btnBgColor,
            btnHoverBgColor,
            btnTextColor,
            btnTextHoverColor,
            btnBorderColor,
            btnBorderHoverColor,
            btn_Htarget,            
            btnPadding,
            btnPaddingMobile,
            btnPaddingTablet,
            btnMargin,
            btnMarginMobile,
            btnMarginTablet,
            btnAlignment,
            btnAlignmentMobile,
            btnAlignmentTablet,
            btnBorder,
            btnBorderType,
            btnBorderMobile,
            btnBorderTablet,
            btnBorderRadius,
            btnBorderRadiusMobile,
            btnBorderRadiusTablet,
            btnIconPosition,
            bntRounded,
            btnSize,
            btnWidth,
            btnIcon,


            //Extra Content
            showExtraContent,
            extraContentText,
            extraContentLoadGoogleFonts, 
				    extraContentTextColor,
				    extraContentfontFamily,
				    extraContentfontWeight,
				    extraContentfontSubset,
				    extraContentfontSizeType,
				    extraContentfontSizeTypeMobile,
				    extraContentfontSizeTypeTablet,
				    extraContentfontSizeDesktop,
				    extraContentfontSizeMobile,
				    extraContentfontSizeTablet,
				    extraContentlineHeight,
				    extraContentlineHeightMobile,
				    extraContentlineHeightTablet,
				    extraContentletterSpacing,
				    extraContentletterSpacingMobile,
				    extraContentletterSpacingTablet,
				    extraContentletterSpacingType,
				    extraContentletterSpacingTypeTablet,
				    extraContentletterSpacingTypeMobile,
				    extraContenttextTransform,
				    extraContenttextDecoration,
				    extraContentfontStyle,

				    enableGlimmerEffect,

				    btnBg,
            btnBgHover,

            enableSchema,
            schemaType,
            schemaSubType,
            schemaTitle,
            schemaDescription,
            schemaRating, 
            schemaApplicationCategory,
            schemaOperatingSystem,
            schemaOffer,
            schemaOfferPrice, 
            schemaOfferPriceCurrency, 
            schemaBrand,
            schemaSku,
            schemaIdentifierType,
            schemaIdentifier,
            schemaImage,
            schemaAuthor,

		} } = this.props;
		const { isVisible } = this.state

		// console.log(keypoints)
		const handletr = () => {			
            const keypoints = [ ...this.props.attributes.keypoints ];
			keypoints.push( {				
				label: 'Title',
				content: 'Content',				
			} );			
            this.props.setAttributes( { keypoints } );           
		};
		const handleRemovetr = ( index ) => {		
			const keypoints = [ ...this.props.attributes.keypoints ];			
			keypoints.splice( index, 1 );
			this.props.setAttributes( { keypoints } );
		};	

		/**   title   ***/
		const thandletxtLabelChange = ( label, index ) => {			
			const keypoints = [ ...this.props.attributes.keypoints ];			
			keypoints[ index ].label = label;			
			this.props.setAttributes( { keypoints } );			
		}; 
 		
 		/**   content   ***/
 		const thandletxtContentChange = ( content, index ) => {			
			const keypoints = [ ...this.props.attributes.keypoints ];			
			keypoints[ index ].content = content;			
			this.props.setAttributes( { keypoints } );			
		}; 

		var element = document.getElementById("affiliate-style-" + this.props.clientId)
        if (null != element && "undefined" != typeof element) {
             element.innerHTML = affiliate_styling(this.props, "affiliate-style")
		} 
		
		let loadTitleGoogleFonts
        let loadKPLabelGoogleFonts		
		let loadKPContentGoogleFonts
		let loadbtnGoogleFotns
		let loadExtraContentGoogleFotns

		//Title Google Font
		if( titleLoadGoogleFonts == true ) {
			const titleConfig = {
				google: {
					families: [ titlefontFamily + ( titlefontWeight ? ":" + titlefontWeight : "" ) ],
				},
			}
			loadTitleGoogleFonts = (
				<WebfontLoader config={ titleConfig }>
				</WebfontLoader>
			)
		}
		

		// Key Points Label Google Font
		if( kpLabelLoadGoogleFonts == true ) {					
			const kplableconfig = {
				google: {
					families: [ kpLabelfontFamily + ( kpLabelfontWeight ? ":" + kpLabelfontWeight : "" ) ],
				},
			}
			loadKPLabelGoogleFonts = (
				<WebfontLoader config={ kplableconfig }>
				</WebfontLoader>
			)
		}

		// Key Points Content Google Font
		if( kpContentLoadGoogleFonts == true ) {
			const kpcontentconfig = {
				google: {
					families: [ kpContentfontFamily + ( kpContentfontWeight ? ":" + kpContentfontWeight : "" ) ],
				},
			}
			loadKPContentGoogleFonts = (
				<WebfontLoader config={ kpcontentconfig }>
				</WebfontLoader>
			)
        }

        // Key Points Button Goolge Font
        if( btnLoadGoogleFonts == true ) {					
			const btnconfig = {
				google: {
					families: [ btnfontFamily + ( btnfontWeight ? ":" + btnfontWeight : "" ) ],
				},
			}
			loadbtnGoogleFotns = (
				<WebfontLoader config={ btnconfig }>
				</WebfontLoader>
			)
        }


        // Key Points Extra Content Goolge Font
        if( extraContentLoadGoogleFonts == true ) {					
			const extracontentconfig = {
				google: {
					families: [ extraContentfontFamily + ( extraContentfontWeight ? ":" + extraContentfontWeight : "" ) ],
				},
			}
			loadExtraContentGoogleFotns = (
				<WebfontLoader config={ extracontentconfig }>
				</WebfontLoader>
			)
        }

		const Tag = titleTag 
		const SubTag = subTitleTag 
		let  repetdata; 

		let newrel;
        if( !btn_Htarget){
            newrel = btnRel
        } else  if( !btn_Htarget && btnRel === NEW_TAB_REL){
            newrel = btnRel
        } else if ( btn_Htarget && !btnRel ) {
        	newrel = NEW_TAB_REL
        } else {
          	newrel = NEW_TAB_REL + ' ' + btnRel
        }

		if ( this.props.attributes.keypoints.length ) {
			
			repetdata = this.props.attributes.keypoints.map( ( location, index )  => {

				return <li key={ index }>				
						
						<div className="affiliate-keypoints-row">
							<Fragment>
								<div className={`affiliate-keypoints-label`}> 
									<RichText 
										tagName={SubTag}
										label = { __( 'Add Title' ) }
										placeholder = { __("Title")}
										className={`label`}
										value = { this.props.attributes.keypoints[ index ].label }
										onChange = { ( label ) => thandletxtLabelChange( label, index ) }
										keepPlaceholderOnFocus										
									/>
								</div>
							</Fragment>

							<Fragment>
								<div className={`affiliate-keypoints-content`}> 
			                        <RichText  
										label = { __( 'Add Content' ) }
										placeholder = { __("Content")}
										className={`content`}
										value = { this.props.attributes.keypoints[ index ].content }
										onChange = { ( content ) => thandletxtContentChange( content, index ) }
										keepPlaceholderOnFocus										
									/>
		                        </div>	
	                        </Fragment>						
						</div>
													
						<div className={`remove-row`}>
							<IconButton						
								className = "remove-row-btn"
								icon = "no-alt"
								label = "Delete row"
								onClick = { () => handleRemovetr( index ) }
							/>	
						</div>
				</li>;				
			} );
		}

		return [		
		<Fragment>
		<InspectorControls key="inspector"> 
			
			<PanelBody title={`General Settings`} initialOpen={false}  icon={ getIcon( 'documentation' ) } className={ 'abblocks-panel-label' }>

				<ToggleControl
                    label={ __( 'Show Title' ) }                        
                    checked={ titleShow }                                      
                    onChange={ ( ) => setAttributes( { titleShow: ! titleShow } ) }
                />

                <ToggleControl
                    label={ __( 'Title In Box' ) }                        
                    checked={ titleInsideOutside }                                      
                    onChange={ ( ) => setAttributes( { titleInsideOutside: ! titleInsideOutside } ) }
                />

                <ToggleControl
                    label={ __( 'Show Rating Box' ) }                        
                    checked={ starRatingShow }                                      
                    onChange={ ( ) => setAttributes( { starRatingShow: ! starRatingShow } ) }
                />    

                <ToggleControl
                    label={ __( 'Show Content Below Button' ) }                        
                    checked={ showExtraContent }                                      
                    onChange={ ( ) => setAttributes( { showExtraContent: ! showExtraContent } ) }
                />      

                <ToggleControl
                    label={ __( 'Show Schema' ) }                        
                    checked={ enableSchema }                                      
                    onChange={ ( ) => setAttributes( { enableSchema: ! enableSchema } ) }
                />      

                { /*<BoxShadow label={__('Box-Shadow')} value={boxShadow} onChange={(value) => setAttributes({ boxShadow: value })} />*/}

                <BorderTypes label={__('Border Type')} value={boxBorderType} onChange={(value) => setAttributes({ boxBorderType: value })} />

              	<Dimension
                	label={__('Border Width')}
                	value={boxBorderWidth}
                	onChange={val => setAttributes({ boxBorderWidth: val })}
                	min={0}
                	max={600}
                	unit={['px','em','rem','%']}
                	clientId={this.props.clientId}
              	/>	


              	<RangeControl
                    label={__("Number of stars")}
                    value={starRatingCount}
                    onChange={value =>
                        setAttributes({
                            starRatingCount: value,
                            starRatingSelectedStars: value < starRatingSelectedStars ? value : starRatingSelectedStars
                        })
                    }
                    min={5}
                    step={1}
                    max={10} 
                    allowReset
                />

                <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                    activeClass="active-tab"
                    tabs={[
                      {
                        name: 'boxdesk',
                        title: <Dashicon icon="desktop" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxtablet',
                        title: <Dashicon icon="tablet" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxmobile',
                        title: <Dashicon icon="smartphone" />,
                        className: 'affiliate-responsive-tabs',
                      },
                    ]}>
                    {
                      (radiustab) => {
                        let tabout;
                        if (radiustab.name) {
                          if ('boxmobile' === radiustab.name) {
                            tabout = (
                                <Range
                                    label={__('Stars Size')}
                                    value={starRatingSizeMobile} 
                                    onChange={(value) => setAttributes({ starRatingSizeMobile: value })}
                                    unit={[]}
                                    min={10}
                                    step={1}
                                    max={60}
                                />
                            );
                          } else if ('boxtablet' === radiustab.name) {
                            tabout = (
                                <Range
                                    label={__('Stars Size')}
                                    value={starRatingSizeTablet} 
                                    onChange={(value) => setAttributes({ starRatingSizeTablet: value })}
                                    unit={[]}
                                    min={10}
                                    step={1}
                                    max={60}
                                />
                            );
                          } else {
                            tabout = (
                                <Range
                                    label={__('Stars Size')}
                                    value={starRatingSize} 
                                    onChange={(value) => setAttributes({ starRatingSize: value })}
                                    unit={[]}
                                    min={10}
                                    step={1}
                                    max={60}
                                />
                            );
                          }
                        }
                        return <div>{tabout}</div>;
                      }
                    }
                </TabPanel>

			</PanelBody>	

			<PanelBody title={ __( 'Typography' ) } initialOpen={false}  icon={ getIcon( 'typography' ) } className={ 'abblocks-panel-label' }>
				
				<SelectControl
					label={ __( 'Title Heading Tag' ) }
					value={ titleTag }
					options= {[
							{ value: 'h2', label: 'Heading 2 (h2)' },
	                        { value: 'h3', label: 'Heading 3 (h3)' },
	                        { value: 'h4', label: 'Heading 4 (h4)' },
	                        { value: 'h5', label: 'Heading 5 (h5)' },
	                        { value: 'h6', label: 'Heading 6 (h6)' },
	                        { value: 'p', label: 'Paragraph (p)' },
						]}
						onChange={ ( value ) => setAttributes( { titleTag: value } ) }
				/>

				<SelectControl
					label={ __( 'Sub Title Heading Tag' ) }
					value={ subTitleTag }
					options= {[
							{ value: 'h2', label: 'Heading 2 (h2)' },
	                        { value: 'h3', label: 'Heading 3 (h3)' },
	                        { value: 'h4', label: 'Heading 4 (h4)' },
	                        { value: 'h5', label: 'Heading 5 (h5)' },
	                        { value: 'h6', label: 'Heading 6 (h6)' },
	                        { value: 'p', label: 'Paragraph (p)' },
						]}
						onChange={ ( value ) => setAttributes( { subTitleTag: value } ) }
				/>

				<TypographyControl
	                label={__("Title Typography")}
	                attributes={attributes}
	                setAttributes={setAttributes}
	                loadGoogleFonts={{ value:titleLoadGoogleFonts, label: __("titleLoadGoogleFonts") }}
	                fontFamily={{ value: titlefontFamily, label: __("titlefontFamily") }}
	                fontWeight={{ value: titlefontWeight, label: __("titlefontWeight") }}
	                fontSubset={{ value: titlefontSubset, label: __("titlefontSubset") }}
	                fontSizeType={{ value: titlefontSizeType, label: __("titlefontSizeType") }}
	                fontSizeTypeMobile={{ value: titlefontSizeTypeMobile, label: __("titlefontSizeTypeMobile") }}
	                fontSizeTypeTablet={{ value: titlefontSizeTypeTablet, label: __("titlefontSizeTypeTablet") }}
	                fontSize={{ value: titlefontSizeDesktop, label: __("titlefontSizeDesktop") }}
	                fontSizeMobile={{ value: titlefontSizeMobile, label: __("titlefontSizeMobile") }}
	                fontSizeTablet={{ value: titlefontSizeTablet, label: __("titlefontSizeTablet") }}
	                lineHeightType={{ value: '', label: __(" ") }}
	                lineHeight={{ value: titlelineHeight, label: __("titlelineHeight") }}
	                lineHeightMobile={{ value: titlelineHeightMobile, label: __("titlelineHeightMobile") }}
	                lineHeightTablet={{ value: titlelineHeightTablet, label: __("titlelineHeightTablet") }}
	                letterSpacing={{ value: titleletterSpacing, label: __("titleletterSpacing") }}
	                letterSpacingMobile={{ value: titleletterSpacingMobile, label: __("titleletterSpacingMobile") }}
	                letterSpacingTablet={{ value: titleletterSpacingTablet, label: __("titleletterSpacingTablet") }}
	                letterSpacingType={{ value: titleletterSpacingType, label: __("titleletterSpacingType") }}
	                letterSpacingTypeTablet={{ value: titleletterSpacingTypeTablet, label: __("titleletterSpacingTypeTablet") }}
	                letterSpacingTypeMobile={{ value: titleletterSpacingTypeMobile, label: __("titleletterSpacingTypeMobile") }}
	                textTransform={titletextTransform}
	                onTextTransform={(value) => setAttributes({ titletextTransform: value })}
	                textDecoration={titletextDecoration}
	                onTextDecoration={(value) => setAttributes({ titletextDecoration: value })}
	                fontStyle={titlefontStyle}
	                onFontStyle={(value) => setAttributes({ titlefontStyle: value })}
	            />

	            <TypographyControl
					label={__("Label Typography")}
					attributes={attributes}
					setAttributes={setAttributes}
					loadGoogleFonts={{ value:kpLabelLoadGoogleFonts, label: __("kpLabelLoadGoogleFonts") }}
					fontFamily={{ value: kpLabelfontFamily, label: __("kpLabelfontFamily") }}
					fontWeight={{ value: kpLabelfontWeight, label: __("kpLabelfontWeight") }}
					fontSubset={{ value: kpLabelfontSubset, label: __("kpLabelfontSubset") }}
					fontSizeType={{ value: kpLabelfontSizeType, label: __("kpLabelfontSizeType") }}
					fontSizeTypeMobile={{ value: kpLabelfontSizeTypeMobile, label: __("kpLabelfontSizeTypeMobile") }}
					fontSizeTypeTablet={{ value: kpLabelfontSizeTypeTablet, label: __("kpLabelfontSizeTypeTablet") }}
					fontSize={{ value: kpLabelfontSizeDesktop, label: __("kpLabelfontSizeDesktop") }}
					fontSizeMobile={{ value: kpLabelfontSizeMobile, label: __("kpLabelfontSizeMobile") }}
					fontSizeTablet={{ value: kpLabelfontSizeTablet, label: __("kpLabelfontSizeTablet") }}
					lineHeightType={{ value: '', label: __(" ") }}
					lineHeight={{ value: kpLabellineHeight, label: __("kpLabellineHeight") }}
					lineHeightMobile={{ value: kpLabellineHeightMobile, label: __("kpLabellineHeightMobile") }}
					lineHeightTablet={{ value: kpLabellineHeightTablet, label: __("kpLabellineHeightTablet") }}
					letterSpacing={{ value: kpLabelletterSpacing, label: __("kpLabelletterSpacing") }}
					letterSpacingMobile={{ value: kpLabelletterSpacingMobile, label: __("kpLabelletterSpacingMobile") }}
					letterSpacingTablet={{ value: kpLabelletterSpacingTablet, label: __("kpLabelletterSpacingTablet") }}
					letterSpacingType={{ value: kpLabelletterSpacingType, label: __("kpLabelletterSpacingType") }}
					letterSpacingTypeTablet={{ value: kpLabelletterSpacingTypeTablet, label: __("kpLabelletterSpacingTypeTablet") }}
					letterSpacingTypeMobile={{ value: kpLabelletterSpacingTypeMobile, label: __("kpLabelletterSpacingTypeMobile") }}
					textTransform={kpLabeltextTransform}
					onTextTransform={(value) => setAttributes({ kpLabeltextTransform: value })}
					textDecoration={kpLabeltextDecoration}
					onTextDecoration={(value) => setAttributes({ kpLabeltextDecoration: value })}
					fontStyle={kpLabelfontStyle}
					onFontStyle={(value) => setAttributes({ kpLabelfontStyle: value })}
				/>
           
				<TypographyControl
					label={__("Content Typography")}
					attributes={attributes}
					setAttributes={setAttributes}
					loadGoogleFonts={{ value:kpContentLoadGoogleFonts, label: __("kpContentLoadGoogleFonts") }}
					fontFamily={{ value: kpContentfontFamily, label: __("kpContentfontFamily") }}
					fontWeight={{ value: kpContentfontWeight, label: __("kpContentfontWeight") }}
					fontSubset={{ value: kpContentfontSubset, label: __("kpContentfontSubset") }}
					fontSizeType={{ value: kpContentfontSizeType, label: __("kpContentfontSizeType") }}
					fontSizeTypeMobile={{ value: kpContentfontSizeTypeMobile, label: __("kpContentfontSizeTypeMobile") }}
					fontSizeTypeTablet={{ value: kpContentfontSizeTypeTablet, label: __("kpContentfontSizeTypeTablet") }}
					fontSize={{ value: kpContentfontSizeDesktop, label: __("kpContentfontSizeDesktop") }}
					fontSizeMobile={{ value: kpContentfontSizeMobile, label: __("kpContentfontSizeMobile") }}
					fontSizeTablet={{ value: kpContentfontSizeTablet, label: __("kpContentfontSizeTablet") }}
					lineHeightType={{ value: '', label: __(" ") }}
					lineHeight={{ value: kpContentlineHeight, label: __("kpContentlineHeight") }}
					lineHeightMobile={{ value: kpContentlineHeightMobile, label: __("kpContentlineHeightMobile") }}
					lineHeightTablet={{ value: kpContentlineHeightTablet, label: __("kpContentlineHeightTablet") }}
					letterSpacing={{ value: kpContentletterSpacing, label: __("kpContentletterSpacing") }}
					letterSpacingMobile={{ value: kpContentletterSpacingMobile, label: __("kpContentletterSpacingMobile") }}
					letterSpacingTablet={{ value: kpContentletterSpacingTablet, label: __("kpContentletterSpacingTablet") }}
					letterSpacingType={{ value: kpContentletterSpacingType, label: __("kpContentletterSpacingType") }}
					letterSpacingTypeTablet={{ value: kpContentletterSpacingTypeTablet, label: __("kpContentletterSpacingTypeTablet") }}
					letterSpacingTypeMobile={{ value: kpContentletterSpacingTypeMobile, label: __("kpContentletterSpacingTypeMobile") }}
					textTransform={kpContenttextTransform}
					onTextTransform={(value) => setAttributes({ kpContenttextTransform: value })}
					textDecoration={kpContenttextDecoration}
					onTextDecoration={(value) => setAttributes({ kpContenttextDecoration: value })}
					fontStyle={kpContentfontStyle}
					onFontStyle={(value) => setAttributes({ kpContentfontStyle: value })}
				/>


				{ showExtraContent && showExtraContent == true &&	
					<TypographyControl
		                label={__("Extra Content Typography")}
		                attributes={attributes}
		                setAttributes={setAttributes}
		                loadGoogleFonts={{ value:extraContentLoadGoogleFonts, label: __("extraContentLoadGoogleFonts") }}
		                fontFamily={{ value: extraContentfontFamily, label: __("extraContentfontFamily") }}
		                fontWeight={{ value: extraContentfontWeight, label: __("extraContentfontWeight") }}
		                fontSubset={{ value: extraContentfontSubset, label: __("extraContentfontSubset") }}
		                fontSizeType={{ value: extraContentfontSizeType, label: __("extraContentfontSizeType") }}
		                fontSizeTypeMobile={{ value: extraContentfontSizeTypeMobile, label: __("extraContentfontSizeTypeMobile") }}
		                fontSizeTypeTablet={{ value: extraContentfontSizeTypeTablet, label: __("extraContentfontSizeTypeTablet") }}
		                fontSize={{ value: extraContentfontSizeDesktop, label: __("extraContentfontSizeDesktop") }}
		                fontSizeMobile={{ value: extraContentfontSizeMobile, label: __("extraContentfontSizeMobile") }}
		                fontSizeTablet={{ value: extraContentfontSizeTablet, label: __("extraContentfontSizeTablet") }}
		                lineHeightType={{ value: '', label: __(" ") }}
		                lineHeight={{ value: extraContentlineHeight, label: __("extraContentlineHeight") }}
		                lineHeightMobile={{ value: extraContentlineHeightMobile, label: __("extraContentlineHeightMobile") }}
		                lineHeightTablet={{ value: extraContentlineHeightTablet, label: __("extraContentlineHeightTablet") }}
		                letterSpacing={{ value: extraContentletterSpacing, label: __("extraContentletterSpacing") }}
		                letterSpacingMobile={{ value: extraContentletterSpacingMobile, label: __("extraContentletterSpacingMobile") }}
		                letterSpacingTablet={{ value: extraContentletterSpacingTablet, label: __("extraContentletterSpacingTablet") }}
		                letterSpacingType={{ value: extraContentletterSpacingType, label: __("extraContentletterSpacingType") }}
		                letterSpacingTypeTablet={{ value: extraContentletterSpacingTypeTablet, label: __("extraContentletterSpacingTypeTablet") }}
		                letterSpacingTypeMobile={{ value: extraContentletterSpacingTypeMobile, label: __("extraContentletterSpacingTypeMobile") }}
		                textTransform={extraContenttextTransform}
		                onTextTransform={(value) => setAttributes({ extraContenttextTransform: value })}
		                textDecoration={extraContenttextDecoration}
		                onTextDecoration={(value) => setAttributes({ extraContenttextDecoration: value })}
		                fontStyle={extraContentfontStyle}
		                onFontStyle={(value) => setAttributes({ extraContentfontStyle: value })}
		            />
		        }

			</PanelBody>	

			<PanelBody title={ __( 'Colors' ) } initialOpen={false}  icon={ getIcon( 'colors' ) } className={ 'abblocks-panel-label' }>

				<Color label={__('Border Color')} disableAlpha value={boxBorderColor} onChange={val => setAttributes({ boxBorderColor: val })} />
				<Color label={__('Background Color')} disableAlpha value={boxBgColor} onChange={val => setAttributes({ boxBgColor: val })} />			
				<Color label={__('Title Text Color')} disableAlpha value={titleTextColor} onChange={val => setAttributes({ titleTextColor: val })} />
				
				<Color label={__('Label Color')} disableAlpha value={kpLabelColor} onChange={val => setAttributes({ kpLabelColor: val })} />
				<Color label={__('Content Color')} disableAlpha value={kpContentColor} onChange={val => setAttributes({ kpContentColor: val })} />
				
				<Color label={__('Star Rating Color')} value={starRatingColor} onChange={(value) => setAttributes({ starRatingColor: value })} />

				{ showExtraContent && showExtraContent == true &&	
					<Color label={__('Extra Content Text Color')} disableAlpha value={extraContentTextColor} onChange={val => setAttributes({ extraContentTextColor: val })} />
				}

			</PanelBody>	

			<PanelBody title={ __( 'Button Settings' ) } initialOpen={false}  icon={ getIcon( 'button' ) } className={ 'abblocks-panel-label' }>	
                
                <ToggleControl
                    label={ __( 'Show Button' ) }                        
                    checked={ btnShow }                                      
                    onChange={ ( ) => setAttributes( { btnShow: ! btnShow } ) }
                />

				<Dropdown
                    className="affiliate-icon-popover"
                    contentClassName="my-popover-content-classname"
                    position="left"
                    renderToggle={ ( { isOpen, onToggle } ) => (
                    <Fragment>
                        <h2>{__('Tag Icon')}</h2>
                        <Button className="affiliate-size-btn"  onClick={ onToggle } aria-expanded={ isOpen }>
                                    <Dashicon icon="admin-tools" />
                        </Button>
                    </Fragment> 
                    ) }
                    renderContent={ () => (
                        <div className="affiliate-iconlist-popwrapper">
                            <IconList value={btnIcon} disableToggle onChange={val => setAttributes({ btnIcon: val })} />
                        </div>
                    ) }
                />

                <RadioAdvanced
                    label={__('Icon Position')}
                    options={[
                        { label: 'Left', value: 'af-icon-is-left', title: 'Left' },
                	    { label: 'Right', value: 'af-icon-is-right', title: 'Right' },
                    ]}
                    value={btnIconPosition}
                    onChange={(value) => setAttributes({ btnIconPosition: value })} />					

                <TextControl		
                    label = { __( 'Button Text' ) }				
                    value={ btnText }						
                    onChange={ ( value ) => setAttributes( { btnText: value } ) }
                />

                <TextControl
                    label = { __( 'Button URL' ) }						
                    value={ btnHref }						
                    onChange={ ( value ) => setAttributes( { btnHref: value } ) }
                />

                <TextControl
                    label = { __( 'Button Rel' ) }						
                    value={ btnRel }						
                    onChange={ ( value ) => setAttributes( { btnRel: value } ) }
                />

                <ToggleControl
                    label={ __( 'Open link in new Tab' ) }						
                    checked={ btn_Htarget }										
                    onChange={ ( ) => setAttributes( { btn_Htarget: ! btn_Htarget } ) }
                />

                <ToggleControl
                    label={ __( 'Rounded Button' ) }						
                    checked={ bntRounded }										
                    onChange={ ( ) => setAttributes( { bntRounded: ! bntRounded } ) }
                />

                <ToggleControl
                    label={ __( 'Enable Glimmer Effect' ) }            
                    checked={ enableGlimmerEffect }                    
                    onChange={ ( ) => setAttributes( { enableGlimmerEffect: ! enableGlimmerEffect } ) }
                />

                <RadioAdvanced
                    label={__('Button Size')}
                    options={[
                        { label: 'S', value: 'small', title: 'Small' },
                        { label: 'M', value: 'medium', title: 'Medium' },
                        { label: 'L', value: 'large', title: 'Large' },
                        { label: 'XL', value: 'extra-large', title: 'Extra Large' },
                    ]}
                    value={btnSize}
                    onChange={(value) => setAttributes({ btnSize: value })} />

                <RadioAdvanced
                    label={__('Button Width')}
                    options={[
                        { label: 'Fixed', value: 'fixed', title: 'Fixed' },
                        { label: 'Flexible', value: 'flex', title: 'Flexible' },
                        { label: 'Full', value: 'full', title: 'Full' },
                    ]}
                    value={btnWidth}
                    onChange={(value) => setAttributes({ btnWidth: value })} />

                <TypographyControl
                    label={__("Button Typography")}
                    attributes={attributes}
                    setAttributes={setAttributes}
                    loadGoogleFonts={{ value:btnLoadGoogleFonts, label: __("btnLoadGoogleFonts") }}
                    fontFamily={{ value: btnfontFamily, label: __("btnfontFamily") }}
                    fontWeight={{ value: btnfontWeight, label: __("btnfontWeight") }}
                    fontSubset={{ value: btnfontSubset, label: __("btnfontSubset") }}
                    fontSizeType={{ value: btnfontSizeType, label: __("btnfontSizeType") }}
                    fontSizeTypeMobile={{ value: btnfontSizeTypeMobile, label: __("btnfontSizeTypeMobile") }}
                    fontSizeTypeTablet={{ value: btnfontSizeTypeTablet, label: __("btnfontSizeTypeTablet") }}
                    fontSize={{ value: btnfontSizeDesktop, label: __("btnfontSizeDesktop") }}
                    fontSizeMobile={{ value: btnfontSizeMobile, label: __("btnfontSizeMobile") }}
                    fontSizeTablet={{ value: btnfontSizeTablet, label: __("btnfontSizeTablet") }}
                    lineHeightType={{ value: '', label: __(" ") }}
                    lineHeight={{ value: btnlineHeight, label: __("btnlineHeight") }}
                    lineHeightMobile={{ value: btnlineHeightMobile, label: __("btnlineHeightMobile") }}
                    lineHeightTablet={{ value: btnlineHeightTablet, label: __("btnlineHeightTablet") }}
                    letterSpacing={{ value: btnletterSpacing, label: __("btnletterSpacing") }}
                    letterSpacingMobile={{ value: btnletterSpacingMobile, label: __("btnletterSpacingMobile") }}
                    letterSpacingTablet={{ value: btnletterSpacingTablet, label: __("btnletterSpacingTablet") }}
                    letterSpacingType={{ value: btnletterSpacingType, label: __("btnletterSpacingType") }}
                    letterSpacingTypeTablet={{ value: btnletterSpacingTypeTablet, label: __("btnletterSpacingTypeTablet") }}
                    letterSpacingTypeMobile={{ value: btnletterSpacingTypeMobile, label: __("btnletterSpacingTypeMobile") }}
                    textTransform={btntextTransform}
                    onTextTransform={(value) => setAttributes({ btntextTransform: value })}
                    textDecoration={btntextDecoration}
                    onTextDecoration={(value) => setAttributes({ btntextDecoration: value })}
                    fontStyle={btnfontStyle}
                    onFontStyle={(value) => setAttributes({ btnfontStyle: value })}
                />

                <Tabs>
                    <Tab tabTitle={__('Normal')}>
                      <Color label={__('Text Color')} disableAlpha value={btnTextColor} onChange={val => setAttributes({ btnTextColor: val })} />
                      <Color label={__('Border Color')} disableAlpha value={btnBorderColor} onChange={val => setAttributes({ btnBorderColor: val })} />
                      <Background
	                      parallax
	                      value={btnBg}
	                      label={__('Background')}
	                      externalImage
	                      sources={['color','gradient']}
	                      onChange={val => setAttributes({ btnBg: val })} 
	                  />
                    </Tab>
                    <Tab tabTitle={__('Hover')}>
                      <Color label={__('Hover Text Color')} disableAlpha value={btnTextHoverColor} onChange={val => setAttributes({ btnTextHoverColor: val })} />
                      <Color label={__('Border Hover Color')} disableAlpha value={btnBorderHoverColor} onChange={val => setAttributes({ btnBorderHoverColor: val })} />
                      <Background
                          parallax
                          value={btnBgHover}
                          label={__('Background')}
                          externalImage
                          sources={['color','gradient']}
                          onChange={val => setAttributes({ btnBgHover: val })}
                        />
                    </Tab>
                </Tabs>
                    
                <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                    activeClass="active-tab"
                    tabs={[
                      {
                        name: 'boxdesk',
                        title: <Dashicon icon="desktop" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxtablet',
                        title: <Dashicon icon="tablet" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxmobile',
                        title: <Dashicon icon="smartphone" />,
                        className: 'affiliate-responsive-tabs',
                      },
                    ]}>
                    {
                      (radiustab) => {
                        let tabout;
                        if (radiustab.name) {
                          if ('boxmobile' === radiustab.name) {
                            tabout = (
                              <Dimension
                                label={__('Padding')} value={btnPaddingMobile}
                                onChange={val => setAttributes({ btnPaddingMobile: val })}
                                min={0} max={600} unit={['px','em','rem','%']}
                                clientId={this.props.clientId}
                              />
                            );
                          } else if ('boxtablet' === radiustab.name) {
                            tabout = (
                              <Dimension label={__('Padding')} value={btnPaddingTablet}
                                onChange={val => setAttributes({ btnPaddingTablet: val })}
                                min={0} max={600} unit={['px','em','rem','%']}
                                clientId={this.props.clientId}
                              />
                            );
                          } else {
                            tabout = (
                              <Dimension
                                label={__('Padding')} value={btnPadding}
                                onChange={val => setAttributes({ btnPadding: val })}
                                min={0} max={600} unit={['px','em','rem','%']}
                                clientId={this.props.clientId}
                              />
                            );
                          }
                        }
                        return <div>{tabout}</div>;
                      }
                    }
                </TabPanel>
                
                <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                    activeClass="active-tab"
                    tabs={[
                      {
                        name: 'boxdesk',
                        title: <Dashicon icon="desktop" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxtablet',
                        title: <Dashicon icon="tablet" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxmobile',
                        title: <Dashicon icon="smartphone" />,
                        className: 'affiliate-responsive-tabs',
                      },
                    ]}>
                    {
                      (radiustab) => {
                        let tabout;
                        if (radiustab.name) {
                          if ('boxmobile' === radiustab.name) {
                            tabout = (
                              <Dimension
                                label={__('Margin')}
                                value={btnMarginMobile}
                                onChange={val => setAttributes({ btnMarginMobile: val })}
                                min={0} max={600} unit={['px','em','rem','%']}
                                clientId={this.props.clientId}
                              />
                            );
                          } else if ('boxtablet' === radiustab.name) {
                            tabout = (
                              <Dimension label={__('Margin')} value={btnMarginTablet}
                                onChange={val => setAttributes({ btnMarginMobile: val })}
                                min={0} max={600} unit={['px','em','rem','%']}
                                clientId={this.props.clientId}
                              />
                            );
                          } else {
                            tabout = (
                              <Dimension
                                label={__('Margin')} value={btnMargin}
                                onChange={val => setAttributes({ btnMargin: val })}
                                min={0} max={600} unit={['px','em','rem','%']}
                                clientId={this.props.clientId}
                              />
                            );
                          }
                        }
                        return <div>{tabout}</div>;
                      }
                    }
                </TabPanel>

                <BorderTypes label={__('Border Type')} value={btnBorderType} onChange={(value) => setAttributes({ btnBorderType: value })} />
                
                <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                    activeClass="active-tab"
                    tabs={[
                      {
                        name: 'boxdesk',
                        title: <Dashicon icon="desktop" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxtablet',
                        title: <Dashicon icon="tablet" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxmobile',
                        title: <Dashicon icon="smartphone" />,
                        className: 'affiliate-responsive-tabs',
                      },
                    ]}>
                    {
                      (radiustab) => {
                        let tabout;
                        if (radiustab.name) {
                          if ('boxmobile' === radiustab.name) {
                            tabout = (
                              <Dimension
                                label={__('Border Width')} value={btnBorderMobile}
                                onChange={val => setAttributes({ btnBorderMobile: val })}
                                min={0} max={600} unit={['px','em','rem','%']}
                                clientId={this.props.clientId}
                              />
                            );
                          } else if ('boxtablet' === radiustab.name) {
                            tabout = (
                              <Dimension label={__('Border Width')} 
                                value={btnBorderTablet}
                                onChange={val => setAttributes({ btnBorderTablet: val })}
                                min={0} max={600} unit={['px','em','rem','%']}
                                clientId={this.props.clientId}
                              />
                            );
                          } else {
                            tabout = (
                              <Dimension
                                label={__('Border Width')} value={btnBorder}
                                onChange={val => setAttributes({ btnBorder: val })}
                                min={0} max={600} unit={['px','em','rem','%']}
                                clientId={this.props.clientId}
                              />
                            );
                          }
                        }
                        return <div>{tabout}</div>;
                      }
                    }
                </TabPanel>
                
                <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                    activeClass="active-tab"
                    tabs={[
                      {
                        name: 'boxdesk',
                        title: <Dashicon icon="desktop" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxtablet',
                        title: <Dashicon icon="tablet" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxmobile',
                        title: <Dashicon icon="smartphone" />,
                        className: 'affiliate-responsive-tabs',
                      },
                    ]}>
                    {
                      (radiustab) => {
                        let tabout;
                        if (radiustab.name) {
                          if ('boxmobile' === radiustab.name) {
                            tabout = (
                              <Dimension
                                label={__('Border Radius')} value={btnBorderRadiusMobile}
                                onChange={val => setAttributes({ btnBorderRadiusMobile: val })}
                                min={0} max={600} unit={['px','em','rem','%']}
                                clientId={this.props.clientId}
                              />
                            );
                          } else if ('boxtablet' === radiustab.name) {
                            tabout = (
                              <Dimension label={__('Border Radius')} 
                                value={btnBorderRadiusTablet}
                                onChange={val => setAttributes({ btnBorderRadiusTablet: val })}
                                min={0} max={600} unit={['px','em','rem','%']}
                                clientId={this.props.clientId}
                              />
                            );
                          } else {
                            tabout = (
                              <Dimension
                                label={__('Border Radius')} value={btnBorderRadius}
                                onChange={val => setAttributes({ btnBorderRadius: val })}
                                min={0} max={600} unit={['px','em','rem','%']}
                                clientId={this.props.clientId}
                              />
                            );
                          }
                        }
                        return <div>{tabout}</div>;
                      }
                    }
                </TabPanel>
                
                <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                    activeClass="active-tab"
                    tabs={[
                      {
                        name: 'boxdesk',
                        title: <Dashicon icon="desktop" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxtablet',
                        title: <Dashicon icon="tablet" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxmobile',
                        title: <Dashicon icon="smartphone" />,
                        className: 'affiliate-responsive-tabs',
                      },
                    ]}>
                    {
                      (radiustab) => {
                        let tabout;
                        if (radiustab.name) {
                          if ('boxmobile' === radiustab.name) {
                            tabout = (
                              <Alignment
                                  label = {__('Alignment')}
                                  disableJustify
                                  alignmentType='content'
                                  flex
                                  value={btnAlignmentMobile}
                                  onChange={(value) => setAttributes({ btnAlignmentMobile: value })}
                              />
                            );
                          } else if ('boxtablet' === radiustab.name) {
                            tabout = (
                              <Alignment
                                  label = {__('Alignment')}
                                  disableJustify
                                  alignmentType='content'
                                  flex
                                  value={btnAlignmentTablet}
                                  onChange={(value) => setAttributes({ btnAlignmentTablet: value })}
                              />
                            );
                          } else {
                            tabout = (
                              <Alignment
                                  label = {__('Alignment')}
                                  disableJustify
                                  alignmentType='content'
                                  flex
                                  value={btnAlignment}
                                  onChange={(value) => setAttributes({ btnAlignment: value })}
                              />
                            );
                          }
                        }
                        return <div>{tabout}</div>;
                      }
                    }
                </TabPanel>     

            </PanelBody>

            { enableSchema && enableSchema == true &&
	            <PanelBody title={ __( 'Schema Settings' ) } initialOpen={false}  icon={ getIcon( 'documentation' ) } className={ 'abblocks-panel-label' }>	
									<SelectControl
										label={ __( 'Item type' ) }
										value={ schemaType }
										options= {[
												{ value: 'Product', label: 'Product' },
                        { value: 'Course', label: 'Course' },
                        { value: 'SoftwareApplication', label: 'Software Application' },
											]}
											onChange={ ( value ) => setAttributes( { schemaType: value } ) }
									/>  

									<TextControl		
	                    label = { __( 'Title' ) }				
	                    value={ schemaTitle }						
	                    onChange={ ( value ) => setAttributes( { schemaTitle: value } ) }
	                />

	                <TextareaControl		
	                    label = { __( 'Description' ) }				
	                    value={ schemaDescription }						
	                    onChange={ ( value ) => setAttributes( { schemaDescription: value } ) }
	                />	                

									<TextControl		
	                    label = { __( 'Rating (out of 5)' ) }				
	                    value={ schemaRating }						
	                    onChange={ ( value ) => setAttributes( { schemaRating: value } ) }
	                />

	                { schemaType && schemaType == 'Product' &&	
		                <Fragment>

		                	<SelectControl
												label={ __( 'Item Subtype' ) }
												value={ schemaSubType }
												options= {[
														{ value: 'IndividualProduct', label: 'Individual Product' },
		                        { value: 'ProductCollection', label: 'Product Collection' },
		                        { value: 'ProductGroup', label: 'Product Group' },
		                        { value: 'ProductModel', label: 'Product Model' },
		                        { value: 'SomeProducts', label: 'Some Products' },
		                        { value: 'Vehicle', label: 'Vehicle' },
													]}
													onChange={ ( value ) => setAttributes( { schemaSubType: value } ) }
											/>  

		                	<Media label={__('Image')} multiple={false} type={['image']} panel={true} value={schemaImage} onChange={val => setAttributes({ schemaImage: val })} />

		                	<TextControl		
			                    label = { __( 'Brand' ) }				
			                    value={ schemaBrand }						
			                    onChange={ ( value ) => setAttributes( { schemaBrand: value } ) }
			                />
			                <TextControl		
			                    label = { __( 'SKU' ) }				
			                    value={ schemaSku }						
			                    onChange={ ( value ) => setAttributes( { schemaSku: value } ) }
			                />

			                <SelectControl
												label={ __( 'Identifier type' ) }
												value={ schemaIdentifierType }
												options= {[
														{ value: 'gtin', label: 'GTIN' },
								                        { value: 'mpn', label: 'MPN' },
								                        { value: 'isbn', label: 'ISBN' },
													]}
													onChange={ ( value ) => setAttributes( { schemaIdentifierType: value } ) }
											/>  

			                <TextControl		
			                    label = { __( 'Identifier' ) }				
			                    value={ schemaIdentifier }						
			                    onChange={ ( value ) => setAttributes( { schemaIdentifier: value } ) }
			                />			                 

			                <SelectControl
												label={ __( 'Offer Status' ) }
												value={ schemaOffer }
												options= {[
														{ value: 'In Stock', label: 'In Stock' },
		                        { value: 'Discontinued', label: 'Discontinued' },
		                        { value: 'In Store Only', label: 'In Store Only' },
		                        { value: 'Limited Availability', label: 'Limited Availability' },
		                        { value: 'Online Only', label: 'Online Only' },
		                        { value: 'Out Of Stock', label: 'Out Of Stock' },
		                        { value: 'Pre Order', label: 'Pre Order' },
		                        { value: 'Pre Sale', label: 'Pre Sale' },
		                        { value: 'Sold Out', label: 'Sold Out' },
													]}
													onChange={ ( value ) => setAttributes( { schemaOffer: value } ) }
											/> 

			                <TextControl		
			                    label = { __( 'Offer Currency' ) }				
			                    value={ schemaOfferPriceCurrency }						
			                    onChange={ ( value ) => setAttributes( { schemaOfferPriceCurrency: value } ) }
			                />

			                <TextControl		
			                    label = { __( 'Offer Price' ) }				
			                    value={ schemaOfferPrice }						
			                    onChange={ ( value ) => setAttributes( { schemaOfferPrice: value } ) }
			                />
        
		                </Fragment>
	                }

	                { schemaType && schemaType == 'SoftwareApplication' &&	
		                <Fragment>

		                	<SelectControl
												label={ __( 'Item Subtype' ) }
												value={ schemaSubType }
												options= {[
														{ value: 'MobileApplication', label: 'Mobile Application' },
		                        { value: 'VideoGame', label: 'Video Game' },
		                        { value: 'WebApplication', label: 'WebApplication' },
													]}
													onChange={ ( value ) => setAttributes( { schemaSubType: value } ) }
											/>  

			                <TextControl		
			                    label = { __( 'Application Category' ) }				
			                    value={ schemaApplicationCategory }						
			                    onChange={ ( value ) => setAttributes( { schemaApplicationCategory: value } ) }
			                />
		                
			                <TextControl		
			                    label = { __( 'Operating System' ) }				
			                    value={ schemaOperatingSystem }						
			                    onChange={ ( value ) => setAttributes( { schemaOperatingSystem: value } ) }
			                />

			                <TextControl		
			                    label = { __( 'Offer Name' ) }				
			                    value={ schemaOffer }						
			                    onChange={ ( value ) => setAttributes( { schemaOffer: value } ) }
			                />

			                <TextControl		
			                    label = { __( 'Offer Price' ) }				
			                    value={ schemaOfferPrice }						
			                    onChange={ ( value ) => setAttributes( { schemaOfferPrice: value } ) }
			                />		                

			                <TextControl		
			                    label = { __( 'Offer Currency' ) }				
			                    value={ schemaOfferPriceCurrency }						
			                    onChange={ ( value ) => setAttributes( { schemaOfferPriceCurrency: value } ) }
			                />
			                
		                </Fragment>
	                }

	                <TextControl		
			                    label = { __( 'Review Author' ) }				
			                    value={ schemaAuthor }						
			                    onChange={ ( value ) => setAttributes( { schemaAuthor: value } ) }
			                />

	            </PanelBody>
	        }

		</InspectorControls>
		</Fragment>	
		,
		<div id={`affiliate-style-${block_id}`} className={ this.props.className }>
			<div className={`affiliate-keypoints-box`}>
			
				<div className={`affiliate-keypoints-inner`}>			

					{ titleShow && titleShow == true &&	titleInsideOutside && titleInsideOutside == true &&		
						<RichText
	                        tagName={Tag}
	                        value={titleText} 
	                        className="affiliate-keypoints-titleText inside"
	                        id={`getSlug(${titleText})`}
	                        placeholder={__('KEY POINTS')}
	                        onChange={titleText => setAttributes({ titleText })}
	                        keepPlaceholderOnFocus
	                    />    
	                }

	                { titleShow && titleShow == true &&	!titleInsideOutside && !titleInsideOutside == true &&			
						<RichText
	                        tagName={Tag}
	                        value={titleText} 
	                        className="affiliate-keypoints-titleText outside"
	                        id={`getSlug(${titleText})`}
	                        placeholder={__('KEY POINTS')}
	                        onChange={titleText => setAttributes({ titleText })}
	                        keepPlaceholderOnFocus
	                    />    
	                }

					<ul className={`affiliate-keypoints-contentrows`}>
						{repetdata}
					</ul>

					<Button  isDefault className=" components_panel_btn" onClick={ handletr.bind( this ) } >
						<span class="screen-reader-text">Add Row</span>
						<svg xmlns="http://www.w3.org/2000/svg" viewBox="-2 -2 24 24" width="24" height="24" role="img" aria-hidden="true" focusable="false"><path d="M10 1c-5 0-9 4-9 9s4 9 9 9 9-4 9-9-4-9-9-9zm0 16c-3.9 0-7-3.1-7-7s3.1-7 7-7 7 3.1 7 7-3.1 7-7 7zm1-11H9v3H6v2h3v3h2v-3h3V9h-3V6zM10 1c-5 0-9 4-9 9s4 9 9 9 9-4 9-9-4-9-9-9zm0 16c-3.9 0-7-3.1-7-7s3.1-7 7-7 7 3.1 7 7-3.1 7-7 7zm1-11H9v3H6v2h3v3h2v-3h3V9h-3V6z"></path></svg>
					</Button>

					<div className={`affiliate-keypoints-footerbox`}>

						{ starRatingShow && starRatingShow == true &&		

							<div className={`affiliate-keypoints-col left`}>

								<div className={`affiliate-keypoints-starratingtext`}>
									<Fragment>OVERALL RATING</Fragment>	
								</div>

								<div className="affiliate-keypoints-starrating" onMouseLeave={() => this.setState({ highlightedStars: 0 })} >
	                                {[...Array(starRatingCount)].map((e, i) => (
	                                   <div className={`affiliate-star-item`} key={i}
	                                        onMouseEnter={() => {
	                                            this.setState({ highlightedStars: i + 1 });
	                                        }}
	                                        onClick={() => {
	                                            if (starRatingSelectedStars % 1 === 0) {
	                                                setAttributes({
	                                                    starRatingSelectedStars: i + (starRatingSelectedStars - 1 === i ? 0.5 : 1)
	                                                });
	                                            } else {
	                                                setAttributes({
	                                                    starRatingSelectedStars: i + (starRatingSelectedStars - 0.5 === i ? 1 : 0.5)
	                                                });
	                                            }
	                                        }}
	                                    >
	                                        {i < (highlightedStars ? highlightedStars : starRatingSelectedStars) ? (
	                                            highlightedStars ? (
	                                                highlightedStars - 1 === i ? (
	                                                    starRatingSelectedStars % 1 > 0 ? (
	                                                        highlightedStars - starRatingSelectedStars - 0.5 !== 0 ? (
	                                                            <HalfStar fillColor={starRatingColor} />
	                                                        ) : (
	                                                            <FullStar fillColor={starRatingColor} />
	                                                        )
	                                                    ) : highlightedStars - starRatingSelectedStars !== 0 ? (
	                                                        <FullStar fillColor={starRatingColor} />
	                                                    ) : (
	                                                        <HalfStar fillColor={starRatingColor} />
	                                                    )
	                                                ) : (
	                                                    <FullStar fillColor={starRatingColor} />
	                                                )
	                                            ) : starRatingSelectedStars - i >= 1 ? (
	                                                <FullStar fillColor={starRatingColor} />
	                                            ) : (
	                                                <HalfStar fillColor={starRatingColor} />
	                                            )
	                                        ) : (
	                                            <EmptyStar fillColor={starRatingColor} />
	                                        )}
	                                    </div>
	                                ))}                                 
	                            </div>							  

		                    </div>

		                }


		                { btnShow && btnShow == true &&		

	                      	<div className={`affiliate-keypoints-col right`}>
	                      		
	                      		 <div className={`affiliate-keypoints-btn`}>
	                                <div className={`affiliate-keypoints-btn-wrapper`}  onClick={() => { this.setState({ isVisible: !isVisible })}}>
	                                    <span className={`affiliate-btn  btn-is-${btnSize} ${
	                                              btnWidth === "full" ? "btn-is-fullw" : btnWidth === "flex" ? `btn-is-flex-${btnSize}` : "" } ${bntRounded ? 'btn-is-rounded' : ''} ${enableGlimmerEffect ? 'glimmer-effect' : ''}`}>
	                                        { btnIconPosition && btnIconPosition == 'af-icon-is-left' &&
	                                              <i className={`affiliate-abbtn-icon ${btnIcon} ${btnIconPosition}`}></i>
	                                        }
	                                        { btnIconPosition && btnIconPosition != 'af-icon-is-left' &&
	                                              <i className={`affiliate-abbtn-icon af-icon-is-left`}></i>
	                                        }
	                                        <RichText
	                                            value={btnText}
	                                            placeholder={__('Button text')}
	                                            onChange={btnText => setAttributes({ btnText })}
	                                            formattingControls={ ['bold', 'italic', 'underline'] }
	                                            href = {btn_Htarget}
	                                            {...(btn_Htarget ? {...btn_Htarget && { rel: newrel }} : { rel: newrel }  )}
	                                            {...(btn_Htarget ? { target: '_blank' } : '' )}
	                                        />
	                                        { btnIconPosition && btnIconPosition == 'af-icon-is-right' &&
	                                              <i className={`affiliate-abbtn-icon ${btnIcon} ${btnIconPosition}`}></i>
	                                        }
	                                        { btnIconPosition && btnIconPosition != 'af-icon-is-right' &&
	                                              <i className={`affiliate-abbtn-icon af-icon-is-right`}></i>
	                                        }
	                                    </span>    
	                                </div>
	                            </div>

	                      	</div>

	                    }


	                    { showExtraContent && showExtraContent == true &&	
	                    	<div className={`affiliate-keypoints-footercol`}>
	                    		<RichText 
			                        value={extraContentText} 
			                        className="affiliate-keypoints-extraContentText"
			                        onChange={extraContentText => setAttributes({ extraContentText })}
			                        keepPlaceholderOnFocus
			                    />
	                    	</div>
	                    }

					</div>

				</div>
			
			
			</div>
			
			{loadTitleGoogleFonts}
			{loadKPLabelGoogleFonts}
			{loadKPContentGoogleFonts}
			{loadbtnGoogleFotns}
			{loadExtraContentGoogleFotns}
			
		</div>
		]
	}
}

export default ( Edit );