/**
 * Set inline styles.
 * @param  {object} props - The block object.
 * @return {object} The inline background type CSS.
 */

import affiliate_generateCSS from "./generateCSS"
import { cssGradient, cssBoxShadow,cssWithoutSelector,cssTextShadow, cssBackground } from '../components/cssHelper'

function affiliate_styling( props, id ) {

	const {
    	
    	block_id,
	    boxShadow,
	    boxBgColor,

	    boxBorderType,
        boxBorderColor,
        boxBorderWidth,

	    // Title settings
	    titleLoadGoogleFonts,
	    titleBgColor,
	    titleTextColor,
	    titlefontFamily,
	    titlefontWeight,
	    titlefontSubset,
	    titlefontSizeType,
	    titlefontSizeTypeMobile,
	    titlefontSizeTypeTablet,
	    titlefontSizeDesktop,
	    titlefontSizeMobile,
	    titlefontSizeTablet,
	    titlelineHeight,
	    titlelineHeightMobile,
	    titlelineHeightTablet,
	    titleletterSpacing,
	    titleletterSpacingMobile,
	    titleletterSpacingTablet,
	    titleletterSpacingType,
	    titleletterSpacingTypeTablet,
	    titleletterSpacingTypeMobile,
	    titletextTransform,
	    titletextDecoration,
	    titlefontStyle,
	    titleTag,
	    titleText,
	    titleShow,
	    
	    // Key Points 
	    keypoints,

	    // Key Points Label
	    kpLabelText,
	    kpLabelLoadGoogleFonts,
	    kpLabelColor,
	    kpLabelfontFamily,
	    kpLabelfontWeight,
	    kpLabelfontSubset,
	    kpLabelfontSizeType,
	    kpLabelfontSizeTypeMobile,
	    kpLabelfontSizeTypeTablet,
	    kpLabelfontSizeDesktop,
	    kpLabelfontSizeMobile,
	    kpLabelfontSizeTablet,
	    kpLabellineHeight,
	    kpLabellineHeightMobile,
	    kpLabellineHeightTablet,
	    kpLabelletterSpacing,
	    kpLabelletterSpacingMobile,
	    kpLabelletterSpacingTablet,
	    kpLabelletterSpacingType,
	    kpLabelletterSpacingTypeTablet,
	    kpLabelletterSpacingTypeMobile,
	    kpLabeltextTransform,
	    kpLabeltextDecoration,
	    kpLabelfontStyle,     
	    kpLabelAlignment,
	    kpLabelAlignmentMobile,
	    kpLabelAlignmentTablet,    
	    
	    // Key Points Content
	    kpContentText, 
	    kpContentLoadGoogleFonts,
	    kpContentColor,
	    kpContentfontFamily,
	    kpContentfontWeight,
	    kpContentfontSubset,
	    kpContentfontSizeType,
	    kpContentfontSizeTypeMobile,
	    kpContentfontSizeTypeTablet,
	    kpContentfontSizeDesktop,
	    kpContentfontSizeMobile,
	    kpContentfontSizeTablet,
	    kpContentlineHeight,
	    kpContentlineHeightMobile,
	    kpContentlineHeightTablet,
	    kpContentletterSpacing,
	    kpContentletterSpacingMobile,
	    kpContentletterSpacingTablet,
	    kpContentletterSpacingType,
	    kpContentletterSpacingTypeTablet,
	    kpContentletterSpacingTypeMobile,
	    kpContenttextTransform,
	    kpContenttextDecoration,
	    kpContentfontStyle, 
	    kpContentAlignment,
	    kpContentAlignmentMobile,
	    kpContentAlignmentTablet,

	    //Star rating
		starRatingCount,
	    starRatingColor,
	    starRatingSelectedStars,
	    starRatingSize,
	    starRatingSizeMobile,
	    starRatingSizeTablet,


	    //Btn 
	    btnText,
        btnHref,
        btnRel,
        btnLoadGoogleFonts,
        btnfontFamily,
        btnfontWeight,
        btnfontSubset,
        btnfontSizeType,
        btnfontSizeTypeMobile,
        btnfontSizeTypeTablet,
        btnfontSizeDesktop,
        btnfontSizeMobile,
        btnfontSizeTablet,
        btnlineHeight,
        btnlineHeightMobile,
        btnlineHeightTablet,
        btnletterSpacing,
        btnletterSpacingMobile,
        btnletterSpacingTablet,
        btnletterSpacingType,
        btnletterSpacingTypeTablet,
        btnletterSpacingTypeMobile,
        btntextTransform,
        btntextDecoration,
        btnfontStyle,
        btnBgColor,
        btnHoverBgColor,
        btnTextColor,
        btnTextHoverColor,
        btnBorderColor,
        btnBorderHoverColor,
        btn_Htarget,            
        btnPadding,
        btnPaddingMobile,
        btnPaddingTablet,
        btnMargin,
        btnMarginMobile,
        btnMarginTablet,
        btnAlignment,
        btnAlignmentMobile,
        btnAlignmentTablet,
        btnBorder,
        btnBorderType,
        btnBorderMobile,
        btnBorderTablet,
        btnBorderRadius,
        btnBorderRadiusMobile,
        btnBorderRadiusTablet,
        btnIconPosition,
        bntRounded,
        btnSize,
        btnWidth,
        btnIcon,


        //Extra Content
        showExtraContent,
        extraContentText,
        extraContentLoadGoogleFonts, 
	    extraContentTextColor,
	    extraContentfontFamily,
	    extraContentfontWeight,
	    extraContentfontSubset,
	    extraContentfontSizeType,
	    extraContentfontSizeTypeMobile,
	    extraContentfontSizeTypeTablet,
	    extraContentfontSizeDesktop,
	    extraContentfontSizeMobile,
	    extraContentfontSizeTablet,
	    extraContentlineHeight,
	    extraContentlineHeightMobile,
	    extraContentlineHeightTablet,
	    extraContentletterSpacing,
	    extraContentletterSpacingMobile,
	    extraContentletterSpacingTablet,
	    extraContentletterSpacingType,
	    extraContentletterSpacingTypeTablet,
	    extraContentletterSpacingTypeMobile,
	    extraContenttextTransform,
	    extraContenttextDecoration,
	    extraContentfontStyle,

	    btnBg,
    	btnBgHover,

	} = props.attributes

	const Tag = titleTag
	var mobile_selectors = {}
	var tablet_selectors = {}
	var style = {}

	var styleBtnBg = cssBackground(btnBg);
  	var styleBtnBgHover = cssBackground(btnBgHover);
  
    var selectors = {
		" .affiliate-keypoints-inner":{
			"box-shadow":cssBoxShadow(boxShadow),
			"background":boxBgColor,
			"border-style":boxBorderType,
            "border-color":boxBorderColor,
            "border-width" : ( boxBorderWidth && undefined !== boxBorderWidth[ 'top' ] && null !== boxBorderWidth[ 'top' ] ? boxBorderWidth[ 'top' ] + boxBorderWidth['unit'] + ' ' + boxBorderWidth[ 'right' ] + boxBorderWidth['unit'] + ' ' + boxBorderWidth[ 'bottom' ] + boxBorderWidth['unit'] + ' ' + boxBorderWidth[ 'left' ] + boxBorderWidth['unit'] : '' ),
		},

		" .affiliate-keypoints-titleText":{
			"font-family": titlefontFamily,
			"font-size": titlefontSizeDesktop + titlefontSizeType,
			"font-style":titlefontStyle,
			"font-weight":titlefontWeight,
			"letter-spacing":titleletterSpacing + titleletterSpacingType,
			"line-height":titlelineHeight,
			"text-decoration":titletextDecoration,
			"text-transform":titletextTransform,
			"color":titleTextColor,
		},
		
      	" .affiliate-keypoints-inner .affiliate-keypoints-row .affiliate-keypoints-label":{
			"font-family": kpLabelfontFamily,
			"font-size": kpLabelfontSizeDesktop + kpLabelfontSizeType,
			"font-style":kpLabelfontStyle,
			"font-weight":kpLabelfontWeight,
			"letter-spacing":kpLabelletterSpacing + kpLabelletterSpacingType,
			"line-height":kpLabellineHeight,
			"text-decoration":kpLabeltextDecoration,
			"text-transform":kpLabeltextTransform,
			"color":kpLabelColor,
    	},

    	" .affiliate-keypoints-inner .affiliate-keypoints-row .affiliate-keypoints-content":{
			"font-family": kpContentfontFamily,
			"font-size": kpContentfontSizeDesktop + kpContentfontSizeType,
			"font-style":kpContentfontStyle,
			"font-weight":kpContentfontWeight,
			"letter-spacing":kpContentletterSpacing + kpContentletterSpacingType,
			"line-height":kpContentlineHeight,
			"text-decoration":kpContenttextDecoration,
			"text-transform":kpContenttextTransform,
			"color":kpContentColor,
    	},

    	" .affiliate-keypoints-inner .affiliate-keypoints-starrating .affiliate-star-item svg":{
            "height": starRatingSize + 'px',
            "width": starRatingSize + 'px',
            "color":starRatingColor,
        },

        " .affiliate-keypoints-btn-wrapper":{
    	    "justify-content":btnAlignment
	    },

	    " .affiliate-keypoints-btn-wrapper .affiliate-btn":{
        	"font-family": btnfontFamily,
          	"font-size": btnfontSizeDesktop + btnfontSizeType,
          	"font-style":btnfontStyle,
          	"font-weight":btnfontWeight,
          	"letter-spacing":btnletterSpacing + btnletterSpacingType,
          	"line-height":btnlineHeight,
          	"text-decoration":btntextDecoration,
          	"text-transform":btntextTransform,
          	"background":styleBtnBg,
          	"color":btnTextColor,
          	"border-color":btnBorderColor,
          	"border-style":btnBorderType,
          	"border-radius":( btnBorderRadius && undefined !== btnBorderRadius[ 'top' ] && null !== btnBorderRadius[ 'top' ] ? btnBorderRadius[ 'top' ] + btnBorderRadius['unit'] + ' ' + btnBorderRadius[ 'right' ] + btnBorderRadius['unit'] + ' ' + btnBorderRadius[ 'bottom' ] + btnBorderRadius['unit'] + ' ' + btnBorderRadius[ 'left' ] + btnBorderRadius['unit'] : '' ),
          	"border-width" : ( btnBorder && undefined !== btnBorder[ 'top' ] && null !== btnBorder[ 'top' ] ? btnBorder[ 'top' ] + btnBorder['unit'] + ' ' + btnBorder[ 'right' ] + btnBorder['unit'] + ' ' + btnBorder[ 'bottom' ] + btnBorder['unit'] + ' ' + btnBorder[ 'left' ] + btnBorder['unit'] : '' ),
          	"padding" : ( btnPadding && undefined !== btnPadding[ 'top' ] && null !== btnPadding[ 'top' ] ? btnPadding[ 'top' ] + btnPadding['unit'] + ' ' + btnPadding[ 'right' ] + btnPadding['unit'] + ' ' + btnPadding[ 'bottom' ] + btnPadding['unit'] + ' ' + btnPadding[ 'left' ] + btnPadding['unit'] : '' ),
          	"margin" : ( btnMargin && undefined !== btnMargin[ 'top' ] && null !== btnMargin[ 'top' ] ? btnMargin[ 'top' ] + btnMargin['unit'] + ' ' + btnMargin[ 'right' ] + btnMargin['unit'] + ' ' + btnMargin[ 'bottom' ] + btnMargin['unit'] + ' ' + btnMargin[ 'left' ] + btnMargin['unit'] : '' ),
    	},
   		" .affiliate-keypoints-btn-wrapper .affiliate-btn:hover":{
          	"background":styleBtnBgHover,
          	"border-color":btnBorderHoverColor,
          	"color":btnTextHoverColor
    	},

    	" .affiliate-keypoints-footercol":{
			"font-family": extraContentfontFamily,
			"font-size": extraContentfontSizeDesktop + extraContentfontSizeType,
			"font-style":extraContentfontStyle,
			"font-weight":extraContentfontWeight,
			"letter-spacing":extraContentletterSpacing + extraContentletterSpacingType,
			"line-height":extraContentlineHeight,
			"text-decoration":extraContenttextDecoration,
			"text-transform":extraContenttextTransform,
			"color":extraContentTextColor,
		},

    }
	 
    tablet_selectors = {
      	" .affiliate-keypoints-inner .affiliate-keypoints-starrating .affiliate-star-item svg":{
            "height": starRatingSizeTablet + 'px',
            "width": starRatingSizeTablet + 'px', 
        },
    }

   	mobile_selectors = {
        " .affiliate-keypoints-inner .affiliate-keypoints-starrating .affiliate-star-item svg":{
            "height": starRatingSizeMobile + 'px',
            "width": starRatingSizeMobile + 'px', 
        },
    }

	var affiliate_styling_css = ""

	affiliate_styling_css = affiliate_generateCSS( selectors, `#${id}-${ props.clientId }` )
	affiliate_styling_css += affiliate_generateCSS( tablet_selectors, `#${id}-${ props.clientId }`, true, "tablet" )
	affiliate_styling_css += affiliate_generateCSS( mobile_selectors, `#${id}-${ props.clientId }`, true, "mobile" )

	return affiliate_styling_css
}

export default affiliate_styling
