import RadioAdvanced from '../../components/fields/RadioAdvanced.js';
import BorderTypes from '../../components/fields/BorderTypes.js';
import Alignment from '../../components/fields/Alignment.js';
import Dimension from '../../components/fields/Dimension/Dimension.js';
import IconSelector from '../../components/fields/IconSelector/IconSelector.js';
import TypographyControl from '../components/typography/index.js';
import WebfontLoader from "../components/typography/fontloader"
import Range from '../../components/fields/Range/Range.js';
import Color  from '../../components/fields/Color/Color.js';
import affiliate_styling  from './styling.js';
import IconList from '../../components/fields/IconList/IconList.js';
import BoxShadow  from './../../components/fields/BoxShadow.js';
import Tabs from '../../components/fields/Tabs/Tabs.js';
import Tab from '../../components/fields/Tab/Tab.js';
import Toggle from '../../components/fields/Toggle.js';
import getIcon from '../../icons/get-icon';

const { __ } = wp.i18n;

const {
	withSelect,
	useDispatch,
	withDispatch
} = wp.data

const {
	compose,
} = wp.compose

const {
    InspectorControls,
    BlockControls,
    MediaUpload,
    URLInput,
    URLInputButton,
    RichText,
    InnerB,
    InnerBlocks
} = wp.blockEditor;

const {
    Component,
    Fragment
} = wp.element;

const {
    PanelBody,
    Toolbar,
    Tooltip,
    TextControl,
    ToggleControl,
    TabPanel,
    Dashicon,
    Button,
    IconButton,
    Popover,
    RangeControl,
    Dropdown,
    SelectControl,
    withNotices
} = wp.components;

let imageSizeOptions = [
	{ value: "thumbnail", label: __( "Thumbnail" ) },
	{ value: "medium", label: __( "Medium" ) },
	{ value: "full", label: __( "Large" ) }
]

$ = jQuery;
const NEW_TAB_REL = 'noopener noreferrer';
class Edit extends Component {

    constructor(props) {
        super(props)
        this.state = {
            removeItemViaBackSpace: 999,
            isVisible:false,
        }

        
        this.getSlug     = this.getSlug.bind(this)
    }
    
    getSlug( title ) {
      return title.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-");
    }

    componentDidMount() {
        const {
            clientId,
            isSelected,
            setAttributes,
            attributes: {
                uniqueId,
                block_id
            }
        } = this.props;
        const _client = clientId.substr(0, 6);

        if (!uniqueId) {
            setAttributes({ uniqueId: _client });
        } else if (uniqueId && uniqueId != _client) {
            setAttributes({ uniqueId: _client });
        }
    
        this.props.setAttributes({ block_id: this.props.clientId })
        const $style = document.createElement("style")
        $style.setAttribute("id", "affiliate-style-" + this.props.clientId)
        document.head.appendChild($style)
    
    }

    render() {
        const {
            name,
            clientId,
            isSelected,
            attributes,
            setAttributes,
            hasInnerBlocks,
            attributes: {
                uniqueId,
                block_id,
                titleLoadGoogleFonts,
                ratingBarSubTitle,
                className, 
                mainBgColor,
                titleTextColor,
                titlefontFamily,
                titlefontWeight,
                titlefontSubset,
                titlefontSizeType,
                titlefontSizeTypeMobile,
                titlefontSizeTypeTablet,
                titlefontSizeDesktop,
                titlefontSizeMobile,
                titlefontSizeTablet,
                titlelineHeight,
                titlelineHeightMobile,
                titlelineHeightTablet,
                titleletterSpacing,
                titleletterSpacingMobile,
                titleletterSpacingTablet,
                titleletterSpacingType,
                titleletterSpacingTypeTablet,
                titleletterSpacingTypeMobile,
                titletextTransform,
                titletextDecoration,
                titlefontStyle,
                subTitleTextColor,              
                subtitleLoadGoogleFonts,
                subtitleTextColor,
                subtitlefontFamily,
                subtitlefontWeight,
                subtitlefontSubset,
                subtitlefontSizeType,
                subtitlefontSizeTypeMobile,
                subtitlefontSizeTypeTablet,
                subtitlefontSizeDesktop,
                subtitlefontSizeMobile,
                subtitlefontSizeTablet,
                subtitlelineHeight,
                subtitlelineHeightMobile,
                subtitlelineHeightTablet,
                subtitleletterSpacing,
                subtitleletterSpacingMobile,
                subtitleletterSpacingTablet,
                subtitleletterSpacingType,
                subtitleletterSpacingTypeTablet,
                subtitleletterSpacingTypeMobile,
                subtitletextTransform,
                subtitletextDecoration,
                subtitlefontStyle,
                subtitleAlignment,
                subtitleAlignmentMobile,
                subtitleAlignmentTablet,
                ratingBarMainTitle,
                progressLoadGoogleFonts,
                progressColor,
                progressfontFamily,
                progressfontWeight,
                progressfontSubset,
                progressfontSizeType,
                progressfontSizeTypeMobile,
                progressfontSizeTypeTablet,
                progressfontSizeDesktop,
                progressfontSizeMobile,
                progressfontSizeTablet,
                progresslineHeight,
                progresslineHeightMobile,
                progresslineHeightTablet,
                progressletterSpacing,
                progressletterSpacingMobile,
                progressletterSpacingTablet,
                progressletterSpacingType,
                progressletterSpacingTypeTablet,
                progressletterSpacingTypeMobile,
                progresstextTransform,
                progresstextDecoration,
                progressfontStyle,
                progressTextColor,
                boxShadow,
                titleTag1,
                titleTag2,

                progressText,
                showRatings,
                inOut,                
                progressHeight,
                progressWidth,
                progressBgColor,

                progressText1,
                showRatings1,
                inOut1,                
                progressHeight1,
                progressWidth1,
                progressBgColor1,

                progressText2,
                showRatings2,
                inOut2,                
                progressHeight2,
                progressWidth2,
                progressBgColor2,

                progressText3,
                showRatings3,
                inOut3,                
                progressHeight3,
                progressWidth3,
                progressBgColor3,

                progressText4,
                showRatings4,
                inOut4,                
                progressHeight4,
                progressWidth4,
                progressBgColor4,   


                progressText5,
                showRatings5,
                inOut5,                
                progressHeight5,
                progressWidth5,
                progressBgColor5,   

                progressText6,
                showRatings6,
                inOut6,                
                progressHeight6,
                progressWidth6,
                progressBgColor6,   

                progressText7,
                showRatings7,
                inOut7,                
                progressHeight7,
                progressWidth7,
                progressBgColor7,   

                progressText8,
                showRatings8,
                inOut8,                
                progressHeight8,
                progressWidth8,
                progressBgColor8,   

                progressText9,
                showRatings9,
                inOut9,                
                progressHeight9,
                progressWidth9,
                progressBgColor9,   

                showTitle,
                showSubTitle,

            }
        } = this.props;
        const { isVisible } = this.state
        
        var element = document.getElementById("affiliate-style-" + this.props.clientId)
        if (null != element && "undefined" != typeof element) {
             element.innerHTML = affiliate_styling(this.props, "affiliate-style")
        }

        let loadtitleGoogleFonts
        let loadsubTitleGoogleFonts
        let loadprogressGoogleFonts

        if( titleLoadGoogleFonts == true ) {
					
			const titleconfig = {
				google: {
					families: [ titlefontFamily + ( titlefontWeight ? ":" + titlefontWeight : "" ) ],
				},
			}

			loadtitleGoogleFonts = (
				<WebfontLoader config={ titleconfig }>
				</WebfontLoader>
			)
        }
        
        if( subtitleLoadGoogleFonts == true ) {
					
			const subtitleconfig = {
				google: {
					families: [ subtitlefontFamily + ( subtitlefontWeight ? ":" + subtitlefontWeight : "" ) ],
				},
			}

			loadsubTitleGoogleFonts = (
				<WebfontLoader config={ subtitleconfig }>
				</WebfontLoader>
			)
        }

        if( progressLoadGoogleFonts == true ) {
					
			const progressconfig = {
				google: {
					families: [ progressfontFamily + ( progressfontWeight ? ":" + progressfontWeight : "" ) ],
				},
			}

			loadprogressGoogleFonts = (
				<WebfontLoader config={ progressconfig }>
				</WebfontLoader>
			)
        }

        const Tag1  = titleTag1
        const Tag2  = titleTag2
        
        return (
            <Fragment>
                <InspectorControls key="inspector">
                <PanelBody title={`General Settings`} initialOpen={false}  icon={ getIcon( 'documentation' ) } className={ 'abblocks-panel-label' }>
                        
                    <ToggleControl
                        label={ __( 'Show Title' ) }                        
                        checked={ showTitle }                                      
                        onChange={ ( ) => setAttributes( { showTitle: ! showTitle } ) }
                    />

                    <ToggleControl
                        label={ __( 'Show Sub Title' ) }                        
                        checked={ showSubTitle }                                      
                        onChange={ ( ) => setAttributes( { showSubTitle: ! showSubTitle } ) }
                    />

                    <BoxShadow label={__('Box-Shadow')} value={boxShadow} onChange={(value) => setAttributes({ boxShadow: value })} />
                </PanelBody>
                
                <PanelBody title={ __( 'Typography' ) } initialOpen={false}  icon={ getIcon( 'typography' ) } className={ 'abblocks-panel-label' }>
                    <SelectControl
                        label={ __( 'Title Heading Tag' ) }
                        value={ titleTag1 }
                        options= {[
                                { value: 'h2', label: 'Heading 2 (h2)' },
                                { value: 'h3', label: 'Heading 3 (h3)' },
                                { value: 'h4', label: 'Heading 4 (h4)' },
                                { value: 'h5', label: 'Heading 5 (h5)' },
                                { value: 'h6', label: 'Heading 6 (h6)' },
                                { value: 'p', label: 'Paragraph (p)' },
                            ]}
                            onChange={ ( value ) => setAttributes( { titleTag1: value } ) }
                     />
                     <SelectControl
                        label={ __( 'Sub Heading Tag' ) }
                        value={ titleTag2 }
                        options= {[
                                { value: 'h2', label: 'Heading 2 (h2)' },
                                { value: 'h3', label: 'Heading 3 (h3)' },
                                { value: 'h4', label: 'Heading 4 (h4)' },
                                { value: 'h5', label: 'Heading 5 (h5)' },
                                { value: 'h6', label: 'Heading 6 (h6)' },
                                { value: 'p', label: 'Paragraph (p)' },
                            ]}
                            onChange={ ( value ) => setAttributes( { titleTag2: value } ) }
                     />
                        
                    <TypographyControl
                        label={__("Title Typography")}
                        attributes={attributes}
                        setAttributes={setAttributes}
                        loadGoogleFonts={{ value:titleLoadGoogleFonts, label: __("titleLoadGoogleFonts") }}
                        fontFamily={{ value: titlefontFamily, label: __("titlefontFamily") }}
                        fontWeight={{ value: titlefontWeight, label: __("titlefontWeight") }}
                        fontSubset={{ value: titlefontSubset, label: __("titlefontSubset") }}
                        fontSizeType={{ value: titlefontSizeType, label: __("titlefontSizeType") }}
                        fontSizeTypeMobile={{ value: titlefontSizeTypeMobile, label: __("titlefontSizeTypeMobile") }}
                        fontSizeTypeTablet={{ value: titlefontSizeTypeTablet, label: __("titlefontSizeTypeTablet") }}
                        fontSize={{ value: titlefontSizeDesktop, label: __("titlefontSizeDesktop") }}
                        fontSizeMobile={{ value: titlefontSizeMobile, label: __("titlefontSizeMobile") }}
                        fontSizeTablet={{ value: titlefontSizeTablet, label: __("titlefontSizeTablet") }}
                        lineHeightType={{ value: '', label: __(" ") }}
                        lineHeight={{ value: titlelineHeight, label: __("titlelineHeight") }}
                        lineHeightMobile={{ value: titlelineHeightMobile, label: __("titlelineHeightMobile") }}
                        lineHeightTablet={{ value: titlelineHeightTablet, label: __("titlelineHeightTablet") }}
                        letterSpacing={{ value: titleletterSpacing, label: __("titleletterSpacing") }}
                        letterSpacingMobile={{ value: titleletterSpacingMobile, label: __("titleletterSpacingMobile") }}
                        letterSpacingTablet={{ value: titleletterSpacingTablet, label: __("titleletterSpacingTablet") }}
                        letterSpacingType={{ value: titleletterSpacingType, label: __("titleletterSpacingType") }}
                        letterSpacingTypeTablet={{ value: titleletterSpacingTypeTablet, label: __("titleletterSpacingTypeTablet") }}
                        letterSpacingTypeMobile={{ value: titleletterSpacingTypeMobile, label: __("titleletterSpacingTypeMobile") }}
                        textTransform={titletextTransform}
                        onTextTransform={(value) => setAttributes({ titletextTransform: value })}
                        textDecoration={titletextDecoration}
                        onTextDecoration={(value) => setAttributes({ titletextDecoration: value })}
                        fontStyle={titlefontStyle}
                        onFontStyle={(value) => setAttributes({ titlefontStyle: value })}
                    />
                    <TypographyControl
                        label={__("Sub title Typography")}
                        attributes={attributes}
                        setAttributes={setAttributes}
                        loadGoogleFonts={{ value:subtitleLoadGoogleFonts, label: __("subtitleLoadGoogleFonts") }}
                        fontFamily={{ value: subtitlefontFamily, label: __("subtitlefontFamily") }}
                        fontWeight={{ value: subtitlefontWeight, label: __("subtitlefontWeight") }}
                        fontSubset={{ value: subtitlefontSubset, label: __("subtitlefontSubset") }}
                        fontSizeType={{ value: subtitlefontSizeType, label: __("subtitlefontSizeType") }}
                        fontSizeTypeMobile={{ value: subtitlefontSizeTypeMobile, label: __("subtitlefontSizeTypeMobile") }}
                        fontSizeTypeTablet={{ value: subtitlefontSizeTypeTablet, label: __("subtitlefontSizeTypeTablet") }}
                        fontSize={{ value: subtitlefontSizeDesktop, label: __("subtitlefontSizeDesktop") }}
                        fontSizeMobile={{ value: subtitlefontSizeMobile, label: __("subtitlefontSizeMobile") }}
                        fontSizeTablet={{ value: subtitlefontSizeTablet, label: __("subtitlefontSizeTablet") }}
                        lineHeightType={{ value: '', label: __(" ") }}
                        lineHeight={{ value: subtitlelineHeight, label: __("subtitlelineHeight") }}
                        lineHeightMobile={{ value: subtitlelineHeightMobile, label: __("subtitlelineHeightMobile") }}
                        lineHeightTablet={{ value: subtitlelineHeightTablet, label: __("subtitlelineHeightTablet") }}
                        letterSpacing={{ value: subtitleletterSpacing, label: __("subtitleletterSpacing") }}
                        letterSpacingMobile={{ value: subtitleletterSpacingMobile, label: __("subtitleletterSpacingMobile") }}
                        letterSpacingTablet={{ value: subtitleletterSpacingTablet, label: __("subtitleletterSpacingTablet") }}
                        letterSpacingType={{ value: subtitleletterSpacingType, label: __("subtitleletterSpacingType") }}
                        letterSpacingTypeTablet={{ value: subtitleletterSpacingTypeTablet, label: __("subtitleletterSpacingTypeTablet") }}
                        letterSpacingTypeMobile={{ value: subtitleletterSpacingTypeMobile, label: __("subtitleletterSpacingTypeMobile") }}
                        textTransform={subtitletextTransform}
                        onTextTransform={(value) => setAttributes({ subtitletextTransform: value })}
                        textDecoration={subtitletextDecoration}
                        onTextDecoration={(value) => setAttributes({ subtitletextDecoration: value })}
                        fontStyle={subtitlefontStyle}
                        onFontStyle={(value) => setAttributes({ subtitlefontStyle: value })}
                    />
                    <TypographyControl
                        label={__("Progress Typography")}
                        attributes={attributes}
                        setAttributes={setAttributes}
                        loadGoogleFonts={{ value:progressLoadGoogleFonts, label: __("progressLoadGoogleFonts") }}
                        fontFamily={{ value: progressfontFamily, label: __("progressfontFamily") }}
                        fontWeight={{ value: progressfontWeight, label: __("progressfontWeight") }}
                        fontSubset={{ value: progressfontSubset, label: __("progressfontSubset") }}
                        fontSizeType={{ value: progressfontSizeType, label: __("progressfontSizeType") }}
                        fontSizeTypeMobile={{ value: progressfontSizeTypeMobile, label: __("progressfontSizeTypeMobile") }}
                        fontSizeTypeTablet={{ value: progressfontSizeTypeTablet, label: __("progressfontSizeTypeTablet") }}
                        fontSize={{ value: progressfontSizeDesktop, label: __("progressfontSizeDesktop") }}
                        fontSizeMobile={{ value: progressfontSizeMobile, label: __("progressfontSizeMobile") }}
                        fontSizeTablet={{ value: progressfontSizeTablet, label: __("progressfontSizeTablet") }}
                        lineHeightType={{ value: '', label: __(" ") }}
                        lineHeight={{ value: progresslineHeight, label: __("progresslineHeight") }}
                        lineHeightMobile={{ value: progresslineHeightMobile, label: __("progresslineHeightMobile") }}
                        lineHeightTablet={{ value: progresslineHeightTablet, label: __("progresslineHeightTablet") }}
                        letterSpacing={{ value: progressletterSpacing, label: __("progressletterSpacing") }}
                        letterSpacingMobile={{ value: progressletterSpacingMobile, label: __("progressletterSpacingMobile") }}
                        letterSpacingTablet={{ value: progressletterSpacingTablet, label: __("progressletterSpacingTablet") }}
                        letterSpacingType={{ value: progressletterSpacingType, label: __("progressletterSpacingType") }}
                        letterSpacingTypeTablet={{ value: progressletterSpacingTypeTablet, label: __("progressletterSpacingTypeTablet") }}
                        letterSpacingTypeMobile={{ value: progressletterSpacingTypeMobile, label: __("progressletterSpacingTypeMobile") }}
                        textTransform={progresstextTransform}
                        onTextTransform={(value) => setAttributes({ progresstextTransform: value })}
                        textDecoration={progresstextDecoration}
                        onTextDecoration={(value) => setAttributes({ progresstextDecoration: value })}
                        fontStyle={progressfontStyle}
                        onFontStyle={(value) => setAttributes({ titlefontStyle: value })}
                    />
                </PanelBody>

                <PanelBody title={ __( 'Colors' ) } initialOpen={false}  icon={ getIcon( 'colors' ) } className={ 'abblocks-panel-label' }>
                    <Color label={__('Main Title Color')} disableAlpha value={titleTextColor} onChange={val => setAttributes({ titleTextColor: val })} />
                    <Color label={__('Sub Title Color')} disableAlpha value={subTitleTextColor} onChange={val => setAttributes({ subTitleTextColor: val })} />
                    <Color label={__('Box Background Color')} disableAlpha value={mainBgColor} onChange={val => setAttributes({ mainBgColor: val })} />
                </PanelBody>
                            
                            
                  <PanelBody title={__('Rating Bar 1')} initialOpen={false} icon={ getIcon( 'shapes' ) } className={ 'abblocks-panel-label' }>
                        <ToggleControl
                            label={ __( 'Show Ratings' ) }						
                            checked={ showRatings }										
                            onChange={ ( ) => setAttributes( { showRatings: ! showRatings } ) }
                        />
                    { showRatings && showRatings == true &&
                        <Fragment>

                          <ToggleControl
                                label={ __( 'Inside/Outside' ) }                      
                                checked={ inOut }                                     
                                onChange={ ( ) => setAttributes( { inOut: ! inOut } ) }
                            />
                          <Range label={__('Rating Width')} value={progressWidth} onChange={(value) => setAttributes({ progressWidth: value })} min={0} max={5} unit={['']} />
                          <Range label={__('Rating Height')} value={progressHeight} onChange={(value) => setAttributes({ progressHeight: value })} min={0} max={100} unit={['']} />
                          <Color label={__('Rating Background Color')} disableAlpha value={progressBgColor} onChange={val => setAttributes({ progressBgColor: val })} />
                          
                        </Fragment>
                    }
                  </PanelBody>


                  <PanelBody title={__('Rating Bar 2')} initialOpen={false} icon={ getIcon( 'shapes' ) } className={ 'abblocks-panel-label' }>
                        <ToggleControl
                            label={ __( 'Show Ratings' ) }                      
                            checked={ showRatings1 }                                     
                            onChange={ ( ) => setAttributes( { showRatings1: ! showRatings1 } ) }
                        />
                    { showRatings1 && showRatings1 == true &&
                        <Fragment>

                          <ToggleControl
                                label={ __( 'Inside/Outside' ) }                      
                                checked={ inOut1 }                                     
                                onChange={ ( ) => setAttributes( { inOut1: ! inOut1 } ) }
                            />
                          <Range label={__('Rating Width')} value={progressWidth1} onChange={(value) => setAttributes({ progressWidth1: value })} min={0} max={5} unit={['']} />
                          <Range label={__('Rating Height')} value={progressHeight1} onChange={(value) => setAttributes({ progressHeight1: value })} min={0} max={100} unit={['']} />
                          <Color label={__('Rating Background Color')} disableAlpha value={progressBgColor1} onChange={val => setAttributes({ progressBgColor1: val })} />
                          
                        </Fragment>
                    }
                  </PanelBody>


                  <PanelBody title={__('Rating Bar 3')} initialOpen={false} icon={ getIcon( 'shapes' ) } className={ 'abblocks-panel-label' }>
                        <ToggleControl
                            label={ __( 'Show Ratings' ) }                      
                            checked={ showRatings2 }                                     
                            onChange={ ( ) => setAttributes( { showRatings2: ! showRatings2 } ) }
                        />
                    { showRatings2 && showRatings2 == true &&
                        <Fragment>

                          <ToggleControl
                                label={ __( 'Inside/Outside' ) }                      
                                checked={ inOut2 }                                     
                                onChange={ ( ) => setAttributes( { inOut2: ! inOut2 } ) }
                            />
                          <Range label={__('Rating Width')} value={progressWidth2} onChange={(value) => setAttributes({ progressWidth2: value })} min={0} max={5} unit={['']} />
                          <Range label={__('Rating Height')} value={progressHeight2} onChange={(value) => setAttributes({ progressHeight2: value })} min={0} max={100} unit={['']} />
                          <Color label={__('Rating Background Color')} disableAlpha value={progressBgColor2} onChange={val => setAttributes({ progressBgColor2: val })} />
                          
                        </Fragment>
                    }
                  </PanelBody>

                  <PanelBody title={__('Rating Bar 4')} initialOpen={false} icon={ getIcon( 'shapes' ) } className={ 'abblocks-panel-label' }>
                        <ToggleControl
                            label={ __( 'Show Ratings' ) }                      
                            checked={ showRatings3 }                                     
                            onChange={ ( ) => setAttributes( { showRatings3: ! showRatings3 } ) }
                        />
                    { showRatings3 && showRatings3 == true &&
                        <Fragment>

                          <ToggleControl
                                label={ __( 'Inside/Outside' ) }                      
                                checked={ inOut3 }                                     
                                onChange={ ( ) => setAttributes( { inOut3: ! inOut3 } ) }
                            />
                          <Range label={__('Rating Width')} value={progressWidth3} onChange={(value) => setAttributes({ progressWidth3: value })} min={0} max={5} unit={['']} />
                          <Range label={__('Rating Height')} value={progressHeight3} onChange={(value) => setAttributes({ progressHeight3: value })} min={0} max={100} unit={['']} />
                          <Color label={__('Rating Background Color')} disableAlpha value={progressBgColor3} onChange={val => setAttributes({ progressBgColor3: val })} />
                          
                        </Fragment>
                    }
                  </PanelBody>


                  <PanelBody title={__('Rating Bar 5')} initialOpen={false} icon={ getIcon( 'shapes' ) } className={ 'abblocks-panel-label' }>
                        <ToggleControl
                            label={ __( 'Show Ratings' ) }                      
                            checked={ showRatings4 }                                     
                            onChange={ ( ) => setAttributes( { showRatings4: ! showRatings4 } ) }
                        />
                    { showRatings4 && showRatings4 == true &&
                        <Fragment>

                          <ToggleControl
                                label={ __( 'Inside/Outside' ) }                      
                                checked={ inOut4 }                                     
                                onChange={ ( ) => setAttributes( { inOut4: ! inOut4 } ) }
                            />
                          <Range label={__('Rating Width')} value={progressWidth4} onChange={(value) => setAttributes({ progressWidth4: value })} min={0} max={5} unit={['']} />
                          <Range label={__('Rating Height')} value={progressHeight4} onChange={(value) => setAttributes({ progressHeight4: value })} min={0} max={100} unit={['']} />
                          <Color label={__('Rating Background Color')} disableAlpha value={progressBgColor4} onChange={val => setAttributes({ progressBgColor4: val })} />
                          
                        </Fragment>
                    }
                  </PanelBody>


                  <PanelBody title={__('Rating Bar 6')} initialOpen={false} icon={ getIcon( 'shapes' ) } className={ 'abblocks-panel-label' }>
                        <ToggleControl
                            label={ __( 'Show Ratings' ) }                      
                            checked={ showRatings5 }                                     
                            onChange={ ( ) => setAttributes( { showRatings5: ! showRatings5 } ) }
                        />
                    { showRatings5 && showRatings5 == true &&
                        <Fragment>

                          <ToggleControl
                                label={ __( 'Inside/Outside' ) }                      
                                checked={ inOut5 }                                     
                                onChange={ ( ) => setAttributes( { inOut5: ! inOut5 } ) }
                            />
                          <Range label={__('Rating Width')} value={progressWidth5} onChange={(value) => setAttributes({ progressWidth5: value })} min={0} max={5} unit={['']} />
                          <Range label={__('Rating Height')} value={progressHeight5} onChange={(value) => setAttributes({ progressHeight5: value })} min={0} max={100} unit={['']} />
                          <Color label={__('Rating Background Color')} disableAlpha value={progressBgColor5} onChange={val => setAttributes({ progressBgColor5: val })} />
                          
                        </Fragment>
                    }
                  </PanelBody>


                  <PanelBody title={__('Rating Bar 7')} initialOpen={false} icon={ getIcon( 'shapes' ) } className={ 'abblocks-panel-label' }>
                        <ToggleControl
                            label={ __( 'Show Ratings' ) }                      
                            checked={ showRatings6 }                                     
                            onChange={ ( ) => setAttributes( { showRatings6: ! showRatings5 } ) }
                        />
                    { showRatings6 && showRatings6 == true &&
                        <Fragment>

                          <ToggleControl
                                label={ __( 'Inside/Outside' ) }                      
                                checked={ inOut6 }                                     
                                onChange={ ( ) => setAttributes( { inOut6: ! inOut5 } ) }
                            />
                          <Range label={__('Rating Width')} value={progressWidth6} onChange={(value) => setAttributes({ progressWidth6: value })} min={0} max={5} unit={['']} />
                          <Range label={__('Rating Height')} value={progressHeight6} onChange={(value) => setAttributes({ progressHeight6: value })} min={0} max={100} unit={['']} />
                          <Color label={__('Rating Background Color')} disableAlpha value={progressBgColor6} onChange={val => setAttributes({ progressBgColor6: val })} />
                          
                        </Fragment>
                    }
                  </PanelBody>


                  <PanelBody title={__('Rating Bar 8')} initialOpen={false} icon={ getIcon( 'shapes' ) } className={ 'abblocks-panel-label' }>
                        <ToggleControl
                            label={ __( 'Show Ratings' ) }                      
                            checked={ showRatings7 }                                     
                            onChange={ ( ) => setAttributes( { showRatings7: ! showRatings5 } ) }
                        />
                    { showRatings7 && showRatings7 == true &&
                        <Fragment>

                          <ToggleControl
                                label={ __( 'Inside/Outside' ) }                      
                                checked={ inOut7 }                                     
                                onChange={ ( ) => setAttributes( { inOut7: ! inOut5 } ) }
                            />
                          <Range label={__('Rating Width')} value={progressWidth7} onChange={(value) => setAttributes({ progressWidth7: value })} min={0} max={5} unit={['']} />
                          <Range label={__('Rating Height')} value={progressHeight7} onChange={(value) => setAttributes({ progressHeight7: value })} min={0} max={100} unit={['']} />
                          <Color label={__('Rating Background Color')} disableAlpha value={progressBgColor7} onChange={val => setAttributes({ progressBgColor7: val })} />
                          
                        </Fragment>
                    }
                  </PanelBody>


                  <PanelBody title={__('Rating Bar 9')} initialOpen={false} icon={ getIcon( 'shapes' ) } className={ 'abblocks-panel-label' }>
                        <ToggleControl
                            label={ __( 'Show Ratings' ) }                      
                            checked={ showRatings8 }                                     
                            onChange={ ( ) => setAttributes( { showRatings8: ! showRatings8 } ) }
                        />
                    { showRatings8 && showRatings8 == true &&
                        <Fragment>

                          <ToggleControl
                                label={ __( 'Inside/Outside' ) }                      
                                checked={ inOut8 }                                     
                                onChange={ ( ) => setAttributes( { inOut8: ! inOut8 } ) }
                            />
                          <Range label={__('Rating Width')} value={progressWidth8} onChange={(value) => setAttributes({ progressWidth8: value })} min={0} max={5} unit={['']} />
                          <Range label={__('Rating Height')} value={progressHeight8} onChange={(value) => setAttributes({ progressHeight8: value })} min={0} max={100} unit={['']} />
                          <Color label={__('Rating Background Color')} disableAlpha value={progressBgColor8} onChange={val => setAttributes({ progressBgColor8: val })} />
                          
                        </Fragment>
                    }
                  </PanelBody>

                  <PanelBody title={__('Rating Bar 10')} initialOpen={false} icon={ getIcon( 'shapes' ) } className={ 'abblocks-panel-label' }>
                        <ToggleControl
                            label={ __( 'Show Ratings' ) }                      
                            checked={ showRatings9 }                                     
                            onChange={ ( ) => setAttributes( { showRatings9: ! showRatings5 } ) }
                        />
                    { showRatings9 && showRatings9 == true &&
                        <Fragment>

                          <ToggleControl
                                label={ __( 'Inside/Outside' ) }                      
                                checked={ inOut9 }                                     
                                onChange={ ( ) => setAttributes( { inOut9: ! inOut9 } ) }
                            />
                          <Range label={__('Rating Width')} value={progressWidth9} onChange={(value) => setAttributes({ progressWidth9: value })} min={0} max={5} unit={['']} />
                          <Range label={__('Rating Height')} value={progressHeight9} onChange={(value) => setAttributes({ progressHeight9: value })} min={0} max={100} unit={['']} />
                          <Color label={__('Rating Background Color')} disableAlpha value={progressBgColor9} onChange={val => setAttributes({ progressBgColor9: val })} />
                          
                        </Fragment>
                    }
                  </PanelBody>

                  
                </InspectorControls>
                
                <div id={`affiliate-style-${block_id}`} className={`affiliate-block-${block_id}${className ? ` ${className}` : ''} affiliate-rb-wrapper`}>
                    <div className={`affiliate-rb-inner`}>
                    
                        <div className={`affiliate-rb-maintitle`}>
                        { showTitle && showTitle == true &&
                            <RichText
                                tagName={Tag1}
                                value={ratingBarMainTitle} 
                                className=""
                                id={`getSlug(${uniqueId})`}
                                placeholder={__('Great')}
                                onChange={ratingBarMainTitle => setAttributes({ ratingBarMainTitle })}
                                keepPlaceholderOnFocus
                            />     
                        }
                        </div>
                    
                        <div className={`affiliate-rb-content-wrapper`}>
                        <div className={`affiliate-rb-content-inner`}>                            
                            
                                <div className={`affiliate-col`}>
                                { showSubTitle && showSubTitle == true &&
                                     <RichText
                                        tagName={Tag2}
                                        value={ratingBarSubTitle}
                                        className="affiliate-ratingbar-sub-title"
                                        id={`getSlug(${uniqueId})`}
                                        placeholder={__('Great')}
                                        onChange={ratingBarSubTitle => setAttributes({ ratingBarSubTitle })}
                                        keepPlaceholderOnFocus
                                    />  
                                }                                                                    
                                </div>
                            
                        </div>
                        <div className={`affiliate-rb-footer-wrapper`}>
                          
                            <div className={`affiliate-rb-progress`}>
                              { showRatings && showRatings == true &&
                                    <div class="affiliate-block-progress-bar ">
                                        <div class="affiliate-block-progress-labels affiliate-position-outside">                                       
                                            <div class={`affiliate-block-progress-bar-title ${inOut ? ` ${inOut}` : ''} `} >
                                                <RichText
                                                    tagName="span"
                                                    value={progressText}
                                                    className="affiliate-progress-text"
                                                    placeholder={__('Great')}
                                                    onChange={progressText => setAttributes({ progressText })}
                                                    keepPlaceholderOnFocus
                                                />
                                            </div>
                                        </div>
                                        <div class="affiliate-progress">
                                            <div class="affiliate-progress-bar" role="progressbar">
                                                <div class="affiliate-progress-striped">
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                }
                                </div>



                                <div className={`affiliate-rb-progress`}>
                                  { showRatings1 && showRatings1 == true &&
                                        <div class="affiliate-block-progress-bar ">
                                            <div class="affiliate-block-progress-labels affiliate-position-outside">                                       
                                                <div class={`affiliate-block-progress-bar-title ${inOut1 ? ` ${inOut1}` : ''} `} >
                                                    <RichText
                                                        tagName="span"
                                                        value={progressText1}
                                                        className="affiliate-progress-text"
                                                        placeholder={__('Great')}
                                                        onChange={progressText1 => setAttributes({ progressText1 })}
                                                        keepPlaceholderOnFocus
                                                    />
                                                </div>
                                            </div>
                                            <div class="affiliate-progress1">
                                                <div class="affiliate-progress-bar1" role="progressbar">
                                                    <div class="affiliate-progress-striped">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    }
                                    </div>


                                    <div className={`affiliate-rb-progress`}>
                                  { showRatings2 && showRatings2 == true &&
                                        <div class="affiliate-block-progress-bar ">
                                            <div class="affiliate-block-progress-labels affiliate-position-outside">                                       
                                                <div class={`affiliate-block-progress-bar-title ${inOut2 ? ` ${inOut2}` : ''} `} >
                                                    <RichText
                                                        tagName="span"
                                                        value={progressText2}
                                                        className="affiliate-progress-text"
                                                        placeholder={__('Great')}
                                                        onChange={progressText2 => setAttributes({ progressText2 })}
                                                        keepPlaceholderOnFocus
                                                    />
                                                </div>
                                            </div>
                                            <div class="affiliate-progress2">
                                                <div class="affiliate-progress-bar2" role="progressbar">
                                                    <div class="affiliate-progress-striped">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    }
                                    </div>



                                    <div className={`affiliate-rb-progress`}>
                                  { showRatings3 && showRatings3 == true &&
                                        <div class="affiliate-block-progress-bar ">
                                            <div class="affiliate-block-progress-labels affiliate-position-outside">                                       
                                                <div class={`affiliate-block-progress-bar-title ${inOut3 ? ` ${inOut3}` : ''} `} >
                                                    <RichText
                                                        tagName="span"
                                                        value={progressText3}
                                                        className="affiliate-progress-text"
                                                        placeholder={__('Great')}
                                                        onChange={progressText3 => setAttributes({ progressText3 })}
                                                        keepPlaceholderOnFocus
                                                    />
                                                </div>
                                            </div>
                                            <div class="affiliate-progress3">
                                                <div class="affiliate-progress-bar3" role="progressbar">
                                                    <div class="affiliate-progress-striped">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    }
                                    </div>


                                    <div className={`affiliate-rb-progress`}>
                                  { showRatings4 && showRatings4 == true &&
                                        <div class="affiliate-block-progress-bar ">
                                            <div class="affiliate-block-progress-labels affiliate-position-outside">                                       
                                                <div class={`affiliate-block-progress-bar-title ${inOut4 ? ` ${inOut4}` : ''} `} >
                                                    <RichText
                                                        tagName="span"
                                                        value={progressText4}
                                                        className="affiliate-progress-text"
                                                        placeholder={__('Great')}
                                                        onChange={progressText4 => setAttributes({ progressText4 })}
                                                        keepPlaceholderOnFocus
                                                    />
                                                </div>
                                            </div>
                                            <div class="affiliate-progress4">
                                                <div class="affiliate-progress-bar4" role="progressbar">
                                                    <div class="affiliate-progress-striped">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    }
                                    </div>



                                    <div className={`affiliate-rb-progress`}>
                                  { showRatings5 && showRatings5 == true &&
                                        <div class="affiliate-block-progress-bar ">
                                            <div class="affiliate-block-progress-labels affiliate-position-outside">                                       
                                                <div class={`affiliate-block-progress-bar-title ${inOut5 ? ` ${inOut5}` : ''} `} >
                                                    <RichText
                                                        tagName="span"
                                                        value={progressText5}
                                                        className="affiliate-progress-text"
                                                        placeholder={__('Great')}
                                                        onChange={progressText5 => setAttributes({ progressText5 })}
                                                        keepPlaceholderOnFocus
                                                    />
                                                </div>
                                            </div>
                                            <div class="affiliate-progress5">
                                                <div class="affiliate-progress-bar5" role="progressbar">
                                                    <div class="affiliate-progress-striped">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    }
                                    </div>


                                    <div className={`affiliate-rb-progress`}>
                                  { showRatings6 && showRatings6 == true &&
                                        <div class="affiliate-block-progress-bar ">
                                            <div class="affiliate-block-progress-labels affiliate-position-outside">                                       
                                                <div class={`affiliate-block-progress-bar-title ${inOut6 ? ` ${inOut6}` : ''} `} >
                                                    <RichText
                                                        tagName="span"
                                                        value={progressText6}
                                                        className="affiliate-progress-text"
                                                        placeholder={__('Great')}
                                                        onChange={progressText6 => setAttributes({ progressText6 })}
                                                        keepPlaceholderOnFocus
                                                    />
                                                </div>
                                            </div>
                                            <div class="affiliate-progress6">
                                                <div class="affiliate-progress-bar6" role="progressbar">
                                                    <div class="affiliate-progress-striped">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    }
                                    </div>


                                    <div className={`affiliate-rb-progress`}>
                                  { showRatings7 && showRatings7 == true &&
                                        <div class="affiliate-block-progress-bar ">
                                            <div class="affiliate-block-progress-labels affiliate-position-outside">                                       
                                                <div class={`affiliate-block-progress-bar-title ${inOut7 ? ` ${inOut7}` : ''} `} >
                                                    <RichText
                                                        tagName="span"
                                                        value={progressText7}
                                                        className="affiliate-progress-text"
                                                        placeholder={__('Great')}
                                                        onChange={progressText7 => setAttributes({ progressText7 })}
                                                        keepPlaceholderOnFocus
                                                    />
                                                </div>
                                            </div>
                                            <div class="affiliate-progress7">
                                                <div class="affiliate-progress-bar7" role="progressbar">
                                                    <div class="affiliate-progress-striped">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    }
                                    </div>


                                    <div className={`affiliate-rb-progress`}>
                                  { showRatings8 && showRatings8 == true &&
                                        <div class="affiliate-block-progress-bar ">
                                            <div class="affiliate-block-progress-labels affiliate-position-outside">                                       
                                                <div class={`affiliate-block-progress-bar-title ${inOut8 ? ` ${inOut8}` : ''} `} >
                                                    <RichText
                                                        tagName="span"
                                                        value={progressText8}
                                                        className="affiliate-progress-text"
                                                        placeholder={__('Great')}
                                                        onChange={progressText8 => setAttributes({ progressText8 })}
                                                        keepPlaceholderOnFocus
                                                    />
                                                </div>
                                            </div>
                                            <div class="affiliate-progress8">
                                                <div class="affiliate-progress-bar8" role="progressbar">
                                                    <div class="affiliate-progress-striped">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    }
                                    </div>


                                    <div className={`affiliate-rb-progress`}>
                                  { showRatings9 && showRatings9 == true &&
                                        <div class="affiliate-block-progress-bar ">
                                            <div class="affiliate-block-progress-labels affiliate-position-outside">                                       
                                                <div class={`affiliate-block-progress-bar-title ${inOut9 ? ` ${inOut9}` : ''} `} >
                                                    <RichText
                                                        tagName="span"
                                                        value={progressText9}
                                                        className="affiliate-progress-text"
                                                        placeholder={__('Great')}
                                                        onChange={progressText9 => setAttributes({ progressText9 })}
                                                        keepPlaceholderOnFocus
                                                    />
                                                </div>
                                            </div>
                                            <div class="affiliate-progress9">
                                                <div class="affiliate-progress-bar9" role="progressbar">
                                                    <div class="affiliate-progress-striped">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    }
                                    </div>

                                
                                </div>
                            </div>        
                        </div>
                    </div>
                {loadtitleGoogleFonts}
                {loadsubTitleGoogleFonts}
                {loadprogressGoogleFonts}
            </Fragment>
        )
    }       
}

const applyWithSelect = withSelect( ( select, props ) => {
  const { getBlocks, getBlocksByClientId } = select( 'core/block-editor' );
	const innerBlocks = getBlocks( props.clientId );
    return {
      innerBlocks,
      hasInnerBlocks: select( 'core/block-editor' ).getBlocks( props.clientId ).length > 1,
    }
} );
export default compose( withNotices, applyWithSelect )( Edit );