import IconSelector from '../../components/fields/IconSelector/IconSelector.js';
import TypographyControl from '../components/typography/index.js';
import RadioAdvanced from '../../components/fields/RadioAdvanced.js';
import IconList  from '../../components/fields/IconList/IconList.js';
import WebfontLoader from "../components/typography/fontloader"
import Color  from '../../components/fields/Color/Color.js';
import Dimension  from '../../components/fields/Dimension/Dimension.js';
import affiliate_styling  from './styling.js';
import Media  from '../../components/fields/Media/Media.js';
import Background  from './../../components/fields/Background/Background.js';
import BorderTypes  from '../../components/fields/BorderTypes.js';
import BoxShadow  from '../../components/fields/BoxShadow.js';
import Alignment from '../../components/fields/Alignment.js';
import Range from '../../components/fields/Range/Range.js';
import icons from '../../components/icons.js';
import Tabs from '../../components/fields/Tabs/Tabs.js';
import Tab from '../../components/fields/Tab/Tab.js';
import ProductImage from './productImage';
import getIcon from '../../icons/get-icon';

const { __ } = wp.i18n;
const {
    InspectorControls,
    BlockControls,
    RichText,
    MediaUpload,
    URLInput,
    URLInputButton,
    InnerBlocks
} = wp.blockEditor;

const {
    Component,
    Fragment
} = wp.element;

const {
    PanelBody,
    Toolbar,
    Tooltip,
    TextControl,
    TextareaControl,
    ToggleControl,
    TabPanel,
    Dashicon,
    Button,
    IconButton,
    Popover,
    Dropdown,
    SelectControl 
} = wp.components;

$ = jQuery;

let imageSizeOptions = [
	{ value: "thumbnail", label: __( "Thumbnail" ) },
	{ value: "medium", label: __( "Medium" ) },
	{ value: "full", label: __( "Large" ) }
]

const NEW_TAB_REL = 'noopener noreferrer';

class Edit extends Component {

    constructor(props) {
        super(props)
        this.state = {
          // removeItemViaBackSpace: 999,
          // isVisible:false,
          // focusedItem: this.props.attributes.listItems.length - 1,
      }

        this.onSelectImage    = this.onSelectImage.bind( this )
        this.getImageSize  	  = this.getImageSize.bind(this)
        this.getSlug     = this.getSlug.bind(this)
    }

    
    
    componentDidMount() {
      const {
          clientId,
          isSelected,
          setAttributes,
          attributes: {
              uniqueId,
              block_id
          }
      } = this.props;
      const _client = clientId.substr(0, 6);

      if (!uniqueId) {
          setAttributes({ uniqueId: _client });
      } else if (uniqueId && uniqueId != _client) {
          setAttributes({ uniqueId: _client });
      }
        
      this.props.setAttributes({ block_id: this.props.clientId })
      const $style = document.createElement("style")
      $style.setAttribute("id", "affiliate-style-" + this.props.clientId)
      document.head.appendChild($style)
  
  }


     /*
      * Event to set Image as while adding.
      */
     onSelectImage( media ) {
      // console.log(this.props)  
      const { image } = this.props.attributes
      const { setAttributes } = this.props

      if ( ! media || ! media.url ) {
        setAttributes( { image: {} } )
        return
      }

      if ( ! media.type || "image" !== media.type ) {
        setAttributes( { image: {} } )
        return
      }
      // if ( media["sizes"] ) {
      //   var new_img = this.getImageSize(media["sizes"])
      //     imageSizeOptions = new_img
      // }
      setAttributes( { image: media } )
    }

    getImageSize( sizes ) {
      var size_arr = []
      $.each(sizes, function (index, item) {
        var name = index
          var p = { "value" : name, "label": name }
          size_arr.push(p)
      })
      return(size_arr)
    }

    getSlug( title ) {
      return title.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-");
    }
    

    /*
    * Event to set Image as null while removing.
    */
    onRemoveImage() {
      const { image } = this.props.attributes
      const { setAttributes } = this.props

      setAttributes( { image: null } )
    }

    removeImage( url ){
      const { multiple, onChangem,setAttributes } = this.props
      const { image } = this.props.attributes
        setAttributes( { image: {} } )

    }
    
    isUrl(url){
      if( ['wbm','jpg','jpeg','gif','png', 'svg'].indexOf( url.split('.').pop().toLowerCase() ) != -1 ){
        return url;
      }
    }

    render() {
        const {
            name,
            clientId,
            isSelected,
            attributes,
            setAttributes,
            attributes: {
                uniqueId,
                block_id,
                className,
                spTitle,
                spSubTitle,
                titleLoadGoogleFonts,
                spBtnText,
                spContent,
                spBtnHref,
                titleTextColor,
                titlefontFamily,
                titlefontWeight,
                titlefontSubset,
                titlefontSizeType,
                titlefontSizeTypeMobile,
                titlefontSizeTypeTablet,
                titlefontSizeDesktop,
                titlefontSizeMobile,
                titlefontSizeTablet,
                titlelineHeight,
                titlelineHeightMobile,
                titlelineHeightTablet,
                titleletterSpacing,
                titleletterSpacingMobile,
                titleletterSpacingTablet,
                titleletterSpacingType,
                titleletterSpacingTypeTablet,
                titleletterSpacingTypeMobile,
                titletextTransform,
                titletextDecoration,
                titlefontStyle,
                titleAlignment,
                titleAlignmentMobile,
                titleAlignmentTablet,
                // CTA BUTTON
                enable_btn1,
                btnLoadGoogleFonts,
                btnfontFamily,
                btnfontWeight,
                listItems,
                bulletStyle,
                listType,
                btnfontSubset,
                btnfontSizeType,
                btnfontSizeTypeMobile,
                btnfontSizeTypeTablet,
                btnfontSizeDesktop,
                btnfontSizeMobile,
                btnfontSizeTablet,
                btnlineHeight,
                btnlineHeightMobile,
                btnlineHeightTablet,
                btnletterSpacing,
                btnletterSpacingMobile,
                btnletterSpacingTablet,
                btnletterSpacingType,
                btnletterSpacingTypeTablet,
                btnletterSpacingTypeMobile,
                btntextTransform,
                btntextDecoration,
                btnfontStyle,
                btnBgColor,
                btnHoverBgColor,
                btnTextColor,
                btnTextHoverColor,
                btnBorderColor,
                btnBorderHoverColor,
                btn_Htarget,
                btnPadding,
                btnPaddingMobile,
                btnPaddingTablet,
                btnMargin,
                btnMarginMobile,
                btnMarginTablet,
                btnAlignment,
                btnAlignmentMobile,
                btnAlignmentTablet,
                btnBorder,
                btnBorderType,
                btnBorderMobile,
                btnBorderTablet,
                btnBorderRadius,
                btnBorderRadiusMobile,
                btnBorderRadiusTablet,
                enableGlimmerEffect,
                enableGlimmerEffect2,
                enableGlimmerEffect3,
                // CTA content
                cntnLoadGoogleFonts,
                cntnfontFamily,
                cntnfontWeight,
                cntnfontSubset,
                cntnfontSizeType,
                cntnfontSizeTypeMobile,
                cntnfontSizeTypeTablet,
                cntnfontSizeDesktop,
                cntnfontSizeMobile,
                cntnfontSizeTablet,
                cntnlineHeight,
                cntnlineHeightMobile,
                cntnlineHeightTablet,
                cntnletterSpacing,
                cntnletterSpacingMobile,
                cntnletterSpacingTablet,
                cntnletterSpacingType,
                cntnletterSpacingTypeTablet,
                cntnletterSpacingTypeMobile,
                cntntextTransform,
                cntntextDecoration,
                cntnfontStyle,
                cntnTextColor,
                // Box
                boxPadding,
                boxPaddingMobile,
                boxPaddingTablet,
                boxMargin,
                boxMarginMobile,
                boxMarginTablet,
                image,
                // Sub Title
                subtitleLoadGoogleFonts,
                subtitleTextColor,
                subtitlefontFamily,
                subtitlefontWeight,
                subtitlefontSubset,
                subtitlefontSizeType,
                subtitlefontSizeTypeMobile,
                subtitlefontSizeTypeTablet,
                subtitlefontSizeDesktop,
                subtitlefontSizeMobile,
                subtitlefontSizeTablet,
                subtitlelineHeight,
                subtitlelineHeightMobile,
                subtitlelineHeightTablet,
                subtitleletterSpacing,
                subtitleletterSpacingMobile,
                subtitleletterSpacingTablet,
                subtitleletterSpacingType,
                subtitleletterSpacingTypeTablet,
                subtitleletterSpacingTypeMobile,
                subtitletextTransform,
                subtitletextDecoration,
                subtitlefontStyle,
                subtitleAlignment,
                subtitleAlignmentMobile,
                subtitleAlignmentTablet,
                boxBorderType,
                boxBorderColor,
                boxBorderWidth,
                boxBackgroundColor,
                boxShadow,
                cntnAlignment,
                cntnAlignmentMobile,
                cntnAlignmentTablet,
                btnSize,
                buttonIcon,
                iconPosition,
                buttonWidth,
                bntRounded,
                contentType,
                pContent,
                imageSize,
                imagePadding,
                imagePaddingMobile,
                imagePaddingTablet,
                customImgWidth,
                customImgWidthMobile,
                customImgWidthTablet,
                iconColor,
                designType,
                listTextItems,
                titleTag1,
                titleTag2,
                btnRel,


                // CTA BUTTON
                enable_btn2,
                buttonIcon2,
                spBtnText2,
                spBtnHref2,
                btnRel2,
                btnSize2,
                btnLoadGoogleFonts2,
                btnfontFamily2,
                btnfontWeight2,
                btnfontSubset2,
                btnfontSizeType2,
                btnfontSizeTypeMobile2,
                btnfontSizeTypeTablet2,
                btnfontSizeDesktop2,
                btnfontSizeMobile2,
                btnfontSizeTablet2,
                btnlineHeight2,
                btnlineHeightMobile2,
                btnlineHeightTablet2,
                btnletterSpacing2,
                btnletterSpacingMobile2,
                btnletterSpacingTablet2,
                btnletterSpacingType2,
                btnletterSpacingTypeTablet2,
                btnletterSpacingTypeMobile2,
                btntextTransform2,
                btntextDecoration2,
                btnfontStyle2,
                btnBgColor2,
                btnHoverBgColor2,
                btnTextColor2,
                btnTextHoverColor2,
                btnBorderColor2,
                btnBorderHoverColor2,
                btn_Htarget2,
                btnPadding2,
                btnPaddingMobile2,
                btnPaddingTablet2,
                btnMargin2,
                btnMarginMobile2,
                btnMarginTablet2,
                btnAlignment2,
                btnAlignmentMobile2,
                btnAlignmentTablet2,
                btnBorder2,
                btnBorderType2,
                btnBorderMobile2,
                btnBorderTablet2,
                btnBorderRadius2,
                btnBorderRadiusMobile2,
                btnBorderRadiusTablet2,
                iconPosition2,
                buttonWidth2,
                bntRounded2,


                // CTA BUTTON
                enable_btn3,
                buttonIcon3,
                spBtnText3,
                spBtnHref3,
                btnRel3,
                btnSize3,
                btnLoadGoogleFonts3,
                btnfontFamily3,
                btnfontWeight3,
                btnfontSubset3,
                btnfontSizeType3,
                btnfontSizeTypeMobile3,
                btnfontSizeTypeTablet3,
                btnfontSizeDesktop3,
                btnfontSizeMobile3,
                btnfontSizeTablet3,
                btnlineHeight3,
                btnlineHeightMobile3,
                btnlineHeightTablet3,
                btnletterSpacing3,
                btnletterSpacingMobile3,
                btnletterSpacingTablet3,
                btnletterSpacingType3,
                btnletterSpacingTypeTablet3,
                btnletterSpacingTypeMobile3,
                btntextTransform3,
                btntextDecoration3,
                btnfontStyle3,
                btnBgColor3,
                btnHoverBgColor3,
                btnTextColor3,
                btnTextHoverColor3,
                btnBorderColor3,
                btnBorderHoverColor3,
                btn_Htarget3,
                btnPadding3,
                btnPaddingMobile3,
                btnPaddingTablet3,
                btnMargin3,
                btnMarginMobile3,
                btnMarginTablet3,
                btnAlignment3,
                btnAlignmentMobile3,
                btnAlignmentTablet3,
                btnBorder3,
                btnBorderType3,
                btnBorderMobile3,
                btnBorderTablet3,
                btnBorderRadius3,
                btnBorderRadiusMobile3,
                btnBorderRadiusTablet3,
                iconPosition3,
                buttonWidth3,
                bntRounded3,

                externalImage,
                externalImageSrc,

                amazonprice,
                amazonpriceposition,
                amazonrating,
                amazonratingposition,
                amazonimage,

                amazonpriceLoadGoogleFonts,
                amazonpriceTextColor,
                amazonpricefontFamily,
                amazonpricefontWeight,
                amazonpricefontSubset,
                amazonpricefontSizeType,
                amazonpricefontSizeTypeMobile,
                amazonpricefontSizeTypeTablet,
                amazonpricefontSizeDesktop,
                amazonpricefontSizeMobile,
                amazonpricefontSizeTablet,
                amazonpricelineHeight,
                amazonpricelineHeightMobile,
                amazonpricelineHeightTablet,
                amazonpriceletterSpacing,
                amazonpriceletterSpacingMobile,
                amazonpriceletterSpacingTablet,
                amazonpriceletterSpacingType,
                amazonpriceletterSpacingTypeTablet,
                amazonpriceletterSpacingTypeMobile,
                amazonpricetextTransform,
                amazonpricetextDecoration,
                amazonpricefontStyle, 
                amazonpriceAlignment,
                amazonpriceAlignmentMobile,
                amazonpriceAlignmentTablet,



                amazonratingLoadGoogleFonts,
                amazonratingTextColor,
                amazonratingfontFamily,
                amazonratingfontWeight,
                amazonratingfontSubset,
                amazonratingfontSizeType,
                amazonratingfontSizeTypeMobile,
                amazonratingfontSizeTypeTablet,
                amazonratingfontSizeDesktop,
                amazonratingfontSizeMobile,
                amazonratingfontSizeTablet,
                amazonratinglineHeight,
                amazonratinglineHeightMobile,
                amazonratinglineHeightTablet,
                amazonratingletterSpacing,
                amazonratingletterSpacingMobile,
                amazonratingletterSpacingTablet,
                amazonratingletterSpacingType,
                amazonratingletterSpacingTypeTablet,
                amazonratingletterSpacingTypeMobile,
                amazonratingtextTransform,
                amazonratingtextDecoration,
                amazonratingfontStyle, 
                amazonratingAlignment,
                amazonratingAlignmentMobile,
                amazonratingAlignmentTablet,

                showTitle,
                showSubTitle,
                showContent,

                btnBg,
                btnBgHover,
                btnBg2,
                btnBgHover2,
                btnBg3,
                btnBgHover3,

            }
        } = this.props;

        const { isVisible } = this.state
        // imageSizeOptions = this.getImageSize(image["sizes"])
        // console.log(image)
        var element = document.getElementById("affiliate-style-" + this.props.clientId)
        if (null != element && "undefined" != typeof element) {
             element.innerHTML = affiliate_styling(this.props, "affiliate-style")
        }
        
        let loadtitleGoogleFonts
        let loadcntnGoogleFonts
        let loadbtnGoogleFonts
        let loadbtnGoogleFonts2
        let loadbtnGoogleFonts3
        let loadsubTitleGoogleFonts

        let loadamazonpriceGoogleFonts
        let loadamazonratingGoogleFonts

        if( btnLoadGoogleFonts == true ) {
					
    			const btnconfig = {
    				google: {
    					families: [ btnfontFamily + ( btnfontWeight ? ":" + btnfontWeight : "" ) ],
    				},
    			}

    			loadbtnGoogleFonts = (
    				<WebfontLoader config={ btnconfig }>
    				</WebfontLoader>
    			)
    		}


        if( btnLoadGoogleFonts2 == true ) {
          
          const btnconfig2 = {
            google: {
              families: [ btnfontFamily2 + ( btnfontWeight2 ? ":" + btnfontWeight2 : "" ) ],
            },
          }

          loadbtnGoogleFonts2 = (
            <WebfontLoader config={ btnconfig2 }>
            </WebfontLoader>
          )
        }


        if( btnLoadGoogleFonts3 == true ) {
          
          const btnconfig3 = {
            google: {
              families: [ btnfontFamily3 + ( btnfontWeight3 ? ":" + btnfontWeight3 : "" ) ],
            },
          }

          loadbtnGoogleFonts3 = (
            <WebfontLoader config={ btnconfig3 }>
            </WebfontLoader>
          )
        }

        if( titleLoadGoogleFonts == true ) {
					
          const titleconfig = {
            google: {
              families: [ titlefontFamily + ( titlefontWeight ? ":" + titlefontWeight : "" ) ],
            },
          }

          loadtitleGoogleFonts = (
            <WebfontLoader config={ titleconfig }>
            </WebfontLoader>
          )
        } 

        if( subtitleLoadGoogleFonts == true ) {
					
          const subtitleconfig = {
            google: {
              families: [ subtitlefontFamily + ( subtitlefontWeight ? ":" + subtitlefontWeight : "" ) ],
            },
          }

          loadsubTitleGoogleFonts = (
            <WebfontLoader config={ subtitleconfig }>
            </WebfontLoader>
          )
        } 


        if( amazonpriceLoadGoogleFonts == true ) {
                    
          const amazonpriceconfig = {
            google: {
              families: [ amazonpricefontFamily + ( amazonpricefontWeight ? ":" + amazonpricefontWeight : "" ) ],
            },
          }

          loadamazonpriceGoogleFonts = (
            <WebfontLoader config={ amazonpriceconfig }>
            </WebfontLoader>
          )
        } 


        if( amazonratingLoadGoogleFonts == true ) {
                    
          const amazonratingconfig = {
            google: {
              families: [ amazonratingfontFamily + ( amazonratingfontWeight ? ":" + amazonratingfontWeight : "" ) ],
            },
          }

          loadamazonratingGoogleFonts = (
            <WebfontLoader config={ amazonratingconfig }>
            </WebfontLoader>
          )
        } 


        const Tag1  = titleTag1
        const Tag2  = titleTag2

        let newrel;
        if( !btn_Htarget){
            newrel = btnRel
        } else  if( !btn_Htarget && btnRel === NEW_TAB_REL){
            newrel = btnRel
        } else if ( btn_Htarget && !btnRel ) {
          newrel = NEW_TAB_REL
        } else {
          newrel = NEW_TAB_REL + ' ' + btnRel
        }


        let newrel2;
        if( !btn_Htarget2){
            newrel2 = btnRel2
        } else  if( !btn_Htarget2 && btnRel2 === NEW_TAB_REL){
            newrel2 = btnRel2
        } else if ( btn_Htarget2 && !btnRel2 ) {
          newrel2 = NEW_TAB_REL
        } else {
          newrel2 = NEW_TAB_REL + ' ' + btnRel2
        }


        let newrel3;
        if( !btn_Htarget3){
            newrel3 = btnRel3
        } else  if( !btn_Htarget3 && btnRel3 === NEW_TAB_REL){
            newrel3 = btnRel3
        } else if ( btn_Htarget3 && !btnRel3 ) {
          newrel3 = NEW_TAB_REL
        } else {
          newrel3 = NEW_TAB_REL + ' ' + btnRel3
        }
        
        function removeDuplicateWords (s) {
          var str = s.split(" ");
          var result = [];
          for(var i =0; i < str.length ; i++){
              if(result.indexOf(str[i]) === -1){
                result.push(str[i]);
              } 
          }
           return result.join(" ");
          }
          
           newrel = removeDuplicateWords(newrel).trim()
        
        return (
            <Fragment>
              <InspectorControls key="inspector">


                <PanelBody title={`General Settings`} initialOpen={false}  icon={ getIcon( 'documentation' ) } className={ 'abblocks-panel-label' }>

                    <ToggleControl
                        label={ __( 'Show Title' ) }                        
                        checked={ showTitle }                                      
                        onChange={ ( ) => setAttributes( { showTitle: ! showTitle } ) }
                    />

                    <ToggleControl
                        label={ __( 'Show Sub Title' ) }                        
                        checked={ showSubTitle }                                      
                        onChange={ ( ) => setAttributes( { showSubTitle: ! showSubTitle } ) }
                    />

                    <ToggleControl
                        label={ __( 'Show Content' ) }                        
                        checked={ showContent }                                      
                        onChange={ ( ) => setAttributes( { showContent: ! showContent } ) }
                    />

                    <RadioAdvanced
                      label={__('Design Type')}
                      options={[
                          { label: 'Fixed', value: 'ab-fixed-design', title: 'Fixed' },
                          { label: 'Dynamic', value: 'ab-dynamic-design', title: 'Dynamic' },
                      ]}
                      value={designType}
                      onChange={(value) => setAttributes({ designType: value })} /> 

                      <ToggleControl
                            label={ __( 'External Image?' ) }                        
                            checked={ externalImage }                                      
                            onChange={ ( ) => setAttributes( { externalImage: ! externalImage } ) }
                        />

                      { designType && designType == 'ab-fixed-design' &&  !externalImage && !externalImage == true &&
                          <Media label={__('Image')} multiple={false} type={['image']} panel={true} value={image} onChange={val => setAttributes({ image: val })} />
                      }

                      { designType && designType == 'ab-fixed-design' &&  externalImage && externalImage == true &&
                        <TextareaControl              
                            label={ __( 'External Image Src' ) }         
                            value={ externalImageSrc }                       
                            onChange={ ( value ) => setAttributes( { externalImageSrc: value } ) }
                        />
                      }


                      <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                      activeClass="active-tab"
                      tabs={[
                        {
                          name: 'boxdesk',
                          title: <Dashicon icon="desktop" />,
                          className: 'affiliate-responsive-tabs',
                        },
                        {
                          name: 'boxtablet',
                          title: <Dashicon icon="tablet" />,
                          className: 'affiliate-responsive-tabs',
                        },
                        {
                          name: 'boxmobile',
                          title: <Dashicon icon="smartphone" />,
                          className: 'affiliate-responsive-tabs',
                        },
                      ]}>
                      {
                        (radiustab) => {
                          let tabout;
                          if (radiustab.name) {
                            if ('boxmobile' === radiustab.name) {
                              tabout = ( 
                                <Range label={__('Custom Image Width')} value={customImgWidthMobile} onChange={(value) => setAttributes({ customImgWidthMobile: value })} min={0} max={1000} unit={['']} />
                              );
                            } else if ('boxtablet' === radiustab.name) {
                              tabout = (
                                <Range label={__('Custom Image Width')} value={customImgWidthTablet} onChange={(value) => setAttributes({ customImgWidthTablet: value })} min={0} max={1000} unit={['']} />
                              );
                            } else {
                              tabout = (
                                <Range label={__('Custom Image Width')} value={customImgWidth} onChange={(value) => setAttributes({ customImgWidth: value })} min={0} max={1000} unit={['']} />
                              );
                            }
                          }
                          return <div>{tabout}</div>;
                        }
                      }
                  </TabPanel>
                  <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                        activeClass="active-tab"
                        tabs={[
                          {
                            name: 'boxdesk',
                            title: <Dashicon icon="desktop" />,
                            className: 'affiliate-responsive-tabs',
                          },
                          {
                            name: 'boxtablet',
                            title: <Dashicon icon="tablet" />,
                            className: 'affiliate-responsive-tabs',
                          },
                          {
                            name: 'boxmobile',
                            title: <Dashicon icon="smartphone" />,
                            className: 'affiliate-responsive-tabs',
                          },
                        ]}>
                        {
                          (radiustab) => {
                            let tabout;
                            if (radiustab.name) {
                              if ('boxmobile' === radiustab.name) {
                                tabout = (
                                  <Dimension
                                    label={__('Image Padding')} value={imagePaddingMobile}
                                    onChange={val => setAttributes({ imagePaddingMobile: val })}
                                    min={0} max={600} unit={['px','em','rem','%']}
                                    clientId={this.props.clientId}
                                  />
                                );
                              } else if ('boxtablet' === radiustab.name) {
                                tabout = (
                                  <Dimension label={__('Image Padding')} value={imagePaddingTablet}
                                    onChange={val => setAttributes({ imagePaddingTablet: val })}
                                    min={0} max={600} unit={['px','em','rem','%']}
                                    clientId={this.props.clientId}
                                  />
                                );
                              } else {
                                tabout = (
                                  <Dimension
                                    label={__('Image Padding')} value={imagePadding}
                                    onChange={val => setAttributes({ imagePadding: val })}
                                    min={0} max={600} unit={['px','em','rem','%']}
                                    clientId={this.props.clientId}
                                  />
                                );
                              }
                            }
                            return <div>{tabout}</div>;
                          }
                        }
                  </TabPanel>


                      <BorderTypes label={__('Border Type')} value={boxBorderType} onChange={(value) => setAttributes({ boxBorderType: value })} />

                      <Dimension
                        label={__('Border Width')}
                        value={boxBorderWidth}
                        onChange={val => setAttributes({ boxBorderWidth: val })}
                        min={0}
                        max={600}
                        unit={['px','em','rem','%']}
                        clientId={this.props.clientId}
                      />

                      <h2 className="alignment-heading-size-title">{__('Title Alignment')}</h2>
                      <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                        activeClass="active-tab"
                        tabs={[
                          {
                            name: 'boxdesk',
                            title: <Dashicon icon="desktop" />,
                            className: 'affiliate-responsive-tabs',
                          },
                          {
                            name: 'boxtablet',
                            title: <Dashicon icon="tablet" />,
                            className: 'affiliate-responsive-tabs',
                          },
                          {
                            name: 'boxmobile',
                            title: <Dashicon icon="smartphone" />,
                            className: 'affiliate-responsive-tabs',
                          },
                        ]}>
                        {
                          (radiustab) => {
                            let tabout;
                            if (radiustab.name) {
                              if ('boxmobile' === radiustab.name) {
                                tabout = (
                                  <Alignment
                                      disableJustify
                                      value={titleAlignmentMobile}
                                      onChange={(value) => setAttributes({ titleAlignmentMobile: value })}
                                  />
                                );
                              } else if ('boxtablet' === radiustab.name) {
                                tabout = (
                                  <Alignment
                                      disableJustify
                                      value={titleAlignmentTablet}
                                      onChange={(value) => setAttributes({ titleAlignmentTablet: value })}
                                  />
                                );
                              } else {
                                tabout = (
                                  <Alignment
                                      disableJustify
                                      value={titleAlignment}
                                      onChange={(value) => setAttributes({ titleAlignment: value })}
                                  />
                                );
                              }
                            }
                            return <div>{tabout}</div>;
                          }
                        }
                      </TabPanel>

                      <h2 className="alignment-heading-size-title">{__('Subtitle Alignment')}</h2>
                  <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                    activeClass="active-tab"
                    tabs={[
                      {
                        name: 'boxdesk',
                        title: <Dashicon icon="desktop" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxtablet',
                        title: <Dashicon icon="tablet" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxmobile',
                        title: <Dashicon icon="smartphone" />,
                        className: 'affiliate-responsive-tabs',
                      },
                    ]}>
                    {
                      (radiustab) => {
                        let tabout;
                        if (radiustab.name) {
                          if ('boxmobile' === radiustab.name) {
                            tabout = (
                              <Alignment
                                  disableJustify
                                  value={subtitleAlignmentMobile}
                                  onChange={(value) => setAttributes({ subtitleAlignmentMobile: value })}
                              />
                            );
                          } else if ('boxtablet' === radiustab.name) {
                            tabout = (
                              <Alignment
                                  disableJustify
                                  value={subtitleAlignmentTablet}
                                  onChange={(value) => setAttributes({ subtitleAlignmentTablet: value })}
                              />
                            );
                          } else {
                            tabout = (
                              <Alignment
                                  disableJustify
                                  value={subtitleAlignment}
                                  onChange={(value) => setAttributes({ subtitleAlignment: value })}
                              />
                            );
                          }
                        }
                        return <div>{tabout}</div>;
                      }
                    }
                  </TabPanel> 


                  <RadioAdvanced
                    label={__('Content Type')}
                    options={[
                        { label: 'List Item', value: 'is-list', title: 'List Item' },
                        { label: 'Paragraph', value: 'is-p', title: 'Paragraph' },
                    ]}
                    value={contentType}
                    onChange={(value) => setAttributes({ contentType: value })} />

                  <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                    activeClass="active-tab"
                    tabs={[
                      {
                        name: 'boxdesk',
                        title: <Dashicon icon="desktop" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxtablet',
                        title: <Dashicon icon="tablet" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxmobile',
                        title: <Dashicon icon="smartphone" />,
                        className: 'affiliate-responsive-tabs',
                      },
                    ]}>
                    {
                      (radiustab) => {
                        let tabout;
                        if (radiustab.name) {
                          if ('boxmobile' === radiustab.name) {
                            tabout = (
                              <Alignment
                                  label= {__('Content Alignment')}  
                                  disableJustify
                                  value={cntnAlignmentMobile}
                                  onChange={(value) => setAttributes({ cntnAlignmentMobile: value })}
                              />
                            );
                          } else if ('boxtablet' === radiustab.name) {
                            tabout = (
                              <Alignment
                                  label= {__('Content Alignment')}  
                                  disableJustify
                                  value={cntnAlignmentTablet}
                                  onChange={(value) => setAttributes({ cntnAlignmentTablet: value })}
                              />
                            );
                          } else {
                            tabout = (
                              <Alignment
                                  label= {__('Content Alignment')}  
                                  disableJustify
                                  value={cntnAlignment}
                                  onChange={(value) => setAttributes({ cntnAlignment: value })}
                              />
                            );
                          }
                        }
                        return <div>{tabout}</div>;
                      }
                    }
                  </TabPanel>
                  {listType == 'unordered' && contentType == 'is-list' &&
                        <Fragment>
                            <IconSelector
                                label="Icon"
                                value={bulletStyle.name}
                                enableSearch
                                icons={[
                                    { name: 'check', value: 'fas fa-check' },
                                    { name: 'check-square', value: 'fas fa-check-square' },
                                    { name: 'check-square-outline', value: 'far fa-check-square' },
                                    { name: 'check-double', value: 'fas fa-check-double' },
                                    { name: 'check-circle', value: 'fas fa-check-circle' },
                                    { name: 'check-circle-outline', value: 'far fa-check-circle' },
                                    { name: 'square', value: 'fas fa-square' },
                                    { name: 'square-outline', value: 'far fa-square' },
                                    { name: 'circle', value: 'fas fa-circle' },
                                    { name: 'circle-outline', value: 'far fa-circle' },
                                    { name: 'arrow-right', value: 'fas fa-arrow-right' },
                                    { name: 'arrow-left', value: 'fas fa-arrow-left' },
                                    { name: 'arrow-circle-right', value: 'fas fa-arrow-circle-right' },
                                    { name: 'arrow-circle-left', value: 'fas fa-arrow-circle-left' },
                                    { name: 'arrow-alt-circle-right', value: 'far fa-arrow-alt-circle-right' },
                                    { name: 'arrow-alt-circle-left', value: 'far fa-arrow-alt-circle-left' },
                                    { name: 'long-arrow-alt-right', value: 'fas fa-long-arrow-alt-right' },
                                    { name: 'long-arrow-alt-left', value: 'fas fa-long-arrow-alt-left' },
                                    { name: 'chevron-right', value: 'fas fa-chevron-right' },
                                    { name: 'chevron-left', value: 'fas fa-chevron-left' },
                                    { name: 'angle-right', value: 'fas fa-angle-right' },
                                    { name: 'angle-left', value: 'fas fa-angle-left' },
                                    { name: 'star', value: 'fas fa-star' },
                                    { name: 'star-outline', value: 'far fa-star' },
                                    { name: 'windows-close-fill', value: 'fas fa-window-close' },
                                    { name: 'ban', value: 'fas fa-ban' },
                                    { name: 'window-close-simple', value: 'far fa-window-close' },
                                    { name: 'times', value: 'fas fa-times' },
                                    { name: 'times-circle', value: 'fas fa-times-circle' },
                                    { name: 'times-circle-simple', value: 'far fa-times-circle' },
                                    { name: 'dot-circle-fill', value: 'fas fa-dot-circle' },
                                    { name: 'dot-circle-simple', value: 'far fa-dot-circle' },
                                    { name: 'thumb-up-fill', value: 'fas fa-thumbs-up' },
                                    { name: 'thumb-up-simple', value: 'far fa-thumbs-up' },
                                    { name: 'thumb-down-fill', value: 'fas fa-thumbs-down' },
                                    { name: 'thumb-down-simple', value: 'far fa-thumbs-down' }, 
                                ]}
                                onChange={val => setAttributes({ bulletStyle: val })}
                            />
                        </Fragment>
                    }
                    {listType == 'ordered' &&
                        <Fragment>
                            <Range label={__('Font Size')} value={numberFontSize} onChange={(value) => setAttributes({ numberFontSize: value })} min={10} max={100} />
                            <Toggle
                                value={useNumberBg}
                                label={__('Use Background')}
                                onChange={val => setAttributes({ useNumberBg: val, recreateStyles: !recreateStyles })}
                            />
                            {
                                useNumberBg == 1 &&
                                <Fragment>
                                    <Range label={__('Background Size')} value={numberBgSize} onChange={(value) => setAttributes({ numberBgSize: value })} min={1} max={15} />
                                    <Range label={__('Corner')} value={numberCorner} onChange={(value) => setAttributes({ numberCorner: value })} min={0} max={100} />
                                </Fragment>
                            }
                        </Fragment>
                    }

                      <BoxShadow label={__('Box-Shadow')} value={boxShadow} onChange={(value) => setAttributes({ boxShadow: value })} />
                </PanelBody>

                <PanelBody title={ __( 'Typography' ) } initialOpen={false}  icon={ getIcon( 'typography' ) } className={ 'abblocks-panel-label' }>
                    <SelectControl
                        label={ __( 'Title Heading Tag' ) }
                        value={ titleTag1 }
                        options= {[                                
                                { value: 'h2', label: 'Heading 2 (h2)' },
                                { value: 'h3', label: 'Heading 3 (h3)' },
                                { value: 'h4', label: 'Heading 4 (h4)' },
                                { value: 'h5', label: 'Heading 5 (h5)' },
                                { value: 'h6', label: 'Heading 6 (h6)' },
                                { value: 'p', label: 'Paragraph (p)' },
                            ]}
                            onChange={ ( value ) => setAttributes( { titleTag1: value } ) }
                      />

                      <TypographyControl
                        label={__("Title Typography")}
                        attributes={attributes}
                        setAttributes={setAttributes}
                        loadGoogleFonts={{ value:titleLoadGoogleFonts, label: __("titleLoadGoogleFonts") }}
                        fontFamily={{ value: titlefontFamily, label: __("titlefontFamily") }}
                        fontWeight={{ value: titlefontWeight, label: __("titlefontWeight") }}
                        fontSubset={{ value: titlefontSubset, label: __("titlefontSubset") }}
                        fontSizeType={{ value: titlefontSizeType, label: __("titlefontSizeType") }}
                        fontSizeTypeMobile={{ value: titlefontSizeTypeMobile, label: __("titlefontSizeTypeMobile") }}
                        fontSizeTypeTablet={{ value: titlefontSizeTypeTablet, label: __("titlefontSizeTypeTablet") }}
                        fontSize={{ value: titlefontSizeDesktop, label: __("titlefontSizeDesktop") }}
                        fontSizeMobile={{ value: titlefontSizeMobile, label: __("titlefontSizeMobile") }}
                        fontSizeTablet={{ value: titlefontSizeTablet, label: __("titlefontSizeTablet") }}
                        lineHeightType={{ value: '', label: __(" ") }}
                        lineHeight={{ value: titlelineHeight, label: __("titlelineHeight") }}
                        lineHeightMobile={{ value: titlelineHeightMobile, label: __("titlelineHeightMobile") }}
                        lineHeightTablet={{ value: titlelineHeightTablet, label: __("titlelineHeightTablet") }}
                        letterSpacing={{ value: titleletterSpacing, label: __("titleletterSpacing") }}
                        letterSpacingMobile={{ value: titleletterSpacingMobile, label: __("titleletterSpacingMobile") }}
                        letterSpacingTablet={{ value: titleletterSpacingTablet, label: __("titleletterSpacingTablet") }}
                        letterSpacingType={{ value: titleletterSpacingType, label: __("titleletterSpacingType") }}
                        letterSpacingTypeTablet={{ value: titleletterSpacingTypeTablet, label: __("titleletterSpacingTypeTablet") }}
                        letterSpacingTypeMobile={{ value: titleletterSpacingTypeMobile, label: __("titleletterSpacingTypeMobile") }}
                        textTransform={titletextTransform}
                        onTextTransform={(value) => setAttributes({ titletextTransform: value })}
                        textDecoration={titletextDecoration}
                        onTextDecoration={(value) => setAttributes({ titletextDecoration: value })}
                        fontStyle={titlefontStyle}
                        onFontStyle={(value) => setAttributes({ titlefontStyle: value })}
                    />

                    <SelectControl
                        label={ __( 'Subtitle Heading Tag' ) }
                        value={ titleTag2 }
                        options= {[
                                { value: 'h2', label: 'Heading 2 (h2)' },
                                { value: 'h3', label: 'Heading 3 (h3)' },
                                { value: 'h4', label: 'Heading 4 (h4)' },
                                { value: 'h5', label: 'Heading 5 (h5)' },
                                { value: 'h6', label: 'Heading 6 (h6)' },
                                { value: 'p', label: 'Paragraph (p)' },
                            ]}
                            onChange={ ( value ) => setAttributes( { titleTag2: value } ) }
                      />

                      <TypographyControl
                        label={__("Sub Title Typography")}
                        attributes={attributes}
                        setAttributes={setAttributes}
                        loadGoogleFonts={{ value:subtitleLoadGoogleFonts, label: __("subtitleLoadGoogleFonts") }}
                        fontFamily={{ value: subtitlefontFamily, label: __("subtitlefontFamily") }}
                        fontWeight={{ value: subtitlefontWeight, label: __("subtitlefontWeight") }}
                        fontSubset={{ value: subtitlefontSubset, label: __("subtitlefontSubset") }}
                        fontSizeType={{ value: subtitlefontSizeType, label: __("subtitlefontSizeType") }}
                        fontSizeTypeMobile={{ value: subtitlefontSizeTypeMobile, label: __("subtitlefontSizeTypeMobile") }}
                        fontSizeTypeTablet={{ value: subtitlefontSizeTypeTablet, label: __("subtitlefontSizeTypeTablet") }}
                        fontSize={{ value: subtitlefontSizeDesktop, label: __("subtitlefontSizeDesktop") }}
                        fontSizeMobile={{ value: subtitlefontSizeMobile, label: __("subtitlefontSizeMobile") }}
                        fontSizeTablet={{ value: subtitlefontSizeTablet, label: __("subtitlefontSizeTablet") }}
                        lineHeightType={{ value: '', label: __(" ") }}
                        lineHeight={{ value: subtitlelineHeight, label: __("subtitlelineHeight") }}
                        lineHeightMobile={{ value: subtitlelineHeightMobile, label: __("subtitlelineHeightMobile") }}
                        lineHeightTablet={{ value: subtitlelineHeightTablet, label: __("subtitlelineHeightTablet") }}
                        letterSpacing={{ value: subtitleletterSpacing, label: __("subtitleletterSpacing") }}
                        letterSpacingMobile={{ value: subtitleletterSpacingMobile, label: __("subtitleletterSpacingMobile") }}
                        letterSpacingTablet={{ value: subtitleletterSpacingTablet, label: __("subtitleletterSpacingTablet") }}
                        letterSpacingType={{ value: subtitleletterSpacingType, label: __("subtitleletterSpacingType") }}
                        letterSpacingTypeTablet={{ value: subtitleletterSpacingTypeTablet, label: __("subtitleletterSpacingTypeTablet") }}
                        letterSpacingTypeMobile={{ value: subtitleletterSpacingTypeMobile, label: __("subtitleletterSpacingTypeMobile") }}
                        textTransform={subtitletextTransform}
                        onTextTransform={(value) => setAttributes({ subtitletextTransform: value })}
                        textDecoration={subtitletextDecoration}
                        onTextDecoration={(value) => setAttributes({ subtitletextDecoration: value })}
                        fontStyle={subtitlefontStyle}
                        onFontStyle={(value) => setAttributes({ subtitlefontStyle: value })}
                    />

                    <TypographyControl
                        label={__("Content Typography")}
                        attributes={attributes}
                        setAttributes={setAttributes}
                        loadGoogleFonts={{ value:cntnLoadGoogleFonts, label: __("cntnLoadGoogleFonts") }}
                        fontFamily={{ value: cntnfontFamily, label: __("cntnfontFamily") }}
                        fontWeight={{ value: cntnfontWeight, label: __("cntnfontWeight") }}
                        fontSubset={{ value: cntnfontSubset, label: __("cntnfontSubset") }}
                        fontSizeType={{ value: cntnfontSizeType, label: __("cntnfontSizeType") }}
                        fontSizeTypeMobile={{ value: cntnfontSizeTypeMobile, label: __("cntnfontSizeTypeMobile") }}
                        fontSizeTypeTablet={{ value: cntnfontSizeTypeTablet, label: __("cntnfontSizeTypeTablet") }}
                        fontSize={{ value: cntnfontSizeDesktop, label: __("cntnfontSizeDesktop") }}
                        fontSizeMobile={{ value: cntnfontSizeMobile, label: __("cntnfontSizeMobile") }}
                        fontSizeTablet={{ value: cntnfontSizeTablet, label: __("cntnfontSizeTablet") }}
                        lineHeightType={{ value: '', label: __(" ") }}
                        lineHeight={{ value: cntnlineHeight, label: __("cntnlineHeight") }}
                        lineHeightMobile={{ value: cntnlineHeightMobile, label: __("cntnlineHeightMobile") }}
                        lineHeightTablet={{ value: cntnlineHeightTablet, label: __("cntnlineHeightTablet") }}
                        letterSpacing={{ value: cntnletterSpacing, label: __("cntnletterSpacing") }}
                        letterSpacingMobile={{ value: cntnletterSpacingMobile, label: __("cntnletterSpacingMobile") }}
                        letterSpacingTablet={{ value: cntnletterSpacingTablet, label: __("cntnletterSpacingTablet") }}
                        letterSpacingType={{ value: cntnletterSpacingType, label: __("cntnletterSpacingType") }}
                        letterSpacingTypeTablet={{ value: cntnletterSpacingTypeTablet, label: __("cntnletterSpacingTypeTablet") }}
                        letterSpacingTypeMobile={{ value: cntnletterSpacingTypeMobile, label: __("cntnletterSpacingTypeMobile") }}
                        textTransform={cntntextTransform}
                        onTextTransform={(value) => setAttributes({ cntntextTransform: value })}
                        textDecoration={cntntextDecoration}
                        onTextDecoration={(value) => setAttributes({ cntntextDecoration: value })}
                        fontStyle={cntnfontStyle}
                        onFontStyle={(value) => setAttributes({ cntnfontStyle: value })}
                    />
                </PanelBody>

                <PanelBody title={ __( 'Colors' ) } initialOpen={false}  icon={ getIcon( 'colors' ) } className={ 'abblocks-panel-label' }>
                    <Color label={__('Border Color')} disableAlpha value={boxBorderColor} onChange={val => setAttributes({ boxBorderColor: val })} />
                    <Color label={__('Title Color')} disableAlpha value={titleTextColor} onChange={val => setAttributes({ titleTextColor: val })} />
                    <Color label={__('Sub Title Color')} disableAlpha value={subtitleTextColor} onChange={val => setAttributes({ subtitleTextColor: val })} />

                    { contentType && contentType == 'is-list' &&
                        <Color label={__('Icon Color')} disableAlpha value={iconColor} onChange={val => setAttributes({ iconColor: val })} />
                    }
                    <Color label={__('Content Color')} disableAlpha value={cntnTextColor} onChange={val => setAttributes({ cntnTextColor: val })} />
                    <Color label={__('Box Background Color')} disableAlpha value={boxBackgroundColor} onChange={val => setAttributes({ boxBackgroundColor: val })} />

                </PanelBody>

                <PanelBody title={`Spacing`}  initialOpen={false} icon={ getIcon( 'spacing' ) } className={ 'abblocks-panel-label' }>
                    <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                      activeClass="active-tab"
                      tabs={[
                        {
                          name: 'boxdesk',
                          title: <Dashicon icon="desktop" />,
                          className: 'affiliate-responsive-tabs',
                        },
                        {
                          name: 'boxtablet',
                          title: <Dashicon icon="tablet" />,
                          className: 'affiliate-responsive-tabs',
                        },
                        {
                          name: 'boxmobile',
                          title: <Dashicon icon="smartphone" />,
                          className: 'affiliate-responsive-tabs',
                        },
                      ]}>
                      {
                        (radiustab) => {
                          let tabout;
                          if (radiustab.name) {
                            if ('boxmobile' === radiustab.name) {
                              tabout = (
                                <Dimension
                                  label={__('Box Padding')}
                                  value={boxPaddingMobile}
                                  onChange={val => setAttributes({ boxPaddingMobile: val })}
                                  min={0}
                                  max={600}
                                  unit={['px','em','rem','%']}
                                  clientId={this.props.clientId}
                                />
                              );
                            } else if ('boxtablet' === radiustab.name) {
                              tabout = (
                                <Dimension label={__('Box Padding')} value={boxPaddingTablet}
                                  onChange={val => setAttributes({ boxPaddingTablet: val })}
                                  min={0}
                                  max={600}
                                  unit={['px','em','rem','%']}
                                  clientId={this.props.clientId}
                                />
                              );
                            } else {
                              tabout = (
                                <Dimension
                                  label={__('Box Padding')}
                                  value={boxPadding}
                                  onChange={val => setAttributes({ boxPadding: val })}
                                  min={0}
                                  max={600}
                                  unit={['px','em','rem','%']}
                                  clientId={this.props.clientId}
                                />
                              );
                            }
                          }
                          return <div>{tabout}</div>;
                        }
                      }
                    </TabPanel>
                    <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                      activeClass="active-tab"
                      tabs={[
                        {
                          name: 'boxdesk',
                          title: <Dashicon icon="desktop" />,
                          className: 'affiliate-responsive-tabs',
                        },
                        {
                          name: 'boxtablet',
                          title: <Dashicon icon="tablet" />,
                          className: 'affiliate-responsive-tabs',
                        },
                        {
                          name: 'boxmobile',
                          title: <Dashicon icon="smartphone" />,
                          className: 'affiliate-responsive-tabs',
                        },
                      ]}>
                      {
                        (radiustab) => {
                          let tabout;
                          if (radiustab.name) {
                            if ('boxmobile' === radiustab.name) {
                              tabout = (
                                <Dimension
                                  label={__('Box Margin')}
                                  value={boxMarginMobile}
                                  onChange={val => setAttributes({ boxMarginMobile: val })}
                                  min={0}
                                  max={600}
                                  unit={['px','em','rem','%']}
                                  clientId={this.props.clientId}
                                />
                              );
                            } else if ('boxtablet' === radiustab.name) {
                              tabout = (
                                <Dimension label={__('Box Margin')} value={boxMarginTablet}
                                  onChange={val => setAttributes({ boxMarginTablet: val })}
                                  min={0}
                                  max={600}
                                  unit={['px','em','rem','%']}
                                  clientId={this.props.clientId}
                                />
                              );
                            } else {
                              tabout = (
                                <Dimension
                                  label={__('Box Margin')}
                                  value={boxMargin}
                                  onChange={val => setAttributes({ boxMargin: val })}
                                  min={0}
                                  max={600}
                                  unit={['px','em','rem','%']}
                                  clientId={this.props.clientId}
                                />
                              );
                            }
                          }
                          return <div>{tabout}</div>;
                        }
                      }
                    </TabPanel>

                    

                </PanelBody>

                <PanelBody title={ __( 'Button Settings' ) } initialOpen={false} icon={ getIcon( 'button' ) } className={ 'abblocks-panel-label' }>

                    <ToggleControl
                          label={ __( 'Enable Button' ) }           
                          checked={ enable_btn1 }                   
                          onChange={ ( ) => setAttributes( { enable_btn1: ! enable_btn1 } ) }
                      />

                      <Dropdown
                              className="affiliate-icon-popover"
                              contentClassName="my-popover-content-classname"
                              position="left"
                              renderToggle={ ( { isOpen, onToggle } ) => (
                                <Fragment>
                                  <h2>{__('Tag Icon')}</h2>
                                  <Button className="affiliate-size-btn"  onClick={ onToggle } aria-expanded={ isOpen }>
                                              <Dashicon icon="admin-tools" />
                                  </Button>
                                </Fragment> 
                              ) }
                              renderContent={ () => (
                                  <div className="affiliate-iconlist-popwrapper">
                                      <IconList value={buttonIcon} disableToggle onChange={val => setAttributes({ buttonIcon: val })} />
                                  </div>
                              ) }
                          />
                          <RadioAdvanced
                                  label={__('Icon Position')}
                                  options={[
                                      { label: 'Left', value: 'af-icon-is-left', title: 'Left' },
                                      { label: 'Right', value: 'af-icon-is-right', title: 'Right' },
                                  ]}
                                  value={iconPosition}
                                  onChange={(value) => setAttributes({ iconPosition: value })} />					
                        <TextControl		
                            label = { __( 'Button Text' ) }				
                            value={ spBtnText }						
                            onChange={ ( value ) => setAttributes( { spBtnText: value } ) }
                        />
                        <TextControl
                            label = { __( 'Button URL' ) }						
                            value={ spBtnHref }						
                            onChange={ ( value ) => setAttributes( { spBtnHref: value } ) }
                        />
                        <TextControl
                            label = { __( 'Button Rel' ) }						
                            value={ btnRel }						
                            onChange={ ( value ) => setAttributes( { btnRel: value } ) }
                        />
                        <ToggleControl
                            label={ __( 'Open link in new Tab' ) }						
                            checked={ btn_Htarget }										
                            onChange={ ( ) => setAttributes( { btn_Htarget: ! btn_Htarget } ) }
                        />
                        <ToggleControl
                            label={ __( 'Rounded Button' ) }						
                            checked={ bntRounded }										
                            onChange={ ( ) => setAttributes( { bntRounded: ! bntRounded } ) }
                        />
                        <ToggleControl
                          label={ __( 'Enable Glimmer Effect' ) }            
                          checked={ enableGlimmerEffect }                    
                          onChange={ ( ) => setAttributes( { enableGlimmerEffect: ! enableGlimmerEffect } ) }
                      />
                        <RadioAdvanced
                                label={__('Button Size')}
                                options={[
                                    { label: 'S', value: 'small', title: 'Small' },
                                    { label: 'M', value: 'medium', title: 'Medium' },
                                    { label: 'L', value: 'large', title: 'Large' },
                                    { label: 'XL', value: 'extra-large', title: 'Extra Large' },
                                ]}
                                value={btnSize}
                                onChange={(value) => setAttributes({ btnSize: value })} />
                        <RadioAdvanced
                                label={__('Button Width')}
                                options={[
                                    { label: 'Fixed', value: 'fixed', title: 'Fixed' },
                                    { label: 'Flexible', value: 'flex', title: 'Flexible' },
                                    { label: 'Full', value: 'full', title: 'Full' },
                                ]}
                                value={buttonWidth}
                                onChange={(value) => setAttributes({ buttonWidth: value })} />
                        <TypographyControl
                                label={__("Button Typography")}
                                attributes={attributes}
                                setAttributes={setAttributes}
                                loadGoogleFonts={{ value:btnLoadGoogleFonts, label: __("btnLoadGoogleFonts") }}
                                fontFamily={{ value: btnfontFamily, label: __("btnfontFamily") }}
                                fontWeight={{ value: btnfontWeight, label: __("btnfontWeight") }}
                                fontSubset={{ value: btnfontSubset, label: __("btnfontSubset") }}
                                fontSizeType={{ value: btnfontSizeType, label: __("btnfontSizeType") }}
                                fontSizeTypeMobile={{ value: btnfontSizeTypeMobile, label: __("btnfontSizeTypeMobile") }}
                                fontSizeTypeTablet={{ value: btnfontSizeTypeTablet, label: __("btnfontSizeTypeTablet") }}
                                fontSize={{ value: btnfontSizeDesktop, label: __("btnfontSizeDesktop") }}
                                fontSizeMobile={{ value: btnfontSizeMobile, label: __("btnfontSizeMobile") }}
                                fontSizeTablet={{ value: btnfontSizeTablet, label: __("btnfontSizeTablet") }}
                                lineHeightType={{ value: '', label: __(" ") }}
                                lineHeight={{ value: btnlineHeight, label: __("btnlineHeight") }}
                                lineHeightMobile={{ value: btnlineHeightMobile, label: __("btnlineHeightMobile") }}
                                lineHeightTablet={{ value: btnlineHeightTablet, label: __("btnlineHeightTablet") }}
                                letterSpacing={{ value: btnletterSpacing, label: __("btnletterSpacing") }}
                                letterSpacingMobile={{ value: btnletterSpacingMobile, label: __("btnletterSpacingMobile") }}
                                letterSpacingTablet={{ value: btnletterSpacingTablet, label: __("btnletterSpacingTablet") }}
                                letterSpacingType={{ value: btnletterSpacingType, label: __("btnletterSpacingType") }}
                                letterSpacingTypeTablet={{ value: btnletterSpacingTypeTablet, label: __("btnletterSpacingTypeTablet") }}
                                letterSpacingTypeMobile={{ value: btnletterSpacingTypeMobile, label: __("btnletterSpacingTypeMobile") }}
                                textTransform={btntextTransform}
                                onTextTransform={(value) => setAttributes({ btntextTransform: value })}
                                textDecoration={btntextDecoration}
                                onTextDecoration={(value) => setAttributes({ btntextDecoration: value })}
                                fontStyle={btnfontStyle}
                                onFontStyle={(value) => setAttributes({ btnfontStyle: value })}
                            />
                            <Tabs>
                                <Tab tabTitle={__('Normal')}>
                                  <Color label={__('Text Color')} disableAlpha value={btnTextColor} onChange={val => setAttributes({ btnTextColor: val })} />
                                  <Color label={__('Border Color')} disableAlpha value={btnBorderColor} onChange={val => setAttributes({ btnBorderColor: val })} />
                                  <Background
                                      parallax
                                      value={btnBg}
                                      label={__('Background')}
                                      externalImage
                                      sources={['color','gradient']}
                                      onChange={val => setAttributes({ btnBg: val })} 
                                  />
                                </Tab>
                                <Tab tabTitle={__('Hover')}>
                                  <Color label={__('Hover Text Color')} disableAlpha value={btnTextHoverColor} onChange={val => setAttributes({ btnTextHoverColor: val })} />
                                  <Color label={__('Border Hover Color')} disableAlpha value={btnBorderHoverColor} onChange={val => setAttributes({ btnBorderHoverColor: val })} />
                                  
                                  <Background
                                      parallax
                                      value={btnBgHover}
                                      label={__('Background')}
                                      externalImage
                                      sources={['color','gradient']}
                                      onChange={val => setAttributes({ btnBgHover: val })}
                                    />
                                </Tab>
                            </Tabs>
                            <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Dimension
                                            label={__('Padding')} value={btnPaddingMobile}
                                            onChange={val => setAttributes({ btnPaddingMobile: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Dimension label={__('Padding')} value={btnPaddingTablet}
                                            onChange={val => setAttributes({ btnPaddingTablet: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Dimension
                                            label={__('Padding')} value={btnPadding}
                                            onChange={val => setAttributes({ btnPadding: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>
                              <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Dimension
                                            label={__('Margin')}
                                            value={btnMarginMobile}
                                            onChange={val => setAttributes({ btnMarginMobile: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Dimension label={__('Margin')} value={btnMarginTablet}
                                            onChange={val => setAttributes({ btnMarginMobile: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Dimension
                                            label={__('Margin')} value={btnMargin}
                                            onChange={val => setAttributes({ btnMargin: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>
                              <BorderTypes label={__('Border Type')} value={btnBorderType} onChange={(value) => setAttributes({ btnBorderType: value })} />
                              <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Dimension
                                            label={__('Border Width')} value={btnBorderMobile}
                                            onChange={val => setAttributes({ btnBorderMobile: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Dimension label={__('Border Width')} 
                                            value={btnBorderTablet}
                                            onChange={val => setAttributes({ btnBorderTablet: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Dimension
                                            label={__('Border Width')} value={btnBorder}
                                            onChange={val => setAttributes({ btnBorder: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>
                              <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Dimension
                                            label={__('Border Radius')} value={btnBorderRadiusMobile}
                                            onChange={val => setAttributes({ btnBorderRadiusMobile: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Dimension label={__('Border Radius')} 
                                            value={btnBorderRadiusTablet}
                                            onChange={val => setAttributes({ btnBorderRadiusTablet: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Dimension
                                            label={__('Border Radius')} value={btnBorderRadius}
                                            onChange={val => setAttributes({ btnBorderRadius: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>
                              <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Alignment
                                              label = {__('Alignment')}
                                              disableJustify
                                              alignmentType='content'
                                              flex
                                              value={btnAlignmentMobile}
                                              onChange={(value) => setAttributes({ btnAlignmentMobile: value })}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Alignment
                                              label = {__('Alignment')}
                                              disableJustify
                                              alignmentType='content'
                                              flex
                                              value={btnAlignmentTablet}
                                              onChange={(value) => setAttributes({ btnAlignmentTablet: value })}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Alignment
                                              label = {__('Alignment')}
                                              disableJustify
                                              alignmentType='content'
                                              flex
                                              value={btnAlignment}
                                              onChange={(value) => setAttributes({ btnAlignment: value })}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>

                  </PanelBody>


                    <PanelBody title={ __( 'Button 2 Settings' ) } initialOpen={false} icon={ getIcon( 'button' ) } className={ 'abblocks-panel-label' }>

                        <ToggleControl
                                  label={ __( 'Enable Button 2' ) }           
                                  checked={ enable_btn2 }                   
                                  onChange={ ( ) => setAttributes( { enable_btn2: ! enable_btn2 } ) }
                              />


                          <Dropdown
                              className="affiliate-icon-popover"
                              contentClassName="my-popover-content-classname"
                              position="left"
                              renderToggle={ ( { isOpen, onToggle } ) => (
                                <Fragment>
                                  <h2>{__('Tag Icon')}</h2>
                                  <Button className="affiliate-size-btn"  onClick={ onToggle } aria-expanded={ isOpen }>
                                              <Dashicon icon="admin-tools" />
                                  </Button>
                                </Fragment> 
                              ) }
                              renderContent={ () => (
                                  <div className="affiliate-iconlist-popwrapper">
                                      <IconList value={buttonIcon2} disableToggle onChange={val => setAttributes({ buttonIcon2: val })} />
                                  </div>
                              ) }
                          />
                        
                          <RadioAdvanced
                                  label={__('Icon Position')}
                                  options={[
                                      { label: 'Left', value: 'af-icon-is-left', title: 'Left' },
                                      { label: 'Right', value: 'af-icon-is-right', title: 'Right' },
                                  ]}
                                  value={iconPosition2}
                                  onChange={(value) => setAttributes({ iconPosition2: value })} />         
                        <TextControl    
                            label = { __( 'Button Text' ) }       
                            value={ spBtnText2 }           
                            onChange={ ( value ) => setAttributes( { spBtnText2: value } ) }
                        />
                        <TextControl
                            label = { __( 'Button URL' ) }            
                            value={ spBtnHref2 }           
                            onChange={ ( value ) => setAttributes( { spBtnHref2: value } ) }
                        />
                        <TextControl
                            label = { __( 'Button Rel' ) }            
                            value={ btnRel2 }            
                            onChange={ ( value ) => setAttributes( { btnRel2: value } ) }
                        />
                        <ToggleControl
                            label={ __( 'Open link in new Tab' ) }           
                            checked={ btn_Htarget2 }                   
                            onChange={ ( ) => setAttributes( { btn_Htarget2: ! btn_Htarget2 } ) }
                        />
                        <ToggleControl
                            label={ __( 'Rounded Button' ) }            
                            checked={ bntRounded2 }                    
                            onChange={ ( ) => setAttributes( { bntRounded2: ! bntRounded2 } ) }
                        />
                        <ToggleControl
                          label={ __( 'Enable Glimmer Effect' ) }            
                          checked={ enableGlimmerEffect2 }                    
                          onChange={ ( ) => setAttributes( { enableGlimmerEffect2: ! enableGlimmerEffect2 } ) }
                      />
                        <RadioAdvanced
                                label={__('Button Size')}
                                options={[
                                    { label: 'S', value: 'small', title: 'Small' },
                                    { label: 'M', value: 'medium', title: 'Medium' },
                                    { label: 'L', value: 'large', title: 'Large' },
                                    { label: 'XL', value: 'extra-large', title: 'Extra Large' },
                                ]}
                                value={btnSize2}
                                onChange={(value) => setAttributes({ btnSize2: value })} />
                        <RadioAdvanced
                                label={__('Button Width')}
                                options={[
                                    { label: 'Fixed', value: 'fixed', title: 'Fixed' },
                                    { label: 'Flexible', value: 'flex', title: 'Flexible' },
                                    { label: 'Full', value: 'full', title: 'Full' },
                                ]}
                                value={buttonWidth2}
                                onChange={(value) => setAttributes({ buttonWidth2: value })} />
                        <TypographyControl
                                label={__("Button Typography")}
                                attributes={attributes}
                                setAttributes={setAttributes}
                                loadGoogleFonts={{ value:btnLoadGoogleFonts2, label: __("btnLoadGoogleFonts2") }}
                                fontFamily={{ value: btnfontFamily2, label: __("btnfontFamily2") }}
                                fontWeight={{ value: btnfontWeight2, label: __("btnfontWeight2") }}
                                fontSubset={{ value: btnfontSubset2, label: __("btnfontSubset2") }}
                                fontSizeType={{ value: btnfontSizeType2, label: __("btnfontSizeType2") }}
                                fontSizeTypeMobile={{ value: btnfontSizeTypeMobile2, label: __("btnfontSizeTypeMobile2") }}
                                fontSizeTypeTablet={{ value: btnfontSizeTypeTablet2, label: __("btnfontSizeTypeTablet2") }}
                                fontSize={{ value: btnfontSizeDesktop2, label: __("btnfontSizeDesktop2") }}
                                fontSizeMobile={{ value: btnfontSizeMobile2, label: __("btnfontSizeMobile2") }}
                                fontSizeTablet={{ value: btnfontSizeTablet2, label: __("btnfontSizeTablet2") }}
                                lineHeightType={{ value: '', label: __(" ") }}
                                lineHeight={{ value: btnlineHeight2, label: __("btnlineHeight2") }}
                                lineHeightMobile={{ value: btnlineHeightMobile2, label: __("btnlineHeightMobile2") }}
                                lineHeightTablet={{ value: btnlineHeightTablet2, label: __("btnlineHeightTablet2") }}
                                letterSpacing={{ value: btnletterSpacing2, label: __("btnletterSpacing2") }}
                                letterSpacingMobile={{ value: btnletterSpacingMobile2, label: __("btnletterSpacingMobile2") }}
                                letterSpacingTablet={{ value: btnletterSpacingTablet2, label: __("btnletterSpacingTablet2") }}
                                letterSpacingType={{ value: btnletterSpacingType2, label: __("btnletterSpacingType2") }}
                                letterSpacingTypeTablet={{ value: btnletterSpacingTypeTablet2, label: __("btnletterSpacingTypeTablet2") }}
                                letterSpacingTypeMobile={{ value: btnletterSpacingTypeMobile2, label: __("btnletterSpacingTypeMobile2") }}
                                textTransform={btntextTransform2}
                                onTextTransform={(value) => setAttributes({ btntextTransform2: value })}
                                textDecoration={btntextDecoration2}
                                onTextDecoration={(value) => setAttributes({ btntextDecoration2: value })}
                                fontStyle={btnfontStyle2}
                                onFontStyle={(value) => setAttributes({ btnfontStyle2: value })}
                            />
                            <Tabs>
                                <Tab tabTitle={__('Normal')}>
                                  <Color label={__('Text Color')} disableAlpha value={btnTextColor2} onChange={val => setAttributes({ btnTextColor2: val })} />
                                  <Color label={__('Border Color')} disableAlpha value={btnBorderColor2} onChange={val => setAttributes({ btnBorderColor2: val })} />
                                  <Background
                                    parallax
                                    value={btnBg2}
                                    label={__('Background')}
                                    externalImage
                                    sources={['color','gradient']}
                                    onChange={val => setAttributes({ btnBg2: val })} 
                                />
                                </Tab>
                                <Tab tabTitle={__('Hover')}>
                                  <Color label={__('Hover Text Color')} disableAlpha value={btnTextHoverColor2} onChange={val => setAttributes({ btnTextHoverColor2: val })} />
                                  <Color label={__('Border Hover Color')} disableAlpha value={btnBorderHoverColor2} onChange={val => setAttributes({ btnBorderHoverColor2: val })} />
                                  <Background
                                    parallax
                                    value={btnBgHover2}
                                    label={__('Background')}
                                    externalImage
                                    sources={['color','gradient']}
                                    onChange={val => setAttributes({ btnBgHover2: val })}
                                  />
                                </Tab>
                            </Tabs>
                            <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Dimension
                                            label={__('Padding')} value={btnPaddingMobile2}
                                            onChange={val => setAttributes({ btnPaddingMobile2: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Dimension label={__('Padding')} value={btnPaddingTablet2}
                                            onChange={val => setAttributes({ btnPaddingTablet2: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Dimension
                                            label={__('Padding')} value={btnPadding2}
                                            onChange={val => setAttributes({ btnPadding2: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>
                              <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Dimension
                                            label={__('Margin')}
                                            value={btnMarginMobile2}
                                            onChange={val => setAttributes({ btnMarginMobile2: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Dimension label={__('Margin')} value={btnMarginTablet2}
                                            onChange={val => setAttributes({ btnMarginMobile2: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Dimension
                                            label={__('Margin')} value={btnMargin2}
                                            onChange={val => setAttributes({ btnMargin2: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>
                              <BorderTypes label={__('Border Type')} value={btnBorderType2} onChange={(value) => setAttributes({ btnBorderType2: value })} />
                              <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Dimension
                                            label={__('Border Width')} value={btnBorderMobile2}
                                            onChange={val => setAttributes({ btnBorderMobile2: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Dimension label={__('Border Width')} 
                                            value={btnBorderTablet2}
                                            onChange={val => setAttributes({ btnBorderTablet2: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Dimension
                                            label={__('Border Width')} value={btnBorder2}
                                            onChange={val => setAttributes({ btnBorder2: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>
                              <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Dimension
                                            label={__('Border Radius')} value={btnBorderRadiusMobile2}
                                            onChange={val => setAttributes({ btnBorderRadiusMobile2: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Dimension label={__('Border Radius')} 
                                            value={btnBorderRadiusTablet2}
                                            onChange={val => setAttributes({ btnBorderRadiusTablet2: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Dimension
                                            label={__('Border Radius')} value={btnBorderRadius2}
                                            onChange={val => setAttributes({ btnBorderRadius2: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>
                              <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Alignment
                                              label = {__('Alignment')}
                                              disableJustify
                                              alignmentType='content'
                                              flex
                                              value={btnAlignmentMobile2}
                                              onChange={(value) => setAttributes({ btnAlignmentMobile2: value })}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Alignment
                                              label = {__('Alignment')}
                                              disableJustify
                                              alignmentType='content'
                                              flex
                                              value={btnAlignmentTablet2}
                                              onChange={(value) => setAttributes({ btnAlignmentTablet2: value })}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Alignment
                                              label = {__('Alignment')}
                                              disableJustify
                                              alignmentType='content'
                                              flex
                                              value={btnAlignment2}
                                              onChange={(value) => setAttributes({ btnAlignment2: value })}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>

                  </PanelBody>

                  <PanelBody title={ __( 'Button 3 Settings' ) } initialOpen={false} icon={ getIcon( 'button' ) } className={ 'abblocks-panel-label' }>

                        <ToggleControl
                                  label={ __( 'Enable Button 3' ) }           
                                  checked={ enable_btn3 }                   
                                  onChange={ ( ) => setAttributes( { enable_btn3: ! enable_btn3 } ) }
                              />


                          <Dropdown
                              className="affiliate-icon-popover"
                              contentClassName="my-popover-content-classname"
                              position="left"
                              renderToggle={ ( { isOpen, onToggle } ) => (
                                <Fragment>
                                  <h2>{__('Tag Icon')}</h2>
                                  <Button className="affiliate-size-btn"  onClick={ onToggle } aria-expanded={ isOpen }>
                                              <Dashicon icon="admin-tools" />
                                  </Button>
                                </Fragment> 
                              ) }
                              renderContent={ () => (
                                  <div className="affiliate-iconlist-popwrapper">
                                      <IconList value={buttonIcon3} disableToggle onChange={val => setAttributes({ buttonIcon3: val })} />
                                  </div>
                              ) }
                          />
                        
                          <RadioAdvanced
                                  label={__('Icon Position')}
                                  options={[
                                      { label: 'Left', value: 'af-icon-is-left', title: 'Left' },
                                      { label: 'Right', value: 'af-icon-is-right', title: 'Right' },
                                  ]}
                                  value={iconPosition3}
                                  onChange={(value) => setAttributes({ iconPosition3: value })} />         
                        <TextControl    
                            label = { __( 'Button Text' ) }       
                            value={ spBtnText3 }           
                            onChange={ ( value ) => setAttributes( { spBtnText3: value } ) }
                        />
                        <TextControl
                            label = { __( 'Button URL' ) }            
                            value={ spBtnHref3 }           
                            onChange={ ( value ) => setAttributes( { spBtnHref3: value } ) }
                        />
                        <TextControl
                            label = { __( 'Button Rel' ) }            
                            value={ btnRel3 }            
                            onChange={ ( value ) => setAttributes( { btnRel3: value } ) }
                        />
                        <ToggleControl
                            label={ __( 'Open link in new Tab' ) }           
                            checked={ btn_Htarget3 }                   
                            onChange={ ( ) => setAttributes( { btn_Htarget3: ! btn_Htarget3 } ) }
                        />
                        <ToggleControl
                            label={ __( 'Rounded Button' ) }            
                            checked={ bntRounded3 }                    
                            onChange={ ( ) => setAttributes( { bntRounded3: ! bntRounded3 } ) }
                        />
                        <ToggleControl
                          label={ __( 'Enable Glimmer Effect' ) }            
                          checked={ enableGlimmerEffect3 }                    
                          onChange={ ( ) => setAttributes( { enableGlimmerEffect3: ! enableGlimmerEffect3 } ) }
                      />
                        <RadioAdvanced
                                label={__('Button Size')}
                                options={[
                                    { label: 'S', value: 'small', title: 'Small' },
                                    { label: 'M', value: 'medium', title: 'Medium' },
                                    { label: 'L', value: 'large', title: 'Large' },
                                    { label: 'XL', value: 'extra-large', title: 'Extra Large' },
                                ]}
                                value={btnSize3}
                                onChange={(value) => setAttributes({ btnSize3: value })} />
                        <RadioAdvanced
                                label={__('Button Width')}
                                options={[
                                    { label: 'Fixed', value: 'fixed', title: 'Fixed' },
                                    { label: 'Flexible', value: 'flex', title: 'Flexible' },
                                    { label: 'Full', value: 'full', title: 'Full' },
                                ]}
                                value={buttonWidth3}
                                onChange={(value) => setAttributes({ buttonWidth3: value })} />
                        <TypographyControl
                                label={__("Button Typography")}
                                attributes={attributes}
                                setAttributes={setAttributes}
                                loadGoogleFonts={{ value:btnLoadGoogleFonts3, label: __("btnLoadGoogleFonts3") }}
                                fontFamily={{ value: btnfontFamily3, label: __("btnfontFamily3") }}
                                fontWeight={{ value: btnfontWeight3, label: __("btnfontWeight3") }}
                                fontSubset={{ value: btnfontSubset3, label: __("btnfontSubset3") }}
                                fontSizeType={{ value: btnfontSizeType3, label: __("btnfontSizeType3") }}
                                fontSizeTypeMobile={{ value: btnfontSizeTypeMobile3, label: __("btnfontSizeTypeMobile3") }}
                                fontSizeTypeTablet={{ value: btnfontSizeTypeTablet3, label: __("btnfontSizeTypeTablet3") }}
                                fontSize={{ value: btnfontSizeDesktop3, label: __("btnfontSizeDesktop3") }}
                                fontSizeMobile={{ value: btnfontSizeMobile3, label: __("btnfontSizeMobile3") }}
                                fontSizeTablet={{ value: btnfontSizeTablet3, label: __("btnfontSizeTablet3") }}
                                lineHeightType={{ value: '', label: __(" ") }}
                                lineHeight={{ value: btnlineHeight3, label: __("btnlineHeight3") }}
                                lineHeightMobile={{ value: btnlineHeightMobile3, label: __("btnlineHeightMobile3") }}
                                lineHeightTablet={{ value: btnlineHeightTablet3, label: __("btnlineHeightTablet3") }}
                                letterSpacing={{ value: btnletterSpacing3, label: __("btnletterSpacing3") }}
                                letterSpacingMobile={{ value: btnletterSpacingMobile3, label: __("btnletterSpacingMobile3") }}
                                letterSpacingTablet={{ value: btnletterSpacingTablet3, label: __("btnletterSpacingTablet3") }}
                                letterSpacingType={{ value: btnletterSpacingType3, label: __("btnletterSpacingType3") }}
                                letterSpacingTypeTablet={{ value: btnletterSpacingTypeTablet3, label: __("btnletterSpacingTypeTablet3") }}
                                letterSpacingTypeMobile={{ value: btnletterSpacingTypeMobile3, label: __("btnletterSpacingTypeMobile3") }}
                                textTransform={btntextTransform3}
                                onTextTransform={(value) => setAttributes({ btntextTransform3: value })}
                                textDecoration={btntextDecoration3}
                                onTextDecoration={(value) => setAttributes({ btntextDecoration3: value })}
                                fontStyle={btnfontStyle3}
                                onFontStyle={(value) => setAttributes({ btnfontStyle3: value })}
                            />
                            <Tabs>
                                <Tab tabTitle={__('Normal')}>
                                  <Color label={__('Text Color')} disableAlpha value={btnTextColor3} onChange={val => setAttributes({ btnTextColor3: val })} />
                                  <Color label={__('Border Color')} disableAlpha value={btnBorderColor3} onChange={val => setAttributes({ btnBorderColor3: val })} />
                                  <Background
                                      parallax
                                      value={btnBg3}
                                      label={__('Background')}
                                      externalImage
                                      sources={['color','gradient']}
                                      onChange={val => setAttributes({ btnBg3: val })} 
                                  />
                                </Tab>
                                <Tab tabTitle={__('Hover')}>
                                  <Color label={__('Hover Text Color')} disableAlpha value={btnTextHoverColor3} onChange={val => setAttributes({ btnTextHoverColor3: val })} />
                                  <Color label={__('Border Hover Color')} disableAlpha value={btnBorderHoverColor3} onChange={val => setAttributes({ btnBorderHoverColor3: val })} />
                                  <Background
                                      parallax
                                      value={btnBgHover3}
                                      label={__('Background')}
                                      externalImage
                                      sources={['color','gradient']}
                                      onChange={val => setAttributes({ btnBgHover3: val })}
                                    />
                                </Tab>
                            </Tabs>
                            <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Dimension
                                            label={__('Padding')} value={btnPaddingMobile3}
                                            onChange={val => setAttributes({ btnPaddingMobile3: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Dimension label={__('Padding')} value={btnPaddingTablet3}
                                            onChange={val => setAttributes({ btnPaddingTablet3: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Dimension
                                            label={__('Padding')} value={btnPadding3}
                                            onChange={val => setAttributes({ btnPadding3: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>
                              <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Dimension
                                            label={__('Margin')}
                                            value={btnMarginMobile3}
                                            onChange={val => setAttributes({ btnMarginMobile3: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Dimension label={__('Margin')} value={btnMarginTablet3}
                                            onChange={val => setAttributes({ btnMarginMobile3: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Dimension
                                            label={__('Margin')} value={btnMargin3}
                                            onChange={val => setAttributes({ btnMargin3: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>
                              <BorderTypes label={__('Border Type')} value={btnBorderType3} onChange={(value) => setAttributes({ btnBorderType3: value })} />
                              <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Dimension
                                            label={__('Border Width')} value={btnBorderMobile3}
                                            onChange={val => setAttributes({ btnBorderMobile3: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Dimension label={__('Border Width')} 
                                            value={btnBorderTablet3}
                                            onChange={val => setAttributes({ btnBorderTablet3: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Dimension
                                            label={__('Border Width')} value={btnBorder3}
                                            onChange={val => setAttributes({ btnBorder3: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>
                              <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Dimension
                                            label={__('Border Radius')} value={btnBorderRadiusMobile3}
                                            onChange={val => setAttributes({ btnBorderRadiusMobile3: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Dimension label={__('Border Radius')} 
                                            value={btnBorderRadiusTablet3}
                                            onChange={val => setAttributes({ btnBorderRadiusTablet3: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Dimension
                                            label={__('Border Radius')} value={btnBorderRadius3}
                                            onChange={val => setAttributes({ btnBorderRadius3: val })}
                                            min={0} max={600} unit={['px','em','rem','%']}
                                            clientId={this.props.clientId}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>
                              <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                                activeClass="active-tab"
                                tabs={[
                                  {
                                    name: 'boxdesk',
                                    title: <Dashicon icon="desktop" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxtablet',
                                    title: <Dashicon icon="tablet" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                  {
                                    name: 'boxmobile',
                                    title: <Dashicon icon="smartphone" />,
                                    className: 'affiliate-responsive-tabs',
                                  },
                                ]}>
                                {
                                  (radiustab) => {
                                    let tabout;
                                    if (radiustab.name) {
                                      if ('boxmobile' === radiustab.name) {
                                        tabout = (
                                          <Alignment
                                              label = {__('Alignment')}
                                              disableJustify
                                              alignmentType='content'
                                              flex
                                              value={btnAlignmentMobile3}
                                              onChange={(value) => setAttributes({ btnAlignmentMobile3: value })}
                                          />
                                        );
                                      } else if ('boxtablet' === radiustab.name) {
                                        tabout = (
                                          <Alignment
                                              label = {__('Alignment')}
                                              disableJustify
                                              alignmentType='content'
                                              flex
                                              value={btnAlignmentTablet3}
                                              onChange={(value) => setAttributes({ btnAlignmentTablet3: value })}
                                          />
                                        );
                                      } else {
                                        tabout = (
                                          <Alignment
                                              label = {__('Alignment')}
                                              disableJustify
                                              alignmentType='content'
                                              flex
                                              value={btnAlignment3}
                                              onChange={(value) => setAttributes({ btnAlignment3: value })}
                                          />
                                        );
                                      }
                                    }
                                    return <div>{tabout}</div>;
                                  }
                                }
                              </TabPanel>

                  </PanelBody>


                <PanelBody title={ __( 'Amazon Settings' ) } initialOpen={false}  icon={ getIcon( 'aws' ) } className={ 'abblocks-panel-label' }>
                    
                     <TextareaControl              
                        label={ __( 'Amazon Product Image Shortcode' ) }         
                        value={ amazonimage }                       
                        onChange={ ( value ) => setAttributes( { amazonimage: value } ) }
                    />

                    <TextareaControl              
                        label={ __( 'Price Shortcode' ) }         
                        value={ amazonprice }                       
                        onChange={ ( value ) => setAttributes( { amazonprice: value } ) }
                    />
                    
                    {/*
                    <SelectControl
                        label={ __( 'Show Price Position' ) }
                        value={ amazonpriceposition }
                        options= {[
                                { value: 'Above Button', label: 'Above Button' },
                                { value: 'Below Button', label: 'Below Button' },
                            ]}
                            onChange={ ( value ) => setAttributes( { amazonpriceposition: value } ) }
                      />

                      <TypographyControl
                        label={__("Price Typography")}
                        attributes={attributes}
                        setAttributes={setAttributes}
                        loadGoogleFonts={{ value:amazonpriceLoadGoogleFonts, label: __("amazonpriceLoadGoogleFonts") }}
                        fontFamily={{ value: amazonpricefontFamily, label: __("amazonpricefontFamily") }}
                        fontWeight={{ value: amazonpricefontWeight, label: __("amazonpricefontWeight") }}
                        fontSubset={{ value: amazonpricefontSubset, label: __("amazonpricefontSubset") }}
                        fontSizeType={{ value: amazonpricefontSizeType, label: __("amazonpricefontSizeType") }}
                        fontSizeTypeMobile={{ value: amazonpricefontSizeTypeMobile, label: __("amazonpricefontSizeTypeMobile") }}
                        fontSizeTypeTablet={{ value: amazonpricefontSizeTypeTablet, label: __("amazonpricefontSizeTypeTablet") }}
                        fontSize={{ value: amazonpricefontSizeDesktop, label: __("amazonpricefontSizeDesktop") }}
                        fontSizeMobile={{ value: amazonpricefontSizeMobile, label: __("amazonpricefontSizeMobile") }}
                        fontSizeTablet={{ value: amazonpricefontSizeTablet, label: __("amazonpricefontSizeTablet") }}
                        lineHeightType={{ value: '', label: __(" ") }}
                        lineHeight={{ value: amazonpricelineHeight, label: __("amazonpricelineHeight") }}
                        lineHeightMobile={{ value: amazonpricelineHeightMobile, label: __("amazonpricelineHeightMobile") }}
                        lineHeightTablet={{ value: amazonpricelineHeightTablet, label: __("amazonpricelineHeightTablet") }}
                        letterSpacing={{ value: amazonpriceletterSpacing, label: __("amazonpriceletterSpacing") }}
                        letterSpacingMobile={{ value: amazonpriceletterSpacingMobile, label: __("amazonpriceletterSpacingMobile") }}
                        letterSpacingTablet={{ value: amazonpriceletterSpacingTablet, label: __("amazonpriceletterSpacingTablet") }}
                        letterSpacingType={{ value: amazonpriceletterSpacingType, label: __("amazonpriceletterSpacingType") }}
                        letterSpacingTypeTablet={{ value: amazonpriceletterSpacingTypeTablet, label: __("amazonpriceletterSpacingTypeTablet") }}
                        letterSpacingTypeMobile={{ value: amazonpriceletterSpacingTypeMobile, label: __("amazonpriceletterSpacingTypeMobile") }}
                        textTransform={amazonpricetextTransform}
                        onTextTransform={(value) => setAttributes({ amazonpricetextTransform: value })}
                        textDecoration={amazonpricetextDecoration}
                        onTextDecoration={(value) => setAttributes({ amazonpricetextDecoration: value })}
                        fontStyle={amazonpricefontStyle}
                        onFontStyle={(value) => setAttributes({ amazonpricefontStyle: value })}
                    />


                    <h2 className="alignment-heading-size-title">{__('Price Alignment')}</h2>
                      <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                        activeClass="active-tab"
                        tabs={[
                          {
                            name: 'boxdesk',
                            title: <Dashicon icon="desktop" />,
                            className: 'affiliate-responsive-tabs',
                          },
                          {
                            name: 'boxtablet',
                            title: <Dashicon icon="tablet" />,
                            className: 'affiliate-responsive-tabs',
                          },
                          {
                            name: 'boxmobile',
                            title: <Dashicon icon="smartphone" />,
                            className: 'affiliate-responsive-tabs',
                          },
                        ]}>
                        {
                          (radiustab) => {
                            let tabout;
                            if (radiustab.name) {
                              if ('boxmobile' === radiustab.name) {
                                tabout = (
                                  <Alignment
                                      disableJustify
                                      value={amazonpriceAlignmentMobile}
                                      onChange={(value) => setAttributes({ amazonpriceAlignmentMobile: value })}
                                  />
                                );
                              } else if ('boxtablet' === radiustab.name) {
                                tabout = (
                                  <Alignment
                                      disableJustify
                                      value={amazonpriceAlignmentTablet}
                                      onChange={(value) => setAttributes({ amazonpriceAlignmentTablet: value })}
                                  />
                                );
                              } else {
                                tabout = (
                                  <Alignment
                                      disableJustify
                                      value={amazonpriceAlignment}
                                      onChange={(value) => setAttributes({ amazonpriceAlignment: value })}
                                  />
                                );
                              }
                            }
                            return <div>{tabout}</div>;
                          }
                        }
                      </TabPanel> 

                    <Color label={__('Price Color')} disableAlpha value={amazonpriceTextColor} onChange={val => setAttributes({ amazonpriceTextColor: val })} />
                    */}
                    <TextareaControl              
                        label={ __( 'Rating Shortcode' ) }         
                        value={ amazonrating }                       
                        onChange={ ( value ) => setAttributes( { amazonrating: value } ) }
                    />
                    {/*
                    <SelectControl
                        label={ __( 'Show Rating Position' ) }
                        value={ amazonratingposition }
                        options= {[
                                { value: 'Above Button', label: 'Above Button' },
                                { value: 'Below Button', label: 'Below Button' },
                            ]}
                            onChange={ ( value ) => setAttributes( { amazonratingposition: value } ) }
                      />



                      <TypographyControl
                        label={__("Rating Typography")}
                        attributes={attributes}
                        setAttributes={setAttributes}
                        loadGoogleFonts={{ value:amazonratingLoadGoogleFonts, label: __("amazonratingLoadGoogleFonts") }}
                        fontFamily={{ value: amazonratingfontFamily, label: __("amazonratingfontFamily") }}
                        fontWeight={{ value: amazonratingfontWeight, label: __("amazonratingfontWeight") }}
                        fontSubset={{ value: amazonratingfontSubset, label: __("amazonratingfontSubset") }}
                        fontSizeType={{ value: amazonratingfontSizeType, label: __("amazonratingfontSizeType") }}
                        fontSizeTypeMobile={{ value: amazonratingfontSizeTypeMobile, label: __("amazonratingfontSizeTypeMobile") }}
                        fontSizeTypeTablet={{ value: amazonratingfontSizeTypeTablet, label: __("amazonratingfontSizeTypeTablet") }}
                        fontSize={{ value: amazonratingfontSizeDesktop, label: __("amazonratingfontSizeDesktop") }}
                        fontSizeMobile={{ value: amazonratingfontSizeMobile, label: __("amazonratingfontSizeMobile") }}
                        fontSizeTablet={{ value: amazonratingfontSizeTablet, label: __("amazonratingfontSizeTablet") }}
                        lineHeightType={{ value: '', label: __(" ") }}
                        lineHeight={{ value: amazonratinglineHeight, label: __("amazonratinglineHeight") }}
                        lineHeightMobile={{ value: amazonratinglineHeightMobile, label: __("amazonratinglineHeightMobile") }}
                        lineHeightTablet={{ value: amazonratinglineHeightTablet, label: __("amazonratinglineHeightTablet") }}
                        letterSpacing={{ value: amazonratingletterSpacing, label: __("amazonratingletterSpacing") }}
                        letterSpacingMobile={{ value: amazonratingletterSpacingMobile, label: __("amazonratingletterSpacingMobile") }}
                        letterSpacingTablet={{ value: amazonratingletterSpacingTablet, label: __("amazonratingletterSpacingTablet") }}
                        letterSpacingType={{ value: amazonratingletterSpacingType, label: __("amazonratingletterSpacingType") }}
                        letterSpacingTypeTablet={{ value: amazonratingletterSpacingTypeTablet, label: __("amazonratingletterSpacingTypeTablet") }}
                        letterSpacingTypeMobile={{ value: amazonratingletterSpacingTypeMobile, label: __("amazonratingletterSpacingTypeMobile") }}
                        textTransform={amazonratingtextTransform}
                        onTextTransform={(value) => setAttributes({ amazonratingtextTransform: value })}
                        textDecoration={amazonratingtextDecoration}
                        onTextDecoration={(value) => setAttributes({ amazonratingtextDecoration: value })}
                        fontStyle={amazonratingfontStyle}
                        onFontStyle={(value) => setAttributes({ amazonratingfontStyle: value })}
                    />


                    <h2 className="alignment-heading-size-title">{__('Rating Alignment')}</h2>
                      <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                        activeClass="active-tab"
                        tabs={[
                          {
                            name: 'boxdesk',
                            title: <Dashicon icon="desktop" />,
                            className: 'affiliate-responsive-tabs',
                          },
                          {
                            name: 'boxtablet',
                            title: <Dashicon icon="tablet" />,
                            className: 'affiliate-responsive-tabs',
                          },
                          {
                            name: 'boxmobile',
                            title: <Dashicon icon="smartphone" />,
                            className: 'affiliate-responsive-tabs',
                          },
                        ]}>
                        {
                          (radiustab) => {
                            let tabout;
                            if (radiustab.name) {
                              if ('boxmobile' === radiustab.name) {
                                tabout = (
                                  <Alignment
                                      disableJustify
                                      value={amazonratingAlignmentMobile}
                                      onChange={(value) => setAttributes({ amazonratingAlignmentMobile: value })}
                                  />
                                );
                              } else if ('boxtablet' === radiustab.name) {
                                tabout = (
                                  <Alignment
                                      disableJustify
                                      value={amazonratingAlignmentTablet}
                                      onChange={(value) => setAttributes({ amazonratingAlignmentTablet: value })}
                                  />
                                );
                              } else {
                                tabout = (
                                  <Alignment
                                      disableJustify
                                      value={amazonratingAlignment}
                                      onChange={(value) => setAttributes({ amazonratingAlignment: value })}
                                  />
                                );
                              }
                            }
                            return <div>{tabout}</div>;
                          }
                        }
                      </TabPanel> 

                    <Color label={__('Rating Color')} disableAlpha value={amazonratingTextColor} onChange={val => setAttributes({ amazonratingTextColor: val })} />
                     */}

                </PanelBody>

                </InspectorControls>
                <BlockControls>
                      <Fragment>
                                
                      </Fragment>          
                </BlockControls>
                    <div id={`affiliate-style-${block_id}`} className={`affiliate-block-${block_id}${className ? ` ${className}` : ''}`}>
                        <div className={"affiliate-sp-wrapper"}>
                          <div className={`affiliate-sp-inner`}>

                            { showTitle && showTitle == true &&
                                <RichText
                                    tagName={Tag1}
                                    value={spTitle}
                                    className="affiliate-sp-title"
                                    id={`getSlug(${spTitle})`}                                
                                    placeholder={__('Title')}
                                    onChange={spTitle => setAttributes({ spTitle })}
                                />
                            }

                            <div className={`affiliate-sp-content`}>
                              <div className={`affiliate-sp-img-wrapper`}>
                                <Fragment>


                                  { designType && designType == 'ab-fixed-design' &&  !externalImage && !externalImage == true &&
                                      <MediaUpload				
                                        onSelect={ this.onSelectImage }				
                                        value={image}				
                                        render={ ( { open } ) => (					
                                          <a className="block-editor-button" onClick={ open }>
                                            <ProductImage attributes={attributes} />
                                              {__("Add-Image")}						
                                          </a>
                                        ) }
                                      />
                                  }

                                   { designType && designType == 'ab-fixed-design' &&  externalImage && externalImage == true &&
                                        <div className={`affiliate-sp-image`}>
                                            <img src={externalImageSrc} />
                                        </div>
                                    }
                                  

                                  { designType && designType == 'ab-dynamic-design' &&
                                      <div className={`aff-inner-block`}>
                                      <InnerBlocks
                                          renderAppender={ () => (
                                            <InnerBlocks.ButtonBlockAppender />
                                          ) }
                                        />
                                      </div>   
                                  }


                                  { amazonimage && amazonimage != "" &&                                     
                                    <div className={`affiliate-sp-amzon-image`}>{amazonimage}</div>                                  
                                  } 


                                </Fragment>
                                </div>
                              <div className={`affiliate-sp-cntn-wrapper`}>
                                    { showSubTitle && showSubTitle == true &&
                                        <RichText
                                            tagName={Tag2}
                                            value={spSubTitle}
                                            className="affiliate-sp-subtitle"
                                            id={`getSlug(${spSubTitle})`}
                                            placeholder={__('Sub Title')}
                                            onChange={spSubTitle => setAttributes({ spSubTitle })}
                                        />
                                    }


                                    { showContent && showContent == true &&
                                        <Fragment>
                                        { contentType == 'is-p' &&
                                          <RichText
                                            value={pContent}
                                            placeholder={__('Button text')}
                                            onChange={pContent => setAttributes({ pContent })}
                                            className={'affiliate-pr-pcontent'}
                                        />
                                        }
                                        { contentType == 'is-list' &&
                                          <div className={`affiliate-block-advanced-list`}>
                                              <RichText
                                                tagName="ul"
                                                multiline="li"
                                                className={`affiliate-list affiliate-list-type-unordered affiliate-list-bullet-${bulletStyle.name}`}
                                                value={ listTextItems }
                                                onChange={ listTextItems => setAttributes( { listTextItems  } ) }
                                                placeholder={ __( 'Enter New Item' ) }
                                                keepPlaceholderOnFocus
                                            />
                                          </div>
                                        }
                                        </Fragment>
                                    }    

                                    { amazonpriceposition && amazonpriceposition == "Above Button" &&
                                      <Fragment>
                                        <div className={`affiliate-sp-amzon-price above`}>{amazonprice}</div>
                                      </Fragment>
                                      }


                                    { amazonratingposition && amazonratingposition == "Above Button" &&
                                      <Fragment>
                                        <div className={`affiliate-sp-amzon-rating above`}>{amazonrating}</div>
                                      </Fragment>
                                      }

                                    { enable_btn1 && enable_btn1 == true &&
                                    <div className={`affiliate-sp-btn-wrapper`}  onClick={() => { this.setState({ isVisible: !isVisible })}}>
                                        <Fragment>
                                            <span  className={`affiliate-sp-btn  btn-is-${btnSize} ${
                                                        buttonWidth === "full" ? "btn-is-fullw" : buttonWidth === "flex" ? `btn-is-flex-${btnSize}` : "" } ${bntRounded ? 'btn-is-rounded' : ''}  ${enableGlimmerEffect ? 'glimmer-effect' : ''}`} >
                                               { iconPosition && iconPosition == 'af-icon-is-left' &&
                                                        <i className={`affiliate-abbtn-icon ${buttonIcon} ${iconPosition}`}></i>
                                                  }
                                                  <RichText
                                                      value={spBtnText}
                                                      placeholder={__('Button text')}                                                    
                                                      formattingControls={ ['bold', 'italic', 'underline'] }
                                                      onChange={spBtnText => setAttributes({ spBtnText })}
                                                      href = {btn_Htarget}
                                                      {...(btn_Htarget ? {...btn_Htarget && { rel: newrel }} : { rel: newrel }  )}
                                                      {...(btn_Htarget ? { target: '_blank' } : '' )}
                                                  />
                                                  { iconPosition && iconPosition == 'af-icon-is-right' &&
                                                        <i className={`affiliate-abbtn-icon ${buttonIcon} ${iconPosition}`}></i>
                                                  }
                                              </span>
                                        </Fragment>
                                      </div>
                                    }
                                      { enable_btn2 && enable_btn2 == true &&
                                      <div className={`affiliate-sp-btn-wrapper`}  onClick={() => { this.setState({ isVisible: !isVisible })}}>
                                        <Fragment>
                                            <span  className={`affiliate-sp-btn btn2  btn-is-${btnSize2} ${
                                                        buttonWidth2 === "full" ? "btn-is-fullw" : buttonWidth2 === "flex" ? `btn-is-flex-${btnSize2}` : "" } ${bntRounded2 ? 'btn-is-rounded' : ''}  ${enableGlimmerEffect2 ? 'glimmer-effect' : ''}`} >
                                               { iconPosition2 && iconPosition2 == 'af-icon-is-left' &&
                                                        <i className={`affiliate-abbtn-icon ${buttonIcon2} ${iconPosition2}`}></i>
                                                  }
                                                  <RichText
                                                      value={spBtnText2}
                                                      placeholder={__('Button text')}                                                    
                                                      formattingControls={ ['bold', 'italic', 'underline'] }
                                                      onChange={spBtnText2 => setAttributes({ spBtnText2 })}
                                                      href = {btn_Htarget2}
                                                      {...(btn_Htarget2 ? {...btn_Htarget2 && { rel: newrel2 }} : { rel: newrel2 }  )}
                                                      {...(btn_Htarget2 ? { target: '_blank' } : '' )}
                                                  />
                                                  { iconPosition2 && iconPosition2 == 'af-icon-is-right' &&
                                                        <i className={`affiliate-abbtn-icon ${buttonIcon2} ${iconPosition2}`}></i>
                                                  }
                                              </span>
                                        </Fragment>

                                    </div>
                                  }


                                  { enable_btn3 && enable_btn3 == true &&
                                      <div className={`affiliate-sp-btn-wrapper`}  onClick={() => { this.setState({ isVisible: !isVisible })}}>
                                        <Fragment>
                                            <span  className={`affiliate-sp-btn btn3  btn-is-${btnSize3} ${
                                                        buttonWidth3 === "full" ? "btn-is-fullw" : buttonWidth3 === "flex" ? `btn-is-flex-${btnSize3}` : "" } ${bntRounded3 ? 'btn-is-rounded' : ''}  ${enableGlimmerEffect3 ? 'glimmer-effect' : ''}`} >
                                               { iconPosition3 && iconPosition3 == 'af-icon-is-left' &&
                                                        <i className={`affiliate-abbtn-icon ${buttonIcon3} ${iconPosition3}`}></i>
                                                  }
                                                  <RichText
                                                      value={spBtnText3}
                                                      placeholder={__('Button text')}                                                    
                                                      formattingControls={ ['bold', 'italic', 'underline'] }
                                                      onChange={spBtnText3 => setAttributes({ spBtnText3 })}
                                                      href = {btn_Htarget3}
                                                      {...(btn_Htarget3 ? {...btn_Htarget3 && { rel: newrel3 }} : { rel: newrel3 }  )}
                                                      {...(btn_Htarget3 ? { target: '_blank' } : '' )}
                                                  />
                                                  { iconPosition3 && iconPosition3 == 'af-icon-is-right' &&
                                                        <i className={`affiliate-abbtn-icon ${buttonIcon3} ${iconPosition3}`}></i>
                                                  }
                                              </span>
                                        </Fragment>

                                    </div>
                                  }

                                  { amazonpriceposition && amazonpriceposition == "Below Button" &&
                                  <Fragment>
                                    <div className={`affiliate-sp-amzon-price below`}>{amazonprice}</div>
                                  </Fragment>
                                  }


                                  { amazonratingposition && amazonratingposition == "Below Button" &&
                                  <Fragment>
                                    <div className={`affiliate-sp-amzon-rating below`}>{amazonrating}</div>
                                  </Fragment>
                                  }

                                </div>    
                            </div>
                        </div>                         
                        </div>
                    </div>
                {loadtitleGoogleFonts}
                {loadcntnGoogleFonts}
                {loadbtnGoogleFonts}
                {loadbtnGoogleFonts2}
                {loadsubTitleGoogleFonts}
                {loadamazonpriceGoogleFonts}
            </Fragment>
        )
    }       
}

export default (Edit);