import TypographyControl from '../components/typography/index.js';
import WebfontLoader from "../components/typography/fontloader"
import Color  from '../../components/fields/Color/Color.js';
import affiliate_styling  from './styling.js';
import BorderTypes from '../../components/fields/BorderTypes.js';
import IconList from '../../components/fields/IconList/IconList.js';
import Dimension from '../../components/fields/Dimension/Dimension.js';
import Alignment from '../../components/fields/Alignment.js';
import Tabs from '../../components/fields/Tabs/Tabs.js';
import Tab from '../../components/fields/Tab/Tab.js';
import Select  from './../../components/fields/Select/Select.js';
import Background  from './../../components/fields/Background/Background.js';
import RadioAdvanced from '../../components/fields/RadioAdvanced.js';
import Range from '../../components/fields/Range/Range.js';
import BoxShadow from "../../components/fields/BoxShadow"
import attributes from './attributes';
import icons from '../../icons/icons';
import times from 'lodash/times';
import memoize from 'memize';
import { keyboardReturn } from '@wordpress/icons';
import { EmptyStar, FullStar, HalfStar } from "./icons";
import getIcon from '../../icons/get-icon';
import classnames from "classnames"

import './editor.scss';
import './style.scss';
const { __ } = wp.i18n; 
const { registerBlockType } = wp.blocks; 
const { Component, Fragment } = wp.element;

const { withSelect, withDispatch } = wp.data
const { compose } = wp.compose

const getPanesTemplate = memoize( ( panes ) => {
    return '';
} );

const { 	
	InspectorControls,    
	AlignmentToolbar,
	BlockControls,
	PanelColorSettings,
	MediaUpload,
	RichText,
	URLInput,
	InnerBlocks,
	URLPopover,
	__experimentalLinkControl
} = wp.blockEditor;
// Register components
const {	    
	Button,
	PanelBody,
	IconButton,
	SelectControl,
	PanelRow,
	RangeControl,
	ToggleControl,
	TextControl,
	TextareaControl,
	Dashicon,
	Tooltip,
	Dropdown,
	Popover,
	TabPanel,
	ToolbarButton,
	ToolbarGroup
} = wp.components;

const NEW_TAB_REL = 'noopener noreferrer';
class Edit extends Component {
	constructor() {
	  super(...arguments);      

		this.onClickLinkSettings = this.onClickLinkSettings.bind(this)
		this.onChangeOpensInNewTab = this.onChangeOpensInNewTab.bind(this)
		this.state = { isURLPickerOpen : false }
		this.state = { selectedBox : null, highlightedStars:0,highlightedStars1:0 }
		this.getSlug     = this.getSlug.bind(this)
		this.getTotalStart     = this.getTotalStart.bind(this)
    }
    
	componentDidMount() {
	  const { attributes, setAttributes, clientId } = this.props;
	  if (!attributes.idtbl) {
		setAttributes({ idtbl: "fdtable-" + clientId });
	  } 
	  
	  this.props.setAttributes({ block_id: this.props.clientId })
        const $style = document.createElement("style")
        $style.setAttribute("id", "affiliate-style-" + this.props.clientId)
        document.head.appendChild($style)
	}

	getSlug( title ) {
      return title.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-");
    }

    getTotalStart( startArr ) {
    	console.log(startArr);
      	return 4;
    }

	onClickLinkSettings (value,index) {
		
		const { attributes, setAttributes } = this.props
		const { target } = attributes 
		if ( "_self" === target ) {
			setAttributes( { opensInNewTab: false } )
		} else if ( "_blank" === target ) {
			setAttributes( { opensInNewTab: true } )
		}

		this.setState( {
			isURLPickerOpen: true
		}) 
	}

	onChangeOpensInNewTab ( value ) {
		if ( true === value ) {
			this.props.setAttributes( { target: '_blank' } )
		} else {
			this.props.setAttributes( { target: '_self' } )
		}
	}

	render() {
		const { idtbl } = this.props.attributes;
		const { isSelected ,realPaneCount, abcompareBlocks,setAttributes, clientId } = this.props;
		const { attributes: { 			
			 
			boxShadow,
			boxBgColor,
			block_id,

			// Title 
			mainTitle, 
			titleLoadGoogleFonts,
			titleTextColor,
			titlefontFamily,
			titlefontWeight,
			titlefontSubset,
			titlefontSizeType,
			titlefontSizeTypeMobile,
			titlefontSizeTypeTablet,
			titlefontSizeDesktop,
			titlefontSizeMobile,
			titlefontSizeTablet,
			titlelineHeight,
			titlelineHeightMobile,
			titlelineHeightTablet,
			titleletterSpacing,
			titleletterSpacingMobile,
			titleletterSpacingTablet,
			titleletterSpacingType,
			titleletterSpacingTypeTablet,
			titleletterSpacingTypeMobile,
			titletextTransform,
			titletextDecoration,
			titlefontStyle,
			titleTag1,

			// content
			reviewbox,
			cntnLoadGoogleFonts,
			cntnfontFamily,
			cntnfontWeight,
			cntnfontSubset,
			cntnfontSizeType,
			cntnfontSizeTypeMobile,
			cntnfontSizeTypeTablet,
			cntnfontSizeDesktop,
			cntnfontSizeMobile,
			cntnfontSizeTablet,
			cntnlineHeight,
			cntnlineHeightMobile,
			cntnlineHeightTablet,
			cntnletterSpacing,
			cntnletterSpacingMobile,
			cntnletterSpacingTablet,
			cntnletterSpacingType,
			cntnletterSpacingTypeTablet,
			cntnletterSpacingTypeMobile,
			cntntextTransform,
			cntntextDecoration,
			cntnfontStyle,
			contentTextColor,

			//Star Rating
	        ratings,
	        ratingsColor,
	        starsSize,
	        starsSizeMobile,
	        starsSizeTablet,

	        titleTag2,
	        subTitle,
	        subtitleColor,              
            subtitleLoadGoogleFonts,
            subtitlefontFamily,
            subtitlefontWeight,
            subtitlefontSubset,
            subtitlefontSizeType,
            subtitlefontSizeTypeMobile,
            subtitlefontSizeTypeTablet,
            subtitlefontSizeDesktop,
            subtitlefontSizeMobile,
            subtitlefontSizeTablet,
            subtitlelineHeight,
            subtitlelineHeightMobile,
            subtitlelineHeightTablet,
            subtitleletterSpacing,
            subtitleletterSpacingMobile,
            subtitleletterSpacingTablet,
            subtitleletterSpacingType,
            subtitleletterSpacingTypeTablet,
            subtitleletterSpacingTypeMobile,
            subtitletextTransform,
            subtitletextDecoration,
            subtitlefontStyle,
            subtitleAlignment,
            subtitleAlignmentMobile,
            subtitleAlignmentTablet,


            starReviewContent,
            finalStar,
            showTitle,
		    showRating,
		    showConclusionTitle,
		    showConclusionSummary,


		    //Button
		    btnShow,
		    btnBgColor,
			btnSize,
			btnRel,
			btnWidth,
			btnIcon,
			btnTitle,
			btnBgHoverColor, 
			btnTarget,
			bntRounded, 
			btnHref, 
			btnIconPosition,
			btnAlignment,
			btnAlignmentMobile,
			btnAlignmentTablet,
			btnPadding,
			btnPaddingTablet,
			btnPaddingMobile,
			btnMargin,
			btnMarginTablet,
			btnMarginMobile,
			btnLoadGoogleFonts,
			btnfontFamily,
			btnfontWeight,
			btnfontSubset,
			btnfontSizeType,
			btnfontSizeTypeMobile,
			btnfontSizeTypeTablet,
			btnfontSizeDesktop,
			btnfontSizeMobile,
			btnfontSizeTablet,
			btnlineHeight,
			btnlineHeightMobile,
			btnlineHeightTablet,
			btnletterSpacing,
			btnletterSpacingMobile,
			btnletterSpacingTablet,
			btnletterSpacingType,
			btnletterSpacingTypeTablet,
			btnletterSpacingTypeMobile,
			btntextTransform,
			btntextDecoration,
			btnfontStyle,
			btnBorder,
			btnBorderMobile,
			btnBorderTablet,
			btnBorderRadius,
			btnBorderRadiusMobile,
			btnBorderRadiusTablet,
			btnBorderColor,
			btnBorderHoverColor,
			btnBorderType, 
		    btnTextColor,
		    btnTextHoverColor,


		    btnBg,
            btnBgHover,

            enableGlimmerEffect,

		} } = this.props;
		// console.log(reviewbox)
		const handletr = () => {			
            const reviewbox = [ ...this.props.attributes.reviewbox ];
            //let itemPushCount = 0			
			reviewbox.push( {				
				reviewtitle: 'Item Title',				
			} );			
            this.props.setAttributes( { reviewbox } );
            //itemPushCount = reviewbox.length
            //this.props.setAttributes( { itemCount:itemPushCount } );
           
		};
		const handleRemovetr = ( index ) => {		
			const reviewbox = [ ...this.props.attributes.reviewbox ];			
			reviewbox.splice( index, 1 );
			this.props.setAttributes( { reviewbox } );
		};	

		/**   content   ***/
		const thandletxtChange = ( reviewtitle, index ) => {			
			const reviewbox = [ ...this.props.attributes.reviewbox ];			
			reviewbox[ index ].reviewtitle = reviewtitle;			
			this.props.setAttributes( { reviewbox } );			
		}; 

		const handleStarChange = ( star, index ) => {		
	
			const reviewbox = [ ...this.props.attributes.reviewbox ];			
			reviewbox[ index ].selectedStars = star;			
			this.props.setAttributes( { reviewbox } );	

		};         

		
		var element = document.getElementById("affiliate-style-" + this.props.clientId)
        if (null != element && "undefined" != typeof element) {
             element.innerHTML = affiliate_styling(this.props, "affiliate-style")
		} 
		
        let loadcntnGoogleFonts		
		let loadTitleGoogleFonts
		let loadsubTitleGoogleFonts
		let loadbtnGoogleFonts
		
		// Content Google Font
		if( cntnLoadGoogleFonts == true ) {
					
			const cntnconfig = {
				google: {
					families: [ cntnfontFamily + ( cntnfontWeight ? ":" + cntnfontWeight : "" ) ],
				},
			}

			loadcntnGoogleFonts = (
				<WebfontLoader config={ cntnconfig }>
				</WebfontLoader>
			)
		}

		//Title Google Font
		if( titleLoadGoogleFonts == true ) {
					
			const titleConfig = {
				google: {
					families: [ titlefontFamily + ( titlefontWeight ? ":" + titlefontWeight : "" ) ],
				},
			}

			loadTitleGoogleFonts = (
				<WebfontLoader config={ titleConfig }>
				</WebfontLoader>
			)
		}

		if( subtitleLoadGoogleFonts == true ) {
					
			const subtitleconfig = {
				google: {
					families: [ subtitlefontFamily + ( subtitlefontWeight ? ":" + subtitlefontWeight : "" ) ],
				},
			}

			loadsubTitleGoogleFonts = (
				<WebfontLoader config={ subtitleconfig }>
				</WebfontLoader>
			)
        }

        if( btnLoadGoogleFonts == true ) {
            
            const btnconfig = {
              google: {
                families: [ btnfontFamily + ( btnfontWeight ? ":" + btnfontWeight : "" ) ],
              },
            }

    		loadbtnGoogleFonts = (
    			<WebfontLoader config={ btnconfig }>
    			</WebfontLoader>
    		)
        }   


        let newrel;
	    let Isconcated = false
	    if( !btnTarget){
	    	newrel = btnRel
	        Isconcated = false
	    } else  if( !btnTarget && btnRel === NEW_TAB_REL){
	    	newrel = btnRel
	        Isconcated = false
	    } else if ( btnTarget && !btnRel ) {
	        newrel = NEW_TAB_REL
	        Isconcated = true
	    } else {
	        newrel = NEW_TAB_REL + ' ' + btnRel
	        Isconcated = true
	    }
	    function removeDuplicateWords (s) {
	        var str = s.split(" ");
	        var result = [];
	        for(var i =0; i < str.length ; i++){
	            if(result.indexOf(str[i]) === -1){
	              result.push(str[i]);
	            } 
	        }
	        return result.join(" ");
	    }
	    newrel = removeDuplicateWords(newrel).trim()

		const Tag1 = titleTag1
		const Tag2 = titleTag2
		let  totalStart, trDisplay;
		let  totalRow = this.props.attributes.reviewbox.length;		

		if ( this.props.attributes.reviewbox.length ) {
			
			trDisplay = this.props.attributes.reviewbox.map( ( location, index )  => {
				
				let highlightedStars = this.props.attributes.reviewbox[ index ].highlightedStars;	
				let selectedStars = this.props.attributes.reviewbox[ index ].selectedStars;	

				return <li  key={ index }>				
						
						<div className="affiliate-star-item">

								<Fragment>
									<RichText
										tagName= {'span'}
										label = { __( 'Add Title' ) }
										placeholder = { __("Item Title")}
										className={`affiliate-txtbox-title`}
										value = { this.props.attributes.reviewbox[ index ].reviewtitle }
										onChange = { ( reviewtitle ) => thandletxtChange( reviewtitle, index ) }
										keepPlaceholderOnFocus										
									/>
								</Fragment>
								

								<div className="affiliate-star-review-rating"
                                        onMouseLeave={() => this.setState({ highlightedStars: 0 })} >
                                        {[...Array(ratings)].map((e, i) => (
                                           <div className={`affiliate-star-item`} key={i}
                                                onMouseEnter={(selectedStars) => {
                                                    handleStarChange(i + 1,index);
                                                }}
                                                onClick={(selectedStars) => {
                                                    if (selectedStars % 1 === 0) {
                                                    	handleStarChange(i + (selectedStars - 1 === i ? 0.5 : 1),index)                                                        
                                                    } else {
                                                        handleStarChange(i + (selectedStars - 1 === i ? 0.5 : 0.5),index)
                                                    }
                                                }}
                                            >
                                                {i < (highlightedStars ? highlightedStars : selectedStars) ? (
                                                    highlightedStars ? (
                                                        highlightedStars - 1 === i ? (
                                                            selectedStars % 1 > 0 ? (
                                                                highlightedStars - selectedStars - 0.5 !== 0 ? (
                                                                    <HalfStar fillColor={ratingsColor} />
                                                                ) : (
                                                                    <FullStar fillColor={ratingsColor} />
                                                                )
                                                            ) : highlightedStars - selectedStars !== 0 ? (
                                                                <FullStar fillColor={ratingsColor} />
                                                            ) : (
                                                                <HalfStar fillColor={ratingsColor} />
                                                            )
                                                        ) : (
                                                            <FullStar fillColor={ratingsColor} />
                                                        )
                                                    ) : selectedStars - i >= 1 ? (
                                                        <FullStar fillColor={ratingsColor} />
                                                    ) : (
                                                        <HalfStar fillColor={ratingsColor} />
                                                    )
                                                ) : (
                                                    <EmptyStar fillColor={ratingsColor} />
                                                )}
                                            </div>
                                        ))}
                                    </div>						
							
						</div>
													
						<div className={`fd_remove-bullet-items`}>
							<IconButton						
								className = "fd_remove-bullet-btn"
								icon = "no-alt"
								label = "Delete row"
								onClick = { () => handleRemovetr( index ) }
							/>	
						</div>
				</li>;				
			} );
		}

		const total = this.props.attributes.reviewbox.reduce((prev,next) => prev + next.selectedStars,0);
		let finalStarRating = 0;
		finalStarRating = (total/totalRow).toFixed(1);
		let highlightedStars1 = (total/totalRow).toFixed(1);	

		return [		
		<Fragment>
		<InspectorControls key="inspector"> 
			
			<PanelBody title={`General Settings`} initialOpen={false}  icon={ getIcon( 'documentation' ) } className={ 'abblocks-panel-label' }>

				<ToggleControl
                    label={ __( 'Show Title' ) }                        
                    checked={ showTitle }                                      
                    onChange={ ( ) => setAttributes( { showTitle: ! showTitle } ) }
                />

                <ToggleControl
                    label={ __( 'Show Conclusion Title' ) }                        
                    checked={ showConclusionTitle }                                      
                    onChange={ ( ) => setAttributes( { showConclusionTitle: ! showConclusionTitle } ) }
                />

                <ToggleControl
                    label={ __( 'Show Conclusion Summary' ) }                        
                    checked={ showConclusionSummary }                                      
                    onChange={ ( ) => setAttributes( { showConclusionSummary: ! showConclusionSummary } ) }
                />

                <ToggleControl
                    label={ __( 'Show Rating' ) }                        
                    checked={ showRating }                                      
                    onChange={ ( ) => setAttributes( { showRating: ! showRating } ) }
                />

                <ToggleControl
                    label={ __( 'Show Button' ) }                        
                    checked={ btnShow }                                      
                    onChange={ ( ) => setAttributes( { btnShow: ! btnShow } ) }
                />

				<BoxShadow label={__('Box-Shadow')} value={boxShadow} onChange={(value) => setAttributes({ boxShadow: value })} />		

				<TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                    activeClass="active-tab"
                    tabs={[
                      {
                        name: 'boxdesk',
                        title: <Dashicon icon="desktop" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxtablet',
                        title: <Dashicon icon="tablet" />,
                        className: 'affiliate-responsive-tabs',
                      },
                      {
                        name: 'boxmobile',
                        title: <Dashicon icon="smartphone" />,
                        className: 'affiliate-responsive-tabs',
                      },
                    ]}>
                    {
                      (radiustab) => {
                        let tabout;
                        if (radiustab.name) {
                          if ('boxmobile' === radiustab.name) {
                            tabout = (
                                <Range
                                    label={__('Stars Size')}
                                    value={starsSizeMobile} 
                                    onChange={(value) => setAttributes({ starsSizeMobile: value })}
                                    unit={[]}
                                    min={10}
                                    step={1}
                                    max={60}
                                />
                            );
                          } else if ('boxtablet' === radiustab.name) {
                            tabout = (
                                <Range
                                    label={__('Stars Size')}
                                    value={starsSizeTablet} 
                                    onChange={(value) => setAttributes({ starsSizeTablet: value })}
                                    unit={[]}
                                    min={10}
                                    step={1}
                                    max={60}
                                />
                            );
                          } else {
                            tabout = (
                                <Range
                                    label={__('Stars Size')}
                                    value={starsSize} 
                                    onChange={(value) => setAttributes({ starsSize: value })}
                                    unit={[]}
                                    min={10}
                                    step={1}
                                    max={60}
                                />
                            );
                          }
                        }
                        return <div>{tabout}</div>;
                      }
                    }
                  </TabPanel>

			</PanelBody>	

			<PanelBody title={ __( 'Typography' ) } initialOpen={false}  icon={ getIcon( 'typography' ) } className={ 'abblocks-panel-label' }>
				<SelectControl
					label={ __( 'Title Heading Tag' ) }
					value={ titleTag1 }
					options= {[
							{ value: 'h2', label: 'Heading 2 (h2)' },
	                        { value: 'h3', label: 'Heading 3 (h3)' },
	                        { value: 'h4', label: 'Heading 4 (h4)' },
	                        { value: 'h5', label: 'Heading 5 (h5)' },
	                        { value: 'h6', label: 'Heading 6 (h6)' },
	                        { value: 'p', label: 'Paragraph (p)' },
						]}
						onChange={ ( value ) => setAttributes( { titleTag1: value } ) }
				/>

				<SelectControl
					label={ __( 'Sub Heading Tag' ) }
					value={ titleTag2 }
					options= {[
							{ value: 'h2', label: 'Heading 2 (h2)' },
	                        { value: 'h3', label: 'Heading 3 (h3)' },
	                        { value: 'h4', label: 'Heading 4 (h4)' },
	                        { value: 'h5', label: 'Heading 5 (h5)' },
	                        { value: 'h6', label: 'Heading 6 (h6)' },
	                        { value: 'p', label: 'Paragraph (p)' },
						]}
						onChange={ ( value ) => setAttributes( { titleTag2: value } ) }
				/>

				<TypographyControl
	                label={__("Title Typography")}
	                attributes={attributes}
	                setAttributes={setAttributes}
	                loadGoogleFonts={{ value:titleLoadGoogleFonts, label: __("titleLoadGoogleFonts") }}
	                fontFamily={{ value: titlefontFamily, label: __("titlefontFamily") }}
	                fontWeight={{ value: titlefontWeight, label: __("titlefontWeight") }}
	                fontSubset={{ value: titlefontSubset, label: __("titlefontSubset") }}
	                fontSizeType={{ value: titlefontSizeType, label: __("titlefontSizeType") }}
	                fontSizeTypeMobile={{ value: titlefontSizeTypeMobile, label: __("titlefontSizeTypeMobile") }}
	                fontSizeTypeTablet={{ value: titlefontSizeTypeTablet, label: __("titlefontSizeTypeTablet") }}
	                fontSize={{ value: titlefontSizeDesktop, label: __("titlefontSizeDesktop") }}
	                fontSizeMobile={{ value: titlefontSizeMobile, label: __("titlefontSizeMobile") }}
	                fontSizeTablet={{ value: titlefontSizeTablet, label: __("titlefontSizeTablet") }}
	                lineHeightType={{ value: '', label: __(" ") }}
	                lineHeight={{ value: titlelineHeight, label: __("titlelineHeight") }}
	                lineHeightMobile={{ value: titlelineHeightMobile, label: __("titlelineHeightMobile") }}
	                lineHeightTablet={{ value: titlelineHeightTablet, label: __("titlelineHeightTablet") }}
	                letterSpacing={{ value: titleletterSpacing, label: __("titleletterSpacing") }}
	                letterSpacingMobile={{ value: titleletterSpacingMobile, label: __("titleletterSpacingMobile") }}
	                letterSpacingTablet={{ value: titleletterSpacingTablet, label: __("titleletterSpacingTablet") }}
	                letterSpacingType={{ value: titleletterSpacingType, label: __("titleletterSpacingType") }}
	                letterSpacingTypeTablet={{ value: titleletterSpacingTypeTablet, label: __("titleletterSpacingTypeTablet") }}
	                letterSpacingTypeMobile={{ value: titleletterSpacingTypeMobile, label: __("titleletterSpacingTypeMobile") }}
	                textTransform={titletextTransform}
	                onTextTransform={(value) => setAttributes({ titletextTransform: value })}
	                textDecoration={titletextDecoration}
	                onTextDecoration={(value) => setAttributes({ titletextDecoration: value })}
	                fontStyle={titlefontStyle}
	                onFontStyle={(value) => setAttributes({ titlefontStyle: value })}
	            />
            <TypographyControl
                label={__("Sub title Typography")}
                attributes={attributes}
                setAttributes={setAttributes}
                loadGoogleFonts={{ value:subtitleLoadGoogleFonts, label: __("subtitleLoadGoogleFonts") }}
                fontFamily={{ value: subtitlefontFamily, label: __("subtitlefontFamily") }}
                fontWeight={{ value: subtitlefontWeight, label: __("subtitlefontWeight") }}
                fontSubset={{ value: subtitlefontSubset, label: __("subtitlefontSubset") }}
                fontSizeType={{ value: subtitlefontSizeType, label: __("subtitlefontSizeType") }}
                fontSizeTypeMobile={{ value: subtitlefontSizeTypeMobile, label: __("subtitlefontSizeTypeMobile") }}
                fontSizeTypeTablet={{ value: subtitlefontSizeTypeTablet, label: __("subtitlefontSizeTypeTablet") }}
                fontSize={{ value: subtitlefontSizeDesktop, label: __("subtitlefontSizeDesktop") }}
                fontSizeMobile={{ value: subtitlefontSizeMobile, label: __("subtitlefontSizeMobile") }}
                fontSizeTablet={{ value: subtitlefontSizeTablet, label: __("subtitlefontSizeTablet") }}
                lineHeightType={{ value: '', label: __(" ") }}
                lineHeight={{ value: subtitlelineHeight, label: __("subtitlelineHeight") }}
                lineHeightMobile={{ value: subtitlelineHeightMobile, label: __("subtitlelineHeightMobile") }}
                lineHeightTablet={{ value: subtitlelineHeightTablet, label: __("subtitlelineHeightTablet") }}
                letterSpacing={{ value: subtitleletterSpacing, label: __("subtitleletterSpacing") }}
                letterSpacingMobile={{ value: subtitleletterSpacingMobile, label: __("subtitleletterSpacingMobile") }}
                letterSpacingTablet={{ value: subtitleletterSpacingTablet, label: __("subtitleletterSpacingTablet") }}
                letterSpacingType={{ value: subtitleletterSpacingType, label: __("subtitleletterSpacingType") }}
                letterSpacingTypeTablet={{ value: subtitleletterSpacingTypeTablet, label: __("subtitleletterSpacingTypeTablet") }}
                letterSpacingTypeMobile={{ value: subtitleletterSpacingTypeMobile, label: __("subtitleletterSpacingTypeMobile") }}
                textTransform={subtitletextTransform}
                onTextTransform={(value) => setAttributes({ subtitletextTransform: value })}
                textDecoration={subtitletextDecoration}
                onTextDecoration={(value) => setAttributes({ subtitletextDecoration: value })}
                fontStyle={subtitlefontStyle}
                onFontStyle={(value) => setAttributes({ subtitlefontStyle: value })}
            />
			<TypographyControl
					label={__("Content Typography")}
					attributes={attributes}
					setAttributes={setAttributes}
					loadGoogleFonts={{ value:cntnLoadGoogleFonts, label: __("cntnLoadGoogleFonts") }}
					fontFamily={{ value: cntnfontFamily, label: __("cntnfontFamily") }}
					fontWeight={{ value: cntnfontWeight, label: __("cntnfontWeight") }}
					fontSubset={{ value: cntnfontSubset, label: __("cntnfontSubset") }}
					fontSizeType={{ value: cntnfontSizeType, label: __("cntnfontSizeType") }}
					fontSizeTypeMobile={{ value: cntnfontSizeTypeMobile, label: __("cntnfontSizeTypeMobile") }}
					fontSizeTypeTablet={{ value: cntnfontSizeTypeTablet, label: __("cntnfontSizeTypeTablet") }}
					fontSize={{ value: cntnfontSizeDesktop, label: __("cntnfontSizeDesktop") }}
					fontSizeMobile={{ value: cntnfontSizeMobile, label: __("cntnfontSizeMobile") }}
					fontSizeTablet={{ value: cntnfontSizeTablet, label: __("cntnfontSizeTablet") }}
					lineHeightType={{ value: '', label: __(" ") }}
					lineHeight={{ value: cntnlineHeight, label: __("cntnlineHeight") }}
					lineHeightMobile={{ value: cntnlineHeightMobile, label: __("cntnlineHeightMobile") }}
					lineHeightTablet={{ value: cntnlineHeightTablet, label: __("cntnlineHeightTablet") }}
					letterSpacing={{ value: cntnletterSpacing, label: __("cntnletterSpacing") }}
					letterSpacingMobile={{ value: cntnletterSpacingMobile, label: __("cntnletterSpacingMobile") }}
					letterSpacingTablet={{ value: cntnletterSpacingTablet, label: __("cntnletterSpacingTablet") }}
					letterSpacingType={{ value: cntnletterSpacingType, label: __("cntnletterSpacingType") }}
					letterSpacingTypeTablet={{ value: cntnletterSpacingTypeTablet, label: __("cntnletterSpacingTypeTablet") }}
					letterSpacingTypeMobile={{ value: cntnletterSpacingTypeMobile, label: __("cntnletterSpacingTypeMobile") }}
					textTransform={cntntextTransform}
					onTextTransform={(value) => setAttributes({ cntntextTransform: value })}
					textDecoration={cntntextDecoration}
					onTextDecoration={(value) => setAttributes({ cntntextDecoration: value })}
					fontStyle={cntnfontStyle}
					onFontStyle={(value) => setAttributes({ cntnfontStyle: value })}
				/>

			</PanelBody>	

			<PanelBody title={ __( 'Colors' ) } initialOpen={false}  icon={ getIcon( 'colors' ) } className={ 'abblocks-panel-label' }>
				<Color label={__('Background Color')} disableAlpha value={boxBgColor} onChange={val => setAttributes({ boxBgColor: val })} />			
				<Color label={__('Title Text Color')} disableAlpha value={titleTextColor} onChange={val => setAttributes({ titleTextColor: val })} />
				<Color label={__('Sub Title Color')} disableAlpha value={subtitleColor} onChange={val => setAttributes({ subtitleColor: val })} />
				<Color label={__('Content title Color')} disableAlpha value={contentTextColor} onChange={val => setAttributes({ contentTextColor: val })} />
				<Color label={__('Rating Color')} value={ratingsColor} onChange={(value) => setAttributes({ ratingsColor: value })} />
			</PanelBody>	


			<PanelBody title={`Button Settings`} initialOpen={false} icon={ getIcon( 'button' ) } className={ 'abblocks-panel-label' }>
                <Dropdown
                  className="affiliate-icon-popover"
                  contentClassName="my-popover-content-classname"
                  position="left"
                  renderToggle={ ( { isOpen, onToggle } ) => (
                    <Fragment>
                      <h2>{__('Tag Icon')}</h2>
                      <Button className="affiliate-size-btn"  onClick={ onToggle } aria-expanded={ isOpen }>
                                  <Dashicon icon="admin-tools" />
                      </Button>
                    </Fragment> 
                  ) }
                  renderContent={ () => (
                      <div className="affiliate-iconlist-popwrapper">
                          <IconList value={btnIcon} disableToggle onChange={val => setAttributes({ btnIcon: val })} />
                      </div>
                  ) }
              	/>
                <RadioAdvanced
                        label={__('Icon Position')}
                        options={[
                            { label: 'Left', value: 'af-icon-is-left', title: 'Left' },
                            { label: 'Right', value: 'af-icon-is-right', title: 'Right' },
                        ]}
                        value={btnIconPosition}
                        onChange={(value) => setAttributes({ btnIconPosition: value })} />
                <TextControl
                    label = { __( 'Button URL' ) }
                    placeholder	= { __( 'https://www.example.com' ) }		
                    help = { __( 'Please Enter http or https in url' ) }			
                    disableAdvanced
                    value={ btnHref }						
                    onChange={ ( value ) => setAttributes( { btnHref: value } ) }
                />
                <TextControl
                    label = { __( 'Button Rel' ) }
                    disableAdvanced
                    value={ btnRel }						
                    onChange={ ( value ) => setAttributes( { btnRel: value } ) }
                />
                <ToggleControl
                    label={ __( 'Open link in new Tab' ) }						
                    checked={ btnTarget }										
                    onChange={ ( ) => setAttributes( { btnTarget: ! btnTarget } ) }
                    
                />
                <ToggleControl
                    label={ __( 'Rounded Button' ) }						
                    checked={ bntRounded }										
                    onChange={ ( ) => setAttributes( { bntRounded: ! bntRounded } ) }
                />
                <ToggleControl
                  label={ __( 'Enable Glimmer Effect' ) }            
                  checked={ enableGlimmerEffect }                    
                  onChange={ ( ) => setAttributes( { enableGlimmerEffect: ! enableGlimmerEffect } ) }
              />
                <RadioAdvanced
                        label={__('Button Size')}
                        options={[
                            { label: 'S', value: 'small', title: 'Small' },
                            { label: 'M', value: 'medium', title: 'Medium' },
                            { label: 'L', value: 'large', title: 'Large' },
                            { label: 'XL', value: 'extra-large', title: 'Extra Large' },
                        ]}
                        value={btnSize}
                        onChange={(value) => setAttributes({ btnSize: value })} />
                <RadioAdvanced
                        label={__('Button Width')}
                        options={[
                            { label: 'Fixed', value: 'fixed', title: 'Fixed' },
                            { label: 'Flexible', value: 'flex', title: 'Flexible' },
                            { label: 'Full', value: 'full', title: 'Full' },
                        ]}
                        value={btnWidth}
                        onChange={(value) => setAttributes({ btnWidth: value })} />        
                
                <BorderTypes label={__('Border Type')} value={btnBorderType} onChange={(value) => setAttributes({ btnBorderType: value })} />
                <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                  activeClass="active-tab"
                  tabs={[
                    {
                      name: 'boxdesk',
                      title: <Dashicon icon="desktop" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxtablet',
                      title: <Dashicon icon="tablet" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxmobile',
                      title: <Dashicon icon="smartphone" />,
                      className: 'affiliate-responsive-tabs',
                    },
                  ]}>
                  {
                    (radiustab) => {
                      let tabout;
                      if (radiustab.name) {
                        if ('boxmobile' === radiustab.name) {
                          tabout = (
                            <Dimension
                              label={__('Border')} value={btnBorderMobile}
                              onChange={val => setAttributes({ btnBorderMobile: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        } else if ('boxtablet' === radiustab.name) {
                          tabout = (
                            <Dimension label={__('Border')} 
                              value={btnBorderTablet}
                              onChange={val => setAttributes({ btnBorderTablet: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        } else {
                          tabout = (
                            <Dimension
                              label={__('Border')} value={btnBorder}
                              onChange={val => setAttributes({ btnBorder: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        }
                      }
                      return <div>{tabout}</div>;
                    }
                  }
                </TabPanel>
                <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                  activeClass="active-tab"
                  tabs={[
                    {
                      name: 'boxdesk',
                      title: <Dashicon icon="desktop" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxtablet',
                      title: <Dashicon icon="tablet" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxmobile',
                      title: <Dashicon icon="smartphone" />,
                      className: 'affiliate-responsive-tabs',
                    },
                  ]}>
                  {
                    (radiustab) => {
                      let tabout;
                      if (radiustab.name) {
                        if ('boxmobile' === radiustab.name) {
                          tabout = (
                            <Dimension
                              label={__('Border Radius')} value={btnBorderRadiusMobile}
                              onChange={val => setAttributes({ btnBorderRadiusMobile: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        } else if ('boxtablet' === radiustab.name) {
                          tabout = (
                            <Dimension label={__('Border Radius')} 
                              value={btnBorderRadiusTablet}
                              onChange={val => setAttributes({ btnBorderRadiusTablet: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        } else {
                          tabout = (
                            <Dimension
                              label={__('Border Radius')} value={btnBorderRadius}
                              onChange={val => setAttributes({ btnBorderRadius: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        }
                      }
                      return <div>{tabout}</div>;
                    }
                  }
                </TabPanel>
                <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                  activeClass="active-tab"
                  tabs={[
                    {
                      name: 'boxdesk',
                      title: <Dashicon icon="desktop" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxtablet',
                      title: <Dashicon icon="tablet" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxmobile',
                      title: <Dashicon icon="smartphone" />,
                      className: 'affiliate-responsive-tabs',
                    },
                  ]}>
                  {
                    (radiustab) => {
                      let tabout;
                      if (radiustab.name) {
                        if ('boxmobile' === radiustab.name) {
                          tabout = (
                            <Alignment
                                label = {__('Alignment')}
                                disableJustify
                                alignmentType='content'
                                flex
                                value={btnAlignmentMobile}
                                onChange={(value) => setAttributes({ btnAlignmentMobile: value })}
                            />
                          );
                        } else if ('boxtablet' === radiustab.name) {
                          tabout = (
                            <Alignment
                                label = {__('Alignment')}
                                disableJustify
                                alignmentType='content'
                                flex
                                value={btnAlignmentTablet}
                                onChange={(value) => setAttributes({ btnAlignmentTablet: value })}
                            />
                          );
                        } else {
                          tabout = (
                            <Alignment
                                label = {__('Alignment')}
                                disableJustify
                                alignmentType='content'
                                flex
                                value={btnAlignment}
                                onChange={(value) => setAttributes({ btnAlignment: value })}
                            />
                          );
                        }
                      }
                      return <div>{tabout}</div>;
                    }
                  }
                </TabPanel>


                <TypographyControl
                        label={__("Button Typography")}
                        attributes={attributes}
                        setAttributes={setAttributes}
                        loadGoogleFonts={{ value:btnLoadGoogleFonts, label: __("btnLoadGoogleFonts") }}
                        fontFamily={{ value: btnfontFamily, label: __("btnfontFamily") }}
                        fontWeight={{ value: btnfontWeight, label: __("btnfontWeight") }}
                        fontSubset={{ value: btnfontSubset, label: __("btnfontSubset") }}
                        fontSizeType={{ value: btnfontSizeType, label: __("btnfontSizeType") }}
                        fontSizeTypeMobile={{ value: btnfontSizeTypeMobile, label: __("btnfontSizeTypeMobile") }}
                        fontSizeTypeTablet={{ value: btnfontSizeTypeTablet, label: __("btnfontSizeTypeTablet") }}
                        fontSize={{ value: btnfontSizeDesktop, label: __("btnfontSizeDesktop") }}
                        fontSizeMobile={{ value: btnfontSizeMobile, label: __("btnfontSizeMobile") }}
                        fontSizeTablet={{ value: btnfontSizeTablet, label: __("btnfontSizeTablet") }}
                        lineHeightType={{ value: '', label: __(" ") }}
                        lineHeight={{ value: btnlineHeight, label: __("btnlineHeight") }}
                        lineHeightMobile={{ value: btnlineHeightMobile, label: __("btnlineHeightMobile") }}
                        lineHeightTablet={{ value: btnlineHeightTablet, label: __("btnlineHeightTablet") }}
                        letterSpacing={{ value: btnletterSpacing, label: __("btnletterSpacing") }}
                        letterSpacingMobile={{ value: btnletterSpacingMobile, label: __("btnletterSpacingMobile") }}
                        letterSpacingTablet={{ value: btnletterSpacingTablet, label: __("btnletterSpacingTablet") }}
                        letterSpacingType={{ value: btnletterSpacingType, label: __("btnletterSpacingType") }}
                        letterSpacingTypeTablet={{ value: btnletterSpacingTypeTablet, label: __("btnletterSpacingTypeTablet") }}
                        letterSpacingTypeMobile={{ value: btnletterSpacingTypeMobile, label: __("btnletterSpacingTypeMobile") }}
                        textTransform={btntextTransform}
                        onTextTransform={(value) => setAttributes({ btntextTransform: value })}
                        textDecoration={btntextDecoration}
                        onTextDecoration={(value) => setAttributes({ btntextDecoration: value })}
                        fontStyle={btnfontStyle}
                        onFontStyle={(value) => setAttributes({ btnfontStyle: value })}
                    />


                    <h2>{__('Backgound & Text Color')}</h2>
	                  <Tabs>
	                    <Tab tabTitle={__('Normal')}>
	                        <Color label={__('Text Color')} disableAlpha value={btnTextColor} onChange={val => setAttributes({ btnTextColor: val })} /> 
	                        <Color label={__('Border Color')} disableAlpha value={btnBorderColor} onChange={val => setAttributes({ btnBorderColor: val })} /> 
	                        <Background
                                      parallax
                                      value={btnBg}
                                      label={__('Background')}
                                      externalImage
                                      sources={['color','gradient']}
                                      onChange={val => setAttributes({ btnBg: val })} 
                                  />
	                    </Tab>
	                    <Tab tabTitle={__('Hover')}>
	                        <Color label={__('Hover Color')} disableAlpha value={btnTextHoverColor} onChange={val => setAttributes({ btnTextHoverColor: val })} /> 
	                        <Color label={__('Hover Border Color')} disableAlpha value={btnBorderHoverColor} onChange={val => setAttributes({ btnBorderHoverColor: val })} /> 
	                        <Background
                                      parallax
                                      value={btnBgHover}
                                      label={__('Background')}
                                      externalImage
                                      sources={['color','gradient']}
                                      onChange={val => setAttributes({ btnBgHover: val })}
                                    />
	                    </Tab>
	                </Tabs>

	                <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                  activeClass="active-tab"
                  tabs={[
                    {
                      name: 'boxdesk',
                      title: <Dashicon icon="desktop" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxtablet',
                      title: <Dashicon icon="tablet" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxmobile',
                      title: <Dashicon icon="smartphone" />,
                      className: 'affiliate-responsive-tabs',
                    },
                  ]}>
                  {
                    (radiustab) => {
                      let tabout;
                      if (radiustab.name) {
                        if ('boxmobile' === radiustab.name) {
                          tabout = (
                            <Dimension
                              label={__('Padding')} value={btnPaddingMobile}
                              onChange={val => setAttributes({ btnPaddingMobile: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        } else if ('boxtablet' === radiustab.name) {
                          tabout = (
                            <Dimension label={__('Padding')} value={btnPaddingTablet}
                              onChange={val => setAttributes({ btnPaddingTablet: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        } else {
                          tabout = (
                            <Dimension
                              label={__('Padding')} value={btnPadding}
                              onChange={val => setAttributes({ btnPadding: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        }
                      }
                      return <div>{tabout}</div>;
                    }
                  }
                </TabPanel>
                <TabPanel className="affiliate-size-type-field-tabs affiliate-dimension-field mt-align-tab"
                  activeClass="active-tab"
                  tabs={[
                    {
                      name: 'boxdesk',
                      title: <Dashicon icon="desktop" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxtablet',
                      title: <Dashicon icon="tablet" />,
                      className: 'affiliate-responsive-tabs',
                    },
                    {
                      name: 'boxmobile',
                      title: <Dashicon icon="smartphone" />,
                      className: 'affiliate-responsive-tabs',
                    },
                  ]}>
                  {
                    (radiustab) => {
                      let tabout;
                      if (radiustab.name) {
                        if ('boxmobile' === radiustab.name) {
                          tabout = (
                            <Dimension
                              label={__('Margin')}
                              value={btnMarginMobile}
                              onChange={val => setAttributes({ btnMarginMobile: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        } else if ('boxtablet' === radiustab.name) {
                          tabout = (
                            <Dimension label={__('Margin')} value={btnMarginTablet}
                              onChange={val => setAttributes({ btnMarginMobile: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        } else {
                          tabout = (
                            <Dimension
                              label={__('Margin')} value={btnMargin}
                              onChange={val => setAttributes({ btnMargin: val })}
                              min={0} max={600} unit={['px','em','rem','%']}
                              clientId={this.props.clientId}
                            />
                          );
                        }
                      }
                      return <div>{tabout}</div>;
                    }
                  }
                </TabPanel>

                </PanelBody>  


		</InspectorControls>
		</Fragment>	
		,
		<div id={`affiliate-style-${block_id}`} className={ this.props.className }>
			<div className={`affiliate-starreview-inner`}>
			
				<div className={`affiliate-starreview-innerouter`}>			

					{ showTitle && showTitle == true &&		
						<RichText
	                        tagName={Tag1}
	                        value={mainTitle} 
	                        className="affiliate-starreview-maintitle"
	                        id={`getSlug(${mainTitle})`}
	                        placeholder={__('Main Title')}
	                        onChange={mainTitle => setAttributes({ mainTitle })}
	                        keepPlaceholderOnFocus
	                    />    
	                }

					<ul className={`affiliate-starreview-starrating`}>
						{trDisplay}
					</ul>

					<Button  isDefault className=" components_panel_btn" onClick={ handletr.bind( this ) } >
						<span class="screen-reader-text">Add Row</span>
						<svg xmlns="http://www.w3.org/2000/svg" viewBox="-2 -2 24 24" width="24" height="24" role="img" aria-hidden="true" focusable="false"><path d="M10 1c-5 0-9 4-9 9s4 9 9 9 9-4 9-9-4-9-9-9zm0 16c-3.9 0-7-3.1-7-7s3.1-7 7-7 7 3.1 7 7-3.1 7-7 7zm1-11H9v3H6v2h3v3h2v-3h3V9h-3V6zM10 1c-5 0-9 4-9 9s4 9 9 9 9-4 9-9-4-9-9-9zm0 16c-3.9 0-7-3.1-7-7s3.1-7 7-7 7 3.1 7 7-3.1 7-7 7zm1-11H9v3H6v2h3v3h2v-3h3V9h-3V6z"></path></svg>
					</Button>

					<div className={`affiliate-starreview-footerbox`}>

						<div className={`affiliate-starreview-footerbox-left`}>

							{ showConclusionTitle && showConclusionTitle == true &&		
								<RichText
			                        tagName={Tag2}
			                        value={subTitle}
			                        className="affiliate-starreview-subtitle"
			                        id={`getSlug(${subTitle})`}
			                        placeholder={__('Conclusion')}
			                        onChange={subTitle => setAttributes({ subTitle })}
			                        keepPlaceholderOnFocus
			                    />
			                }

			                { showConclusionSummary && showConclusionSummary == true &&		
			                    <div className={`affiliate-starreview-c_content`}>
				                    <RichText                                    
			                            value={starReviewContent}
			                            className="affiliate-starreview-content"
			                            placeholder={__('Content')}
			                            onChange={starReviewContent => setAttributes({ starReviewContent })}
			                            keepPlaceholderOnFocus
			                        />
		                        </div>
		                    }

	                    </div>

                      	<div className={`affiliate-starreview-footerbox-right`}>
                      		
                      		{ showRating && showRating == true &&		
                      			<Fragment>
	                      		<div className={`affiliate-starreview-total`}><asside>{finalStarRating}</asside><asside className={`affiliate-starreview-totalcount`}>/5</asside></div>

	                      		<div className="affiliate-star-review-rating">

	                      			{[...Array(ratings)].map((e, i) => (
	                                   <div className={`affiliate-star-item`} key={i} >
	                                        {i < (highlightedStars1) ? (
	                                           	finalStarRating - i >= 1 ? (
	                                                <FullStar fillColor={ratingsColor} />
	                                            ) : (
	                                                <HalfStar fillColor={ratingsColor} />
	                                            )
	                                        ) : (
	                                            <EmptyStar fillColor={ratingsColor} />
	                                        )}
	                                    </div>
	                                ))}
	                                
	                            </div>
	                            </Fragment>
	                        }

                      	</div>

					</div>

					<div className={`affiliate-abbtn-inner`}>
					{ btnShow && btnShow == true &&	
	                    <Fragment>
	                        <span className={classnames(`affiliate-abbtn  btn-is-${btnSize} ${btnWidth === "full" ? "btn-is-fullw" : btnWidth === "flex" ? `btn-is-flex-${btnSize}` : "" } ${bntRounded ? 'btn-is-rounded' : ''}  ${enableGlimmerEffect ? 'glimmer-effect' : ''}`)}>
	                            { btnIconPosition && btnIconPosition == 'af-icon-is-left' &&
	                                  <i className={`affiliate-abbtn-icon ${btnIcon} ${btnIconPosition}`}></i>
	                            }
	                            <RichText
	                                value={btnTitle}
	                                placeholder={__('Button text')}
	                                onChange={btnTitle => setAttributes({ btnTitle })}
	                                formattingControls={ ['bold', 'italic', 'underline'] }
	                                href = {btnHref}
	                                {...(btnTarget ? {...btnTarget && { rel: newrel }} : { rel: newrel })}
	                                {...(btnTarget ? { target: '_blank' } : '')}
	                              
	                            />
	                            { btnIconPosition && btnIconPosition == 'af-icon-is-right' &&
	                                  <i className={`affiliate-abbtn-icon ${btnIcon} ${btnIconPosition}`}></i>
	                            }
	                        </span>
	                	</Fragment>    
	                }
                	</div>
				</div>
			
			
			</div>
			
			{loadcntnGoogleFonts}
			{loadsubTitleGoogleFonts}
			{loadTitleGoogleFonts}
			{loadbtnGoogleFonts}
			
		</div>
		]
	}
}

export default ( Edit );