/**
 * Set inline styles.
 * @param  {object} props - The block object.
 * @return {object} The inline background type CSS.
 */

import affiliate_generateCSS from "./generateCSS"
import { cssGradient, cssBoxShadow,cssWithoutSelector,cssTextShadow, cssBackground } from '../components/cssHelper'

function affiliate_styling( props, id ) {

	const {
    block_id,    
    boxShadow, 
    boxBgColor, 

    // title
		titlefontFamily,
		titlefontWeight,
		titlefontSubset,
		titlefontSizeType,
		titlefontSizeTypeMobile,
		titlefontSizeTypeTablet,
		titlefontSizeDesktop,
		titlefontSizeMobile,
		titlefontSizeTablet,
		titlelineHeight,
		titlelineHeightMobile,
		titlelineHeightTablet,
		titleletterSpacing,
		titleletterSpacingMobile,
		titleletterSpacingTablet,
		titleletterSpacingType,
		titleletterSpacingTypeTablet,
		titleletterSpacingTypeMobile,
		titletextTransform,
		titletextDecoration,
		titlefontStyle, 
		titleTextColor,
		tableStyle,
		titleTag1,

    // content
    reviewbox,
    cntnLoadGoogleFonts,
		cntnfontFamily,
		cntnfontWeight,
		cntnfontSubset,
		cntnfontSizeType,
		cntnfontSizeTypeMobile,
		cntnfontSizeTypeTablet,
		cntnfontSizeDesktop,
		cntnfontSizeMobile,
		cntnfontSizeTablet,
		cntnlineHeight,
		cntnlineHeightMobile,
		cntnlineHeightTablet,
		cntnletterSpacing,
		cntnletterSpacingMobile,
		cntnletterSpacingTablet,
		cntnletterSpacingType,
		cntnletterSpacingTypeTablet,
		cntnletterSpacingTypeMobile,
		cntntextTransform,
		cntntextDecoration,
		cntnfontStyle,
		contentTextColor,
	
		//Rating
		ratings,
		ratingsColor,
		starsSize,
    starsSizeMobile,
    starsSizeTablet,

    //Sub Title
    titleTag2,
    subtitleColor,              
    subtitleLoadGoogleFonts,
    subtitlefontFamily,
    subtitlefontWeight,
    subtitlefontSubset,
    subtitlefontSizeType,
    subtitlefontSizeTypeMobile,
    subtitlefontSizeTypeTablet,
    subtitlefontSizeDesktop,
    subtitlefontSizeMobile,
    subtitlefontSizeTablet,
    subtitlelineHeight,
    subtitlelineHeightMobile,
    subtitlelineHeightTablet,
    subtitleletterSpacing,
    subtitleletterSpacingMobile,
    subtitleletterSpacingTablet,
    subtitleletterSpacingType,
    subtitleletterSpacingTypeTablet,
    subtitleletterSpacingTypeMobile,
    subtitletextTransform,
    subtitletextDecoration,
    subtitlefontStyle,
    subtitleAlignment,
    subtitleAlignmentMobile,
    subtitleAlignmentTablet,


    //Button
    btnBgColor,
		btnSize,
		btnRel,
		btnWidth,
		btnIcon,
		btnTitle,
		btnBgHoverColor, 
		btnTarget,
		bntRounded, 
		btnHref, 
		btnIconPosition,
		btnAlignment,
		btnAlignmentMobile,
		btnAlignmentTablet,
		btnPadding,
		btnPaddingTablet,
		btnPaddingMobile,
		btnMargin,
		btnMarginTablet,
		btnMarginMobile,
		btnLoadGoogleFonts,
		btnfontFamily,
		btnfontWeight,
		btnfontSubset,
		btnfontSizeType,
		btnfontSizeTypeMobile,
		btnfontSizeTypeTablet,
		btnfontSizeDesktop,
		btnfontSizeMobile,
		btnfontSizeTablet,
		btnlineHeight,
		btnlineHeightMobile,
		btnlineHeightTablet,
		btnletterSpacing,
		btnletterSpacingMobile,
		btnletterSpacingTablet,
		btnletterSpacingType,
		btnletterSpacingTypeTablet,
		btnletterSpacingTypeMobile,
		btntextTransform,
		btntextDecoration,
		btnfontStyle,
		btnBorder,
		btnBorderMobile,
		btnBorderTablet,
		btnBorderRadius,
		btnBorderRadiusMobile,
		btnBorderRadiusTablet,
		btnBorderColor,
		btnBorderHoverColor,
		btnBorderType, 
    btnTextColor,
    btnTextHoverColor,


    btnBg,
    btnBgHover,


	} = props.attributes

	const Tag1 = titleTag1
	const Tag2 = titleTag2
	  var mobile_selectors = {}
	  var tablet_selectors = {}
	  var style = {}


	  var styleBtnBg = cssBackground(btnBg);
    var styleBtnBgHover = cssBackground(btnBgHover);
  
        var selectors = {
			" .affiliate-starreview-inner":{
				"box-shadow":cssBoxShadow(boxShadow),
				"background":boxBgColor
			},
			" .affiliate-starreview-maintitle":{
				"font-family": titlefontFamily,
				"font-size": titlefontSizeDesktop + titlefontSizeType,
				"font-style":titlefontStyle,
				"font-weight":titlefontWeight,
				"letter-spacing":titleletterSpacing + titleletterSpacingType,
				"line-height":titlelineHeight,
				"text-decoration":titletextDecoration,
				"text-transform":titletextTransform,
				"color":titleTextColor,
			},
			
          " .affiliate-starreview-inner .affiliate-star-item .affiliate-txtbox-title":{
              "font-family": cntnfontFamily,
              "font-size": cntnfontSizeDesktop + cntnfontSizeType,
              "font-style":cntnfontStyle,
              "font-weight":cntnfontWeight,
              "letter-spacing":cntnletterSpacing + cntnletterSpacingType,
              "line-height":cntnlineHeight,
              "text-decoration":cntntextDecoration,
              "text-transform":cntntextTransform,
              "color":contentTextColor,
        },

        " .affiliate-starreview-subtitle":{
				"font-family": subtitlefontFamily,
				"font-size": subtitlefontSizeDesktop + subtitlefontSizeType,
				"font-style":subtitlefontStyle,
				"font-weight":subtitlefontWeight,
				"letter-spacing":subtitleletterSpacing + subtitleletterSpacingType,
				"line-height":subtitlelineHeight,
				"text-decoration":subtitletextDecoration,
				"text-transform":subtitletextTransform,
				"color":subtitleColor,
			},
         
		" .affiliate-starreview-starrating .affiliate-star-item svg":{
			"height":starsSize+'px',  
          	"width":starsSize+'px',
		},

		" .affiliate-starreview-footerbox-right .affiliate-star-item svg":{
			"height":starsSize+'px',  
          	"width":starsSize+'px',
		},


		" .affiliate-abbtn":{
              "font-family": btnfontFamily,
              "font-size": btnfontSizeDesktop + btnfontSizeType,
              "font-style":btnfontStyle,
              "font-weight":btnfontWeight,
              "letter-spacing":btnletterSpacing + btnletterSpacingType,
              "line-height": btnlineHeight,
              "text-transform": btntextTransform,
              "text-decoration": btntextDecoration,
              "color":btnTextColor,
              "text-align":btnAlignment,
              "background":styleBtnBg,
              "border-style":btnBorderType,
              "border-radius":( btnBorderRadius && undefined !== btnBorderRadius[ 'top' ] && null !== btnBorderRadius[ 'top' ] ? btnBorderRadius[ 'top' ] + btnBorderRadius['unit'] + ' ' + btnBorderRadius[ 'right' ] + btnBorderRadius['unit'] + ' ' + btnBorderRadius[ 'bottom' ] + btnBorderRadius['unit'] + ' ' + btnBorderRadius[ 'left' ] + btnBorderRadius['unit'] : '' ),
              "border-color":btnBorderColor,
              "border-width" : ( btnBorder && undefined !== btnBorder[ 'top' ] && null !== btnBorder[ 'top' ] ? btnBorder[ 'top' ] + btnBorder['unit'] + ' ' + btnBorder[ 'right' ] + btnBorder['unit'] + ' ' + btnBorder[ 'bottom' ] + btnBorder['unit'] + ' ' + btnBorder[ 'left' ] + btnBorder['unit'] : '' ),
              "padding" : ( btnPadding && undefined !== btnPadding[ 'top' ] && null !== btnPadding[ 'top' ] ? btnPadding[ 'top' ] + btnPadding['unit'] + ' ' + btnPadding[ 'right' ] + btnPadding['unit'] + ' ' + btnPadding[ 'bottom' ] + btnPadding['unit'] + ' ' + btnPadding[ 'left' ] + btnPadding['unit'] : '' ),
              "margin" : ( btnMargin && undefined !== btnMargin[ 'top' ] && null !== btnMargin[ 'top' ] ? btnMargin[ 'top' ] + btnMargin['unit'] + ' ' + btnMargin[ 'right' ] + btnMargin['unit'] + ' ' + btnMargin[ 'bottom' ] + btnMargin['unit'] + ' ' + btnMargin[ 'left' ] + btnMargin['unit'] : '' ),
          },
          " .affiliate-abbtn-inner":{
              "justify-content":btnAlignment
          },
          " .affiliate-abbtn:hover":{
              "color":btnTextHoverColor,
              "background":styleBtnBgHover,
              "border-color":btnBorderHoverColor,
          },

		
     }
	 
	
	 	
        tablet_selectors = {
          
       }

        mobile_selectors = {
          
        }



	var affiliate_styling_css = ""

	affiliate_styling_css = affiliate_generateCSS( selectors, `#${id}-${ props.clientId }` )

  affiliate_styling_css += affiliate_generateCSS( tablet_selectors, `#${id}-${ props.clientId }`, true, "tablet" )

  affiliate_styling_css += affiliate_generateCSS( mobile_selectors, `#${id}-${ props.clientId }`, true, "mobile" )

	return affiliate_styling_css
}

export default affiliate_styling
