const { Component,Fragment } = wp.element;
const { RichText } = wp.blockEditor;
import classnames from "classnames"
import ABTOC from './toc3';

class Save extends Component {
    constructor(props) {
        super( ...arguments )
    }
    render() {
        
        const {
            name,
            clientId,
            isSelected,
            headers,
            attributes,
            setAttributes,
            className,
            attributes: {
                block_id,
                mappingHeaders,
                align,
                tColumnsDesktop,
                initialCollapse,
                heading,
                headerLinks,
                tColumns,
                scrollToTop,
                boxMargin,
                boxMarginMobile,
                boxMarginTablet,
                boxPadding,
                boxPaddingMobile,
                boxPaddingTablet,
                boxBorder,
                boxBorderMobile,
                boxBorderTablet,
                boxBorderRadius,
                boxBorderRadiusMobile,
                boxBorderRadiusTablet,
                titleTextColor,
                titleLoadGoogleFonts,
                titlefontFamily,
                titlefontSizeDesktop,
                titlefontSizeMobile,
                titlefontSizeTablet,
                titlefontStyle,
                titlefontSubset,
                titlefontWeight,
                titlefontSizeType,
                titlefontSizeTypeMobile,
                titlefontSizeTypeTablet,
                titleletterSpacing,
                titleletterSpacingMobile,
                titleletterSpacingTablet,
                titleletterSpacingType,
                titleletterSpacingTypeTablet,
                titleletterSpacingTypeMobile,
                titlelineHeight,
                titlelineHeightMobile,
                titlelineHeightTablet,
                titletextDecoration,
                titletextTransform,
                cntnLoadGoogleFonts,
                cntnfontFamily,
                cntnfontWeight,
                cntnfontSubset,
                cntnfontSizeType,
                cntnfontSizeTypeMobile,
                cntnfontSizeTypeTablet,
                cntnfontSizeDesktop,
                cntnfontSizeMobile,
                cntnfontSizeTablet,
                cntnlineHeight,
                cntnlineHeightMobile,
                cntnlineHeightTablet,
                cntnletterSpacing,
                cntnletterSpacingMobile,
                cntnletterSpacingTablet,
                cntnletterSpacingType,
                cntnletterSpacingTypeTablet,
                cntnletterSpacingTypeMobile,
                cntntextTransform,
                cntntextDecoration,
                cntnfontStyle,
                cntnTextColor,
                boxBorderType,
                customWidthType,
                customWidthTypeMobile,
                customWidthTypeTablet,
                customWidth,
                customWidthMobile,
                customWidthTablet,
                boxPosition,
                enableCustomWidth,
                borderColor,
                boxBgColor,
                boxShadow,
                numberofColumns,
                numberofColumnsMobile,
                numberofColumnsTablet,
                isCollapsible,
                listType,
                collapsibleType,
                collapseOpenText,
                collapseCloseText,
                toggleIcon,
                isCollapsed,
                smoothScroll,
                smoothScrollDelay,
                smoothScrollOffset
              }
        } = this.props;
        let icon_html = ''

        const currentIconClass = {};
        switch(toggleIcon) {
            case 'chevron-cirlce':
                currentIconClass.open = 'fas fa-chevron-circle-down';
                currentIconClass.close = 'fas fa-chevron-circle-up';
                break;
            case 'plus':
                currentIconClass.open = 'fas fa-plus';
                currentIconClass.close = 'fas fa-minus';
                break;
            case 'plus-square':
                currentIconClass.open = 'fas fa-plus-square';
                currentIconClass.close = 'fas fa-minus-square';
                break;
            default:
                currentIconClass.open = 'fas fa-angle-down';
                currentIconClass.close = 'fas fa-angle-up';
        }

        if ( isCollapsible ) {
            icon_html = (
                    <div className={`affiliate-toc-collapsible-wrap affiliate-table-of-contents-toggle ${initialCollapse ? '': 'affiliate-toc-collapsed'}`}>
                        {
                            collapsibleType !== 'icon' ? (
                                <Fragment>
                                    <a className='affiliate-collapsible-text affiliate-toc-close-text' href='javascript:;'>{collapseCloseText}</a>
                                    <a className='affiliate-collapsible-text affiliate-toc-open-text' href='javascript:;'>{collapseOpenText}</a>
                                </Fragment>
                            ) : (
                                <Fragment>
                                    <a href="javascript:;" className={classnames([
                                        'affiliate-collapsible-icon affiliate-toc-close-icon',
                                        currentIconClass.close
                                    ])} />
                                    <a href="javascript:;" className={classnames([
                                        'affiliate-collapsible-icon affiliate-toc-open-icon',
                                        currentIconClass.open
                                    ])} />
                                </Fragment>
                            )
                        }
                    </div>
            )	
        }  

        return (
            <Fragment>
                   <div id={`affiliate-style-${block_id}`} 
                    className={ classnames( className, `wp-block-affiliate-booster-ab-tableof-content affiliate-toc-align-${align}`, `affiliate-toc-columns-${tColumnsDesktop}`, ( initialCollapse ) ? `` : 'affiliate-toc-collapse',
                    `affiliate-block-${ block_id.substr( 0, 8 ) }` )} data-scroll={smoothScroll} data-offset={smoothScrollOffset} data-delay={smoothScrollDelay} >
                     <div className={`affiliate-toc-inner affiliate-toc-is${listType} affiliate-toc-align-${boxPosition}`}>
                        <div className="affiliate-toc-wrap">
                            <div className="affiliate-toc-title-wrap">
                                <RichText.Content
                                    value={ heading }
                                    tagName='div'
                                    className='affiliate-toc-title'
                                />
                                {icon_html}
                            </div>
                            {/* <ABTOC2 itemlisttype = {listType} mappingHeaders={mappingHeaders} headers={headerLinks && JSON.parse(headerLinks)}/> */}
                            <ABTOC
                                headers={headerLinks && JSON.parse(headerLinks)}
                                blockProp={this.props}
                                // frontend
                            />
                        </div>
                    </div>
                </div>
            </Fragment>
        );
    }
}

export default Save;