const { __ } = wp.i18n

const attributes = {
	block_id : {
		type    : "string",
		default : "not_set",
	},
	listType:{
		type: 'string',
        default: 'list'
	},
	boxBg: {
        type: 'object',
        default: {
            openBg : false,
            bgimgPosition: 'center center',
            bgimgSize: 'cover',
            bgimgRepeat: 'no-repeat',
            bgDefaultColor: '#f5f5f5',
            bgimageSource: 'local',
            externalImageUrl: {}
        },
	},
	boxBgColor: {
		type:'string',
		default:'#eaeaea',	
	},
	
	boxShadow:{
        type: 'object',
        default: {
            openShadow: true,
            blur:35,
            color:"rgba(0, 0, 0, 0.14)",
            inset : 0,
            spread : 0,
            horizontal: 0,
            vertical : 8
        }
	},
	isCollapsible :{
		type:'boolean',
		default:false
	},
	boxPadding:{
        type: 'object',
        default: {
            unit:'px',
        }
    },
    boxPaddingTablet:{
        type: 'object',
        default: {
            unit:'px',
        }
    },
    boxPaddingMobile:{
        type: 'object',
        default: {
            unit:'px',
        }
    },
    boxMargin:{
        type: 'object',
        default: {
            unit:'px',
        }
    },
    boxMarginTablet:{
        type: 'object',
        default: {
            unit:'px',
        }
    },
    boxMarginMobile:{
        type: 'object',
        default: {
            unit:'px',
        }
	},
	boxBorder:{
        type: 'object',
        default: {
			unit: 'px',
			top: 2,
			right: 2,
			bottom: 2,
			left: 2,
        }
	},
	boxBorderMobile:{
        type: 'object',
        default: {
            unit:'px',
        }
	},
	boxBorderTablet:{
        type: 'object',
        default: {
            unit:'px',
        }
	},
	boxBorderRadius:{
        type: 'object',
        default: {
            unit:'px',
        }
	},
	boxBorderRadiusTablet:{
        type: 'object',
        default: {
            unit:'px',
        }
	},
	boxBorderRadiusMobile:{
        type: 'object',
        default: {
            unit:'px',
        }
	},
	boxBorderType:{
		type: 'string',
        default: ''
	},
	enableCustomWidth:{
		type:'boolean',
		default:false
	},
	customWidthMobile:{
        type:'number',
        default:'',
    },
    customWidthTablet:{
        type:'number',
        default:'',
    },
    customWidthType:{
        type:'string',
        default:'%',
    },
    customWidthTypeMobile:{
        type:'string',
        default:'%',
    },
    customWidthTypeTablet:{
        type:'string',
        default:'%',
	},
	boxPosition: {
        type: 'string',
        default:'',
    },
	titleLoadGoogleFonts:{
        type: 'boolean',
        default: false
	},
	titleBgColor: {
        type: 'string',
        default:'',
    },
    titleTextColor: {
        type: 'string',
        default:'#000000',
	},
	titleTextHoverColor:{
		type: 'string',
        default:'#000000',
	},
    titlefontFamily: {
        type: 'string',
        default:'',
    },
    titlefontWeight: {
        type: 'string',
        default: '',
    },
    titlefontSubset: {
        type: 'string',
        default: '',
    },
    titlefontSizeType: {
        type: 'string',
        default: 'px',
    },
    titlefontSizeTypeMobile: {
        type: 'string',
        default: 'px',
    },
    titlefontSizeTypeTablet: {
        type: 'string',
        default: 'px',
    },
    titlefontSizeDesktop: {
        type: 'number',
        default: '20',
	},
	isCollapsed: {
        type: 'boolean',
        default: false
    },
	collapseOpenText:{
		type: 'string',
        default: 'Show',
	},
	collapseCloseText:{
		type: 'string',
        default: 'Hide',
	},
	toggleIcon:{
		type: 'string',
        default: '',
	},
	collapsibleType:{
		type: 'string',
        default: 'icon',
	},
    titlefontSizeMobile: {
        type: 'number',
        default: '',
    },
    titlefontSizeTablet: {
        type: 'number',
        default: '',
    },
    titlelineHeight: {
        type: 'string',
        default: ''
    },
    titlelineHeightMobile: {
        type: 'string',
        default: ''
    },
    titlelineHeightTablet: {
        type: 'string',
        default: ''
    },
    titleletterSpacing: {
        type: 'number',
        default: ''
    },
    titleletterSpacingMobile: {
        type: 'number',
        default: ''
    },
    titleletterSpacingTablet: {
        type: 'number',
        default: ''
    },
    titleletterSpacingType: {
        type: 'string',
        default: 'px'
    },
    titleletterSpacingTypeTablet: {
        type: 'string',
        default: 'px'
    },
    titleletterSpacingTypeMobile: {
        type: 'string',
        default: 'px'
    },
    titletextTransform: {
        type: 'string',
        default: ''
    },
    titletextDecoration: {
        type: 'string',
        default: ''
    },
    titlefontStyle: {
        type: 'string',
        default: ''
    },
	classMigrate: {
		type: "boolean",
		default: false
	},
	disableBullets : {
		type    : "boolean",
		default : false,
	},
	makeCollapsible : {
		type    : "boolean",
		default : false,
	},
	initialCollapse : {
		type    : "boolean",
		default : true,
	},
	icon : {
		type : "string",
		default : "fa-angle-down"
	},
	iconSize : {
		type: "number",
	},
	iconColor : {
		type : "string",
	},
	bulletColor : {
		type : "string",
	},
	smoothScroll : {
		type    : "boolean",
		default : true,
	},
	smoothScrollDelay : {
		type    : "number",
		default : 800,
	},
	smoothScrollOffset : {
		type    : "number",
		default : 30,
	},
	scrollToTop : {
		type    : "boolean",
		default : false,
	},
	scrollToTopColor : {
		type : "string",
	},
	scrollToTopBgColor : {
		type : "string",
	},
	mappingHeaders: {
		type: 'array',
		default: Array(6).fill(true)
	},
	headerLinks: {
		type: 'string',
		default: ''
	},
	align : {
		type    : "string",
		default : "left",
	},
	heading: {
		source: "html",
		selector: ".affiliate-toc-title",
		default: "Table Of Contents",
	},
	numberofColumns : {
		type: "string",
		default : 1
	},
	numberofColumnsMobile : {
		type: "string",
		default : 1
	},
	numberofColumnsTablet : {
		type: "string",
		default : 1
	},
	customWidth : {
		type: "number",
		default : ''
	},
	widthTypeDesktop : {
		type    : "string",
		default : "%",
	},
	widthTypeTablet : {
		type    : "string",
		default : "%",
	},
	widthTypeMobile : {
		type    : "string",
		default : "%",
	},
	widthDesktop : {
		type    : "number",
		default : 100,
	},
	widthTablet : {
		type    : "number",
	},
	widthMobile : {
		type    : "number",
	},
	tColumnsDesktop : {
		type    : "number",
		default : 1,
	},
	tColumnsTablet : {
		type    : "number",
		default : 1,
	},
	tColumnsMobile : {
		type    : "number",
		default : 1,
	},

	// Color
	backgroundColor: {
		type: "string",
		default: "#b8b8b8"
	},
	linkColor: {
		type: "string",
		default: "#333"
	},
	linkHoverColor: {
		type: "string"
	},
	headingColor : {
		type: "string"
	},

	// Padding
	vPaddingDesktop :{
		type: "number",
		default: 30,
	},
	hPaddingDesktop :{
		type: "number",
		default: 30,
	},
	vPaddingTablet :{
		type: "number",
	},
	hPaddingTablet :{
		type: "number",
	},
	vPaddingMobile :{
		type: "number",
	},
	hPaddingMobile :{
		type: "number",
	},
	// Margin
	vMarginDesktop :{
		type: "number",
	},
	hMarginDesktop :{
		type: "number",
	},
	vMarginTablet :{
		type: "number",
	},
	hMarginTablet :{
		type: "number",
	},
	vMarginMobile :{
		type: "number",
	},
	hMarginMobile :{
		type: "number",
	},
	marginTypeDesktop : {
		type    : "string",
		default : "px",
	},
	marginTypeTablet : {
		type    : "string",
		default : "px",
	},
	marginTypeMobile : {
		type    : "string",
		default : "px",
	},
	headingBottom :{
		type: "number"
	},	
	paddingTypeDesktop : {
		type    : "string",
		default : "px",
	},
	paddingTypeTablet : {
		type    : "string",
		default : "px",
	},
	paddingTypeMobile : {
		type    : "string",
		default : "px",
	},

	// Content Padding
	contentPaddingDesktop :{
		type: "number",
	},
	contentPaddingTablet :{
		type: "number",
	},
	contentPaddingMobile :{
		type: "number",
	},	
	contentPaddingTypeDesktop : {
		type    : "string",
		default : "px",
	},
	contentPaddingTypeTablet : {
		type    : "string",
		default : "px",
	},
	contentPaddingTypeMobile : {
		type    : "string",
		default : "px",
	},

	// Border
	borderStyle : {
		type: "string",
		default: "solid"
	},
	borderWidth : {
		type: "number",
		default: 1
	},
	borderRadius : {
		type: "number"
	},
	borderColor : {
		type: "string",
		default:'#b8b8b8',
	},
	mappedHeaders: {
        type: 'object',
        default: {
            h1: true,
            h2: true,
            h3: true,
            h4: true,
            h5: true,
            h6: true,
        }
    },

	// Typography
	// Link Font Family
	loadGoogleFonts: {
		type: "boolean",
		default: false
	},
	fontFamily: {
		type: "string",
		default: "Default",
	},
	fontWeight: {
		type: "string",
	},
	fontSubset: {
		type: "string",
	},
	// Link Font Size
	fontSize: {
		type: "number",
	},
	fontSizeType: {
		type: "string",
		default: "px"
	},
	fontSizeTablet: {
		type: "number",
	},
	fontSizeMobile: {
		type: "number",
	},
	// Link Line Height
	lineHeightType: {
		type: "string",
		default: "em"
	},
	lineHeight: {
		type: "number",
	},
	lineHeightTablet: {
		type: "number",
	},
	lineHeightMobile: {
		type: "number",
	},

	// Link Font Family
	headingLoadGoogleFonts: {
		type: "boolean",
		default: false
	},
	headingFontFamily: {
		type: "string",
		default: "Default",
	},
	headingFontWeight: {
		type: "string",
		default: "500"
	},
	headingFontSubset: {
		type: "string",
	},
	// Link Font Size
	headingFontSize: {
		type: "number",
		default: 20
	},
	headingFontSizeType: {
		type: "string",
		default: "px"
	},
	headingFontSizeTablet: {
		type: "number",
	},
	headingFontSizeMobile: {
		type: "number",
	},
	// Link Line Height
	headingLineHeightType: {
		type: "string",
		default: "em"
	},
	headingLineHeight: {
		type: "number",
	},
	headingLineHeightTablet: {
		type: "number",
	},
	headingLineHeightMobile: {
		type: "number",
	},
	cntnfontFamily: {
        type: 'string',
        default:'',
    },
    cntnfontWeight: {
        type: 'string',
        default: '',
    },
    cntnfontSubset: {
        type: 'string',
        default: '',
    },
    cntnfontSizeType: {
        type: 'string',
        default: 'px',
    },
    cntnfontSizeTypeMobile: {
        type: 'string',
        default: 'px',
    },
    cntnfontSizeTypeTablet: {
        type: 'string',
        default: 'px',
    },
    cntnfontSizeDesktop: {
        type: 'number',
        default: '',
    },
    cntnfontSizeMobile: {
        type: 'number',
        default: '',
    },
    cntnfontSizeTablet: {
        type: 'number',
        default: '',
    },
    cntnlineHeight: {
        type: 'string',
        default: ''
    },
    cntnlineHeightMobile: {
        type: 'string',
        default: ''
    },
    cntnlineHeightTablet: {
        type: 'string',
        default: ''
    },
    cntnletterSpacing: {
        type: 'number',
        default: ''
    },
    cntnletterSpacingMobile: {
        type: 'number',
        default: ''
    },
    cntnletterSpacingTablet: {
        type: 'number',
        default: ''
    },
    cntnletterSpacingType: {
        type: 'string',
        default: 'px'
    },
    cntnletterSpacingTypeTablet: {
        type: 'string',
        default: 'px'
    },
    cntnletterSpacingTypeMobile: {
        type: 'string',
        default: 'px'
    },
    cntntextTransform: {
        type: 'string',
        default: ''
    },
    cntntextDecoration: {
        type: 'string',
        default: ''
    },
    cntnfontStyle: {
        type: 'string',
        default: ''
	},
	cntnLoadGoogleFonts:{
		type: 'boolean',
        default: false
	},
	cntnBgColor:{
		type: 'string',
        default: ''
	},
	cntnHoverBgColor:{
		type: 'string',
        default: ''
	},
	cntnTextColor:{
		type: 'string',
        default: '#000000'
	},
	cntnTextHoverColor:{
		type: 'string',
        default: ''
	},
	cntnBorderColor:{
		type: 'string',
        default: ''
	},
	cntnBorderHoverColor:{
		type: 'string',
        default: ''
	},
}

export default attributes
