/**
 * Set inline styles.
 * @param  {object} props - The block object.
 * @return {object} The inline background type CSS.
 */

import affiliate_generateCSS from "./generateCSS"
import { cssGradient, cssBoxShadow,cssWithoutSelector,cssTextShadow, cssBackground } from '../components/cssHelper'
function affiliate_styling( props, id ) {

	const {
    block_id,
    mappingHeaders,
    align,
    tColumnsDesktop,
    initialCollapse,
    heading,
    headerLinks,
    tColumns,
    scrollToTop,
    boxMargin,
    boxMarginMobile,
    boxMarginTablet,
    boxPadding,
    boxPaddingMobile,
    boxPaddingTablet,
    boxBorder,
    boxBorderMobile,
    boxBorderTablet,
    boxBorderRadius,
    boxBorderRadiusMobile,
    boxBorderRadiusTablet,
    titleTextColor,
    titleLoadGoogleFonts,
    titlefontFamily,
    titlefontSizeDesktop,
    titlefontSizeMobile,
    titlefontSizeTablet,
    titlefontStyle,
    titlefontSubset,
    titlefontWeight,
    titlefontSizeType,
    titlefontSizeTypeMobile,
    titlefontSizeTypeTablet,
    titleletterSpacing,
    titleletterSpacingMobile,
    titleletterSpacingTablet,
    titleletterSpacingType,
    titleletterSpacingTypeTablet,
    titleletterSpacingTypeMobile,
    titlelineHeight,
    titlelineHeightMobile,
    titlelineHeightTablet,
    titletextDecoration,
    titletextTransform,
    cntnLoadGoogleFonts,
    cntnfontFamily,
    cntnfontWeight,
    cntnfontSubset,
    cntnfontSizeType,
    cntnfontSizeTypeMobile,
    cntnfontSizeTypeTablet,
    cntnfontSizeDesktop,
    cntnfontSizeMobile,
    cntnfontSizeTablet,
    cntnlineHeight,
    cntnlineHeightMobile,
    cntnlineHeightTablet,
    cntnletterSpacing,
    cntnletterSpacingMobile,
    cntnletterSpacingTablet,
    cntnletterSpacingType,
    cntnletterSpacingTypeTablet,
    cntnletterSpacingTypeMobile,
    cntntextTransform,
    cntntextDecoration,
    cntnfontStyle,
    cntnTextColor,
    boxBorderType,
    customWidthType,
    customWidthTypeMobile,
    customWidthTypeTablet,
    customWidth,
    customWidthMobile,
    customWidthTablet,
    boxPosition,
    enableCustomWidth,
    borderColor,
    boxShadow,
    boxBgColor,
    numberofColumns,
    titleTextHoverColor
	} = props.attributes

  var mobile_selectors = {}
  var tablet_selectors = {}
  var style = {}
  // var styleBackground = cssBackground(boxBg);

        var selectors = {
          " .affiliate-toc-wrap":{
              "width":customWidth + customWidthType,
              "border-color":borderColor,
              "border-style":boxBorderType,
              "background":boxBgColor,
              "border-width" : ( boxBorder && undefined !== boxBorder[ 'top' ] && null !== boxBorder[ 'top' ] ? boxBorder[ 'top' ] + boxBorder['unit'] + ' ' + boxBorder[ 'right' ] + boxBorder['unit'] + ' ' + boxBorder[ 'bottom' ] + boxBorder['unit'] + ' ' + boxBorder[ 'left' ] + boxBorder['unit'] : '' ),
              "border-radius" : ( boxBorderRadius && undefined !== boxBorderRadius[ 'top' ] && null !== boxBorderRadius[ 'top' ] ? boxBorderRadius[ 'top' ] + boxBorderRadius['unit'] + ' ' + boxBorderRadius[ 'right' ] + boxBorderRadius['unit'] + ' ' + boxBorderRadius[ 'bottom' ] + boxBorderRadius['unit'] + ' ' + boxBorderRadius[ 'left' ] + boxBorderRadius['unit'] : '' ),
              "padding" : ( boxPadding && undefined !== boxPadding[ 'top' ] && null !== boxPadding[ 'top' ] ? boxPadding[ 'top' ] + boxPadding['unit'] + ' ' + boxPadding[ 'right' ] + boxPadding['unit'] + ' ' + boxPadding[ 'bottom' ] + boxPadding['unit'] + ' ' + boxPadding[ 'left' ] + boxPadding['unit'] : '' ),
              "margin" : ( boxMargin && undefined !== boxMargin[ 'top' ] && null !== boxMargin[ 'top' ] ? boxMargin[ 'top' ] + boxMargin['unit'] + ' ' + boxMargin[ 'right' ] + boxMargin['unit'] + ' ' + boxMargin[ 'bottom' ] + boxMargin['unit'] + ' ' + boxMargin[ 'left' ] + boxMargin['unit'] : '' ),
              "box-shadow":cssBoxShadow(boxShadow),
          },
          " .affiliate-toc-list-wrap":{
              "column-count":numberofColumns,
          },
          " .affiliate-toc-title":{
              "font-family": titlefontFamily,
              "font-size": titlefontSizeDesktop + titlefontSizeType,
              "font-style":titlefontStyle,
              "font-weight":titlefontWeight,
              "letter-spacing":titleletterSpacing + titleletterSpacingType,
              "line-height":titlelineHeight,
              "text-decoration":titletextDecoration,
              "text-transform":titletextTransform,
              "color":titleTextColor,
          },
          " .affiliate-toc-list a":{
              "text-decoration":cntntextDecoration,
              "color":cntnTextColor,
          },
          " .affiliate-toc-list a:hover":{
              "color":titleTextHoverColor,
          },
          " ul.affiliate-toc-list li:hover":{
              "color":titleTextHoverColor,
          },
          " ol.affiliate-toc-list li:hover":{
            "color":titleTextHoverColor,
          },
          " .affiliate-toc-list":{
              "font-family": cntnfontFamily,
              "font-size": cntnfontSizeDesktop + cntnfontSizeType,
              "font-style":cntnfontStyle,
              "font-weight":cntnfontWeight,
              "letter-spacing":cntnletterSpacing + cntnletterSpacingType,
              "line-height":cntnlineHeight,
              "text-decoration":cntntextDecoration,
              "text-transform":cntntextTransform,
              "color":cntnTextColor,
          },
        }
  
      tablet_selectors = {
      
      }

      mobile_selectors = {
      
      }



	var affiliate_styling_css = ""

	affiliate_styling_css = affiliate_generateCSS( selectors, `#${id}-${ props.clientId }` )

  affiliate_styling_css += affiliate_generateCSS( tablet_selectors, `#${id}-${ props.clientId }`, true, "tablet" )

  affiliate_styling_css += affiliate_generateCSS( mobile_selectors, `#${id}-${ props.clientId }`, true, "mobile" )

	return affiliate_styling_css
}

export default affiliate_styling
