const {
    Fragment,
    Component
} = wp.element;
const { select, subscribe } = wp.data;
const { __ } = wp.i18n;

class ABTOC extends Component {
    constructor(props) {
        super(props);
        this.state = {
            headers: props.headers,
            unsubscribe: null
        };
    }

    componentDidMount() {

        const getAllChildHeadingBlocks = parentBlock => {
            let childs = [];
            parentBlock.innerBlocks.forEach(childBlock => {
                if (childBlock.name === 'core/heading') {
                    childs.push(childBlock);
                }
                if (childBlock.name === 'affiliate-booster/ab-single-product') {
                    childs.push(childBlock);
                } 
                if (childBlock.name === 'affiliate-booster/ab-toppick-box') {
                    childs.push(childBlock);
                } 
                if (childBlock.name === 'affiliate-booster/ab-product-review') {
                    childs.push(childBlock);
                }
                if (childBlock.name === 'affiliate-booster/ab-comparison-table') {
                    childs.push(childBlock);
                }
                if (childBlock.name === 'affiliate-booster/ab-callto-action') {
                    childs.push(childBlock);
                }
                if (childBlock.name === 'affiliate-booster/ab-notice-box') {
                    childs.push(childBlock);
                }
                if (childBlock.name === 'affiliate-booster/ab-title-block') {
                    childs.push(childBlock);
                }
                if (childBlock.name === 'affiliate-booster/ab-star-review') {
                    childs.push(childBlock);
                }
                if (childBlock.name === 'affiliate-booster/ab-ratingbar') {
                    childs.push(childBlock);
                }
                if (childBlock.name === 'affiliate-booster/ab-notification-box') {
                    childs.push(childBlock);
                }


                if (childBlock.name === 'affiliate-booster/ab-coupon1') {
                    childs.push(childBlock);
                }
                if (childBlock.name === 'affiliate-booster/ab-coupon2') {
                    childs.push(childBlock);
                }
                if (childBlock.name === 'affiliate-booster/ab-coupon3') {
                    childs.push(childBlock);
                }

                if (childBlock.name === 'affiliate-booster/ab-top-pick-specs') {
                    childs.push(childBlock);
                }
                if (childBlock.name === 'affiliate-booster/ab-single-product-pros-cons') {
                    childs.push(childBlock);
                }
                if (childBlock.name === 'affiliate-booster/ab-single-product-specs') {
                    childs.push(childBlock);
                }
                if (childBlock.name === 'affiliate-booster/ab-key-points') {
                    childs.push(childBlock);
                }

                if (childBlock.innerBlocks.length > 0) {
                    childs.push(...getAllChildHeadingBlocks(childBlock));
                }
            });
            return childs;
        };
        const getsHeadingBlocks = () => {
            let targetBlocks = [];
            const allBlocks = select('core/block-editor').getBlocks();
            allBlocks.forEach(block => {
                if (block.name === 'core/heading') {
                    targetBlocks.push(block);
                } else if (block.name === 'affiliate-booster/ab-single-product') {
                    targetBlocks.push(block);
                } else if (block.name === 'affiliate-booster/ab-toppick-box') {
                    targetBlocks.push(block);
                } else if (block.name === 'affiliate-booster/ab-product-review') {
                    targetBlocks.push(block);
                } else if (block.name === 'affiliate-booster/ab-comparison-table') {
                    targetBlocks.push(block);
                } else if (block.name === 'affiliate-booster/ab-callto-action') {
                    targetBlocks.push(block);
                } else if (block.name === 'affiliate-booster/ab-notice-box') {
                    targetBlocks.push(block);
                } else if (block.name === 'affiliate-booster/ab-title-block') {
                    targetBlocks.push(block);
                } else if (block.name === 'affiliate-booster/ab-ratingbar') {
                    targetBlocks.push(block);
                } else if (block.name === 'affiliate-booster/ab-star-review') {
                    targetBlocks.push(block);
                }  else if (block.name === 'affiliate-booster/ab-notification-box') {
                    targetBlocks.push(block);
                } else if (block.name === 'affiliate-booster/ab-coupon1') {
                    targetBlocks.push(block);
                } else if (block.name === 'affiliate-booster/ab-coupon2') {
                    targetBlocks.push(block);
                } else if (block.name === 'affiliate-booster/ab-coupon3') {
                    targetBlocks.push(block);
                } else if (block.name === 'affiliate-booster/ab-top-pick-specs') {
                    targetBlocks.push(block);
                } else if (block.name === 'affiliate-booster/ab-single-product-pros-cons') {
                    targetBlocks.push(block);
                } else if (block.name === 'affiliate-booster/ab-single-product-specs') {
                    targetBlocks.push(block);
                } else if (block.name === 'affiliate-booster/ab-key-points') {
                    targetBlocks.push(block);
                } else if (block.innerBlocks.length > 0) {
                    let childHeadingBlocks = getAllChildHeadingBlocks(block);
                    if (childHeadingBlocks.length > 0) {
                        targetBlocks.push(...childHeadingBlocks);
                    }
                }
            })
            return targetBlocks;
        };

        const setHeaders = () => {

            let headings = getsHeadingBlocks().map(header => header.attributes);
            let finalheadings = [];
            let kk = 1;
            headings.forEach((heading, key) => {

                if (heading.content) {

                        if (!heading.anchor) {
                            heading.anchor =
                                `${key + 1}-` +
                                heading.content
                                    .toString()
                                    .toLowerCase()
                                    .replace(/( |<.+?>|&nbsp;)/g, "-");
                            heading.anchor = encodeURIComponent(
                                heading.anchor.replace(
                                    /[^\w\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF\s-]/g,
                                    ""
                                )
                            );
                        }

                        if(heading.titleText){

                            if(heading.titleTag1 != 'p'){   
                                let levelval = 0;
                                if(heading.titleTag1 == 'h1'){
                                    levelval = 1;
                                }else if(heading.titleTag1 == 'h2'){
                                    levelval = 2;
                                }else if(heading.titleTag1 == 'h3'){
                                    levelval = 3;
                                }else if(heading.titleTag1 == 'h4'){
                                    levelval = 4;
                                }else if(heading.titleTag1 == 'h5'){
                                    levelval = 5;
                                }else if(heading.titleTag1 == 'h6'){
                                    levelval = 6;
                                }
                                finalheadings.push({
                                    content:heading.titleText.toString(),
                                    level:levelval,
                                    anchor:heading.titleText.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                                });               
                            }

                        }else{

                            finalheadings.push({
                                content:heading.content,
                                level:heading.level,
                                anchor:heading.anchor
                            }); 

                        }
                }

                if(heading.spTitle){
                    if(heading.titleTag1 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag1 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag1 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag1 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag1 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag1 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag1 == 'h6'){
                            levelval = 6;
                        }
                        finalheadings.push({
                            content:heading.spTitle.toString(),
                            level:levelval,
                            anchor:heading.spTitle.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });               
                    } 

                    if(heading.titleTag2 != 'p'){   

                        let levelval = 0;
                        if(heading.titleTag2 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag2 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag2 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag2 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag2 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag2 == 'h6'){
                            levelval = 6;
                        }

                        finalheadings.push({
                            content:heading.spSubTitle.toString(),
                            level:levelval,
                            anchor:heading.spSubTitle.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });    
                    } 
                }

                if(heading.topPickMainTitle){
                    if(heading.titleTag1 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag1 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag1 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag1 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag1 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag1 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag1 == 'h6'){
                            levelval = 6;
                        }
                        finalheadings.push({
                            content:heading.topPickMainTitle.toString(),
                            level:levelval,
                            anchor:heading.topPickMainTitle.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });               
                    } 

                    if(heading.titleTag2 != 'p'){   

                        let levelval = 0;
                        if(heading.titleTag2 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag2 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag2 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag2 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag2 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag2 == 'h6'){
                            levelval = 6;
                        } 

                        finalheadings.push({
                            content:heading.propsTitle.toString(),
                            level:levelval,
                            anchor:heading.propsTitle.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });

                        finalheadings.push({
                            content:heading.consTitle.toString(),
                            level:levelval,
                            anchor:heading.consTitle.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });    
                    } 
                }

                if(heading.tdbox){
                    if(heading.titleTag1 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag1 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag1 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag1 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag1 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag1 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag1 == 'h6'){
                            levelval = 6;
                        }

                        heading.tdbox.forEach((heading1, key1) => {
                            finalheadings.push({
                                content:heading1.fdprd.toString(),
                                level:levelval,
                                anchor:heading1.fdprd.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                            });   
                        });    
                    }                    
                }

                if(heading.ctaTitle){
                    if(heading.titleTag1 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag1 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag1 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag1 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag1 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag1 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag1 == 'h6'){
                            levelval = 6;
                        }
                        finalheadings.push({
                            content:heading.ctaTitle.toString(),
                            level:levelval,
                            anchor:heading.ctaTitle.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });               
                    } 
                }

                if(heading.noticeTitle){
                    if(heading.titleTag1 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag1 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag1 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag1 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag1 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag1 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag1 == 'h6'){
                            levelval = 6;
                        }
                        finalheadings.push({
                            content:heading.noticeTitle.toString(),
                            level:levelval,
                            anchor:heading.noticeTitle.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });               
                    }                     
                }


                if(heading.ratingBarMainTitle){
                    if(heading.titleTag1 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag1 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag1 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag1 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag1 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag1 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag1 == 'h6'){
                            levelval = 6;
                        }
                        finalheadings.push({
                            content:heading.ratingBarMainTitle.toString(),
                            level:levelval,
                            anchor:heading.ratingBarMainTitle.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });               
                    }                     
                }


                if(heading.ratingBarSubTitle){
                    if(heading.titleTag2 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag2 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag2 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag2 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag2 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag2 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag2 == 'h6'){
                            levelval = 6;
                        }
                        finalheadings.push({
                            content:heading.ratingBarSubTitle.toString(),
                            level:levelval,
                            anchor:heading.ratingBarSubTitle.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });               
                    }                     
                }


                if(heading.mainTitle){
                    if(heading.titleTag1 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag1 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag1 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag1 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag1 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag1 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag1 == 'h6'){
                            levelval = 6;
                        }
                        finalheadings.push({
                            content:heading.mainTitle.toString(),
                            level:levelval,
                            anchor:heading.mainTitle.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });               
                    }                     
                }


                if(heading.subTitle){
                    if(heading.titleTag2 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag2 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag2 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag2 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag2 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag2 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag2 == 'h6'){
                            levelval = 6;
                        }
                        finalheadings.push({
                            content:heading.subTitle.toString(),
                            level:levelval,
                            anchor:heading.subTitle.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });               
                    }                     
                }

                if(heading.noticeboxContent){
                    if(heading.titleTag1 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag1 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag1 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag1 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag1 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag1 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag1 == 'h6'){
                            levelval = 6;
                        }

                        finalheadings.push({
                            content:heading.noticeboxContent.toString(),
                            level:levelval,
                            anchor:'notice-'+heading.block_id                            
                        });               
                    }                     
                }

                if(heading.couponMainTitle){
                    if(heading.titleTag1 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag1 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag1 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag1 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag1 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag1 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag1 == 'h6'){
                            levelval = 6;
                        }
                        finalheadings.push({
                            content:heading.couponMainTitle.toString(),
                            level:levelval,
                            anchor:heading.couponMainTitle.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });               
                    }                     
                }


                if(heading.titleText1){
                    if(heading.titleTag1 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag1 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag1 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag1 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag1 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag1 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag1 == 'h6'){
                            levelval = 6;
                        }
                        finalheadings.push({
                            content:heading.titleText1.toString(),
                            level:levelval,
                            anchor:heading.titleText1.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });               
                    }                     
                }

                if(heading.titleText2){
                    if(heading.titleTag2 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag2 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag2 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag2 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag2 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag2 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag2 == 'h6'){
                            levelval = 6;
                        }
                        finalheadings.push({
                            content:heading.titleText2.toString(),
                            level:levelval,
                            anchor:heading.titleText2.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });               
                    }                     
                }


                if(heading.titleText3){
                    if(heading.titleTag3 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag3 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag3 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag3 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag3 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag3 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag3 == 'h6'){
                            levelval = 6;
                        }
                        finalheadings.push({
                            content:heading.titleText3.toString(),
                            level:levelval,
                            anchor:heading.titleText3.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });               
                    }                     
                }

                if(heading.titleText4){
                    if(heading.titleTag4 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag4 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag4 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag4 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag4 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag4 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag4 == 'h6'){
                            levelval = 6;
                        }
                        finalheadings.push({
                            content:heading.titleText4.toString(),
                            level:levelval,
                            anchor:heading.titleText4.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });               
                    }                     
                }

                if(heading.titleText5){
                    if(heading.titleTag5 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag5 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag5 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag5 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag5 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag5 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag5 == 'h6'){
                            levelval = 6;
                        }
                        finalheadings.push({
                            content:heading.titleText5.toString(),
                            level:levelval,
                            anchor:heading.titleText5.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });               
                    }                     
                }

                if(heading.titleText6){
                    if(heading.titleTag6 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag6 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag6 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag6 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag6 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag6 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag6 == 'h6'){
                            levelval = 6;
                        }
                        finalheadings.push({
                            content:heading.titleText6.toString(),
                            level:levelval,
                            anchor:heading.titleText6.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });               
                    }                     
                }

                if(heading.titleText7){
                    if(heading.titleTag7 != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag7 == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag7 == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag7 == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag7 == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag7 == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag7 == 'h6'){
                            levelval = 6;
                        }
                        finalheadings.push({
                            content:heading.titleText7.toString(),
                            level:levelval,
                            anchor:heading.titleText7.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });               
                    }                     
                }


                if(heading.titleText){
                    if(heading.titleTag != 'p'){   
                        let levelval = 0;
                        if(heading.titleTag == 'h1'){
                            levelval = 1;
                        }else if(heading.titleTag == 'h2'){
                            levelval = 2;
                        }else if(heading.titleTag == 'h3'){
                            levelval = 3;
                        }else if(heading.titleTag == 'h4'){
                            levelval = 4;
                        }else if(heading.titleTag == 'h5'){
                            levelval = 5;
                        }else if(heading.titleTag == 'h6'){
                            levelval = 6;
                        }

                        finalheadings.push({
                            content:heading.titleText.toString(),
                            level:levelval,
                            anchor:heading.titleText.toString().toLowerCase().replace(/( |<.+?>|&nbsp;)/g, "-")
                        });       
                    }                    
                }


            });
            
            if (JSON.stringify(finalheadings) !== JSON.stringify(this.state.headers)) {             
                this.setState({ headers: finalheadings });
            }

        };

        setHeaders();

        const unsubscribe = subscribe(_ => setHeaders());
        this.setState({ unsubscribe });
    }

    componentDidUpdate(prevProps, prevState) {
        if (JSON.stringify(prevProps.headers) !== JSON.stringify(prevState.headers)) {
            this.props.blockProp.setAttributes({
                headerLinks: JSON.stringify(this.state.headers)
            });
        }
    }
    componentWillUnmount() {
        this.state.unsubscribe();
    }
    render() {
        const { headers } = this.state;
        const { listType, mappedHeaders } = this.props.blockProp.attributes;

        let DesktopCol = this.props.blockProp.attributes.numberofColumns;
        let TabletCol = this.props.blockProp.attributes.numberofColumnsTablet;
        let MobileCol = this.props.blockProp.attributes.numberofColumnsMobile;

        let ClassName = 'affiliate-toc-list desktop'+DesktopCol+' tablet'+TabletCol+' mobile'+MobileCol;

        let ListTag = 'ul';
        if (listType === 'number') {
            ListTag = 'ol'
        }
        if (headers.length === 0) {
            return (
                <p className="affiliate_table-of-contents-placeholder">
                    {__(
                        'Add a header to begin generating the table of contents'
                    )}
                </p>
            );
        }

        const createHierarchy = (formattedHeaders, currentHeader) => {
            let lastIndex = formattedHeaders.length - 1;
            
            if (formattedHeaders.length === 0 || formattedHeaders[0].level === currentHeader.level) {
                formattedHeaders.push(Object.assign({}, currentHeader));
            } else if (formattedHeaders[lastIndex].level < currentHeader.level) {
                if (!formattedHeaders[lastIndex].children) {
                    formattedHeaders[lastIndex].children = [Object.assign({}, currentHeader)];
                } else createHierarchy(formattedHeaders[lastIndex].children, currentHeader);
            }
        };

        const formatHeaders = allHeaders => {
            let formattedHeaders2 = [];
            allHeaders.filter(header => mappedHeaders[`h${header.level}`]).forEach(header => createHierarchy(formattedHeaders2, header));            
            return formattedHeaders2;
        };

        const parseList = list =>
            list.map(item => (              
                <li>
                    <a
                        href={`#${item.anchor}`}
                        dangerouslySetInnerHTML={{
                            __html: item.content.replace(/(<.+?>)/g, "")
                        }}
                    />
                    {
                        item.children && <ListTag className="affiliate-toc-list">{parseList(item.children)}</ListTag>
                    }
                </li>
            ));
        return (
            <div className="affiliate-toc-list-wrap">
                <ListTag className={ClassName}>
                    {parseList(formatHeaders(headers))}
                </ListTag>
            </div>
        );
    }
}

// export { ABTOC };
export default ABTOC;