/**
 * Set inline styles.
 * @param  {object} props - The block object.
 * @return {object} The inline background type CSS.
 */

import affiliate_generateCSS from "./generateCSS"
import { cssGradient, cssBoxShadow,cssWithoutSelector,cssTextShadow, cssBackground } from '../components/cssHelper'
function affiliate_styling( props, id ) {

	const {
    uniqueId,
    block_id,
    className,
    spTitle,
    spSubTitle,
    titleLoadGoogleFonts,
    spBtnText,
    spContent,
    spBtnHref,
    titleTextColor,
    titlefontFamily,
    titlefontWeight,
    titlefontSubset,
    titlefontSizeType,
    titlefontSizeTypeMobile,
    titlefontSizeTypeTablet,
    titlefontSizeDesktop,
    titlefontSizeMobile,
    titlefontSizeTablet,
    titlelineHeight,
    titlelineHeightMobile,
    titlelineHeightTablet,
    titleletterSpacing,
    titleletterSpacingMobile,
    titleletterSpacingTablet,
    titleletterSpacingType,
    titleletterSpacingTypeTablet,
    titleletterSpacingTypeMobile,
    titletextTransform,
    titletextDecoration,
    titlefontStyle,
    titleAlignment,
    titleAlignmentMobile,
    titleAlignmentTablet,
    // CTA BUTTON
    btnLoadGoogleFonts,
    btnfontFamily,
    btnfontWeight,
    listItems,
    bulletStyle,
    listType,
    btnfontSubset,
    btnfontSizeType,
    btnfontSizeTypeMobile,
    btnfontSizeTypeTablet,
    btnfontSizeDesktop,
    btnfontSizeMobile,
    btnfontSizeTablet,
    btnlineHeight,
    btnlineHeightMobile,
    btnlineHeightTablet,
    btnletterSpacing,
    btnletterSpacingMobile,
    btnletterSpacingTablet,
    btnletterSpacingType,
    btnletterSpacingTypeTablet,
    btnletterSpacingTypeMobile,
    btntextTransform,
    btntextDecoration,
    btnfontStyle,
    btnBgColor,
    btnHoverBgColor,
    btnTextColor,
    btnTextHoverColor,
    btnBorderColor,
    btnBorderHoverColor,
    btn_Htarget,
    btnPadding,
    btnPaddingMobile,
    btnPaddingTablet,
    btnMargin,
    btnMarginMobile,
    btnMarginTablet,
    btnAlignment,
    btnAlignmentMobile,
    btnAlignmentTablet,
    btnBorder,
    btnBorderType,
    btnBorderMobile,
    btnBorderTablet,
    btnBorderRadius,
    btnBorderRadiusMobile,
    btnBorderRadiusTablet,
    // CTA content
    cntnLoadGoogleFonts,
    cntnfontFamily,
    cntnfontWeight,
    cntnfontSubset,
    cntnfontSizeType,
    cntnfontSizeTypeMobile,
    cntnfontSizeTypeTablet,
    cntnfontSizeDesktop,
    cntnfontSizeMobile,
    cntnfontSizeTablet,
    cntnlineHeight,
    cntnlineHeightMobile,
    cntnlineHeightTablet,
    cntnletterSpacing,
    cntnletterSpacingMobile,
    cntnletterSpacingTablet,
    cntnletterSpacingType,
    cntnletterSpacingTypeTablet,
    cntnletterSpacingTypeMobile,
    cntntextTransform,
    cntntextDecoration,
    cntnfontStyle,
    cntnTextColor,
    // Box
    boxPadding,
    boxPaddingMobile,
    boxPaddingTablet,
    boxMargin,
    boxMarginMobile,
    boxMarginTablet,
    image,
    // Sub Title
    subtitleLoadGoogleFonts,
    subtitleTextColor,
    subtitlefontFamily,
    subtitlefontWeight,
    subtitlefontSubset,
    subtitlefontSizeType,
    subtitlefontSizeTypeMobile,
    subtitlefontSizeTypeTablet,
    subtitlefontSizeDesktop,
    subtitlefontSizeMobile,
    subtitlefontSizeTablet,
    subtitlelineHeight,
    subtitlelineHeightMobile,
    subtitlelineHeightTablet,
    subtitleletterSpacing,
    subtitleletterSpacingMobile,
    subtitleletterSpacingTablet,
    subtitleletterSpacingType,
    subtitleletterSpacingTypeTablet,
    subtitleletterSpacingTypeMobile,
    subtitletextTransform,
    subtitletextDecoration,
    subtitlefontStyle,
    subtitleAlignment,
    subtitleAlignmentMobile,
    subtitleAlignmentTablet,
    boxBorderType,
    boxBorderColor,
    boxBorderWidth,
    boxShadow,
    cntnAlignment,
    cntnAlignmentMobile,
    cntnAlignmentTablet,
    cntnText,
    cntnTextBottom,
    topBoxText,
    // isVisible
    topPickfontFamily,
    topPickfontWeight,
    topPickfontSubset,
    topPickfontSizeType,
    topPickfontSizeTypeMobile,
    topPickfontSizeTypeTablet,
    topPickfontSizeDesktop,
    topPickfontSizeMobile,
    topPickfontSizeTablet,
    topPicklineHeight,
    topPicklineHeightMobile,
    topPicklineHeightTablet,
    topPickletterSpacing,
    topPickletterSpacingMobile,
    topPickletterSpacingTablet,
    topPickletterSpacingType,
    topPickletterSpacingTypeTablet,
    topPickletterSpacingTypeMobile,
    topPicktextTransform,
    topPicktextDecoration,
    topPickfontStyle,
    topPickBgColor,
    topPickColor,
    topBoxLoadGoogleFonts,
    customWidthType,
    customWidthTypeMobile,
    customWidthTypeTablet,
    customWidth,
    customWidthMobile,
    customWidthTablet,
    btnSize,
    buttonIcon,
    iconPosition,
    buttonWidth,
    bntRounded,
    imagePosition,
    imagePadding,
    imagePaddingMobile,
    imagePaddingTablet,
    customImgWidth,
    customImgWidthMobile,
    customImgWidthTablet,
    iconColor,


    enable_btn2,btnLoadGoogleFonts2,btnBgColor2,btnTextColor2,btnfontFamily2,btnfontWeight2,btnfontSubset2,btnfontSizeType2,btnfontSizeTypeMobile2,
btnfontSizeTypeTablet2,btnfontSizeDesktop2,btnfontSizeMobile2,btnfontSizeTablet2,btnlineHeight2,btnlineHeightMobile2,btnlineHeightTablet2,
btnletterSpacing2,btnletterSpacingMobile2,btnletterSpacingTablet2,btnletterSpacingType2,btnletterSpacingTypeTablet2,btnletterSpacingTypeMobile2,
btntextTransform2,btntextDecoration2,btnfontStyle2,btnHoverBgColor2,btnTextHoverColor2,btnBorderColor2,
btnBorderHoverColor2,btnRel2,btn_Htarget2,bntRounded2,btnSize2,buttonWidth2,buttonIcon2,iconPosition2,spBtnText2,spBtnHref2,btnAlignment2,
btnAlignmentMobile2,btnAlignmentTablet2,btnPadding2,btnPaddingTablet2,btnPaddingMobile2,btnMargin2,btnMarginTablet2,btnMarginMobile2,
btnBorder2,btnBorderMobile2,btnBorderTablet2,btnBorderRadius2,btnBorderRadiusMobile2,btnBorderRadiusTablet2,btnBorderType2,

enable_btn3,btnLoadGoogleFonts3,btnBgColor3,btnTextColor3,btnfontFamily3,btnfontWeight3,btnfontSubset3,btnfontSizeType3,btnfontSizeTypeMobile3,
btnfontSizeTypeTablet3,btnfontSizeDesktop3,btnfontSizeMobile3,btnfontSizeTablet3,btnlineHeight3,btnlineHeightMobile3,btnlineHeightTablet3,
btnletterSpacing3,btnletterSpacingMobile3,btnletterSpacingTablet3,btnletterSpacingType3,btnletterSpacingTypeTablet3,btnletterSpacingTypeMobile3,
btntextTransform3,btntextDecoration3,btnfontStyle3,btnHoverBgColor3,btnTextHoverColor3,btnBorderColor3,
btnBorderHoverColor3,btnRel3,btn_Htarget3,bntRounded3,btnSize3,buttonWidth3,buttonIcon3,iconPosition3,spBtnText3,spBtnHref3,btnAlignment3,
btnAlignmentMobile3,btnAlignmentTablet3,btnPadding3,btnPaddingTablet3,btnPaddingMobile3,btnMargin3,btnMarginTablet3,btnMarginMobile3,
btnBorder3,btnBorderMobile3,btnBorderTablet3,btnBorderRadius3,btnBorderRadiusMobile3,btnBorderRadiusTablet3,btnBorderType3,
    
    btnBg,
    btnBgHover,
    btnBg2,
    btnBgHover2,
    btnBg3,
    btnBgHover3,

	} = props.attributes

  var mobile_selectors = {}
  var tablet_selectors = {}
  var style = {}
  // var styleBackground = cssBackground(boxBg);

  var styleBtnBg = cssBackground(btnBg);
  var styleBtnBgHover = cssBackground(btnBgHover);
  var styleBtnBg2 = cssBackground(btnBg2);
  var styleBtnBgHover2 = cssBackground(btnBgHover2);
  var styleBtnBg3 = cssBackground(btnBg3);
  var styleBtnBgHover3 = cssBackground(btnBgHover3);
  
    // console.log(styleBackground)
        var selectors = {
          " .affiliate-toppickspecs":{
            "font-family": topPickfontFamily,
            "font-size": topPickfontSizeDesktop + topPickfontSizeType,
            "font-style":topPickfontStyle,
            "font-weight":topPickfontWeight,
            "letter-spacing":topPickletterSpacing + topPickletterSpacingType,
            "line-height":topPicklineHeight,
            "text-decoration":topPicktextDecoration,
            "text-transform":topPicktextTransform,
            "color":topPickColor,
            "background":topPickBgColor,
            
        },
        " .affiliate-toppickspecs:after":{
            "border-right-color":topPickBgColor,
        },
        " .affiliate-toppick-image":{
            "padding" : ( imagePadding && undefined !== imagePadding[ 'top' ] && null !== imagePadding[ 'top' ] ? imagePadding[ 'top' ] + imagePadding['unit'] + ' ' + imagePadding[ 'right' ] + imagePadding['unit'] + ' ' + imagePadding[ 'bottom' ] + imagePadding['unit'] + ' ' + imagePadding[ 'left' ] + imagePadding['unit'] : '' ),
        },
        " .affiliate-toppick-image img":{
            "width" : customImgWidth + 'px',
        },
          " .affiliate-toppickspecs-wrapper":{
              "width":customWidth + customWidthType,
              "padding" : ( boxPadding && undefined !== boxPadding[ 'top' ] && null !== boxPadding[ 'top' ] ? boxPadding[ 'top' ] + boxPadding['unit'] + ' ' + boxPadding[ 'right' ] + boxPadding['unit'] + ' ' + boxPadding[ 'bottom' ] + boxPadding['unit'] + ' ' + boxPadding[ 'left' ] + boxPadding['unit'] : '' ),
              "margin" : ( boxMargin && undefined !== boxMargin[ 'top' ] && null !== boxMargin[ 'top' ] ? boxMargin[ 'top' ] + boxMargin['unit'] + ' ' + boxMargin[ 'right' ] + boxMargin['unit'] + ' ' + boxMargin[ 'bottom' ] + boxMargin['unit'] + ' ' + boxMargin[ 'left' ] + boxMargin['unit'] : '' ),
              "border-style":boxBorderType,
              "border-color":topPickBgColor,
              "border-width" : ( boxBorderWidth && undefined !== boxBorderWidth[ 'top' ] && null !== boxBorderWidth[ 'top' ] ? boxBorderWidth[ 'top' ] + boxBorderWidth['unit'] + ' ' + boxBorderWidth[ 'right' ] + boxBorderWidth['unit'] + ' ' + boxBorderWidth[ 'bottom' ] + boxBorderWidth['unit'] + ' ' + boxBorderWidth[ 'left' ] + boxBorderWidth['unit'] : '' ),
              "box-shadow":cssBoxShadow(boxShadow),
            },
          " .affiliate-toppickspecs-title":{
              "font-family": titlefontFamily,
              "font-size": titlefontSizeDesktop + titlefontSizeType,
              "font-style":titlefontStyle,
              "font-weight":titlefontWeight,
              "letter-spacing":titleletterSpacing + titleletterSpacingType,
              "line-height":titlelineHeight,
              "text-decoration":titletextDecoration,
              "text-transform":titletextTransform,
              "color":titleTextColor,
              "text-align":titleAlignment,
              
          },
          " .affiliate-toppickspecs-subtitle":{
              "font-family": subtitlefontFamily,
              "font-size": subtitlefontSizeDesktop + subtitlefontSizeType,
              "font-style":subtitlefontStyle,
              "font-weight":subtitlefontWeight,
              "letter-spacing":subtitleletterSpacing + subtitleletterSpacingType,
              "line-height":subtitlelineHeight,
              "text-decoration":subtitletextDecoration,
              "text-transform":subtitletextTransform,
              "color":subtitleTextColor,
              "text-align":subtitleAlignment,
          },
          " .affiliate-toppickspecs-cntn, .affiliate-toppickspecs-cntn li":{
              "font-family": cntnfontFamily,
              "font-size": cntnfontSizeDesktop + cntnfontSizeType,
              "font-style":cntnfontStyle,
              "font-weight":cntnfontWeight,
              "letter-spacing":cntnletterSpacing + cntnletterSpacingType,
              "line-height":cntnlineHeight,
              "text-decoration":cntntextDecoration,
              "text-transform":cntntextTransform,
              "color":cntnTextColor,
              "text-align":cntnAlignment,
              "flex-direction":imagePosition,
        },
        " .affiliate-toppickspecs-cntn li:before" :{
            "color": iconColor,
        },
        " .affiliate-toppickspecs-btn-wrapper":{
            "justify-content":btnAlignment
        },
        " .affiliate-toppickspecs-btn":{
            "font-family": btnfontFamily,
            "font-size": btnfontSizeDesktop + btnfontSizeType,
            "font-style":btnfontStyle,
            "font-weight":btnfontWeight,
            "letter-spacing":btnletterSpacing + btnletterSpacingType,
            "line-height":btnlineHeight,
            "text-decoration":btntextDecoration,
            "text-transform":btntextTransform,
            "background":styleBtnBg,
            "border-color":btnBorderColor,
            "color":btnTextColor,
            "border-style":btnBorderType,
            "border-radius":( btnBorderRadius && undefined !== btnBorderRadius[ 'top' ] && null !== btnBorderRadius[ 'top' ] ? btnBorderRadius[ 'top' ] + btnBorderRadius['unit'] + ' ' + btnBorderRadius[ 'right' ] + btnBorderRadius['unit'] + ' ' + btnBorderRadius[ 'bottom' ] + btnBorderRadius['unit'] + ' ' + btnBorderRadius[ 'left' ] + btnBorderRadius['unit'] : '' ),
            "border-color":btnBorderColor,
            "border-width" : ( btnBorder && undefined !== btnBorder[ 'top' ] && null !== btnBorder[ 'top' ] ? btnBorder[ 'top' ] + btnBorder['unit'] + ' ' + btnBorder[ 'right' ] + btnBorder['unit'] + ' ' + btnBorder[ 'bottom' ] + btnBorder['unit'] + ' ' + btnBorder[ 'left' ] + btnBorder['unit'] : '' ),
            "padding" : ( btnPadding && undefined !== btnPadding[ 'top' ] && null !== btnPadding[ 'top' ] ? btnPadding[ 'top' ] + btnPadding['unit'] + ' ' + btnPadding[ 'right' ] + btnPadding['unit'] + ' ' + btnPadding[ 'bottom' ] + btnPadding['unit'] + ' ' + btnPadding[ 'left' ] + btnPadding['unit'] : '' ),
            "margin" : ( btnMargin && undefined !== btnMargin[ 'top' ] && null !== btnMargin[ 'top' ] ? btnMargin[ 'top' ] + btnMargin['unit'] + ' ' + btnMargin[ 'right' ] + btnMargin['unit'] + ' ' + btnMargin[ 'bottom' ] + btnMargin['unit'] + ' ' + btnMargin[ 'left' ] + btnMargin['unit'] : '' ),
      },
      " .affiliate-toppickspecs-btn:hover":{
            "background":styleBtnBgHover,
            "border-color":btnBorderHoverColor,
            "color":btnTextHoverColor
      },


      " .affiliate-toppickspecs-btn.btn2":{
            "font-family": btnfontFamily2,
            "font-size": btnfontSizeDesktop2 + btnfontSizeType2,
            "font-style":btnfontStyle2,
            "font-weight":btnfontWeight2,
            "letter-spacing":btnletterSpacing2 + btnletterSpacingType2,
            "line-height":btnlineHeight2,
            "text-decoration":btntextDecoration2,
            "text-transform":btntextTransform2,
            "background":styleBtnBg2,
            "border-color":btnBorderColor2,
            "color":btnTextColor2,
            "border-style":btnBorderType2,
            "border-radius":( btnBorderRadius2 && undefined !== btnBorderRadius2[ 'top' ] && null !== btnBorderRadius2[ 'top' ] ? btnBorderRadius2[ 'top' ] + btnBorderRadius2['unit'] + ' ' + btnBorderRadius2[ 'right' ] + btnBorderRadius2['unit'] + ' ' + btnBorderRadius2[ 'bottom' ] + btnBorderRadius2['unit'] + ' ' + btnBorderRadius2[ 'left' ] + btnBorderRadius2['unit'] : '' ),
            "border-color":btnBorderColor2,
            "border-width" : ( btnBorder2 && undefined !== btnBorder2[ 'top' ] && null !== btnBorder2[ 'top' ] ? btnBorder2[ 'top' ] + btnBorder2['unit'] + ' ' + btnBorder2[ 'right' ] + btnBorder2['unit'] + ' ' + btnBorder2[ 'bottom' ] + btnBorder2['unit'] + ' ' + btnBorder2[ 'left' ] + btnBorder2['unit'] : '' ),
            "padding" : ( btnPadding2 && undefined !== btnPadding2[ 'top' ] && null !== btnPadding2[ 'top' ] ? btnPadding2[ 'top' ] + btnPadding2['unit'] + ' ' + btnPadding2[ 'right' ] + btnPadding2['unit'] + ' ' + btnPadding2[ 'bottom' ] + btnPadding2['unit'] + ' ' + btnPadding2[ 'left' ] + btnPadding2['unit'] : '' ),
            "margin" : ( btnMargin2 && undefined !== btnMargin2[ 'top' ] && null !== btnMargin2[ 'top' ] ? btnMargin2[ 'top' ] + btnMargin2['unit'] + ' ' + btnMargin2[ 'right' ] + btnMargin2['unit'] + ' ' + btnMargin2[ 'bottom' ] + btnMargin2['unit'] + ' ' + btnMargin2[ 'left' ] + btnMargin2['unit'] : '' ),
      },
      " .affiliate-toppickspecs-btn.btn2:hover":{
            "background":styleBtnBgHover2,
            "border-color":btnBorderHoverColor2,
            "color":btnTextHoverColor2
      },


      " .affiliate-toppickspecs-btn.btn3":{
            "font-family": btnfontFamily3,
            "font-size": btnfontSizeDesktop3 + btnfontSizeType3,
            "font-style":btnfontStyle3,
            "font-weight":btnfontWeight3,
            "letter-spacing":btnletterSpacing3 + btnletterSpacingType3,
            "line-height":btnlineHeight3,
            "text-decoration":btntextDecoration3,
            "text-transform":btntextTransform3,
            "background":styleBtnBg3,
            "border-color":btnBorderColor3,
            "color":btnTextColor3,
            "border-style":btnBorderType3,
            "border-radius":( btnBorderRadius3 && undefined !== btnBorderRadius3[ 'top' ] && null !== btnBorderRadius3[ 'top' ] ? btnBorderRadius3[ 'top' ] + btnBorderRadius3['unit'] + ' ' + btnBorderRadius3[ 'right' ] + btnBorderRadius3['unit'] + ' ' + btnBorderRadius3[ 'bottom' ] + btnBorderRadius3['unit'] + ' ' + btnBorderRadius3[ 'left' ] + btnBorderRadius3['unit'] : '' ),
            "border-color":btnBorderColor3,
            "border-width" : ( btnBorder3 && undefined !== btnBorder3[ 'top' ] && null !== btnBorder3[ 'top' ] ? btnBorder3[ 'top' ] + btnBorder3['unit'] + ' ' + btnBorder3[ 'right' ] + btnBorder3['unit'] + ' ' + btnBorder3[ 'bottom' ] + btnBorder3['unit'] + ' ' + btnBorder3[ 'left' ] + btnBorder3['unit'] : '' ),
            "padding" : ( btnPadding3 && undefined !== btnPadding3[ 'top' ] && null !== btnPadding3[ 'top' ] ? btnPadding3[ 'top' ] + btnPadding3['unit'] + ' ' + btnPadding3[ 'right' ] + btnPadding3['unit'] + ' ' + btnPadding3[ 'bottom' ] + btnPadding3['unit'] + ' ' + btnPadding3[ 'left' ] + btnPadding3['unit'] : '' ),
            "margin" : ( btnMargin3 && undefined !== btnMargin3[ 'top' ] && null !== btnMargin3[ 'top' ] ? btnMargin3[ 'top' ] + btnMargin3['unit'] + ' ' + btnMargin3[ 'right' ] + btnMargin3['unit'] + ' ' + btnMargin3[ 'bottom' ] + btnMargin3['unit'] + ' ' + btnMargin3[ 'left' ] + btnMargin3['unit'] : '' ),
      },
      " .affiliate-toppickspecs-btn.btn3:hover":{
            "background":styleBtnBgHover3,
            "border-color":btnBorderHoverColor3,
            "color":btnTextHoverColor3
      }


      }
  
        tablet_selectors = {
       
        }

        mobile_selectors = {
       
        }



	var affiliate_styling_css = ""

	affiliate_styling_css = affiliate_generateCSS( selectors, `#${id}-${ props.clientId }` )

  affiliate_styling_css += affiliate_generateCSS( tablet_selectors, `#${id}-${ props.clientId }`, true, "tablet" )

  affiliate_styling_css += affiliate_generateCSS( mobile_selectors, `#${id}-${ props.clientId }`, true, "mobile" )

	return affiliate_styling_css
}

export default affiliate_styling
