import IconSelector from '../../components/fields/IconSelector/IconSelector.js';
import TypographyControl from '../components/typography/index.js';
import WebfontLoader from "../components/typography/fontloader"
import Range from '../../components/fields/Range/Range.js';
import BoxShadow  from './../../components/fields/BoxShadow.js';
import Color  from '../../components/fields/Color/Color.js';
import affiliate_styling  from './styling.js';
import getIcon from '../../icons/get-icon';

const { __ } = wp.i18n;
const {
    InspectorControls,
    BlockControls,
    RichText,
} = wp.blockEditor;

const {
    Component,
    Fragment
} = wp.element;

const {
    PanelBody,
    Toolbar,
    Tooltip,
    TextControl,
    SelectControl
} = wp.components;

class Edit extends Component {

    constructor(props) {
        super(props)
        this.state = {
    
        }
    }
    
    componentDidMount() {
        const {
            clientId,
            isSelected,
            setAttributes,
            attributes: {
                uniqueId,
                block_id
            }
        } = this.props;
        const _client = clientId.substr(0, 6);

        if (!uniqueId) {
            setAttributes({ uniqueId: _client });
        } else if (uniqueId && uniqueId != _client) {
            setAttributes({ uniqueId: _client });
        }
        
        this.props.setAttributes({ block_id: this.props.clientId })
        const $style = document.createElement("style")
        $style.setAttribute("id", "affiliate-style-" + this.props.clientId)
        document.head.appendChild($style)
    
    }

    render() {
        const {
            name,
            clientId,
            isSelected,
            attributes,
            setAttributes,
            attributes: {
                uniqueId,
                block_id,
                titleLoadGoogleFonts,
                listLoadGoogleFonts,
                propsTitle,
                consTitle,
                className,
                recreateStyles,
                alignment,
                listType,
                bulletStyle,
                bulletStyleTwo,
                numberCorner,
                numberFontSize,
                numberBgSize,
                useNumberBg,
                numberBg,
                numberBgHover,
                titleBgColor,
                titleTextColor,
                titlefontFamily,
                titlefontWeight,
                titlefontSubset,
                titlefontSizeType,
                titlefontSizeTypeMobile,
                titlefontSizeTypeTablet,
                titlefontSizeDesktop,
                titlefontSizeMobile,
                titlefontSizeTablet,
                titlelineHeight,
                titlelineHeightMobile,
                titlelineHeightTablet,
                titleletterSpacing,
                titleletterSpacingMobile,
                titleletterSpacingTablet,
                titleletterSpacingType,
                titleletterSpacingTypeTablet,
                titleletterSpacingTypeMobile,
                titletextTransform,
                titletextDecoration,
                titlefontStyle,
                // 
                listfontFamily,
                listfontWeight,
                listfontSubset,
                listfontSizeType,
                listfontSizeTypeMobile,
                listfontSizeTypeTablet,
                listfontSizeDesktop,
                listfontSizeMobile,
                listfontSizeTablet,
                listlineHeight,
                listlineHeightMobile,
                listlineHeightTablet,
                listletterSpacing,
                listletterSpacingMobile,
                listletterSpacingTablet,
                listletterSpacingType,
                listletterSpacingTypeTablet,
                listletterSpacingTypeMobile,
                listtextTransform,
                listtextDecoration,
                listfontStyle,
                listTextColor,
                propsBgColor,
                propsTextColor,
                propsIconColor,
                consBgColor,
                consTextColor,
                consIconColor,
                consListColor,
                propsListColor,
                boxShadow,
                listTextItems,
                listTextItemsTwo,
                titleTag1,
                titleTag2,
                prosConsDesignStyle,

                propsTextColor1,
                consTextColor1,

                prosBorderColor,
                consBorderColor,

                style3ContentProsBg,
                style3ContentConsBg,

            }
        } = this.props;
        const { device } = this.state;
        
        var element = document.getElementById("affiliate-style-" + this.props.clientId)
        if (null != element && "undefined" != typeof element) {
             element.innerHTML = affiliate_styling(this.props, "affiliate-style")
        }
        
        let loadtitleGoogleFonts
        let loadlistGoogleFonts

        if( titleLoadGoogleFonts == true ) {
					
			const titleconfig = {
				google: {
					families: [ titlefontFamily + ( titlefontWeight ? ":" + titlefontWeight : "" ) ],
				},
			}

			loadtitleGoogleFonts = (
				<WebfontLoader config={ titleconfig }>
				</WebfontLoader>
			)
        } 
        
        const Tag1 = titleTag1
        
        return (
            <Fragment>
                <InspectorControls key="inspector">

                <PanelBody title={`General Settings`} initialOpen={false}  icon={ getIcon( 'documentation' ) } className={ 'abblocks-panel-label' }>
                    <SelectControl
                        label={ __( 'Pros & Cons Design Style' ) }
                        value={ prosConsDesignStyle }
                        options= {[
                                { value: 'default', label: 'Default' },
                                { value: 'style1', label: 'Style 1' },
                                { value: 'style2', label: 'Style 2' },
                                { value: 'style3', label: 'Style 3' },
                            ]}
                            onChange={ ( value ) => setAttributes( { prosConsDesignStyle: value } ) }
                    />

                    {listType == 'unordered' &&
                            <Fragment>
                                <IconSelector
                                    label="Pros Icon"
                                    value={bulletStyle.name}
                                    enableSearch
                                    icons={[
                                        { name: 'check', value: 'fas fa-check' },
                                        { name: 'check-square', value: 'fas fa-check-square' },
                                        { name: 'check-square-outline', value: 'far fa-check-square' },
                                        { name: 'check-double', value: 'fas fa-check-double' },
                                        { name: 'check-circle', value: 'fas fa-check-circle' },
                                        { name: 'check-circle-outline', value: 'far fa-check-circle' },
                                        { name: 'square', value: 'fas fa-square' },
                                        { name: 'square-outline', value: 'far fa-square' },
                                        { name: 'circle', value: 'fas fa-circle' },
                                        { name: 'circle-outline', value: 'far fa-circle' },
                                        { name: 'arrow-right', value: 'fas fa-arrow-right' },
                                        { name: 'arrow-left', value: 'fas fa-arrow-left' },
                                        { name: 'arrow-circle-right', value: 'fas fa-arrow-circle-right' },
                                        { name: 'arrow-circle-left', value: 'fas fa-arrow-circle-left' },
                                        { name: 'arrow-alt-circle-right', value: 'far fa-arrow-alt-circle-right' },
                                        { name: 'arrow-alt-circle-left', value: 'far fa-arrow-alt-circle-left' },
                                        { name: 'long-arrow-alt-right', value: 'fas fa-long-arrow-alt-right' },
                                        { name: 'long-arrow-alt-left', value: 'fas fa-long-arrow-alt-left' },
                                        { name: 'chevron-right', value: 'fas fa-chevron-right' },
                                        { name: 'chevron-left', value: 'fas fa-chevron-left' },
                                        { name: 'angle-right', value: 'fas fa-angle-right' },
                                        { name: 'angle-left', value: 'fas fa-angle-left' },
                                        { name: 'star', value: 'fas fa-star' },
                                        { name: 'star-outline', value: 'far fa-star' },
                                        { name: 'windows-close-fill', value: 'fas fa-window-close' },
                                        { name: 'ban', value: 'fas fa-ban' },
                                        { name: 'window-close-simple', value: 'far fa-window-close' },
                                        { name: 'times', value: 'fas fa-times' },
                                        { name: 'times-circle', value: 'fas fa-times-circle' },
                                        { name: 'times-circle-simple', value: 'far fa-times-circle' },
                                        { name: 'dot-circle-fill', value: 'fas fa-dot-circle' },
                                        { name: 'dot-circle-simple', value: 'far fa-dot-circle' },
                                        { name: 'thumb-up-fill', value: 'fas fa-thumbs-up' },
                                        { name: 'thumb-up-simple', value: 'far fa-thumbs-up' },
                                        { name: 'thumb-down-fill', value: 'fas fa-thumbs-down' },
                                        { name: 'thumb-down-simple', value: 'far fa-thumbs-down' }, 
                                    ]}
                                    onChange={val => setAttributes({ bulletStyle: val })}
                                />
                            </Fragment>
                        }
                        {listType == 'ordered' &&
                            <Fragment>
                                <Range label={__('Font Size')} value={numberFontSize} onChange={(value) => setAttributes({ numberFontSize: value })} min={10} max={100} />
                                <Toggle
                                    value={useNumberBg}
                                    label={__('Use Background')}
                                    onChange={val => setAttributes({ useNumberBg: val, recreateStyles: !recreateStyles })}
                                />
                                {
                                    useNumberBg == 1 &&
                                    <Fragment>
                                        <Range label={__('Background Size')} value={numberBgSize} onChange={(value) => setAttributes({ numberBgSize: value })} min={1} max={15} />
                                        <Range label={__('Corner')} value={numberCorner} onChange={(value) => setAttributes({ numberCorner: value })} min={0} max={100} />
                                    </Fragment>
                                }
                            </Fragment>
                        }


                       {listType == 'unordered' &&
                            <Fragment>
                                <IconSelector
                                    label="Cons Icon"
                                    value={bulletStyleTwo.name}
                                    enableSearch
                                    icons={[
                                        { name: 'check', value: 'fas fa-check' },
                                        { name: 'check-square', value: 'fas fa-check-square' },
                                        { name: 'check-square-outline', value: 'far fa-check-square' },
                                        { name: 'check-double', value: 'fas fa-check-double' },
                                        { name: 'check-circle', value: 'fas fa-check-circle' },
                                        { name: 'check-circle-outline', value: 'far fa-check-circle' },
                                        { name: 'square', value: 'fas fa-square' },
                                        { name: 'square-outline', value: 'far fa-square' },
                                        { name: 'circle', value: 'fas fa-circle' },
                                        { name: 'circle-outline', value: 'far fa-circle' },
                                        { name: 'arrow-right', value: 'fas fa-arrow-right' },
                                        { name: 'arrow-left', value: 'fas fa-arrow-left' },
                                        { name: 'arrow-circle-right', value: 'fas fa-arrow-circle-right' },
                                        { name: 'arrow-circle-left', value: 'fas fa-arrow-circle-left' },
                                        { name: 'arrow-alt-circle-right', value: 'far fa-arrow-alt-circle-right' },
                                        { name: 'arrow-alt-circle-left', value: 'far fa-arrow-alt-circle-left' },
                                        { name: 'long-arrow-alt-right', value: 'fas fa-long-arrow-alt-right' },
                                        { name: 'long-arrow-alt-left', value: 'fas fa-long-arrow-alt-left' },
                                        { name: 'chevron-right', value: 'fas fa-chevron-right' },
                                        { name: 'chevron-left', value: 'fas fa-chevron-left' },
                                        { name: 'angle-right', value: 'fas fa-angle-right' },
                                        { name: 'angle-left', value: 'fas fa-angle-left' },
                                        { name: 'star', value: 'fas fa-star' },
                                        { name: 'star-outline', value: 'far fa-star' },
                                        { name: 'windows-close-fill', value: 'fas fa-window-close' },
                                        { name: 'ban', value: 'fas fa-ban' },
                                        { name: 'window-close-simple', value: 'far fa-window-close' },
                                        { name: 'times', value: 'fas fa-times' },
                                        { name: 'times-circle', value: 'fas fa-times-circle' },
                                        { name: 'times-circle-simple', value: 'far fa-times-circle' },
                                        { name: 'dot-circle-fill', value: 'fas fa-dot-circle' },
                                        { name: 'dot-circle-simple', value: 'far fa-dot-circle' },
                                        { name: 'thumb-up-fill', value: 'fas fa-thumbs-up' },
                                        { name: 'thumb-up-simple', value: 'far fa-thumbs-up' },
                                        { name: 'thumb-down-fill', value: 'fas fa-thumbs-down' },
                                        { name: 'thumb-down-simple', value: 'far fa-thumbs-down' }, 
                                    ]}
                                    onChange={val => setAttributes({ bulletStyleTwo: val })}
                                />
                            </Fragment>
                        }
                        {listType == 'ordered' &&
                            <Fragment>
                                <Range label={__('Font Size')} value={numberFontSize} onChange={(value) => setAttributes({ numberFontSize: value })} min={10} max={100} />
                                <Toggle
                                    value={useNumberBg}
                                    label={__('Use Background')}
                                    onChange={val => setAttributes({ useNumberBg: val, recreateStyles: !recreateStyles })}
                                />
                                {
                                    useNumberBg == 1 &&
                                    <Fragment>
                                        <Range label={__('Background Size')} value={numberBgSize} onChange={(value) => setAttributes({ numberBgSize: value })} min={1} max={15} />
                                        <Range label={__('Corner')} value={numberCorner} onChange={(value) => setAttributes({ numberCorner: value })} min={0} max={100} />
                                    </Fragment>
                                }
                            </Fragment>
                        } 

                    <BoxShadow label={__('Box-Shadow')} value={boxShadow} onChange={(value) => setAttributes({ boxShadow: value })} />
                </PanelBody>

                <PanelBody title={ __( 'Typography' ) } initialOpen={false}  icon={ getIcon( 'typography' ) } className={ 'abblocks-panel-label' }>
                    <SelectControl
                        label={ __( 'Pros & Cons Heading Tag' ) }
                        value={ titleTag1 }
                        options= {[
                                { value: 'h2', label: 'Heading 2 (h2)' },
                                { value: 'h3', label: 'Heading 3 (h3)' },
                                { value: 'h4', label: 'Heading 4 (h4)' },
                                { value: 'h5', label: 'Heading 5 (h5)' },
                                { value: 'h6', label: 'Heading 6 (h6)' },
                                { value: 'p', label: 'Paragraph (p)' },
                            ]}
                            onChange={ ( value ) => setAttributes( { titleTag1: value } ) }
                    />
                    
                    <TextControl        
                        label = { __( 'Pros Title' ) }              
                        value={ propsTitle }                        
                        onChange={ ( value ) => setAttributes( { propsTitle: value } ) }
                    />
                    <TextControl
                        label = { __( 'Cons Title' ) }                      
                        value={ consTitle }                     
                        onChange={ ( value ) => setAttributes( { consTitle: value } ) }
                    />

                    <TypographyControl
                        label={__("Title Typography")}
                        attributes={attributes}
                        setAttributes={setAttributes}
                        loadGoogleFonts={{ value:titleLoadGoogleFonts, label: __("titleLoadGoogleFonts") }}
                        fontFamily={{ value: titlefontFamily, label: __("titlefontFamily") }}
                        fontWeight={{ value: titlefontWeight, label: __("titlefontWeight") }}
                        fontSubset={{ value: titlefontSubset, label: __("titlefontSubset") }}
                        fontSizeType={{ value: titlefontSizeType, label: __("titlefontSizeType") }}
                        fontSizeTypeMobile={{ value: titlefontSizeTypeMobile, label: __("titlefontSizeTypeMobile") }}
                        fontSizeTypeTablet={{ value: titlefontSizeTypeTablet, label: __("titlefontSizeTypeTablet") }}
                        fontSize={{ value: titlefontSizeDesktop, label: __("titlefontSizeDesktop") }}
                        fontSizeMobile={{ value: titlefontSizeMobile, label: __("titlefontSizeMobile") }}
                        fontSizeTablet={{ value: titlefontSizeTablet, label: __("titlefontSizeTablet") }}
                        lineHeightType={{ value: '', label: __(" ") }}
                        lineHeight={{ value: titlelineHeight, label: __("titlelineHeight") }}
                        lineHeightMobile={{ value: titlelineHeightMobile, label: __("titlelineHeightMobile") }}
                        lineHeightTablet={{ value: titlelineHeightTablet, label: __("titlelineHeightTablet") }}
                        letterSpacing={{ value: titleletterSpacing, label: __("titleletterSpacing") }}
                        letterSpacingMobile={{ value: titleletterSpacingMobile, label: __("titleletterSpacingMobile") }}
                        letterSpacingTablet={{ value: titleletterSpacingTablet, label: __("titleletterSpacingTablet") }}
                        letterSpacingType={{ value: titleletterSpacingType, label: __("titleletterSpacingType") }}
                        letterSpacingTypeTablet={{ value: titleletterSpacingTypeTablet, label: __("titleletterSpacingTypeTablet") }}
                        letterSpacingTypeMobile={{ value: titleletterSpacingTypeMobile, label: __("titleletterSpacingTypeMobile") }}
                        textTransform={titletextTransform}
                        onTextTransform={(value) => setAttributes({ titletextTransform: value })}
                        textDecoration={titletextDecoration}
                        onTextDecoration={(value) => setAttributes({ titletextDecoration: value })}
                        fontStyle={titlefontStyle}
                        onFontStyle={(value) => setAttributes({ titlefontStyle: value })}
                    />
                    <TypographyControl
                        label={__("List Typography")} 
                        attributes={attributes}
                        setAttributes={setAttributes}
                        loadGoogleFonts={{ value:listLoadGoogleFonts, label: __("listLoadGoogleFonts") }}
                        fontFamily={{ value: listfontFamily, label: __("listfontFamily") }}
                        fontWeight={{ value: listfontWeight, label: __("listfontWeight") }}
                        fontSubset={{ value: listfontSubset, label: __("listfontSubset") }}
                        fontSizeType={{ value: listfontSizeType, label: __("listfontSizeType") }}
                        fontSizeTypeMobile={{ value: listfontSizeTypeMobile, label: __("listfontSizeTypeMobile") }}
                        fontSizeTypeTablet={{ value: listfontSizeTypeTablet, label: __("listfontSizeTypeTablet") }}
                        fontSize={{ value: listfontSizeDesktop, label: __("listfontSizeDesktop") }}
                        fontSizeMobile={{ value: listfontSizeMobile, label: __("listfontSizeMobile") }}
                        fontSizeTablet={{ value: listfontSizeTablet, label: __("listfontSizeTablet") }}
                        lineHeightType={{ value: '', label: __(" ") }}
                        lineHeight={{ value: listlineHeight, label: __("listlineHeight") }}
                        lineHeightMobile={{ value: listlineHeightMobile, label: __("listlineHeightMobile") }}
                        lineHeightTablet={{ value: listlineHeightTablet, label: __("listlineHeightTablet") }}
                        letterSpacing={{ value: listletterSpacing, label: __("listletterSpacing") }}
                        letterSpacingMobile={{ value: listletterSpacingMobile, label: __("listletterSpacingMobile") }}
                        letterSpacingTablet={{ value: listletterSpacingTablet, label: __("listletterSpacingTablet") }}
                        letterSpacingType={{ value: listletterSpacingType, label: __("listletterSpacingType") }}
                        letterSpacingTypeTablet={{ value: listletterSpacingTypeTablet, label: __("listletterSpacingTypeTablet") }}
                        letterSpacingTypeMobile={{ value: listletterSpacingTypeMobile, label: __("listletterSpacingTypeMobile") }}
                        textTransform={listtextTransform}
                        onTextTransform={(value) => setAttributes({ listtextTransform: value })}
                        textDecoration={listtextDecoration}
                        onTextDecoration={(value) => setAttributes({ listtextDecoration: value })}
                        fontStyle={listfontStyle}
                        onFontStyle={(value) => setAttributes({ listfontStyle: value })}
                    />
                </PanelBody>

                <PanelBody title={ __( 'Colors' ) } initialOpen={false}  icon={ getIcon( 'colors' ) } className={ 'abblocks-panel-label' }>
                    { prosConsDesignStyle && prosConsDesignStyle == 'default' &&
                        <Color label={__('Pros Background Color')} disableAlpha value={propsBgColor} onChange={val => setAttributes({ propsBgColor: val })} />
                    }
                    { prosConsDesignStyle && prosConsDesignStyle == 'style3' &&
                        <Color label={__('Pros Background Color')} disableAlpha value={propsBgColor} onChange={val => setAttributes({ propsBgColor: val })} />
                    }

                    { prosConsDesignStyle && prosConsDesignStyle == 'default' &&
                        <Color label={__('Pros Text Color')} disableAlpha value={propsTextColor} onChange={val => setAttributes({ propsTextColor: val })} />
                    }
                    { prosConsDesignStyle && prosConsDesignStyle == 'style1' &&
                        <Color label={__('Pros Text Color')} disableAlpha value={propsTextColor1} onChange={val => setAttributes({ propsTextColor1: val })} />
                    }
                    { prosConsDesignStyle && prosConsDesignStyle == 'style1' &&                     
                        <Color label={__('Pros Border Color')} disableAlpha value={prosBorderColor} onChange={val => setAttributes({ prosBorderColor: val })} />
                    }
                    { prosConsDesignStyle && prosConsDesignStyle == 'style2' &&
                        <Color label={__('Pros Text Color')} disableAlpha value={propsTextColor1} onChange={val => setAttributes({ propsTextColor1: val })} />
                     
                    }
                    { prosConsDesignStyle && prosConsDesignStyle == 'style2' &&                     
                        <Color label={__('Pros Border Color')} disableAlpha value={prosBorderColor} onChange={val => setAttributes({ prosBorderColor: val })} />
                    }
                    { prosConsDesignStyle && prosConsDesignStyle == 'style3' &&
                        <Color label={__('Pros Text Color')} disableAlpha value={propsTextColor} onChange={val => setAttributes({ propsTextColor: val })} />
                    }
                    { prosConsDesignStyle && prosConsDesignStyle == 'style3' &&                     
                        <Color label={__('Pros Content Background')} disableAlpha value={style3ContentProsBg} onChange={val => setAttributes({ style3ContentProsBg: val })} />
                    }

                    <Color label={__('Pros Icon Color')} disableAlpha value={propsIconColor} onChange={val => setAttributes({ propsIconColor: val })} />
                    <Color label={__('Pros List Color')} disableAlpha value={propsListColor} onChange={val => setAttributes({ propsListColor: val })} />

                    { prosConsDesignStyle && prosConsDesignStyle == 'default' &&
                        <Color label={__('Cons Background Color')} disableAlpha value={consBgColor} onChange={val => setAttributes({ consBgColor: val })} />
                    }
                    { prosConsDesignStyle && prosConsDesignStyle == 'style3' &&
                        <Color label={__('Cons Background Color')} disableAlpha value={consBgColor} onChange={val => setAttributes({ consBgColor: val })} />
                    }

                    { prosConsDesignStyle && prosConsDesignStyle == 'default' &&
                        <Color label={__('Cons text Color')} disableAlpha value={consTextColor} onChange={val => setAttributes({ consTextColor: val })} />
                    }
                    { prosConsDesignStyle && prosConsDesignStyle == 'style1' &&
                        <Color label={__('Cons text Color')} disableAlpha value={consTextColor1} onChange={val => setAttributes({ consTextColor1: val })} />
                    }
                    { prosConsDesignStyle && prosConsDesignStyle == 'style1' &&                     
                        <Color label={__('Cons Border Color')} disableAlpha value={consBorderColor} onChange={val => setAttributes({ consBorderColor: val })} />
                    }
                    { prosConsDesignStyle && prosConsDesignStyle == 'style2' &&
                        <Color label={__('Cons text Color')} disableAlpha value={consTextColor1} onChange={val => setAttributes({ consTextColor1: val })} />                        
                    }

                    { prosConsDesignStyle && prosConsDesignStyle == 'style2' &&                     
                        <Color label={__('Cons Border Color')} disableAlpha value={consBorderColor} onChange={val => setAttributes({ consBorderColor: val })} />
                    }

                    { prosConsDesignStyle && prosConsDesignStyle == 'style3' &&
                        <Color label={__('Cons text Color')} disableAlpha value={consTextColor} onChange={val => setAttributes({ consTextColor: val })} />
                    }
                    { prosConsDesignStyle && prosConsDesignStyle == 'style3' &&                     
                        <Color label={__('Cons Content Background')} disableAlpha value={style3ContentConsBg} onChange={val => setAttributes({ style3ContentConsBg: val })} />
                    }

                    <Color label={__('Cons Icon Color')} disableAlpha value={consIconColor} onChange={val => setAttributes({ consIconColor: val })} />        
                    <Color label={__('Cons List Color')} disableAlpha value={consListColor} onChange={val => setAttributes({ consListColor: val })} />
                </PanelBody>

               
                </InspectorControls>
                
                <div id={`affiliate-style-${block_id}`} className={`affiliate-block-${block_id}${className ? ` ${className}` : ''} ${prosConsDesignStyle} affiliate-wrapper`}>
                    <div className={`affiliate-d-table affiliate-procon-inner`}>
                        <div className={`affiliate-block-advanced-list ${prosConsDesignStyle} affiliate-props-list affiliate-alignment-${alignment}`}>

                        { prosConsDesignStyle && prosConsDesignStyle == 'style2' &&
                            <span class="affiliate-proscons-icon"><i class="fas fa-thumbs-up"></i></span>
                        }

                        <Tag1 className={`affiliate-props-title ${prosConsDesignStyle} affiliate-propcon-title`}> { propsTitle } </Tag1>            
                            {/* {this.renderListItems()} */}
                            <RichText
                                tagName="ul"
                                multiline="li"
                                className={`affiliate-list affiliate-list-type-unordered affiliate-list-bullet-${bulletStyle.name}`}
                                value={ listTextItems }
                                onChange={ listTextItems => setAttributes( { listTextItems  } ) }
                                placeholder={ __( 'Enter New Item' ) }
                                keepPlaceholderOnFocus
                            />
                        </div>
                        <div className={`affiliate-block-advanced-list ${prosConsDesignStyle} affiliate-cons-list affiliate-alignment-${alignment}`}>
                        { prosConsDesignStyle && prosConsDesignStyle == 'style2' &&
                            <span class="affiliate-proscons-icon"><i class="fas fa-thumbs-down"></i></span>
                        }
                        <Tag1 className={`affiliate-const-title ${prosConsDesignStyle} affiliate-propcon-title`}> { consTitle } </Tag1>            
                           <div className={`affiliate-block-${uniqueId}${className ? ` ${className}` : ''} affiliate-list-two-wrspper`}>
                                {/* {this.renderListItemsTwo()}  */}
                                <RichText
                                    tagName="ul"
                                    multiline="li"
                                    className={`affiliate-list affiliate-list-type-unordered affiliate-list-bullet-${bulletStyleTwo.name}`}
                                    value={ listTextItemsTwo }
                                    onChange={ listTextItemsTwo => setAttributes( { listTextItemsTwo  } ) }
                                    placeholder={ __( 'Enter New Item' ) }
                                    keepPlaceholderOnFocus
                                />
                           </div> 
                        </div>
                    </div>
                </div>
                {loadtitleGoogleFonts}
                {loadlistGoogleFonts}
            </Fragment>
        )
    }       
}

export default (Edit);