<?php  
define('EDD_SL_STORE_URL', 'https://store.affiliatebooster.com/' );
define('EDD_SL_ITEM_ID', 1331);
define('EDD_SL_ITEM_NAME','Affiliatebooster Blocks');
define('EDD_SL_PLUGIN_VERSION','2.1.10');

if ( ! class_exists( 'AFFILIATE_SL_Plugin_Updater' ) ) {
	// load our custom updater.
	include AFB_DIR . 'updater/plugin-updater.php';
}

// retrieve our license key from the DB.
$license_key = trim( get_option( 'affbooster_plugin_license_key' ) );

$active_plugins = get_option( 'active_plugins' );
$plugin_dir_and_filename = '';
foreach ( $active_plugins as $active_plugin ) {
	if ( false !== strpos( $active_plugin, 'affiliatebooster-blocks.php' ) ) {
		$plugin_dir_and_filename = $active_plugin;
		break;
	}
}
if ( ! isset( $plugin_dir_and_filename ) || empty( $plugin_dir_and_filename ) ) {

}

// setup the updater.
$edd_updater = new AFFILIATE_SL_Plugin_Updater(
	EDD_SL_STORE_URL,
	$plugin_dir_and_filename,
	array(
		'version' => EDD_SL_PLUGIN_VERSION, // current version number.
		'license' => $license_key, // license key (used get_option above to retrieve from DB).
		'item_id' => EDD_SL_ITEM_ID, // id of this product in EDD.
		'author'  => 'Kulwant Nagi', // author of this plugin.
		'url'     => home_url(),
	)
);
include AFB_DIR . 'updater/setting.php';
?>