<?php
/*function affiliate_license_menu() {
	add_plugins_page( 'Affiliate Booster Blocks', 'Affiliate Booster Blocks', 'manage_options', 'affiliate_booster_activation', 'affiliate_edd_license_page' );
}
add_action('admin_menu', 'affiliate_license_menu');*/

/**
 * Display success or error message
 */
if (!function_exists('affiliate_admin_notice_message')) {
    function affiliate_admin_notice_message()
    {
        ?>
        <div class="error is-dismissible notice settings-error">
            <p><?php _e('Please enter valid licence key', AFB_DOMAIN); ?></p>
        </div>
    <?php
        }
    }

function affiliate_edd_license_page() {
	global $status;
	$license = get_option( 'affbooster_plugin_license_key' );
	$status  = get_option( 'affbooster_license_status' );
	?>
	<div id="acera-content" class="affiliate-activation-wrapper tab-content" style="display: block;">
		<h2><?php _e('Affiliate Booster Plugin License Key',AFB_DOMAIN); ?></h2>
		<h4><?php _e('How to Activate License Key.','affiliatebooster')?></h4>
		<ul>	
			<li><?php _e('<strong>Step 1:</strong> Enter your license key.','affiliatebooster')?></li>
			<li><?php _e('<strong>Step 2:</strong> Click on save changes button.','affiliatebooster')?></li>
			<li><?php _e('<strong>Step 3:</strong> Click on Activate license button.','affiliatebooster')?></li>
		</ul>
		<form method="post" action="options.php">
			<?php settings_fields('affiliate_license'); ?>
			<table class="form-table">
				<tbody>
					<tr valign="top">
						<th scope="row" valign="top">
							<?php _e('License Key',AFB_DOMAIN); ?>
						</th>
						<td>
							<input id="affbooster_plugin_license_key" placeholder="<?php _e('Enter your licence key');?>" name="affbooster_plugin_license_key" type="text" class="regular-text" value="<?php esc_attr_e( $license ); ?>" />
							<label class="description" for="affbooster_plugin_license_key">
									<?php if($license !== '' ){ if( $status !== false && $status == 'valid') { ?>
										<span style="color:green;"><?php _e('Active'); ?></span>
										<?php wp_nonce_field( 'affiliate_post_nonce', 'affiliate_post_nonce' ); ?>
									<?php } else {
										wp_nonce_field( 'affiliate_post_nonce', 'affiliate_post_nonce' ); ?>
										<span class="error-message"><?php _e('Inactive',AFB_DOMAIN); ?></span>
									<?php } } ?>
							</label>
						</td>
					</tr>
					<?php 
					if( false !== $license ) { ?>
						<tr valign="top">
							<th scope="row" valign="top">
								<?php _e('Activate License',AFB_DOMAIN); ?>
							</th>
							<td>
								<?php if( $status !== false && $status == 'valid' ) { ?>
									<?php wp_nonce_field( 'affiliate_post_nonce', 'affiliate_post_nonce' ); ?>
									<?php echo get_site_url();?>
									<input type="submit" class="button-secondary" name="affiliate_license_activate" value="<?php _e('Deactivate License',AFB_DOMAIN); ?>"/>
									<input type="hidden" name="affiliate_license_status" value="deactive"/>
								<?php } else {
									
									wp_nonce_field( 'affiliate_post_nonce', 'affiliate_post_nonce' ); ?>
									<?php echo get_site_url();?>
									<input type="submit" class="button-secondary" name="affiliate_license_activate" value="<?php _e('Activate License',AFB_DOMAIN); ?>"/>
									<input type="hidden" name="affiliate_license_status" value="active"/>
								<?php } ?>
							</td>
						</tr>
					<?php } ?>
				</tbody>
			</table>
			<?php submit_button(); ?>
		</form>
	</div>	
	<?php
}

function affiliate_edd_register_option() {
	// creates our settings in the options table
	register_setting('affiliate_license', 'affbooster_plugin_license_key', 'affiliate_sanitize_license' );
}
add_action('admin_init', 'affiliate_edd_register_option');

function affiliate_init_category(){
	
	$status  = get_option( 'affbooster_license_status' );
	if($status == 'valid'){
		//add_filter('block_categories', 'affiliate_register_category', 10, 2);
	}
}

add_action( 'init','affiliate_init_category');

function affiliate_sanitize_license( $new ) {
	$old = get_option( 'affbooster_plugin_license_key' );
	if( $old && $old != $new ) {
		delete_option( 'affbooster_license_status' ); // new license has been entered, so must reactivate
	}
	return $new;
}


// add_action('admin_init', 'affiliate_activate_license');
function affiliate_booster_plugin_activate_license() {
	  
	// listen for our activate button to be clicked
	if( isset( $_POST['affiliate_license_activate'] ) ) {
		
		// run a quick security check
	 	if( ! check_admin_referer( 'affiliate_post_nonce', 'affiliate_post_nonce' ) )
			return; // get out if we didn't click the Activate button

		// retrieve the license from the database
		$license = trim( get_option( 'affbooster_plugin_license_key' ) );

		$licence_status = sanitize_text_field($_POST['affiliate_license_status']);
		$action = '';
		if($licence_status == 'deactive'){
			$action = 'deactivate_license';
		 }else {
			$action = 'check_license';
			// $action = 'activate_license';
		}

		// data to send in our API request
		$api_params = array(
			// 'edd_action' => $action,
			'edd_action' => $action,
			'license'    => $license,
			'item_id'    => EDD_SL_ITEM_ID,// The ID of the item in EDD
			'url'        => get_site_url(),
		);

		// Call the custom API.
		// $response = wp_remote_post( EDD_SL_STORE_URL, array( 'timeout' => 15, 'sslverify' => false, 'body' => $api_params ) );
		$response = wp_remote_get( add_query_arg( $api_params, EDD_SL_STORE_URL ), array( 'timeout' => 15, 'sslverify' => false ) );

		// make sure the response came back okay
		if ( is_wp_error( $response ) || 200 !== wp_remote_retrieve_response_code( $response ) ) {

			$message =  ( is_wp_error( $response ) && ! empty( $response->get_error_message() ) ) ? $response->get_error_message() : __( 'An error occurred, please try again.' );

		} else {
			
			if($licence_status != 'deactive'){
			$license_data = json_decode( wp_remote_retrieve_body( $response ) );
			
			if ( false === $license_data->success ) {
				
				// switch( property_exists($license_data,'error')) {
				switch( $license_data->error) {

					case 'expired' :

						$message = sprintf(
							__( 'Your <b><i> Affiliate Booster Plugin</i></b> license key expired on %s. Please renew to get plugin updates.', AFB_DOMAIN ),
							date_i18n( get_option( 'date_format' ), strtotime( $license_data->expires, current_time( 'timestamp' ) ) )
						);
						break;

					case 'revoked' :

						$message = sprintf(__( 'Admin has disabled your <i><b> Affiliate Booster Plugin </b></i> license key. Please contact AffiliateBooster support.' ,AFB_DOMAIN));
						break;

					case 'missing' :

						$message = sprintf(__( '<b><i> Affiliate Booster Plugin</i></b> Invalid license.' ,AFB_DOMAIN));
						break;

					// case 'invalid' :
					case 'site_inactive' :

						$message = sprintf(__( 'Your <i><b> Affiliate Booster Plugin </b></i> license is not active for this URL.', AFB_DOMAIN));
						break;

					case 'item_name_mismatch' :

						$message = sprintf( __( 'Your <i><b> Affiliate Booster Plugin </b></i> license key is not matched.' , AFB_DOMAIN) );
						break;

					case 'no_activations_left':

						$message = sprintf( __( 'Your <i><b> Affiliate Booster Plugin </b></i> license activation limit has exceeded. Please buy more license keys or remove your site(s) from the your dashboard.', AFB_DOMAIN ));
						break;
					
					case 'disabled' :

						$message = sprintf(__( '<i><b> Affiliate Booster Plugin </b></i> Admin has disabled your license key. Please contact AffiliateBooster support.' , AFB_DOMAIN));
						break;

					case 'invalid_item_id' :

						$message = sprintf(__( '<i><b> Affiliate Booster Plugin </b></i> license key is not valid for this item.' , AFB_DOMAIN ));
						break;

					default :

						$message = sprintf(__( '<i><b> Affiliate Booster Plugin </b></i> An error occurred, please try again.', AFB_DOMAIN ));
						break;
				}
			}
			}
		}

		// Check if anything passed on a message constituting a failure
		if ( ! empty( $message ) ) {
			$base_url = admin_url( 'plugins.php?page=affiliate_booster' );
			$redirect = add_query_arg( array( 'sl_activation' => 'false', 'message' => urlencode( $message ) ), $base_url );
			wp_redirect( $redirect );
			exit();
		}

		if ( $licence_status !== 'deactive' && true === $license_data->success ) {
			if( $license_data->license == 'disabled'){
				$base_url = admin_url( 'plugins.php?page=affiliate_booster' );
				$message = sprintf(__( 'Your license key is disabled.',AFB_DOMAIN ));
				$redirect = add_query_arg( array( 'sl_activation' => 'false', 'message' => urlencode( $message ) ), $base_url );
				wp_redirect( $redirect );
				exit();
			} else {
				// data to send in our API request
				$api_params = array(
					// 'edd_action' => $action,
					'edd_action' => 'activate_license',
					'license'    => $license,
					'item_id'    => EDD_SL_ITEM_ID,// The ID of the item in EDD
					'url'        => get_site_url(),
				);
				$active_response = wp_remote_get( add_query_arg( $api_params, EDD_SL_STORE_URL ), array( 'timeout' => 15, 'sslverify' => false ) );
				$active_data = json_decode( wp_remote_retrieve_body( $active_response ) );
				// $license_data->license will be either "valid" or "invalid"
				update_option( 'affbooster_plugin_license_key', $license );
				update_option( 'affbooster_license_status', $active_data->license );
				$base_url = admin_url( 'plugins.php?page=affiliate_booster' );
				$redirect = add_query_arg( array( 'sl_activation' => 'true'), $base_url );

				wp_redirect( $redirect );
				exit();
			}
		} else {
			delete_option( 'affbooster_plugin_license_key');
			delete_option( 'affbooster_license_status');
			//update_option( 'affbooster_license_status', $license_data->license );
		} 
	}
}
add_action('admin_init', 'affiliate_booster_plugin_activate_license');

/**
 * This is a means of catching errors from the activation method above and displaying it to the customer
 */
function affiliate_booster_admin_notices() {
	if ( isset( $_GET['sl_activation'] ) && ! empty( $_GET['message'] ) ) {

		switch( $_GET['sl_activation'] ) {

			case 'false':
				$message = urldecode( $_GET['message'] );
				?>
				<div class="notice is-dismissible notice-error">
					<p><?php echo $message; ?></p>
				</div>
				<?php
				break;

			case 'true':
				$message = sprintf(__('Item Activated Successfully',AFB_DOMAIN));
			?>
			<div class="notice is-dismissible notice-success">
					<p><?php echo $message; ?></p>
			</div>
			<?php
			default:
				// Developers can put a custom success message here for when activation is successful if they way.
				break;

		}
	}
}
add_action( 'admin_notices', 'affiliate_booster_admin_notices' );

/**
 * Display activation notice 
 */
function affiliate_check_plugin_activation(){
	$license = trim( get_option( 'affbooster_plugin_license_key' ) );
	$licence_status = get_option( 'affbooster_license_status');
	
	$is_multisite     = is_multisite();
	$is_network_admin = is_network_admin();
	if ( is_multisite() ) {
		$url =  network_admin_url( 'plugins.php?page=affiliate_booster' );
	} else {
		$url =  admin_url( 'plugins.php?page=affiliate_booster');
	}
	
	if($licence_status == '' && $license == ''){
		$message = sprintf(__( 'Please', AFB_DOMAIN )) . ' <a href="' . $url . '" class="affiliate-core-license-form-btn" plugin-slug="Affiliate Booster">' 
				. sprintf(__( 'activate', AFB_DOMAIN )) . '</a> ' . sprintf(__( 'your copy of the', AFB_DOMAIN )) . ' <b><i> Affiliate Booster Plugin</i></b> ' 
				. sprintf(__( 'to get update notifications, access to support features & other resources!', AFB_DOMAIN ));
		if(empty($license) || ( $is_multisite && $is_network_admin ) && !$is_multisite || $licence_status == 'invalid' ){
			echo '<div class="notice is-dismissible notice-warning"> <p> '. $message . '</p> </div>';
		}
	}
	
	if($license != ''){
		
		$action = '';
		$action = 'activate_license';
		// data to send in our API request
		$api_params = array(
			// 'edd_action' => $action,
			'edd_action' => $action,
			'license'    => $license,
			'item_id'    => EDD_SL_ITEM_ID,// The ID of the item in EDD
			'url'        => get_site_url(),
		);

		// Call the custom API.
		// $response = wp_remote_post( EDD_SL_STORE_URL, array( 'timeout' => 15, 'sslverify' => false, 'body' => $api_params ) );
		$response = wp_remote_get( add_query_arg( $api_params, EDD_SL_STORE_URL ), array( 'timeout' => 15, 'sslverify' => false ) );

		// make sure the response came back okay
		if ( is_wp_error( $response ) || 200 !== wp_remote_retrieve_response_code( $response ) ) {

			$message =  ( is_wp_error( $response ) && ! empty( $response->get_error_message() ) ) ? $response->get_error_message() : __( 'An error occurred, please try again.' );

		} else {

			$license_data = json_decode( wp_remote_retrieve_body( $response ) );
			//echo "<pre>";
			//print_r($license_data);
			
			if ( false === $license_data->success || 0 == $license_data->success ) {
					
					// switch( property_exists($license_data,'error')) {
					switch( $license_data->error) {

					case 'expired' :

						$message = sprintf(
							__( 'Your <b><i> Affiliate Booster Plugin</i></b> license key expired on %s. Please renew to get plugin updates.', AFB_DOMAIN ),
							date_i18n( get_option( 'date_format' ), strtotime( $license_data->expires, current_time( 'timestamp' ) ) )
						);
						break;

					case 'revoked' :

						$message = sprintf(__( 'Admin has disabled your <i><b> Affiliate Booster Plugin </b></i> license key. Please contact AffiliateBooster support.' ,AFB_DOMAIN));
						break;

					case 'missing' :

						$message = sprintf(__( '<b><i> Affiliate Booster Plugin</i></b> Invalid license.' ,AFB_DOMAIN));
						break;

					// case 'invalid' :
					case 'site_inactive' :

						$message = sprintf(__( 'Your <i><b> Affiliate Booster Plugin </b></i> license activation limit has exceeded. Please buy more license keys or remove your site(s) from the your dashboard.', AFB_DOMAIN));
						break;

					case 'item_name_mismatch' :

						$message = sprintf( __( 'Your <i><b> Affiliate Booster Plugin </b></i> license key is not matched.' , AFB_DOMAIN) );
						break;

					case 'no_activations_left':

						$message = sprintf( __( 'Your <i><b> Affiliate Booster Plugin </b></i> license activation limit has exceeded. Please buy more license keys or remove your site(s) from the your dashboard.', AFB_DOMAIN ));
						break;
					
					case 'disabled' :

						$message = sprintf(__( '<i><b> Affiliate Booster Plugin </b></i> Admin has disabled your license key. Please contact AffiliateBooster support.' , AFB_DOMAIN));
						break;

					case 'invalid_item_id' :

						$message = sprintf(__( '<i><b> Affiliate Booster Plugin </b></i> license key is not valid for this item.' , AFB_DOMAIN ));
						break;

					default :

						$message = '';
						break;
				}
				
				if($message != ''){
					echo '<div class="notice is-dismissible notice-error"> <p> '. $message . '</p> </div>';
				}
			}
		}
		
	}
	
	
}

add_action( 'admin_notices', 'affiliate_check_plugin_activation', 1000 );
add_action( 'network_admin_notices', 'affiliate_check_plugin_activation', 1000 );
