<?php
/**
 * The template for displaying archive pages
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/
 *
 * @package Affiliate_Booster
 */
$main_width = get_theme_mod( 'aff_booster_container', '1350' );
$sidebar_width = get_theme_mod( 'sidebar_custom_width_settings', '400' );
$content_width = $main_width - $sidebar_width - 2;
?>
<style>
	@media only screen and (min-width: 1024px) {
		div.col-md-8.main-content{
			flex: auto;
			max-width: <?php echo $content_width.'px'; ?>;
		}
		aside.col-md-4.sidebars{
			flex: auto;
			max-width: <?php echo $sidebar_width.'px'; ?>;
		}

	}
</style>
<?php get_header(); ?>
	<main id="content" class="container-fluid aff-site-content" style="max-width: <?php echo $main_width.'px'; ?>">
		<div class="row">
		<?php if ( is_archive() ) {
				$pagelayout = get_theme_mod('archive_layout');
				$global_layout = get_theme_mod('global_layout');
				if(empty($pagelayout)){ $pagelayout = 1; }
				$pagelayout;
				if ( true == get_theme_mod( 'affiliate_booster_field_global_layout_flag_switcher') ){
						if($global_layout == 'full-width'){
							$pagelayout = 7;
						}
						elseif($global_layout == 'right-sidebar'){
							$pagelayout = 8;
						}
						elseif($global_layout == 'left-sidebar') {
							$pagelayout = 9;
						}
						else {
							$pagelayout = 11; 
						}
						get_template_part( 'templates/category/layout'.$pagelayout); 
					} else {
				get_template_part( 'templates/category/layout'.$pagelayout);
				}
			} else {
				?>
			<?php $sidebar = get_post_meta( get_the_ID(), 'aff_booster_sidebar_position', true ); ?>
			<?php if ($sidebar == 'global' || $sidebar == 'right-sidebar') { ?>
						<div class="col-md-8 main-content">
							<div class="aff-content aff-page-layout">
							
								<?php while( have_posts() ) : the_post(); ?>
									
								   <article id="post-<?php the_ID(); ?>">
	
									   <?php get_template_part( 'templates/page/content','page');  ?>
	
									</article>
	
								<?php endwhile; ?>
							</div>
						</div>
						<aside class="col-md-4 sidebars" <?php aff_do_microdata( 'sidebar' ); ?>>
							<?php get_sidebar(); ?>
						</aside>
						<?php } elseif ($sidebar == 'left-sidebar') { ?>
							<aside class="col-md-4 sidebars" <?php aff_do_microdata( 'sidebar' ); ?>>
								<?php get_sidebar(); ?>
							</aside>
							<div class="col-md-8 main-content">
								<div class="aff-content aff-page-layout">
							
									<?php while( have_posts() ) : the_post(); ?>
									
									   <article id="post-<?php the_ID(); ?>">
	
										   <?php get_template_part( 'templates/page/content','page');  ?>
	
									</article>
	
									<?php endwhile; ?>
								</div>
							</div>
						<?php } elseif ($sidebar == 'full-width') { ?>
							<div class="col-md-12 main-content full-layout-page">
								<div class="aff-content aff-page-layout">
							
									<?php while( have_posts() ) : the_post(); ?>
									
									   <article id="post-<?php the_ID(); ?>">
	
										   <?php get_template_part( 'templates/page/content','page');  ?>
	
									</article>
	
									<?php endwhile; ?>
								</div>
							</div>
						<?php } else { ?>
						<div class="col-md-8 main-content">
							<div class="aff-content aff-page-layout">
							
								<?php while( have_posts() ) : the_post(); ?>
									
								   <article id="post-<?php the_ID(); ?>">
	
									   <?php get_template_part( 'templates/page/content','page');  ?>
	
									</article>
	
								<?php endwhile; ?>
							</div>
						</div>
						<aside class="col-md-4 sidebars" <?php aff_do_microdata( 'sidebar' ); ?>>
							<?php get_sidebar(); ?>
						</aside>
						<?php } ?>	
				<?php } ?>
		</div>
	</main>

<?php get_footer(); ?>