<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // No direct access, please.
}

class Aff_booster_Elements_Metabox {
    private static $instance;
    public static function get_instance() {
		if ( ! isset( self::$instance ) ) {
			self::$instance = new self;
		}

		return self::$instance;
	}
	public function __construct() {
		//add_action( 'add_meta_boxes', array( $this, 'aff_booster_global_meta_box' ) );
		add_action( 'save_post', array( $this, 'aff_booster_save_meta_box_data' ) );
    }
	public function aff_booster_global_meta_box() {
 
	  $screens = get_post_types();
	   foreach ($screens as $screen) {
		   if($screen == 'post'){
			add_meta_box(
				'aff_booster_global_meta_box_id',           // Unique ID
				' Page Builder container',                   // Box title
				 array( $this,'aff_booster_global_meta_box_cde'),          // Content callback, must be of type callable
				$screen ,			                        // Post type
				'side'
			);
		   }
		}
	}
	public function aff_booster_global_meta_box_cde($post)
	{
   
		$page_bud_radio = array(
			'full-width' => __('Full Width Content', 'affiliatebooster'),
			'left-sidebar' => __( 'Sidebar / Content', 'affiliatebooster'),
			'right-sidebar' => __( 'Content / Sidebar', 'affiliatebooster'),
			'both-sidebars' => __( 'Sidebar / Content / Sidebar', 'affiliatebooster'),
			'both-left' => __( 'Sidebar / Sidebar / Content', 'affiliatebooster'),
			'both-right' => __( 'Content / Sidebar / Sidebar', 'affiliatebooster')
		);
		$value = get_post_meta( $post->ID, 'aff_bost_temp_value', true );
		if(empty($value)){
			$value = 'right-sidebar';
		}
		foreach($page_bud_radio as $name => $type_side)
		{ ?>
			<input type="radio" name="aff_bost_layout_temp" value="<?php echo $name ?>" <?php checked($value ,$name); ?>><?php echo $type_side; ?></br>
		<?php }
	}
	function aff_booster_save_meta_box_data( $post_id ) {

        /*
         * We need to verify this came from our screen and with proper authorization,
         * because the save_post action can be triggered at other times.
         */

       
        // If this is an autosave, our form has not been submitted, so we don't want to do anything.
        if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
                return;
        }

        // Check the user's permissions.
        if ( !current_user_can( 'edit_post', $post_id ) ) {
                return;
        }
			if(isset( $_POST['aff_bost_layout_temp']))
		   {
			    $new_meta_value = $_POST['aff_bost_layout_temp'];
		   }else{
			   $new_meta_value = "right-sidebar";
		   }
        // Update the meta field in the database.
        update_post_meta( $post_id, 'aff_bost_temp_value', $new_meta_value );

}

}
Aff_booster_Elements_Metabox::get_instance();
?>