<?php

class Aff_booster_Social_Icons_Widget extends WP_Widget {


	protected $version = '3.0.2';

	protected $defaults;

	protected $sizes;

	protected $profiles;

	protected $active_instances;

	protected $disable_css_output;

	function __construct() {

		$this->defaults = apply_filters( 'simple_social_default_styles', array(
			'title'                  => '',
			'new_window'             => 0,
			'size'                   => 36,
			'border_radius'          => 3,
			'border_width'           => 0,
			'border_color'           => '#ffffff',
			'border_color_hover'     => '#ffffff',
			'icon_color'             => '#ffffff',
			'icon_color_hover'       => '#ffffff',
			'background_color'       => '#999999',
			'background_color_hover' => '#666666',
			'alignment'              => 'alignleft',
			'behance'                => '',
			'bloglovin'              => '',
			'dribbble'               => '',
			'email'                  => '',
			'facebook'               => '',
			'flickr'                 => '',
			'github'                 => '',
			'gplus'                  => '',
			'instagram'              => '',
			'linkedin'               => '',
			'medium'                 => '',
			'periscope'              => '',
			'phone'                  => '',
			'pinterest'              => '',
			'rss'                    => '',
			'snapchat'               => '',
			'stumbleupon'            => '',
			'tumblr'                 => '',
			'twitter'                => '',
			'vimeo'                  => '',
			'xing'                   => '',
			'youtube'                => '',
		) );

		/**
		 * Filter for social profile choices.
		 *
		 * @since 1.0.6
		 *
		 * @param array $profiles Social icons to include in widget options.
		 */
		$this->profiles = apply_filters( 'simple_social_default_profiles', array(
			'behance' => array(
				'label'   => __( 'Behance URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'behance', __( 'Behance', 'affiliatebooster' ) ),
			),
			'bloglovin' => array(
				'label'   => __( 'Bloglovin URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'bloglovin', __( 'Bloglovin', 'affiliatebooster' ) ),
			),
			'dribbble' => array(
				'label'   => __( 'Dribbble URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'dribbble', __( 'Dribbble', 'affiliatebooster' ) ),
			),
			'email' => array(
				'label'   => __( 'Email URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'email', __( 'Email', 'affiliatebooster' ) ),
			),
			'facebook' => array(
				'label'   => __( 'Facebook URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'facebook', __( 'Facebook', 'affiliatebooster' ) ),
			),
			'flickr' => array(
				'label'   => __( 'Flickr URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'flickr', __( 'Flickr', 'affiliatebooster' ) ),
			),
			'github' => array(
				'label'   => __( 'GitHub URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'github', __( 'GitHub', 'affiliatebooster' ) ),
			),
			'gplus' => array(
				'label'   => __( 'Google+ URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'gplus', __( 'Google+', 'affiliatebooster' ) ),
			),
			'instagram' => array(
				'label'   => __( 'Instagram URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'instagram', __( 'Instagram', 'affiliatebooster' ) ),
			),
			'linkedin' => array(
				'label'   => __( 'Linkedin URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'linkedin', __( 'LinkedIn', 'affiliatebooster' ) ),
			),
			'medium' => array(
				'label'   => __( 'Medium URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'medium', __( 'Medium', 'affiliatebooster' ) ),
			),
			'periscope' => array(
				'label'   => __( 'Periscope URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'periscope', __( 'Periscope', 'affiliatebooster' ) ),
			),
			'phone' => array(
				'label'   => __( 'Phone URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'phone', __( 'Phone', 'affiliatebooster' ) ),
			),
			'pinterest' => array(
				'label'   => __( 'Pinterest URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'pinterest', __( 'Pinterest', 'affiliatebooster' ) ),
			),
			'rss' => array(
				'label'   => __( 'RSS URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'rss', __( 'RSS', 'affiliatebooster' ) ),
			),
			'snapchat' => array(
				'label'   => __( 'Snapchat URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'snapchat', __( 'Snapchat', 'affiliatebooster' ) ),
			),
			'stumbleupon' => array(
				'label'   => __( 'StumbleUpon URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'stumbleupon', __( 'StumbleUpon', 'affiliatebooster' ) ),
			),
			'tumblr' => array(
				'label'   => __( 'Tumblr URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'tumblr', __( 'Tumblr', 'affiliatebooster' ) ),
			),
			'twitter' => array(
				'label'   => __( 'Twitter URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'twitter', __( 'Twitter', 'affiliatebooster' ) ),
			),
			'vimeo' => array(
				'label'   => __( 'Vimeo URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'vimeo', __( 'Vimeo', 'affiliatebooster' ) ),
			),
			'xing' => array(
				'label'   => __( 'Xing URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'xing', __( 'xing', 'affiliatebooster' ) ),
			),
			'youtube' => array(
				'label'   => __( 'YouTube URI', 'affiliatebooster' ),
				'pattern' => $this->get_icon_markup( 'youtube', __( 'YouTube', 'affiliatebooster' ) ),
			),
		) );

		/**
		 * Filter to disable output of custom CSS.
		 *
		 * Setting this to true in your child theme will:
		 *  - Stop output of inline custom icon CSS.
		 *  - Stop styling options showing in Simple Social Icons widget settings.
		 *
		 * The intent if enabling is that your theme will provide CSS for all
		 * widget areas, instead of allowing people to set their own icon
		 * styles. You should consider mentioning in theme documentation that
		 * Simple Social Icons widget settings will not display styling
		 * options, as your theme styles icons instead.
		 *
		 * @since 3.0.0
		 *
		 * @param bool $disable_css_output True if custom CSS should be disabled.
		 */
		$this->disable_css_output = apply_filters( 'simple_social_disable_custom_css', false );

		$widget_ops = array(
			'classname'   => 'simple-social-icons',
			'description' => __( 'Displays select social icons.', 'affiliatebooster' ),
		);

		$control_ops = array(
			'id_base' => 'affiliatebooster',
		);

		$this->active_instances = array();

		parent::__construct( 'simple-social-icons', __( 'Simple Social Icons', 'affiliatebooster' ), $widget_ops, $control_ops );

		/** Enqueue scripts and styles */
		add_action( 'wp_enqueue_scripts', array( $this, 'enqueue_css' ) );

		/** Load CSS in <head> */
		add_action( 'wp_footer', array( $this, 'css' ) );

		/** Load color picker */
		add_action( 'admin_enqueue_scripts', array( $this, 'load_color_picker' ) );
		add_action( 'admin_footer-widgets.php', array( $this, 'print_scripts' ), 9999 );

	}

	/**
	 * Color Picker.
	 *
	 * Enqueue the color picker script.
	 *
	 */
	function load_color_picker( $hook ) {
		if( 'widgets.php' != $hook )
			return;
			wp_enqueue_style( 'wp-color-picker' );
			wp_enqueue_script( 'wp-color-picker' );
			wp_enqueue_script( 'underscore' );
	}

	/**
	 * Print scripts.
	 *
	 * Reference https://core.trac.wordpress.org/attachment/ticket/25809/color-picker-widget.php
	 *
	 */
	function print_scripts() {
		?>
		<script>
			( function( $ ){
				function initColorPicker( widget ) {
					widget.find( '.ssiw-color-picker' ).wpColorPicker( {
						change: function ( event ) {
							var $picker = $( this );
							_.throttle(setTimeout(function () {
								$picker.trigger( 'change' );
							}, 5), 250);
						},
						width: 235,
					});
				}

				function onFormUpdate( event, widget ) {
					initColorPicker( widget );
				}

				$( document ).on( 'widget-added widget-updated', onFormUpdate );

				$( document ).ready( function() {
					$( '#widgets-right .widget:has(.ssiw-color-picker)' ).each( function () {
						initColorPicker( $( this ) );
					} );
				} );
			}( jQuery ) );
		</script>
		<?php
	}

	/**
	 * Widget Form.
	 *
	 * Outputs the widget form that allows users to control the output of the widget.
	 *
	 */
	function form( $instance ) {

		/** Merge with defaults */
		$instance = wp_parse_args( (array) $instance, $this->defaults );
		?>

		<p><label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:', 'affiliatebooster' ); ?></label> <input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $instance['title'] ); ?>" /></p>

		<p><label><input id="<?php echo $this->get_field_id( 'new_window' ); ?>" type="checkbox" name="<?php echo $this->get_field_name( 'new_window' ); ?>" value="1" <?php checked( 1, $instance['new_window'] ); ?>/> <?php esc_html_e( 'Open links in new window?', 'affiliatebooster' ); ?></label></p>

		<?php if ( ! $this->disable_css_output ) { ?>

			<p><label for="<?php echo $this->get_field_id( 'size' ); ?>"><?php _e( 'Icon Size', 'affiliatebooster' ); ?>:</label> <input id="<?php echo $this->get_field_id( 'size' ); ?>" name="<?php echo $this->get_field_name( 'size' ); ?>" type="text" value="<?php echo esc_attr( $instance['size'] ); ?>" size="3" />px</p>

			<p><label for="<?php echo $this->get_field_id( 'border_radius' ); ?>"><?php _e( 'Icon Border Radius:', 'affiliatebooster' ); ?></label> <input id="<?php echo $this->get_field_id( 'border_radius' ); ?>" name="<?php echo $this->get_field_name( 'border_radius' ); ?>" type="text" value="<?php echo esc_attr( $instance['border_radius'] ); ?>" size="3" />px</p>

			<p><label for="<?php echo $this->get_field_id( 'border_width' ); ?>"><?php _e( 'Border Width:', 'affiliatebooster' ); ?></label> <input id="<?php echo $this->get_field_id( 'border_width' ); ?>" name="<?php echo $this->get_field_name( 'border_width' ); ?>" type="text" value="<?php echo esc_attr( $instance['border_width'] ); ?>" size="3" />px</p>

			<p>
				<label for="<?php echo $this->get_field_id( 'alignment' ); ?>"><?php _e( 'Alignment', 'affiliatebooster' ); ?>:</label>
				<select id="<?php echo $this->get_field_id( 'alignment' ); ?>" name="<?php echo $this->get_field_name( 'alignment' ); ?>">
					<option value="alignleft" <?php selected( 'alignright', $instance['alignment'] ) ?>><?php _e( 'Align Left', 'affiliatebooster' ); ?></option>
					<option value="aligncenter" <?php selected( 'aligncenter', $instance['alignment'] ) ?>><?php _e( 'Align Center', 'affiliatebooster' ); ?></option>
					<option value="alignright" <?php selected( 'alignright', $instance['alignment'] ) ?>><?php _e( 'Align Right', 'affiliatebooster' ); ?></option>
				</select>
			</p>

			<hr style="background: #ccc; border: 0; height: 1px; margin: 20px 0;" />

			<p><label for="<?php echo $this->get_field_id( 'background_color' ); ?>"><?php _e( 'Icon Color:', 'affiliatebooster' ); ?></label><br /> <input id="<?php echo $this->get_field_id( 'icon_color' ); ?>" name="<?php echo $this->get_field_name( 'icon_color' ); ?>" type="text" class="ssiw-color-picker" data-default-color="<?php echo esc_attr( $this->defaults['icon_color'] ); ?>" value="<?php echo esc_attr( $instance['icon_color'] ); ?>" size="6" /></p>

			<p><label for="<?php echo $this->get_field_id( 'background_color_hover' ); ?>"><?php _e( 'Icon Hover Color:', 'affiliatebooster' ); ?></label><br /> <input id="<?php echo $this->get_field_id( 'icon_color_hover' ); ?>" name="<?php echo $this->get_field_name( 'icon_color_hover' ); ?>" type="text" class="ssiw-color-picker" data-default-color="<?php echo esc_attr( $this->defaults['icon_color_hover'] ); ?>" value="<?php echo esc_attr( $instance['icon_color_hover'] ); ?>" size="6" /></p>

			<p><label for="<?php echo $this->get_field_id( 'background_color' ); ?>"><?php _e( 'Background Color:', 'affiliatebooster' ); ?></label><br /> <input id="<?php echo $this->get_field_id( 'background_color' ); ?>" name="<?php echo $this->get_field_name( 'background_color' ); ?>" type="text" class="ssiw-color-picker" data-default-color="<?php echo esc_attr( $this->defaults['background_color'] ); ?>" value="<?php echo esc_attr( $instance['background_color'] ); ?>" size="6" /></p>

			<p><label for="<?php echo $this->get_field_id( 'background_color_hover' ); ?>"><?php _e( 'Background Hover Color:', 'affiliatebooster' ); ?></label><br /> <input id="<?php echo $this->get_field_id( 'background_color_hover' ); ?>" name="<?php echo $this->get_field_name( 'background_color_hover' ); ?>" type="text" class="ssiw-color-picker" data-default-color="<?php echo esc_attr( $this->defaults['background_color_hover'] ); ?>" value="<?php echo esc_attr( $instance['background_color_hover'] ); ?>" size="6" /></p>

			<p><label for="<?php echo $this->get_field_id( 'border_color' ); ?>"><?php _e( 'Border Color:', 'affiliatebooster' ); ?></label><br /> <input id="<?php echo $this->get_field_id( 'border_color' ); ?>" name="<?php echo $this->get_field_name( 'border_color' ); ?>" type="text" class="ssiw-color-picker" data-default-color="<?php echo esc_attr( $this->defaults['border_color'] ); ?>" value="<?php echo esc_attr( $instance['border_color'] ); ?>" size="6" /></p>

			<p><label for="<?php echo $this->get_field_id( 'border_color_hover' ); ?>"><?php _e( 'Border Hover Color:', 'affiliatebooster' ); ?></label><br /> <input id="<?php echo $this->get_field_id( 'border_color_hover' ); ?>" name="<?php echo $this->get_field_name( 'border_color_hover' ); ?>" type="text" class="ssiw-color-picker" data-default-color="<?php echo esc_attr( $this->defaults['border_color_hover'] ); ?>" value="<?php echo esc_attr( $instance['border_color_hover'] ); ?>" size="6" /></p>

			<hr style="background: #ccc; border: 0; height: 1px; margin: 20px 0;" />
		<?php } ?>

		<?php
		foreach ( (array) $this->profiles as $profile => $data ) {

			printf( '<p><label for="%s">%s:</label></p>', esc_attr( $this->get_field_id( $profile ) ), esc_attr( $data['label'] ) );
			printf( '<p><input type="text" id="%s" name="%s" value="%s" class="widefat" />', esc_attr( $this->get_field_id( $profile ) ), esc_attr( $this->get_field_name( $profile ) ), $instance[ $profile ] );
			printf( '</p>' );

		}

	}

	/**
	 * Form validation and sanitization.
	 *
	 * Runs when you save the widget form. Allows you to validate or sanitize widget options before they are saved.
	 *
	 */
	function update( $newinstance, $oldinstance ) {

		// Fields that can be transparent if their values are unset.
		$can_be_transparent = array(
			'background_color',
			'background_color_hover',
			'border_color',
			'border_color_hover',
		);

		foreach ( $newinstance as $key => $value ) {

			/** Border radius and Icon size must not be empty, must be a digit */
			if ( ( 'border_radius' == $key || 'size' == $key ) && ( '' == $value || ! ctype_digit( $value ) ) ) {
				$newinstance[ $key ] = 0;
			}

			if ( ( 'border_width' == $key || 'size' == $key ) && ( '' == $value || ! ctype_digit( $value ) ) ) {
				$newinstance[ $key ] = 0;
			}

			/** Accept empty colors for permitted keys. */
			elseif ( in_array( $key, $can_be_transparent, true ) && '' == trim( $value ) ) {
				$newinstance[ $key ] = '';
			}

			/** Validate hex code colors */
			elseif ( strpos( $key, '_color' ) && 0 == preg_match( '/^#(([a-fA-F0-9]{3}$)|([a-fA-F0-9]{6}$))/', $value ) ) {
				$newinstance[ $key ] = $oldinstance[ $key ];
			}

			/** Sanitize Profile URIs */
			elseif ( array_key_exists( $key, (array) $this->profiles ) && ! is_email( $value ) && ! 'phone' === $key ) {
				$newinstance[ $key ] = esc_url( $newinstance[ $key ] );
			}
		}

		return $newinstance;

	}

	/**
	 * Widget Output.
	 *
	 * Outputs the actual widget on the front-end based on the widget options the user selected.
	 *
	 */
	function widget( $args, $instance ) {

		extract( $args );

		/** Merge with defaults */
		$instance = wp_parse_args( (array) $instance, $this->defaults );

		echo $before_widget;

			if ( ! empty( $instance['title'] ) )
				echo $before_title . apply_filters( 'widget_title', $instance['title'], $instance, $this->id_base ) . $after_title;

			$output = '';

			$profiles = (array) $this->profiles;

			foreach ( $profiles as $profile => $data ) {

				if ( empty( $instance[ $profile ] ) )
					continue;

				$new_window = $instance['new_window'] ? 'target="_blank" rel="noopener noreferrer"' : '';

				if ( is_email( $instance[ $profile ] ) || false !== strpos( $instance[ $profile ], 'mailto:' ) )
					$new_window = '';

				if ( is_email( $instance[ $profile ] ) ) {
					$output .= sprintf( $data['pattern'], 'mailto:' . esc_attr( antispambot( $instance[ $profile ] ) ), $new_window );
				} elseif ( 'phone' === $profile ) {
					$output .= sprintf( $data['pattern'], 'tel:' . esc_attr( antispambot( $instance[ $profile ] ) ), $new_window );
				} else {
					$output .= sprintf( $data['pattern'], esc_url( $instance[ $profile ] ), $new_window );
				}

			}

			if ( $output ) {
				$output = str_replace( '{WIDGET_INSTANCE_ID}', $this->number, $output );
				printf( '<ul class="%s">%s</ul>', $instance['alignment'], $output );
			}

		echo $after_widget;

		$this->active_instances[] = $this->number;

	}

	function enqueue_css() {

		/**
		 * Filter the plugin stylesheet location.
		 *
		 * @since 2.0.0
		 *
		 * @param string $cssfile The full path to the stylesheet.
		 */
		$cssfile = apply_filters( 'simple_social_default_stylesheet', plugin_dir_url( __FILE__ ) . 'css/style.css' );

		wp_enqueue_style( 'simple-social-icons-font', esc_url( $cssfile ), array(), $this->version, 'all' );

		if ( ! function_exists( 'is_amp_endpoint' ) || ( function_exists( 'is_amp_endpoint' ) && ! is_amp_endpoint() ) ) {
			wp_enqueue_script('svg-x-use', plugin_dir_url(__FILE__) . 'svgxuse.js', array(), '1.1.21' );
		}
	}

	/**
	 * Custom CSS.
	 *
	 * Outputs custom CSS to control the look of the icons.
	 */
	function css() {

		/** Pull widget settings, merge with defaults */
		$all_instances = $this->get_settings();

		$css = '';

		foreach ( $this->active_instances as $instance_id ) {
			// Skip if info for this instance does not exist - this should never happen.
			if ( ! isset( $all_instances[ $instance_id ] ) || $this->disable_css_output ) {
				continue;
			}

			$instance = wp_parse_args( $all_instances[ $instance_id ], $this->defaults );

			$font_size    = round( (int) $instance['size'] / 2 );
			$icon_padding = round( (int) $font_size / 2 );

			// Treat empty background and border colors as transparent.
			$instance['background_color']       = $instance['background_color'] ?: 'transparent';
			$instance['border_color']           = $instance['border_color'] ?: 'transparent';
			$instance['background_color_hover'] = $instance['background_color_hover'] ?: 'transparent';
			$instance['border_color_hover']     = $instance['border_color_hover'] ?: 'transparent';

			/** The CSS to output */
			$css .= '
			#simple-social-icons-' . $instance_id . ' ul li a,
			#simple-social-icons-' . $instance_id . ' ul li a:hover,
			#simple-social-icons-' . $instance_id . ' ul li a:focus {
				background-color: ' . $instance['background_color'] . ' !important;
				border-radius: ' . $instance['border_radius'] . 'px;
				color: ' . $instance['icon_color'] . ' !important;
				border: ' . $instance['border_width'] . 'px ' . $instance['border_color'] . ' solid !important;
				font-size: ' . $font_size . 'px;
				padding: ' . $icon_padding . 'px;
			}

			#simple-social-icons-' . $instance_id . ' ul li a:hover,
			#simple-social-icons-' . $instance_id . ' ul li a:focus {
				background-color: ' . $instance['background_color_hover'] . ' !important;
				border-color: ' . $instance['border_color_hover'] . ' !important;
				color: ' . $instance['icon_color_hover'] . ' !important;
			}

			#simple-social-icons-' . $instance_id . ' ul li a:focus {
				outline: 1px dotted ' . $instance['background_color_hover'] . ' !important;
			}';

		}

		// Minify a bit.
		$css = str_replace( "\t", '', $css );
		$css = str_replace( array( "\n", "\r" ), ' ', $css );

		echo '<style media="screen">' . $css . '</style>';

	}

	/**
	 * Construct the markup for each icon
	 *
	 * @param string The lowercase icon name for use in tag attributes.
	 * @param string The plain text icon label.
	 *
	 * @return string The full markup for the given icon.
	 */
	function get_icon_markup( $icon, $label ) {
		$markup = '<li class="ssi-' . $icon . '"><a href="%s" %s>';
		$markup .= '<svg role="img" class="social-' . $icon . '" aria-labelledby="social-' . $icon . '-{WIDGET_INSTANCE_ID}">';
		$markup .= '<title id="social-' . $icon . '-{WIDGET_INSTANCE_ID}' . '">' . $label . '</title>';
		$markup .= '<use xlink:href="' . esc_attr( plugin_dir_url( __FILE__ ) . 'symbol-defs.svg#social-' . $icon ) . '"></use>';
		$markup .= '</svg></a></li>';

		/**
		 * Filter the icon markup HTML.
		 *
		 * @since 3.0.0
		 *
		 * @param string $markup The full HTML markup for a single icon.
		 * @param string $icon The lowercase icon name used in tag attributes.
		 * @param string $label The plain text icon label.
		 */
		return apply_filters( 'simple_social_icon_html', $markup, $icon, $label );
	}

	/**
	 * Remove option when uninstalling the plugin.
	 *
	 * @since 2.1.0
	 */



}
add_action( 'widgets_init', 'ssiw_load_widget' );
/**
 * Widget Registration.
 *
 * Register Simple Social Icons widget.
 *
 */
function ssiw_load_widget() {

	register_widget( 'Aff_booster_Social_Icons_Widget' );

}
