<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // No direct access, please.
}
class Aff_Booster_embed_metabox
{
	private static $instance;
    public static function get_instance() {
		if ( ! isset( self::$instance ) ) {
			self::$instance = new self;
		}

		return self::$instance;
	}
	public function __construct() {
        add_action( 'add_meta_boxes', array( $this, 'aff_embed_add_meta_box' ) );
		add_action( 'save_post', array( $this, 'aff_embed_save_meta_box' ) );
		// add_action( 'wp_head',   array( $this, 'output_header_code' ));
		// add_action( 'wp_footer',   array( $this, 'output_footer_code' ));
    }
 
    /**
     * Adds the meta box container.
     */
    public function aff_embed_add_meta_box( $post_type ) {
        // Limit meta box to certain post types.
        $post_types = array( 'post','page');
 
        if ( in_array( $post_type, $post_types ) ) {
            add_meta_box(
                'aff_add_embed_meta_box',
                __( 'Embed Code', 'affiliatebooster' ),
                array( $this, 'get_field_affembed_code' ),
                $post_type,
                'advanced',
                'high'
            );

        }
    }
	public function get_field_affembed_code( $post ) {
 
 
        $header_code = get_post_meta( $post->ID, '_header_code', true );
		$footer_code = get_post_meta( $post->ID, '_footer_code', true );

        ?>
        <style type="text/css">
        	.header_code_field > div {margin-right: 75px;}
        	.footer_code_field > div {margin-right: 75px;}
        </style>
		<div class="header_code_field" style="display: flex;">
			<div class="embed-label">
				<label for="header_embed_code">
					<?php _e( 'Header Code', 'affiliatebooster' ); ?>
				</label>
			</div>
			<div class="embed-textarea">
				<textarea id="header_code" name="header_embed_code" rows="4" cols="80" placeholder="Paste Header Code" style="Width:100%;" value="<?php echo esc_html( $header_code ); ?>"><?php echo esc_html( $header_code ); ?></textarea><br>
				<?php echo "The code will output immediately before the closing <code> &lt;/head&gt; </code> tag"; ?>
			</div>
	   </div>
	   <br>
		<div class="footer_code_field" style="display: flex;">
			<div class="embed-label">
				<label for="footer_embed_code">
					<?php _e( 'Footer Code', 'affiliatebooster' ); ?>
				</label>
			</div>
			<div class="embed-textarea">
				<textarea id="footer_code" name="footer_embed_code" rows="4" cols="80" placeholder="Paste Footer Code" style="Width:100%;"  value="<?php echo esc_html( $footer_code ); ?>"><?php echo esc_html( $footer_code ); ?></textarea><br>
				<?php echo "The code will output immediately before the closing <code> &lt;/body&gt; </code> tag"; ?>
			</div>
		</div>
        <?php
    }
	
	public function output_header_code() {

		$option = get_post_meta(get_the_ID(),'_header_code',true);
		if ( isset( $option) ) {
			echo $option;
		}
	}
	public function output_footer_code() {

		$option = get_post_meta(get_the_ID(),'_footer_code',true);
		if ( isset( $option) ) {
			echo $option;
		}
	}
	public function aff_embed_save_meta_box( $post_id ) {

     
        // Check if our nonce is set.
        if ( !isset( $_POST['header_embed_code'] ) || !isset( $_POST['footer_embed_code'] ) ) {
                return;
        }

        // If this is an autosave, our form has not been submitted, so we don't want to do anything.
        if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
                return;
        }

        // Check the user's permissions.
        if ( !current_user_can( 'edit_post', $post_id ) ) {
                return;
        }

		$hed_code = ( isset( $_POST['header_embed_code'] ) ? $_POST['header_embed_code']  : '' );
        $foot_code = ( isset( $_POST['footer_embed_code'] ) ? $_POST['footer_embed_code']  : '' );
        // Update the meta field in the database.
        update_post_meta( $post_id, '_header_code', $hed_code );
		update_post_meta( $post_id, '_footer_code', $foot_code );

	}
	
	

	
}
Aff_Booster_embed_metabox::get_instance();
?>