<?php
/**
 * The template for displaying the footer
 *
 * Contains the closing of the #content div and all content after.
 *
 * @link https://developer.wordpress.org/themes/basics/template-files/#template-partials
 *
 * @package Affiliate_Booster
 */

?>
<?php 
get_template_part('templates/widgets-area/above-footer');
?>
<?php
	$options = get_post_meta( get_the_ID(), 'aff_booster_options', true );
	$remove_footer = $options ? in_array( 'remove-footer', $options ) : false; 
?>
	<?php if ( ( is_singular() && $remove_footer ) || ( is_page() && $remove_footer ) ) { 
		//no single footer ?>
	<?php } else { ?>
	<?php if( is_active_sidebar( 'footer_sidebar_1' ) ){ ?>
<footer id="footer" class="container-fluid aff-site-content aff-footer" <?php aff_do_microdata( 'footer' ); ?>>
<div class="aff-footer-site-content">
	<div class="row">
		<?php 
			/*$demo = 
			print_r(get_theme_mod('aff_footer'));*/
			$layout = explode( "_", get_theme_mod('aff_footer','3_4'));
			$layout_count = count($layout);
			if(!empty($layout) && $layout_count > 1){
				$columns = $layout[0];
				$col_lg = $layout[1];
				$col_md = $columns > 1 ? 6 : 12;
			
				for($i = 1; $i <= $columns; $i++) { ?>
				<div class="col-lg-<?php echo $col_lg; ?> col-md-<?php echo $col_md; ?> col-sm-12">
					<?php if( is_active_sidebar( 'footer_sidebar_'.$i ) ){ 
						dynamic_sidebar( 'footer_sidebar_'.$i );
					}
					?>
					
				</div>
			<?php }} ?>
	</div>
	<?php ?>
	 <?php
	 $site_name = get_option('blogname');
	 $home_url = get_home_url();
	 ?>		
</div>	
</footer>
<?php } ?>
<?php if ( has_nav_menu( 'footer-menu' ) ) { 
	$ffms = get_theme_mod( 'footer_footer_menu_settings','' );
	if( $ffms == '' ){
		$ffms = '#1e73be';
	}
?>
<div class="aff-footer footer_footer_menu" style="background-color: <?php echo $ffms; //esc_url( get_theme_mod( 'footer_footer_menu_settings', '' ) ); ?>;">
		<div class="footer-nav-menu">
			<?php wp_nav_menu( array( 'theme_location' => 'footer-menu', 'depth' => 1 ) ); ?>
		</div>
</div>
<?php } ?>
<div class="aff-copyright bottom-footer" style="background-color: <?php echo esc_url( get_theme_mod( 'bottom_footer_background_color', '#fff1ef') ); ?>">
	<?php
	$footer_copy = get_theme_mod( 'footer_copyright_link', 'Copyright &copy; [year] &bull; [sitename] &bull; Powered by [affiliatebooster]' );
	?>
	<p class="aff-copyright-text"><?php echo do_shortcode( $footer_copy ); ?></p>
</div>	
<?php } ?>
</div><!--#page .site-->	
<?php if ( true == get_theme_mod( 'footer_scroll_top', false ) ) : ?>
	<a href="#" id="smoothup" title="Back to top"><i class="icon-caret-square-up-solid"></i></a>
<?php endif; ?>
<?php  wp_footer(); ?>
<?php $footer_code = wp_specialchars_decode(get_theme_mod('cust_scr_foo', '')); ?>
<?php echo $footer_code; ?>
<script>
jQuery(document).ready(function(){
	jQuery('#header .toggle_menu').on('click', function(e) {
		
		jQuery('.flex_menu').toggle('slow');
		 
	});
	jQuery('#header .toggle_menu_secondary').on('click', function(e) {
		
		jQuery('.flex_menu_secondary').toggle('slow');
		 
	});
});
</script>
<?php 
if ( is_single() || 'post' == get_post_type() || is_page() ) {
	echo get_post_meta( get_the_ID(), '_footer_code', true );
}
?>
</body>
</html>

<script type = "application/ld+json">
{ 
"@context" : "https://schema.org",
"@type" : "BreadcrumbList",
"itemListElement" : 
[{ 
"@type" : "ListItem",
"position" : "1",
"name" : "https://demotesting.xyz/",
"item" : "https://demotesting.xyz/"
 }] 
 } 
 </script>