const gulp = require('gulp');
const cleanCSS = require('gulp-clean-css');
const uglifycss = require('gulp-uglifycss');
const rename = require('gulp-rename');
var uglify = require('gulp-uglify');
 
gulp.task('minify-css', () => {
  return gulp.src(['*.css', 'css/*.css'])
    .pipe(cleanCSS({compatibility: 'ie8'}))
    .pipe(uglifycss({
        "maxLineLen": 80,
        "uglyComments": true
      }))
      .pipe(rename({
        suffix: '.min'
    }))
    .pipe(gulp.dest('dist/css'));
});

gulp.task('minify-js', function() {
    return gulp.src(['js/customizer.js', 'js/main.js', 'js/license-kirki-activation-custom-message.js'])
      .pipe(uglify())
      .pipe(rename({
        suffix: '.min'
    }))
      .pipe(gulp.dest('dist/js'))
  });

gulp.task('default', gulp.parallel(['minify-css', 'minify-js']));