<?php
/**
 * The header for our theme
 *
 * This is the template that displays all of the <head> section and everything up until <div id="content">
 *
 * @link https://developer.wordpress.org/themes/basics/template-files/#template-partials
 *
 * @package Affiliate_Booster
 */

?>
<!doctype html>
<html <?php language_attributes(); ?>>
<head>
	<meta charset="<?php bloginfo( 'charset' ); ?>">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="profile" href="https://gmpg.org/xfn/11">
	<?php if (get_theme_mod( 'site_identity_site_icon_settings', '' ) == '') {
		?>
		<link rel="icon" href="<?php echo esc_url( get_template_directory_uri(). '/images/wordpress-favicon.png' ); ?>" type="image/x-icon" />
		<?php
	}else{
		?>
		<link rel="icon" href="<?php echo esc_url( get_theme_mod( 'site_identity_site_icon_settings', '' ) ); ?>" type="image/x-icon" />
		<?php
	} ?>
	
	<?php if ( is_singular() && pings_open( get_queried_object() ) ) : ?>
	<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>">
	<?php endif; ?>
	<?php wp_head(); ?>
	<?php echo wp_specialchars_decode(get_theme_mod('cust_scr_head', '')); ?>
	
	<style>
		.aff-site-content{padding-top: <?php echo esc_attr(get_theme_mod( 'container_top_padding', '60' )).'px'; ?>}
	</style>
	<?php 
	if ( is_single() || 'post' == get_post_type() || is_page() ) {
		echo get_post_meta( get_the_ID(), '_header_code', true );
	}
	?>
</head>
<body <?php body_class(); ?> <?php aff_do_microdata( 'body' ); ?>>

	<?php wp_body_open(); ?>
		<div id="page" class="site <?php if ( true == get_theme_mod( 'aff_header_setting_fixed', false ) ){ echo 'fixed-header'; }?>">
			<a class="skip-link screen-reader-text" href="#primary"><?php esc_html_e( 'Skip to content', 'affiliatebooster' ); ?></a>
			<?php get_header(); ?>
			<?php
				$options = get_post_meta( get_the_ID(), 'aff_booster_options', true );
				$remove_header = $options ? in_array( 'remove-header', $options ) : false; 
			?>
	<?php if ( ( is_singular() && $remove_header ) || ( is_page() && $remove_header ) ) { 
		//no single header ?>
					<?php } else { ?>
							<header id="header" class="aff-site-header hidden-md-down aff-header-shadow" <?php aff_do_microdata( 'header' ); ?>>
							<?php $heads = get_theme_mod( 'aff_header_setting', '' );
								$heads = (string) $heads;if ( '' !== $heads ) {
									get_template_part( 'headers/'.$heads);
								}else{
									get_template_part( 'headers/header1'); }
							?>
							<!--mobile nav menu-->
							<div class="aff-sidebar-action-wrapperr flex_menu <?php echo $heads?>" style="display:none;">
								<!-- <span class="aff-action-close">
									<i class="fa fa-times" aria-hidden="true"></i>
								</span> -->
								<div class="aff-sidebar-action-inside">
									<div class="hidden-lg-up widget6 aff-box widget_nav_menu">
										<?php if ( has_nav_menu( 'header-menu' ) ) {
											wp_nav_menu( array( 'theme_location' => 'header-menu', 'container'=> '', 'menu_class' => 'aff-mobile-menu' ) );
										} ?>
									</div>
								</div>
							</div>
							<div class="aff-sidebar-action-wrapperr flex_menu_secondary <?php echo $heads?>" style="display:none;">
								<div class="aff-sidebar-action-inside">
									<div class="hidden-lg-up widget6 aff-box widget_nav_menu">
										<?php if ( has_nav_menu( 'secondary-menu' ) ) {
											wp_nav_menu( array( 'theme_location' => 'secondary-menu', 'container'=> '', 'menu_class' => 'aff-mobile-menu' ) );
										} ?>
									</div>
								</div>
							</div>
						</header>
						<div id="below_header" class="container-fluid">
							<?php if ( is_active_sidebar( 'below_header' ) ) : ?>
							    <?php dynamic_sidebar( 'below_header' ); ?>
							<?php endif; ?>
						</div>
						
				<?php	} ?>


