<?php 
add_action( 'show_user_profile', 'extra_user_profile_fields' );
add_action( 'edit_user_profile', 'extra_user_profile_fields' );

function extra_user_profile_fields( $user ) { ?>
    <h3><?php _e("Extra profile information", "affiliatebooster"); ?></h3>

    <table class="form-table">
    <tr>
        <th><label for="fb"><?php _e("Facebook", "affiliatebooster"); ?></label></th>
        <td>
            <input type="text" name="facebook" id="fb" value="<?php echo esc_attr( get_the_author_meta( 'facebook', $user->ID ) ); ?>" class="regular-text" /><br />
            <span class="description"><?php _e("Facebook Profile Link.", "affiliatebooster"); ?></span>
        </td>
    </tr>
    <tr>
        <th><label for="twitter"><?php _e("Twitter", 'affiliatebooster'); ?></label></th>
        <td>
            <input type="text" name="twitter" id="twitter" value="<?php echo esc_attr( get_the_author_meta( 'twitter', $user->ID ) ); ?>" class="regular-text" /><br />
            <span class="description"><?php _e("Twitter Profile Link", "affiliatebooster"); ?></span>
        </td>
    </tr>
    <tr>
    <th><label for="instagram"><?php _e("Instagram", "affiliatebooster"); ?></label></th>
        <td>
            <input type="text" name="instagram" id="instagram" value="<?php echo esc_attr( get_the_author_meta( 'instagram', $user->ID ) ); ?>" class="regular-text" /><br />
            <span class="description"><?php _e("Instagram Profile Link", "affiliatebooster"); ?></span>
        </td>
    </tr>
    <tr>
    <th><label for="pinterest"><?php _e("Pinterest", "affiliatebooster"); ?></label></th>
        <td>
            <input type="text" name="pinterest" id="pinterest" value="<?php echo esc_attr( get_the_author_meta( 'pinterest', $user->ID ) ); ?>" class="regular-text" /><br />
            <span class="description"><?php _e("Pinterest Profile Link", "affiliatebooster"); ?></span>
        </td>
    </tr>
    <tr>
    <!-- <th><label for="googleplus"><?php //_e("Google Plus", "affiliatebooster"); ?></label></th>
        <td>
            <input type="text" name="googleplus" id="googleplus" value="<?php //echo esc_attr( get_the_author_meta( 'googleplus', $user->ID ) ); ?>" class="regular-text" /><br />
            <span class="description"><?php //_e("Google Plus Email", "affiliatebooster"); ?></span>
        </td>
    </tr> -->
    </table>
<?php }

add_action( 'personal_options_update', 'save_extra_user_profile_fields' );
add_action( 'edit_user_profile_update', 'save_extra_user_profile_fields' );

function save_extra_user_profile_fields( $user_id ) {
    if ( !current_user_can( 'edit_user', $user_id ) ) { 
        return false; 
    }
    update_user_meta( $user_id, 'facebook', $_POST['facebook'] );
    update_user_meta( $user_id, 'twitter', $_POST['twitter'] );
    update_user_meta( $user_id, 'instagram', $_POST['instagram'] );
    update_user_meta( $user_id, 'pinterest', $_POST['pinterest'] );
    /*update_user_meta( $user_id, 'googleplus', $_POST['googleplus'] );*/
}