<?php
function license_kirki_activation_custom_message_print_templates() {
    ?>
    <script type="text/html" id="tmpl-license-kirki-activation-custom-message">
        <p class="license-kirki-activation-custom-message"><?php esc_html_e( 'Please activate your license key to use theme\'s customization features.', 'affiliatebooster' ) ?>
            <a class="btn-activate-theme" target="_blank" href="<?php echo esc_url( home_url().'/wp-admin/themes.php?page=affiliatebooster' ); ?>">Activate Theme</a>
        </p>
    </script>
    <?php
}

function license_kirki_activation_custom_message_enqueue_scripts() {
    wp_enqueue_script(
        'license-kirki-activation-custom-message',
        get_template_directory_uri() . '/dist/js/license-kirki-activation-custom-message.min.js',
        ['jquery']
    );
}



add_action( 'init', function() {
    $license = get_option('affiliate_booster_theme_license_key');
    if ($license){
        $status = get_option('affiliate_booster_theme_license_key_status');
    }else {
        $status = false;
    }

    if (class_exists('Kirki') && $status !== false && $status == 'valid' && $license !== '') {

        $affiliateBoosterTheme = 'aff_booster_config';

        Kirki::add_config($affiliateBoosterTheme, [
            'option_type' => 'theme_mod',
            'capability' => 'edit_theme_options'
        ]);
        /**
         * Add Panel
         */
        Kirki::add_panel( 'affiliate_booster_options_panel', array(
            'priority'    => 10,
            'title'       => __( 'AffiliateBooster Theme Panel', 'affiliatebooster' ),
            'description' => __( 'Kirki integration for AffiliateBooster', 'affiliatebooster' ),
        ) );

        //Global Options
        Kirki::add_panel( 'affiliate_booster_global_options', array(
            'title'    => __( 'Global Options', 'affiliatebooster' ),
            'priority' => 5,
            'panel'       => 'affiliate_booster_options_panel'
        ) );
        // Container Width
        Kirki::add_section( 'affiliate_booster_global_container', array(
            'title'         => __( 'Container', 'affiliatebooster' ),
            'priority'      => 10,
            'panel'         => 'affiliate_booster_global_options'
        ) );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'select',
            'settings'    => 'aff_container_dropdown_settings',
            'label'       => esc_html__( 'Select Container', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_global_container',
            'default'     => 'full',
            'placeholder' => esc_html__( 'Select an option...', 'affiliatebooster' ),
            'priority'    => 10,
            'multiple'    => 1,
            'choices'     => [
                'full' => esc_html__( 'Full Width', 'affiliatebooster' ),
                'contained' => esc_html__( 'Contained', 'affiliatebooster' ),
            ],
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'number',
            'settings'    => 'aff_booster_container',
            'label'       => esc_html__( 'Container Width', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_global_container',
            'default'     => 1350,
            'choices'     => [
                'min'  => 0,
                'max'  => 1450,
                'step' => 1,
            ],
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'number',
            'settings'    => 'container_top_padding',
            'label'       => esc_html__( 'Container Top Padding', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_global_container',
            'default'     => 60,
            'choices'     => [
                'min'  => 0,
                'max'  => 200,
                'step' => 1,
            ],
            
        ] );

        Kirki::add_section( 'affiliate_booster_global_options_body_bgcolor', array(
            'title'    => __( 'Body Background Color', 'affiliatebooster' ),
            'priority' => 10,
            'panel'       => 'affiliate_booster_global_options'
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'background',
            'settings'    => 'global_body_bgcolor',
            'label'       => esc_html__( 'Body Background Control', 'affiliatebooster' ),
            'description' => esc_html__( 'You can choose which background to use for body', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_global_options_body_bgcolor',
            'default'     => [
                'background-color'      => '#f3f3f3',
                'background-image'      => '',
                'background-repeat'     => 'repeat',
                'background-position'   => 'center center',
                'background-size'       => 'cover',
                'background-attachment' => 'scroll',
            ],
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => 'body, .home, .single, .page, .archive, search, error404, category'
                ],
            ],
        ] );
        Kirki::add_section( 'affiliate_booster_global_options_content_bgcolor', array(
            'title'    => __( 'Content Background Color', 'affiliatebooster' ),
            'priority' => 10,
            'panel'       => 'affiliate_booster_global_options'
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'background',
            'settings'    => 'global_conent_bgcolor',
            'label'       => esc_html__( 'Content Background Color Control', 'affiliatebooster' ),
            'description' => esc_html__( 'You can choose which background to use for content', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_global_options_content_bgcolor',
            'default'     => [
                'background-color'      => '#ffffff',
                'background-image'      => '',
                'background-repeat'     => 'repeat',
                'background-position'   => 'center center',
                'background-size'       => 'cover',
                'background-attachment' => 'scroll',
            ],
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.main-content, .col-md-12.main-content.full-layout-posts, .col-md-12.main-content.full-layout-page, .single-post .sidebars > ul, .home .sidebars > ul, .blog .sidebars > ul, .category .sidebars > ul, .col-md-8.single-blog-excerpt .aff-single-content-bg,
                    .page .sidebars > ul, .archive .sidebars > ul, .search .sidebars > ul, .error404 .sidebars > ul'
                ],
            ],
        ] );

        // Site Identity
        Kirki::add_section( 'affiliate_booster_site_identity_option', array(
            'title'    => __( 'Site Identity/Logo', 'affiliatebooster' ),
            'priority' => 10,
            'panel'       => 'affiliate_booster_options_panel'
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'toggle',
            'settings'    => 'switch_setting_for_default_logo',
            'label'       => esc_html__( 'Enable/Disable Default Logo', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_site_identity_option',
            'default'     => '1',
            'priority'    => 8,
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'     => 'text',
            'settings' => 'site_identity_text_settings',
            'label'    => esc_html__( 'Site Title', 'affiliatebooster' ),
            'section'  => 'affiliate_booster_site_identity_option',
            'default'  => get_bloginfo( 'name' ),
            'priority' => 10,
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'checkbox',
            'settings'    => 'site_identity_hide_title_settings',
            'label'       => esc_html__( 'Hide Title', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_site_identity_option',
            'default'     => false,
            'priority'    => 20,
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'     => 'text',
            'settings' => 'site_identity_tagline_settings',
            'label'    => esc_html__( 'Tagline', 'affiliatebooster' ),
            'section'  => 'affiliate_booster_site_identity_option',
            'default'  => get_bloginfo( 'description' ),
            'priority' => 30,
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'checkbox',
            'settings'    => 'site_identity_hide_tagline_settings',
            'label'       => esc_html__( 'Hide Tagline', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_site_identity_option',
            'default'     => false,
            'priority'    => 40,
        ] );
		
		// Header background Color
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'background',
            'settings'    => 'header_bgcolor',
            'label'       => esc_html__( 'Header Background Color', 'affiliatebooster' ),
            'description' => esc_html__( 'You can choose which background to use on header', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_site_identity_option',
            'priority'    => 9,
            'default'     => [
                'background-color'      => '#ffffff',
                'background-image'      => '',
                'background-repeat'     => 'repeat',
                'background-position'   => 'center center',
                'background-size'       => 'cover',
                'background-attachment' => 'scroll',
            ],
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.aff-header-wrapper'
                ],
            ],
        ] );
		
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'site_identity_typhography_settings',
            'label'       => esc_html__( 'Select Site Title Typography', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_site_identity_option',
            'default'     => [
                'font-family'    => 'inherit',
                'variant'        => 'regular',
                'font-size'      => '',
                'line-height'    => '',
                'letter-spacing' => '',
                'color'          => '#000000',
                'text-transform' => '',
            ],
            'priority'    => 50,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.aff-header-1 span.site-title.h2 a, .aff-header-3 span.site-title.h2 a, .aff-header-5 span.site-title.h2 a',
                ],
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'site_identity_tagline_typhography_settings',
            'label'       => esc_html__( 'Select Tagline Typography', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_site_identity_option',
            'default'     => [
                'font-family'    => 'inherit',
                'variant'        => '',
                'font-size'      => '',
                'line-height'    => '',
                'letter-spacing' => '',
                'color'          => '#000000',
                'text-transform' => '',
                /*'text-align'     => '',*/
            ],
            'priority'    => 51,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.aff-header-1 p.site-description, .aff-header-3 p.site-description, .aff-header-5 p.site-description',
                ],
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'image',
            'settings'    => 'site_identity_site_logo_settings',
            'label'       => esc_html__( 'Site Logo', 'affiliatebooster' ),
            'description' => esc_html__( 'Recommended Logo Size: 220px x 100px', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_site_identity_option',
            'default'     => '',
            'priority'    => 52,
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'slider',
            'settings'    => 'site_identity_image_width_slider_settings',
            'label'       => esc_html__( 'Logo Width (px)', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_site_identity_option',
            'priority'    => 60,
            'default'     => 220,
            'choices'     => [
                'min'  => 0,
                'max'  => 300,
                'step' => 1,
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'image',
            'settings'    => 'site_identity_site_icon_settings',
            'label'       => esc_html__( 'Site Icon', 'affiliatebooster' ),
            'description' => __( '<p>Site Icons are what you see in browser tabs, bookmark bars, and within the WordPress mobile apps. Upload one here!</p> <p>Site Icons should be square and at least 512 × 512 pixels.</p>', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_site_identity_option',
            'default'     => '',
            'priority'    => 70,
        ] );
        
  
        //Advanced Typography
        Kirki::add_panel( 'affiliate_booster_advanced_typography', array(
            'title'    => __( 'Advanced Typography', 'affiliatebooster' ),
            'priority' => 20,
            'panel'       => 'affiliate_booster_global_options'
        ) );
        Kirki::add_section( 'affiliate_booster_global_typography_body', array(
            'title'    => __( 'Global Typography', 'affiliatebooster' ),
            'priority' => 10,
            'panel'       => 'affiliate_booster_advanced_typography'
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type' => 'typography',
            'settings' => 'aff_advanced_typography_global_typhography',
            'label' => esc_html__('Global Typography', 'affiliatebooster'),
            'description'    => esc_html__('Please Select Font Which you like', 'affiliatebooster'),
            'section' => 'affiliate_booster_global_typography_body',
            'default' => [
                'font-family'    => 'Poppins',
                'variant'        => 'regular',
            ],
            'priority' => 10,
            'transport' => 'auto',
            'output' => [
                [
                    'element' => 'body',
                ],
            ],
        ]);
        Kirki::add_field( $affiliateBoosterTheme, [
            'type' => 'typography',
            'settings' => 'aff_advanced_font_global_typhography',
            'label' => esc_html__('Global Font Typography', 'affiliatebooster'),
            // 'description'    => esc_html__('Please Select Font Size Which you like', 'affiliatebooster'),
            'section' => 'affiliate_booster_global_typography_body',
            'default' => [
                // 'font-family'    => 'Poppins',
                'variant'        => 'regular',
                'font-size'      => '18px',
                'line-height'    => '2.0',
                'letter-spacing' => '0',
                // 'color'          => '',
                'text-transform' => '',
                'text-align'     => 'left',
            ],
            'priority' => 10,
            'transport' => 'auto',
            'output' => [
                [
                    'element' => 'body, body div.textwidget, body.home div.cf.aff-entry-content p, body.single-post p, main#content aside ul h4, footer div.aff-widget a, .aff-footer .aff-footer-site-content .widget_categories li a,body .aff-footer .footer-nav-menu ul li a, body .aff-copyright.bottom-footer p, body .aff-copyright.bottom-footer p a, body .aff-header-bottom .aff-main-nav>li>a, body .aff-header-sticky .aff-main-nav>li>a, body .aff-main-nav.aff-7 li>a, body .aff-main-nav.aff-8 li>a, body.single-post p, .relatedposts .related-content p.title, table, table tr, table td',
                ],
            ],
        ]);
        
        Kirki::add_section( 'affiliate_booster_advanced_typography_h1', array(
            'title'    => __( 'Heading 1 (h1)', 'affiliatebooster' ),
            'priority' => 10,
            'panel'       => 'affiliate_booster_advanced_typography'
        ) );
        Kirki::add_field($affiliateBoosterTheme, [
            'type' => 'typography',
            'settings' => 'aff_advanced_typography_h1_settings',
            'label' => esc_html__('Advanced Typography', 'affiliatebooster'),
            'description'    => esc_html__('Please add px with the font size. e.g 16px, 24px', 'affiliatebooster'),
            'section' => 'affiliate_booster_advanced_typography_h1',
            'default' => [
                'font-family'    => 'inherit',
                'variant'        => '700',
                'font-size'      => '',
                'line-height'    => '',
                'letter-spacing' => '0',
                'color'          => '#111111',
                'text-transform' => 'none',
                'text-align'     => 'inherit',
            ],
            'priority' => 10,
            'transport' => 'auto',
            'output' => [
                [
                    'element' => 'body.single h1, body.blog h1, .entry-header > h1.entry-title, .post-content.entry-content > h1, body.page h1, body.single header',
                ],
            ],
            
        ]);
        Kirki::add_section( 'affiliate_booster_advanced_typography_h2', array(
            'title'    => __( 'Heading 2 (h2)', 'affiliatebooster' ),
            'priority' => 20,
            'panel'       => 'affiliate_booster_advanced_typography'
        ) );
        Kirki::add_field($affiliateBoosterTheme, [
            'type' => 'typography',
            'settings' => 'aff_advanced_typography_h2_settings',
            'label' => esc_html__('Advanced Typography', 'affiliatebooster'),
            'description'    => esc_html__('Please add px with the font size. e.g 16px, 24px', 'affiliatebooster'),
            'section' => 'affiliate_booster_advanced_typography_h2',
            'default' => [
                'font-family'    => 'inherit',
                'variant'        => '700',
                'font-size'      => '32px',
                'line-height'    => '',
                'letter-spacing' => '0',
                'color'          => '#111111',
                'text-transform' => 'none',
                'text-align'     => 'inherit',
            ],
            'priority' => 10,
            'transport' => 'auto',
            'output' => [
                [
                    'element' => 'body.single-post h2, body.page h2, .entry-header > h2.entry-title, .post-content.entry-content > h2',
                ],
            ],
        ]);
        Kirki::add_section( 'affiliate_booster_advanced_typography_h3', array(
            'title'    => __( 'Heading 3 (h3)', 'affiliatebooster' ),
            'priority' => 30,
            'panel'       => 'affiliate_booster_advanced_typography'
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type' => 'typography',
            'settings' => 'aff_advanced_typography_h3_settings',
            'label' => esc_html__('Advanced Typography', 'affiliatebooster'),
            'description'    => esc_html__('Please add px with the font size. e.g 16px, 24px', 'affiliatebooster'),
            'section' => 'affiliate_booster_advanced_typography_h3',
            'default' => [
                'font-family'    => 'inherit',
                'variant'        => '700',
                'font-size'      => '30px',
                'line-height'    => '',
                'letter-spacing' => '0',
                'color'          => '#111111',
                'text-transform' => 'none',
                'text-align'     => 'inherit',
            ],
            'priority' => 99,
            'transport' => 'auto',
            'output' => [
                [
                    'element' => 'body.single-post h3, body.page h3, body.blog h3, .entry-header h3.entry-title, .post-content.entry-content > h3',

                ],
            ],
        ]);
        Kirki::add_section( 'affiliate_booster_advanced_typography_h4', array(
            'title'    => __( 'Heading 4 (h4)', 'affiliatebooster' ),
            'priority' => 40,
            'panel'       => 'affiliate_booster_advanced_typography'
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type' => 'typography',
            'settings' => 'aff_advanced_typography_h4_settings',
            'label' => esc_html__('Advanced Typography', 'affiliatebooster'),
            'description'    => esc_html__('Please add px with the font size. e.g 16px, 24px', 'affiliatebooster'),
            'section' => 'affiliate_booster_advanced_typography_h4',
            'default' => [
                'font-family'    => 'inherit',
                'variant'        => '700',
                'font-size'      => '',
                'line-height'    => '',
                'letter-spacing' => '0',
                'color'          => '#111111',
                'text-transform' => 'none',
                'text-align'     => 'inherit',
            ],
            'priority' => 10,
            'transport' => 'auto',
            'output' => [
                [
                    'element' => 'body.single-post h4, body.page h4, body.blog h4, .entry-header > h4.entry-title, .post-content.entry-content > h4, body.category h4, body.search-results h4, body.author h4, main#content aside ul h4',
                ],
            ],
        ]);
        Kirki::add_section( 'affiliate_booster_advanced_typography_h5', array(
            'title'    => __( 'Heading 5 (h5)', 'affiliatebooster' ),
            'priority' => 50,
            'panel'       => 'affiliate_booster_advanced_typography'
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type' => 'typography',
            'settings' => 'aff_advanced_typography_h5_settings',
            'label' => esc_html__('Advanced Typography', 'affiliatebooster'),
            'description'    => esc_html__('Please add px with the font size. e.g 16px, 24px', 'affiliatebooster'),
            'section' => 'affiliate_booster_advanced_typography_h5',
            'default' => [
                'font-family'    => 'inherit',
                'variant'        => '700',
                'font-size'      => '',
                'line-height'    => '',
                'letter-spacing' => '0',
                'color'          => '#111111',
                'text-transform' => 'none',
                'text-align'     => 'inherit',
            ],
            'priority' => 10,
            'transport' => 'auto',
            'output' => [
                [
                    'element' => 'body.single-post h5, body.blog h5, body.page h5, .entry-header > h5.entry-title, .post-content.entry-content > h5',
                ],
            ],
        ]);
        Kirki::add_section( 'affiliate_booster_advanced_typography_h6', array(
            'title'    => __( 'Heading 6 (h6)', 'affiliatebooster' ),
            'priority' => 60,
            'panel'       => 'affiliate_booster_advanced_typography'
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type' => 'typography',
            'settings' => 'aff_advanced_typography_h6_settings',
            'label' => esc_html__('Advanced Typography', 'affiliatebooster'),
            'description'    => esc_html__('Please add px with the font size. e.g 16px, 24px', 'affiliatebooster'),
            'section' => 'affiliate_booster_advanced_typography_h6',
            'default' => [
                'font-family'    => 'inherit',
                'variant'        => '700',
                'font-size'      => '',
                'line-height'    => '',
                'letter-spacing' => '0',
                'color'          => '#111111',
                'text-transform' => 'none',
                'text-align'     => 'inherit',
            ],
            'priority' => 10,
            'transport' => 'auto',
            'output' => [
                [
                    'element' => 'body.single-post h6, body.blog h6, body.page h6, body.category h6, body.author h6, body.search-results h6, .entry-header > h6.entry-title, .post-content.entry-content > h6',
                ],
            ],
        ]);

        
        // Global Colors
        Kirki::add_section( 'affiliate_booster_advanced_typography_link', array(
            'title'    => __( 'Global Colors', 'affiliatebooster' ),
            'priority' => 10,
            'panel'       => 'affiliate_booster_global_options'
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type' => 'typography',
            'settings' => 'aff_advanced_typography_link_settings',
            'label' => esc_html__('Select Link Color', 'affiliatebooster'),
            'section' => 'affiliate_booster_advanced_typography_link',
            'default' => [
                'color'          => '#e84d15',
            ],
            'priority' => 10,
            'transport' => 'auto',
            'output' => [
                [
                    'element' => 'a, body.home a, body.archive a, body.single-post a, body.single a, .post .aff-post-title a, .post .aff-post-title a span, div.related-content p.title, .aff-post-meta-c .aff-post-author>a, body.single-post .entry-meta span a span, .comments-area a, .comments-area a:visited, .widget ul li a, .post-content.entry-content > h1 > a, .post-content.entry-content > h2 > a, .post-content.entry-content > h3 > a, .post-content.entry-content > h4 > a, .post-content.entry-content > h5 > a, .post-content.entry-content > h6 > a, body.single nav.rank-math-breadcrumb a',
                ],
            ],
        ]);
        Kirki::add_field( $affiliateBoosterTheme, [
            'type' => 'typography',
            'settings' => 'aff_advanced_typography_link_hover_settings',
            'label' => esc_html__('Select Link Hover Color', 'affiliatebooster'),
            'section' => 'affiliate_booster_advanced_typography_link',
            'default' => [
                'color'          => '#F18713',
            ],
            'priority' => 10,
            'transport' => 'auto',
            'output' => [
                [
                    
                    'element' => '.aff-post-title-alt a:hover, .post .aff-post-title a span:hover, main#content aside ul li .post div.aff-post-title a span:hover, body.home h2.is-title.aff-post-title-alt a:hover, div.related-content p.title:hover, .aff-copyright.bottom-footer p a:hover, aside a:hover, span.aff-meta-item.aff-post-author a:hover, body.page-template-default.page a:hover',
                    'suffix' => ' !important',
                ],
            ],
        ]);
        Kirki::add_field( $affiliateBoosterTheme, [
            'type' => 'background',
            'settings' => 'aff_advanced_typography_link_visited_settings',
            'label' => esc_html__('Select Button Background Color', 'affiliatebooster'),
            'section' => 'affiliate_booster_advanced_typography_link',
            'default' => [
                'background-color'  => '#2032D8',
            ],
            'priority' => 10,
            'transport' => 'auto',
            'output' => [
                [
                    'element' => 'body.blog button[type="Submit"], body.single-post button[type="Submit"], .aff-comments-area input[type="submit"], a.btn_404',
                ],
            ],
        ]);
        Kirki::add_field( $affiliateBoosterTheme, [
            'type' => 'background',
            'settings' => 'aff_advanced_typography_btn_hover_settings',
            'label' => esc_html__('Select Button Background Hover Color', 'affiliatebooster'),
            'section' => 'affiliate_booster_advanced_typography_link',
            'default' => [
                'background-color'  => '#2032D8',
            ],
            'priority' => 10,
            'transport' => 'auto',
            'output' => [
                [
                    'element' => 'body.blog button[type="Submit"]:hover, body.single-post button[type="Submit"]:hover, .aff-comments-area input[type="submit"]:hover, a.btn_404:hover',
                ],
            ],
        ]);

        // Sidebar Typhography
        Kirki::add_section( 'affiliate_booster_sidebar_typhography', array(
            'title'    => __( 'Sidebar Options', 'affiliatebooster' ),
            'priority' => 10,
            'panel'       => 'affiliate_booster_global_options'
        ) );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'number',
            'settings'    => 'sidebar_custom_width_settings',
            'label'       => esc_html__( 'Set Sidebar width', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_sidebar_typhography',
            'default'     => 400,
            'priority'    => 20,
            'choices'     => [
                'min'  => 0,
                'max'  => 500,
                'step' => 1,
            ],
        ] );
    
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'dimensions',
            'settings'    => 'sidebar_typhography_padding_settings',
            'label'       => esc_html__( 'Sidebar Padding', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_sidebar_typhography',
            'priority'    => 30,
            'default'     => [
                'padding-top'    => '20px',
                'padding-bottom' => '20px',
                'padding-left'   => '20px',
                'padding-right'  => '20px',
            ],
            'transport'   => 'auto',
            'output' => [
                [
                    'element' => 'main#content aside ul:first-child, main#content .col-md-4.sidebars ul:first-child',
                ],
            ],

        ] );

        // Sidebar Typhography
        Kirki::add_section( 'affiliate_booster_readmore_section', array(
            'title'    => __( 'Read More Options', 'affiliatebooster' ),
            'priority' => 11,
            'panel'       => 'affiliate_booster_global_options'
        ) );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'toggle',
            'settings'    => 'homepage_read_more_toggle',
            'label'       => esc_html__( 'Enable/Disable Read More', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_readmore_section',
            'default'     => '0',
            'priority'    => 11,

        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'     => 'text',
            'settings' => 'read_more_text_setting',
            'label'    => esc_html__( 'Change Text For Read More', 'affiliatebooster' ),
            'section'  => 'affiliate_booster_readmore_section',
            'default'  => esc_html__( 'Read More', 'affiliatebooster' ),
            'priority' => 12,
            'active_callback' => [
                [
                    'setting'  => 'homepage_read_more_toggle',
                    'operator' => '==',
                    'value'    => true,
                ]
            ],
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio-buttonset',
            'settings'    => 'radio_text_and_button_setting',
            'label'       => esc_html__( 'Select Type of Read More Button', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_readmore_section',
            'default'     => 'text',
            'priority'    => 13,
            'choices'     => [
                'text'   => esc_html__( 'Text', 'affiliatebooster' ),
                'button' => esc_html__( 'Button', 'affiliatebooster' ),
            ],
            'active_callback' => [
                [
                    'setting'  => 'homepage_read_more_toggle',
                    'operator' => '==',
                    'value'    => true,
                ]
            ],
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'read_more_background_color',
            'label'       => __( 'Read More Background Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_readmore_section',
            'priority'    => 14,
            'default'     => '#000000',
            'output' => array(
                array(
                    'element'  => 'p.readmore_button a',
                    'property' => 'background',
                ),
            ),
            'active_callback' => [
                [
                    'setting'  => 'homepage_read_more_toggle',
                    'operator' => '==',
                    'value'    => true,
                ],
                [
                    'setting'  => 'radio_text_and_button_setting',
                    'operator' => '==',
                    'value'    => 'button',
                ]
            ],
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'read_more_typography_setting',
            'label'       => esc_html__( 'Read More Button Typography', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_readmore_section',
            'default'     => [
                'font-size'      => '12px',
                'color'          => '#fff',
                'text-transform' => 'none',
                'text-align'     => 'left',
            ],
            'priority'    => 15,
            'transport'   => 'auto',
            'output' => array(
                array(
                    'element'  => 'p.readmore_button, p.readmore_button a',
                    'suffix'   => '!important', 
                ),
            ),
            'active_callback' => [
                [
                    'setting'  => 'homepage_read_more_toggle',
                    'operator' => '==',
                    'value'    => true,
                ],
                [
                    'setting'  => 'radio_text_and_button_setting',
                    'operator' => '==',
                    'value'    => 'button',
                ]
            ],
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'dimensions',
            'settings'    => 'read_more_dimensions_setting',
            'label'       => esc_html__( 'Read More Button Padding', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_readmore_section',
            'priority'    => 16,
            'default'     => [
                'padding-top'    => '10px',
                'padding-bottom' => '10px',
                'padding-left'   => '10px',
                'padding-right'  => '10px',
            ],
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => 'p.readmore_button a',
                    'suffix'  => '!important',
                ],
            ],
            'active_callback' => [
                [
                    'setting'  => 'homepage_read_more_toggle',
                    'operator' => '==',
                    'value'    => true,
                ],
                [
                    'setting'  => 'radio_text_and_button_setting',
                    'operator' => '==',
                    'value'    => 'button',
                ]
            ],

        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'read_more_text_typography_setting',
            'label'       => esc_html__( 'Read More Text Typography', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_readmore_section',
            'default'     => [
                'variant'        => 'regular',
                'font-size'      => '14px',
                'color'          => '#000000',
                'text-transform' => 'none',
                'text-align'     => 'left',
            ],
            'priority'    => 16,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => 'p.readmore_text, p.readmore_text a',
                    'suffix'  => '!important',
                ],
            ],
            'active_callback' => [
                [
                    'setting'  => 'homepage_read_more_toggle',
                    'operator' => '==',
                    'value'    => true,
                ],
                [
                    'setting'  => 'radio_text_and_button_setting',
                    'operator' => '==',
                    'value'    => 'text',
                ]
            ],
        ] );

        //Header Option Section
        Kirki::add_section( 'affiliate_booster_header', array(
            'title'    => __( 'Header Layouts', 'affiliatebooster' ),
            'description'    => 'You can choose what is displayed on the your site. Different Header options we have on our theme.',
            'priority' => 30,
            'panel'       => 'affiliate_booster_layouts_all'
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'toggle',
            'settings'    => 'aff_header_sticky_settings',
            'label'       => esc_html__( 'Make Header Sticky', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_header',
            'default'     => '0',
            'priority'    => 9,

        ] );
        //Setting header section
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio',
            'settings'    => 'aff_header_setting',
            'label'       => esc_html__( 'Select Header', 'affiliatebooster' ),
            'description' => __('You can choose Different header layout along with search Icon', 'affiliatebooster'),
            'section'     => 'affiliate_booster_header',
            'default'     => 'header1',
            'priority'    => 30,
            'choices'     => [
                'header1'   => [
                    esc_html__( 'Header 1', 'affiliatebooster' ),
                    esc_html__( 'Logo + Secondary Menu', 'affiliatebooster' ),
                ],
                'header3'   => [
                    esc_html__( 'Header 2', 'affiliatebooster' ),
                    esc_html__( 'Centered Logo', 'affiliatebooster' ),
                ],
                'header5'   => [
                    esc_html__( 'Header 3', 'affiliatebooster' ),
                    esc_html__( 'Logo + Banner', 'affiliatebooster' ),
                ],
            ],
        ] );

        //Header Padding
        kirki::add_field($affiliateBoosterTheme,[
            'type'        => 'dimensions',
            'settings'    => 'header_padding_settings',
            'label'       => esc_html__( 'Header Padding', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_header',
            'priority'    => 40,
            'default'     => [
                'padding-top'    => '15px',
                'padding-bottom' => '15px',
                'padding-left'   => '0px',
                'padding-right'  => '0px',
            ],
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.aff-header-wrapper'
                ],
            ],
        ]);


        //Menus
        Kirki::add_panel( 'affiliate_booster_menus', array(
            'title'    => __( 'Menu Options', 'affiliatebooster' ),
            'priority' => 15,
            'panel'       => 'affiliate_booster_options_panel'
        ) );
        //Widget Header Menu and Above Header Menu
        Kirki::add_section( 'affiliate_booster_widget_header_menu', array(
            'title'    => __( 'Above Header Menu', 'affiliatebooster' ),
            'priority' => 10,
            'panel'       => 'affiliate_booster_menus'
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'toggle',
            'settings'    => 'aff_header_setting_fixed_top',
            'label'       => esc_html__( 'Sticky Above Header Menu', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_widget_header_menu',
            'default'     => '0',
            'priority'    => 10,
        ] );
        
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'aff_widget_header_menu_typography_header_v2',
            'label'       => esc_html__( 'Above Header Menu Typography', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_widget_header_menu',
            'default'     => [
                'font-family'    => 'Poppins',
                'variant'        => 'regular',
                'font-size'      => '16px',
                // 'line-height'    => '',
                'letter-spacing' => '0',
                'color'          => '#fff',
                'text-transform' => 'none',
            ],
            'priority'    => 20,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.aff-ad.clickable .widget_nav_menu ul>li>a, .above-header-menu ul>li>a, .above-header-mobile-menu',
                ],
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'aff_widget_header_menu_link_hover',
            'label'       => __( 'Color Control (hex-only)', 'affiliatebooster' ),
            'description' => esc_html__( 'Hover For Above Widget Header Menu Links', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_widget_header_menu',
            'default'     => '#ff780e',
            'transport'   => 'auto',
            'priority'    => 30,
            'output' => array(
                array(
                    //.widget_pages ul>li>a
                    'element'  => '.aff-ad.clickable .widget_nav_menu ul>li>a:hover, .above-header-menu ul>li>a:hover',
                    'property' => 'color',
                ),
            ),
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'dimensions',
            'settings'    => 'above_header_padding_settings',
            'label'       => esc_html__( 'Padding Option', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_widget_header_menu',
            'priority'    => 31,
            'default'     => [
                'padding-top'    => '0px',
                'padding-bottom' => '0px',
                'padding-left'   => '0px',
                'padding-right'  => '0px',
            ],
            'output' => array(
                array(
                    'element'  => '.top-header-parent',
                ),
            ),
        ] );

        // Above Header Social Icons
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'custom',
            'settings'    => 'above_header_social_custom_heading',
            // 'label'    => esc_html__( 'This is the label', 'kirki' ), // optional
            'section'     => 'affiliate_booster_widget_header_menu',
            'default'     => '<h3 style="padding:15px 0px; margin:0; font-size: 18px;">' . __( 'Social Links', 'affiliatebooster' ) . '</h3>',
            'priority'    => 32,
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'toggle',
            'settings'    => 'social_icon_show_hide_setting',
            'label'       => esc_html__( 'Show/Hide Social Icons', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_widget_header_menu',
            'default'     => '0',
            'priority'    => 33,
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'     => 'link',
            'settings' => 'above_header_fb_link',
            'label'    => __( 'Facebook Link', 'affiliatebooster' ),
            'section'  => 'affiliate_booster_widget_header_menu',
            'default'  => '',
            'priority' => 34,
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'fb_icon_hover_color_setting',
            'label'       => __( 'Change Facebook Icons Hover Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_widget_header_menu',
            'default'     => '#187CDD',
            'priority'    => 35,
            'output' => array(
                array(
                    'element'  => 'i.fab.fa-facebook-f:hover',
                    'property' => 'color',
                ),
            )
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'     => 'link',
            'settings' => 'above_header_twitter_link',
            'label'    => __( 'Twitter Link', 'affiliatebooster' ),
            'section'  => 'affiliate_booster_widget_header_menu',
            'default'  => '',
            'priority' => 36,
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'twittter_icon_hover_color_setting',
            'label'       => __( 'Change Twitter Icons Hover Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_widget_header_menu',
            'default'     => '#0AA3ED',
            'priority'    => 37,
            'output' => array(
                array(
                    'element'  => 'i.fab.fa-twitter:hover',
                    'property' => 'color',
                ),
            )
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'     => 'link',
            'settings' => 'above_header_ins_link',
            'label'    => __( 'Instagram Link', 'affiliatebooster' ),
            'section'  => 'affiliate_booster_widget_header_menu',
            'default'  => '',
            'priority' => 38,
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'instagram_icon_hover_color_setting',
            'label'       => __( 'Change Instagram Icons Hover Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_widget_header_menu',
            'default'     => '#DB3662',
            'priority'    => 39,
            'output' => array(
                array(
                    'element'  => 'i.fab.fa-instagram:hover',
                    'property' => 'color',
                ),
            )
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'     => 'link',
            'settings' => 'above_header_linkedin_link',
            'label'    => __( 'LinkedIn Link', 'affiliatebooster' ),
            'section'  => 'affiliate_booster_widget_header_menu',
            'default'  => '',
            'priority' => 39,
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'linkedin_icon_hover_color_setting',
            'label'       => __( 'Change LinkedIn Icons Hover Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_widget_header_menu',
            'default'     => '#0E76a8',
            'priority'    => 39,
            'output' => array(
                array(
                    'element'  => 'i.fab.fa-linkedin-in:hover',
                    'property' => 'color',
                ),
            )
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'     => 'link',
            'settings' => 'above_header_pin_link',
            'label'    => __( 'Pinterest Link', 'affiliatebooster' ),
            'section'  => 'affiliate_booster_widget_header_menu',
            'default'  => '',
            'priority' => 40,
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'pinterest_icon_hover_color_setting',
            'label'       => __( 'Change Pinterest Icons Hover Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_widget_header_menu',
            'default'     => '#C41F25',
            'priority'    => 41,
            'output' => array(
                array(
                    'element'  => 'i.fab.fa-pinterest-p:hover',
                    'property' => 'color',
                ),
            )
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'     => 'link',
            'settings' => 'above_header_youtube_link',
            'label'    => __( 'Youtube Link', 'affiliatebooster' ),
            'section'  => 'affiliate_booster_widget_header_menu',
            'default'  => '',
            'priority' => 42,
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'youtube_icon_hover_color_setting',
            'label'       => __( 'Change Youtube Icons Hover Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_widget_header_menu',
            'default'     => '#F80003',
            'priority'    => 43,
            'output' => array(
                array(
                    'element'  => 'i.fab.fa-youtube:hover',
                    'property' => 'color',
                ),
            )
        ] );

        /*Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'number',
            'settings'    => 'social_icon_font_size',
            'label'       => esc_html__( 'Change Icon Font Size', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_widget_header_menu',
            'default'     => 20,
            'priority'    => 44,
            'choices'     => [
                'min'  => 0,
                'max'  => 100,
                'step' => 1,
            ],
        ] );*/

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'slider',
            'settings'    => 'social_icon_font_size',
            'label'       => esc_html__( 'Change Icon Font Size', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_widget_header_menu',
            'priority'    => 44,
            'default'     => 20,
            'choices'     => [
                'min'  => 15,
                'max'  => 25,
                'step' => 1,
            ],
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'social_icon_color_setting',
            'label'       => __( 'Change Icons Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_widget_header_menu',
            'default'     => '#fff',
            'priority'    => 45,
            'output' => array(
                array(
                    'element'  => 'p.font-social a i',
                    'property' => 'color',
                ),
            )
        ] );

        /*Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'social_icon_hover_color_setting',
            'label'       => __( 'Change Icons Hover Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_widget_header_menu',
            'default'     => '',
            'priority'    => 41,
            'output' => array(
                array(
                    'element'  => 'p.font-social a i:hover',
                    'property' => 'color',
                ),
            )
        ] );*/

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio-buttonset',
            'settings'    => 'aff_widget_header_menu_position',
            'label'       => esc_html__( 'Menu Alignment', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_widget_header_menu',
            'default'     => 'left',
            'priority'    => 10,
            'transport' => 'auto',
            'choices'     => [
                'left'   => esc_html__( 'Left', 'affiliatebooster' ),
                /*'center' => esc_html__( 'Center', 'affiliatebooster' ),*/
                'right' => esc_html__( 'Right', 'affiliatebooster' ),
            ],
            /*'output' => array(
                array(
                    'element'  => '.above-header-menu, .above-header-mobile-menu',
                    'property' => 'text-align',
                ),
            )*/
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'multicolor',
            'settings'    => 'aff_widget_header_menu_bg_color',
            'label'       => esc_html__( 'Menu Background Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_widget_header_menu',
            'priority'    => 10,
            'transport' => 'auto',
            'choices'     => [
                'link'    => esc_html__( 'Background Color', 'affiliatebooster' )
            ],
            'default'     => [
                'link'    => '#333'
            ],
            'output' => array(
                array(
                    'element'  => '.above-header-menu, .above-header-mobile-menu, .top-header-parent',
                    'property' => 'background-color',
                    'suffix'   => ' !important',
                ),
            )
        ] );

        //Primary Menu
        Kirki::add_section( 'affiliate_booster_main_menu', array(
            'title'    => __( 'Primary Menu', 'affiliatebooster' ),
            'priority' => 40,
            'panel'       => 'affiliate_booster_menus',
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'toggle',
            'settings'    => 'aff_header_setting_fixed',
            'label'       => esc_html__( 'Sticky Primary Navigation Menu', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_main_menu',
            'default'     => '0',
            'priority'    => 8,
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'toggle',
            'settings'    => 'aff_main_menu_search_show_hide',
            'label'       => esc_html__( 'Enable/Disable Search', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_main_menu',
            'default'     => '0',
            'priority'    => 9,
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio-buttonset',
            'settings'    => 'aff_widget_primary_menu_position',
            'label'       => esc_html__( 'Menu Alignment', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_main_menu',
            'default'     => 'left',
            'priority'    => 10,
            'transport' => 'auto',
            'choices'     => [
                'left'   => esc_html__( 'Left', 'affiliatebooster' ),
                'center' => esc_html__( 'Center', 'affiliatebooster' ),
                'right' => esc_html__( 'Right', 'affiliatebooster' ),
            ],
            'output' => array(
                array(
                    'element'  => '.aff-header-1 nav.aff-main-navigation, .aff-header-3 nav.aff-main-navigation, .aff-header-5 nav.aff-main-navigation, .aff-header-7 .aff-slot-c, .aff-header-3 .aff-site-header .aff-menu, .aff-header-5 ul.aff-actions.aff-menu, .aff-header-bottom.aff-head1-bottom .aff-slot-c',
                    'property' => 'text-align',
                ),
            )
        ] );
        //this field hided when header option is 'header1' or 'header2'
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'multicolor',
            'settings'    => 'aff_main_menu_bg_color',
            'label'       => esc_html__( 'Menu Background Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_main_menu',
            'priority'    => 10,
            'transport' => 'auto',
            'choices'     => [
                'link'    => esc_html__( 'Background Color', 'affiliatebooster' )
            ],
            'default'     => [
                'link'    => '#212c41'
            ],
            'output' => array(
                array(
                    'element'  => '.aff-header-bottom',
                    'property' => 'background-color',
                ),
            ),
            'active_callback' => array(
                array(
                    'setting'  => 'aff_header_setting',
                    'operator' => '!==',
                    'value'    => 'header1',
                ),
                array(
                    'setting'  => 'aff_header_setting',
                    'operator' => '!==',
                    'value'    => 'header2',
                )
            )
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'multicolor',
            'settings'    => 'header_bg_color_for_header1',
            'label'       => esc_html__( 'Background Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_main_menu',
            'priority'    => 19,
            'choices'     => [
                'background-color'    => esc_html__( 'Background Color', 'affiliatebooster' )
            ],
            'default'     => [
                'background-color'    => '#212c41',
            ],
            'output'      => [
                [
                    'element' => '.aff-header-bottom.aff-head1-bottom',
                ],
            ],
            'active_callback' => array(
                array(
                    'setting'  => 'aff_header_setting',
                    'operator' => '!==',
                    'value'    => 'header3',
                ),
                array(
                    'setting'  => 'aff_header_setting',
                    'operator' => '!==',
                    'value'    => 'header4',
                ),
                array(
                    'setting'  => 'aff_header_setting',
                    'operator' => '!==',
                    'value'    => 'header5',
                ),
                array(
                    'setting'  => 'aff_header_setting',
                    'operator' => '!==',
                    'value'    => 'header6',
                )
            )

        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'aff_main_menu_typography_header_v1',
            'label'       => esc_html__( 'Menu Typography for Header versions 2 and 3', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_main_menu',
            'default'     => [
                'font-family'    => 'Poppins',
                'variant'        => 'regular',
                'font-size'      => '',
                // 'line-height'    => '40px',
                'letter-spacing' => '0',
                'color'          => '#ffffff',
                'text-transform' => 'none',
            ],
            'priority'    => 20,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.aff-header-bottom .aff-main-nav>li>a, .aff-header-sticky .aff-main-nav>li>a, .aff-header-bottom .aff-actions>li>span, span.aff-sidebar-action.bars p',
                    'suffix'  => '!important',
                ],
            ],
            'active_callback' => array(
                array(
                    'setting'  => 'aff_header_setting',
                    'operator' => '!==',
                    'value'    => 'header1',
                ),
                array(
                    'setting'  => 'aff_header_setting',
                    'operator' => '!==',
                    'value'    => 'header2',
                )
            )
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'aff_main_menu_typography_header_v2',
            'label'       => esc_html__( 'Menu Typography for header version 1', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_main_menu',
            'default'     => [
                'font-family'    => 'Poppins',
                'variant'        => 'regular',
                'font-size'      => '16px',
                /*'line-height'    => '',*/
                'letter-spacing' => '0',
                'color'          => '#ffffff',
                'text-transform' => 'none',
            ],
            'priority'    => 20,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.aff-header-1 .aff-main-nav li > a, .aff-header-2 .aff-main-nav li > a, .aff-header-bottom.aff-head1-bottom .aff-slot-c, .aff-header-bottom.aff-head1-bottom .aff-slot-c ul li a, .aff-header-bottom.aff-head1-bottom .aff-slot-r ul li.toggle_menu p',
                ],
            ],
            'active_callback' => array(
                array(
                    'setting'  => 'aff_header_setting',
                    'operator' => '!==',
                    'value'    => 'header3',
                ),
                array(
                    'setting'  => 'aff_header_setting',
                    'operator' => '!==',
                    'value'    => 'header4',
                ),
                array(
                    'setting'  => 'aff_header_setting',
                    'operator' => '!==',
                    'value'    => 'header5',
                ),
                array(
                    'setting'  => 'aff_header_setting',
                    'operator' => '!==',
                    'value'    => 'header6',
                )
            )
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'aff_main_menu_link_hover',
            'label'       => __( 'Color Control (hex-only)', 'affiliatebooster' ),
            'description' => esc_html__( 'Hover For Main Menu Links', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_main_menu',
            'default'     => '#FF780E',
            'transport'   => 'auto',
            'priority'    => 30,
            'output' => array(
                array(
                    'element'  => '.aff-main-nav > li > a:hover, .aff-header-bottom .aff-actions-button > span:hover',
                    'property' => 'color',
                    'suffix' => '!important'
                ),
            )
        ] );

        //Secondary Menu
        Kirki::add_section( 'affiliate_booster_secondary_menu', array(
            'title'    => __( 'Secondary Menu', 'affiliatebooster' ),
            'priority' => 50,
            'panel'       => 'affiliate_booster_menus',
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'toggle',
            'settings'    => 'aff_main_menu_search_show_hide_secondary',
            'label'       => esc_html__( 'Enable/Disable Search', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_secondary_menu',
            'default'     => '0',
            'priority'    => 7,
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio-buttonset',
            'settings'    => 'aff_widget_secondary_menu_position',
            'label'       => esc_html__( 'Menu Alignment', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_secondary_menu',
            'default'     => 'right',
            'priority'    => 8,
            'transport' => 'auto',
            'choices'     => [
                'left'   => esc_html__( 'Left', 'affiliatebooster' ),
                'center' => esc_html__( 'Center', 'affiliatebooster' ),
                'right' => esc_html__( 'Right', 'affiliatebooster' ),
            ],
            'output' => array(
                array(
                    'element'  => '.aff-header-1 .aff-slot-r nav.aff-main-navigation',
                    'property' => 'text-align',
                ),
            )
        ] );
        kirki::add_field($affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'secondary_menu_typo_settings',
            'label'       => esc_html__( 'Menu Typography', 'affiliatebooster' ),
            // 'description' => esc_html__( 'Menu Typography Header versions 7 and 8', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_secondary_menu',
            'priority'    => 10,
            'default'     => [
                'font-family'    => 'inherit',
                'variant'        => 'regular',
                'font-size'      => '',
                // 'line-height'    => '',
                'letter-spacing' => '',
                'color'          => '#111111',
                'text-transform' => 'none',
            ],
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.aff-main-nav.aff-7 li>a, .aff-main-nav.aff-8 li>a, .aff-main-nav.aff-7 li ul.sub-menu li a, span.aff-sidebar-action.bars p, .aff-header-middle span.aff-sidebar-action.bars i.icon-menu, .aff-header-middle span.aff-sidebar-action.bars i.icon-cancel, .aff-header-middle li.aff-actions-button.aff-action-search i.icon-search',
                    /*'suffix'  => ' !important',*/
                ],
            ],
        ]);
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'secondary_menu_hover_color_settings',
            'label'       => __( 'Menu Hover Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_secondary_menu',
            'default'     => '#000000',
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => 'nav ul.aff-main-nav.aff-7 > li > a:hover, .aff-main-nav.aff-7 li ul.sub-menu li a:hover, .aff-header-middle .aff-actions-button > span:hover, .aff-header-middle li.aff-actions-button.aff-action-search i.icon-search:hover',
                    'property' => 'color',
                    'suffix'  => '!important',
                ],
            ],
        ] );
        /*Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'secondary_menu_background_color_settings',
            'label'       => __( 'Menu Background Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_secondary_menu',
            'default'     => '#ffffff',
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '',
                    'property' => 'background-color',
                    
                ],
            ],
        ] );*/

        //Sub Menu
        Kirki::add_section( 'affiliate_booster_sub_menu', array(
            'title'    => __( 'Sub Menu', 'affiliatebooster' ),
            'priority' => 60,
            'panel'       => 'affiliate_booster_menus'
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio-buttonset',
            'settings'    => 'aff_sub_menu_algn_pos',
            'label'       => esc_html__( 'Sub Menu Alignment', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_sub_menu',
            'default'     => 'left',
            'priority'    => 10,
            'transport' => 'auto',
            'choices'     => [
                'left'   => esc_html__( 'Left', 'affiliatebooster' ),
                'center' => esc_html__( 'Center', 'affiliatebooster' ),
                'right' => esc_html__( 'Right', 'affiliatebooster' ),
            ],
            'output' => array(
                array(
                    'element'  => '.aff-main-nav .sub-menu a',
                    'property' => 'text-align',
                ),
            )
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'slider',
            'settings'    => 'aff_sub_menu_width',
            'label'       => esc_html__( 'Width', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_sub_menu',
            'priority'    => 20,
            'transport' => 'auto',
            'default'     => 300,
            'choices'     => [
                'min'  => 0,
                'max'  => 400,
                'step' => 1,
            ],
            'output' => array(
                array(
                    'element'  => '.aff-site-header .sub-menu',
                    'property' => 'width',
                    'units' => 'px'
                ),
            )
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'dimensions',
            'settings'    => 'aff_sub_menu_padding',
            'label'       => esc_html__( 'Padding', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_sub_menu',
            'priority'    => 30,
            'transport' => 'auto',
            'default'     => [
                'top'  => '0px',
                'right' => '10px',
                'left' => '10px',
                'bottom' => '0px',
            ],
            'output' => array(
                array(
                    'element'  => '.aff-main-nav .sub-menu a, .widget_nav_menu .sub-menu a',
                    'property' => 'padding',
                ),
            )
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'multicolor',
            'settings'    => 'aff_sub_menu_links_bg',
            'label'       => esc_html__( 'Drop Down Background Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_sub_menu',
            'priority'    => 40,
            'transport' => 'auto',
            'choices'     => [
                'link'    => esc_html__( 'Background Color', 'affiliatebooster' )
            ],
            'default'     => [
                'link'    => '#ffffff'
            ],
            'output' => array(
                array(
                    'element'  => '.aff-main-nav .sub-menu li',
                    'property' => 'background-color',
                ),
            )
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'multicolor',
            'settings'    => 'aff_sub_menu_links_color',
            'label'       => esc_html__( 'Links Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_sub_menu',
            'priority'    => 50,
            'transport' => 'auto',
            'choices'     => [
                'link'    => esc_html__( 'Color', 'affiliatebooster' )
            ],
            'default'     => [
                'link'    => '#000000'
            ],
            'output' => array(
                array(
                    'element'  => '.aff-main-nav .sub-menu a, .widget_nav_menu .sub-menu a',
                    'property' => 'color',
                    'suffix' => '!important'
                ),
            )
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'multicolor',
            'settings'    => 'aff_sub_menu_links_hover_color',
            'label'       => esc_html__( 'Links Hover Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_sub_menu',
            'priority'    => 60,
            'transport' => 'auto',
            'choices'     => [
                'link'    => esc_html__( 'Color', 'affiliatebooster' )
            ],
            'default'     => [
                'link'    => '#000000'
            ],
            'output' => array(
                array(
                    'element'  => '.aff-main-nav .sub-menu a:hover',
                    'property' => 'color',
                    'suffix' => '!important'
                ),
            )
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'aff_sub_menu_typography',
            'label'       => esc_html__( 'Typography Sub Menu', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_sub_menu',
            'default'     => [
                'font-size'      => '18px',
                'line-height'    => '40px',
                'letter-spacing' => '0',
                'text-transform' => 'capitalize',
            ],
            'priority'    => 70,
            'transport'   => 'auto',
            'output' => array(
                array(
                    'element'  => '.aff-site-header .sub-menu li a'
                )
            )
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'dimension',
            'settings'    => 'aff_sub_menu_duration',
            'label'       => esc_html__( 'Duration Transition', 'affiliatebooster' ),
            'description' => esc_html__( 'Determine a duration for the hover effect in miliseconds.', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_sub_menu',
            'priority'    => 80,
            'default'     => '0.3',
            'transport'   => 'auto',
            'output' => array(
                array(
                    'element'  => '.aff-site-header .sub-menu',
                    'property' => 'transition-duration',
                    'suffix' => 's'
                )
            )
        ] );

         //Footer Menu
         Kirki::add_section( 'affiliate_booster_footer_menu', array(
            'title'    => __( 'Footer Menu', 'affiliatebooster' ),
            'priority' => 50,
            'panel'       => 'affiliate_booster_menus'
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'aff_footer_menu_typography_setting',
            'label'       => esc_html__( 'Footer Menu Typography', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer_menu',
            'default'     => [
                'font-family'    => 'Poppins',
                'variant'        => 'regular',
                'font-size'      => '13px',
                'line-height'    => '1.4',
                'letter-spacing' => '0',
                'text-transform' => 'none',
            ],
            'priority'    => 10,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.aff-footer .footer-nav-menu ul li a',
                    'suffix'  => '!important',
                ],
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'multicolor',
            'settings'    => 'aff_footer_menu_color_setting',
            'label'       => esc_html__( 'Links Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer_menu',
            'priority'    => 20,
            'transport' => 'auto',
            'choices'     => [
                'link'    => esc_html__( 'Color', 'affiliatebooster' )
            ],
            'default'     => [
                'link'    => '#ffffff'
            ],
            'output' => array(
                array(
                    'element'  => '.aff-footer .footer-nav-menu ul li a',
                    'property' => 'color',
                    'suffix' => '!important'
                ),
            )
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'aff_footer_menu_hover_color_setting',
            'label'       => __( 'Color Control (hex-only)', 'affiliatebooster' ),
            'description' => esc_html__( 'Hover For Footer Menu Links', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer_menu',
            'default'     => '#e84d15',
            'transport'   => 'auto',
            'priority'    => 30,
            'output' => array(
                array(
                    'element'  => '.aff-footer .footer-nav-menu ul li a:hover',
                    'property' => 'color',
                    'suffix' => '!important'
                ),
            )
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'footer_footer_menu_settings',
            'label'       => __( 'Select Background Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer_menu',
            'default'     => '',
            'priority'    => 40,
            'transport'   => 'auto',
            'default'     => '#1e73be',
            'output'      => [
                [
                    'element'  => '.aff-footer.footer_footer_menu',
                ],
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'dimensions',
            'settings'    => 'footer_footer_menu_padding_settings',
            'label'       => __( 'Select Footer Menu Padding', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer_menu',
            'priority'    => 50,
            'default'     => [
                'padding-top'    => '10px',
                'padding-bottom' => '10px',
                'padding-left'   => '10px',
                'padding-right'  => '10px',
            ],
            'output'      => [
                [
                    'element'  => '.aff-footer.footer_footer_menu',
                ],
            ],
           
        ] );

        //Layouts
          Kirki::add_panel( 'affiliate_booster_layouts_all', array(
            'title'    => __( 'Layouts', 'affiliatebooster' ),
            'priority' => 20,
            'panel'       => 'affiliate_booster_options_panel'
        ) );

        //Homepage Layout
        Kirki::add_section( 'affiliate_booster_homepage', array(
            'title'    => __( 'Home Page Layout', 'affiliatebooster' ),
            'description'    => __('Desgin Home page with Customize', 'affiliatebooster'),
            'priority' => 60,
            'panel'       => 'affiliate_booster_layouts_all'
        ) );
        /*Kirki::add_field(  $affiliateBoosterTheme, [
            'type'        => 'multicheck',
            'settings'    => 'homepage_layout_info_multicheck',
            'label'       => esc_html__( 'Post Info', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_homepage',
            'default'     => array('option-1', 'option-2'),
            'priority'    => 2,
            'choices'     => [
                'option-1' => esc_html__( 'Show Author Name', 'affiliatebooster' ),
                'option-2' => esc_html__( 'Show Published on', 'affiliatebooster' ),
                'option-3' => esc_html__( 'Show Last Updated', 'affiliatebooster' ),
                'option-4' => esc_html__( 'Show Comment Count', 'affiliatebooster' ),
                'option-5' => esc_html__( 'Show Categories', 'affiliatebooster' ),
            ],
        ] );*/

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'sortable',
            'settings'    => 'sortable_post_info_setting',
            'label'       => esc_html__( 'Post Info', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_homepage',
            'default'     => [
                'option1',
                'option2',
            ],
            'choices'     => [
                'option1' => esc_html__( 'Show Author Name', 'affiliatebooster' ),
                'option2' => esc_html__( 'Show Published on', 'affiliatebooster' ),
                'option3' => esc_html__( 'Show Last Updated', 'affiliatebooster' ),
                'option4' => esc_html__( 'Show Comment Count', 'affiliatebooster' ),
                'option5' => esc_html__( 'Show Categories', 'affiliatebooster' ),
            ],
            'priority'    => 3,
        ] );
        //Homepage Layout Type
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio',
            'settings'    => 'homepage_layout',
            'label'       => esc_html__( 'Homepage Layout', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_homepage',
            'default'     => '1',
            'priority'    => 10,
            'choices'     => [
                '1'   => esc_html__( 'Basic Layout', 'affiliatebooster' ),
                '3'   => esc_html__( 'Basic Layout + Big Featured Image', 'affiliatebooster' ),
                '5'   => esc_html__( 'Wide Featured Images', 'affiliatebooster' ),
                '7'   => esc_html__( 'Grid Layout', 'affiliatebooster' ),
                '8'   => esc_html__( 'Grid Layout + Big Featured Image', 'affiliatebooster' ),
                '10'   => esc_html__( 'Full-width Featured Image', 'affiliatebooster' ),
                '12'   => esc_html__( 'Full-width Grid Layout', 'affiliatebooster' ),
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio-buttonset',
            'settings'    => 'homepage_sidebar_settings',
            'label'       => esc_html__( 'Select Sidebar', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_homepage',
            'default'     => 'right',
            'priority'    => 10,
            'choices'     => [
                'left' => esc_html__( 'Left', 'affiliatebooster' ),
                'right'   => esc_html__( 'Right', 'affiliatebooster' ),
            ],
        ] );
        
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio-buttonset',
            'settings'    => 'homepage_layout_info_separator_type',
            'label'       => esc_html__( 'Select Type of Separator', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_homepage',
            'default'     => '/',
            'priority'    => 4,
            'choices'     => [
                '/'   => esc_html__( '/', 'affiliatebooster' ),
                '-' => esc_html__( '-', 'affiliatebooster' ),
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'number',
            'settings'    => 'homepage_layout_excerpt_length',
            'label'       => esc_html__( 'Excerpt length', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_homepage',
            'priority'    => 20,
            'default'     => 120,
            'choices'     => [
                'min'  => 0,
                'max'  => 200,
                'step' => 10,
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'toggle',
            'settings'    => 'homepage_layout_featured_image',
            'label'       => esc_html__( 'Enable/Disable featured image', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_homepage',
            'default'     => '1',
            'priority'    => 30,
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'dimensions',
            'settings'    => 'homepage_layout_padding',
            'label'       => esc_html__( 'Content Padding', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_homepage',
            'priority'    => 50,
            'transport' => 'auto',
            'default'     => [
                'top'  => '40px',
                'right' => '40px',
                'left' => '40px',
                'bottom' => '40px',
            ],
            'output' => array(
                array(
                    'element'  => '.main-content, .col-md-12.main-content.full-layout-posts, .col-md-12.main-content.full-layout-page',
                    'property' => 'padding',
                ),
            )
        ] );
        // Homepage post title typography
        kirki::add_field($affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'homepage_post_title_typo_settings',
            'label'       => esc_html__( 'Post Title', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_homepage',
            'priority'    => 60,
            'default'     => [
                'font-family'    => 'inherit',
                'variant'        => '700',
                'font-size'      => '24px',
                'line-height'    => '',
                'color'          => '#000000',
                'letter-spacing' => '',
                'text-transform' => '',
                'text-align'     => '',
            ],
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => 'body.home.blog h2, body.home.blog h2 a, body.home.blog h2.is-title.aff-post-title-alt a, body.category h2.is-title.aff-post-title-alt a, body.archive.author h2.is-title.aff-post-title-alt a, body.search-results h2.is-title.aff-post-title-alt a, body.archive.category .aff-post-meta.aff-post-meta-c.aff-post-meta-left.has-below',
                ],
            ],            
        ]);
        // Homepage post excerpt typography
        kirki::add_field($affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'homepage_post_excerpt_typo_settings',
            'label'       => esc_html__( 'Post Excerpt', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_homepage',
            'priority'    => 70,
            'default'     => [
                'font-family'    => 'inherit',
                'variant'        => 'regular',
                'font-size'      => '18px',
                'line-height'    => '',
                'letter-spacing' => '',
                'text-transform' => '',
                'text-align'     => '',
                'color'          => '#111111',
            ],
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => 'body.home div.cf.aff-entry-content p, body.category p.category_excerpt, body.archive.category div.cf.aff-entry-content p, body.search-results div.cf.aff-entry-content p, body.archive.author div.cf.aff-entry-content p, body.category p.category_excerpt',
                ],
            ],            
        ]);
        // Homepage meta info
        kirki::add_field($affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'home_blog_meta_settings',
            'label'       => esc_html__( 'Meta Typography', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_homepage',
            'priority'    => 80,
            'default'     => [
                'font-family'    => 'inherit',
                'variant'        => 'regular',
                'font-size'      => '12px',
                'color'          => '#111111',


            ],
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => 'body.home .meta-title span, body.category .meta-title span, body.archive.category .meta-title span, body.category .meta-title span, body.search-results .meta-title span, body.archive.author .meta-title span',
                ],
            ],
        ]);

        //Homepage pagination color
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'homepage_pagination_color',
            'label'       => esc_html__( 'Pagination Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_homepage',
            'default'     => '#1b3e5a',
            'priority'    => 81,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.page-nav-container a.page-numbers',
                    'property' => 'background-color',
                ],
            ],
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'homepage_pagination__hover_color',
            'label'       => esc_html__( 'Pagination Hover Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_homepage',
            'default'     => '#f9cc29',
            'priority'    => 82,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.page-nav-container a.page-numbers:hover',
                    'property' => 'background-color',
                ],
            ],
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'homepage_pagination__active_color',
            'label'       => esc_html__( 'Pagination Active Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_homepage',
            'default'     => '#f9cc29',
            'priority'    => 83,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.page-nav-container span.page-numbers.current',
                    'property' => 'background-color',
                ],
            ],
        ] );

        //Single post layout
        Kirki::add_section( 'affiliate_booster_singlepost', array(
            'title'    => __( 'Single Post Layout', 'affiliatebooster' ),
            'description'    => 'Select Single Featured Image layout form here area form there',
            'priority' => 70,
            'panel'       => 'affiliate_booster_layouts_all'
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'toggle',
            'settings'    => 'aff_single_post_featured_image',
            'label'       => esc_html__( 'Enable/Disable Featured Image', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_singlepost',
            'default'     => '1',
            'priority'    => 1,
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'toggle',
            'settings'    => 'aff_single_post_author_bio',
            'label'       => esc_html__( 'Enable/Disable Author Bio', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_singlepost',
            'default'     => '1',
            'priority'    => 2,
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'toggle',
            'settings'    => 'single_post_breadcrums_settings',
            'label'       => esc_html__( 'Enable/Disable Breadcrums', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_singlepost',
            'default'     => '1',
            'priority'    => 3,
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'     => 'text',
            'settings' => 'breadcrumbs_home_text',
            'label'    => esc_html__( 'Breadcrums Home Text', 'affiliatebooster' ),
            'section'  => 'affiliate_booster_singlepost',
            'default'  => esc_html__( 'Home', 'affiliatebooster' ),
            'priority' => 3,
            'active_callback' => [
                [
                    'setting'  => 'single_post_breadcrums_settings',
                    'operator' => '===',
                    'value'    => true,
                ],
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'single_post_breadcrums_typhography',
            'label'       => esc_html__( 'Breadcrums Typography', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_singlepost',
            'default'     => [
                'font-family'    => 'inherit',
                'variant'        => 'regular',
                'font-size'      => '14px',
                'line-height'    => '',
                'letter-spacing' => '0',
                'color'          => '#333333',
                'text-transform' => 'none',
                'text-align'     => 'left',
            ],
            'priority'    => 3,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => 'body.single-post #breadcrumbs, body.single-post #breadcrumbs li, body.single #breadcrumbs, body.single #breadcrumbs li, nav.rank-math-breadcrumb a, nav.rank-math-breadcrumb p, nav.rank-math-breadcrumb p span',
                    'suffix'  => ' !important',
                ],
            ],
        ] );
        /*Kirki::add_field(  $affiliateBoosterTheme, [
            'type'        => 'multicheck',
            'settings'    => 'aff_single_post_info_multicheck',
            'label'       => esc_html__( 'Post Info', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_singlepost',
            'default'     => array('option-1', 'option-2'),
            'priority'    => 3,
            'choices'     => [
                'option-1' => esc_html__( 'Show Author Name', 'affiliatebooster' ),
                'option-2' => esc_html__( 'Show Published on', 'affiliatebooster' ),
                'option-3' => esc_html__( 'Show Last Updated', 'affiliatebooster' ),
                'option-4' => esc_html__( 'Show Comment Count', 'affiliatebooster' ),
                'option-5' => esc_html__( 'Show Categories', 'affiliatebooster' ),
            ],
        ] );*/
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'sortable',
            'settings'    => 'sortable_single_post_info_setting',
            'label'       => esc_html__( 'Post Info', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_singlepost',
            'default'     => [
                'option1',
                'option2',
            ],
            'choices'     => [
                'option1' => esc_html__( 'Show Author Name', 'affiliatebooster' ),
                'option2' => esc_html__( 'Show Published on', 'affiliatebooster' ),
                'option3' => esc_html__( 'Show Last Updated', 'affiliatebooster' ),
                'option4' => esc_html__( 'Show Comment Count', 'affiliatebooster' ),
                'option5' => esc_html__( 'Show Categories', 'affiliatebooster' ),
            ],
            'priority'    => 3,
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio-buttonset',
            'settings'    => 'aff_single_post_info_separator_type',
            'label'       => esc_html__( 'Select Type of Separator', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_singlepost',
            'default'     => '/',
            'priority'    => 4,
            'choices'     => [
                '/'   => esc_html__( '/', 'affiliatebooster' ),
                '-' => esc_html__( '-', 'affiliatebooster' ),
            ],
        ] );
        //display if layout1
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio-buttonset',
            'settings'    => 'aff_single_post_image',
            'label'       => esc_html__( 'Featured Image', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_singlepost',
            'default'     => 'below-title',
            'priority'    => 10,
            'choices'     => [
                'below-title'   => esc_html__( 'Below Title', 'affiliatebooster' ),
                'above-title' => esc_html__( 'Above Title', 'affiliatebooster' )
            ],
            'active_callback' => [
                [
                    'setting'  => 'aff_single_layout',
                    'operator' => '!==',
                    'value'    => 'layout2',
                ],  
                [   
                    'setting'  => 'aff_single_layout',  
                    'operator' => '!==',    
                    'value'    => 'layout3',    
                ],
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio-buttonset',
            'settings'    => 'aff_single_title',
            'label'       => esc_html__( 'Post Title', 'affiliatebooster' ),
            'description'   => __('Choose Title Inside or Outside Container', 'affiliatebooster'),
            'section'     => 'affiliate_booster_singlepost',
            'default'     => 'inside',
            'priority'    => 20,
            'choices'     => [
                'inside'   => esc_html__( 'Inside Container', 'affiliatebooster' ),
                'outside' => esc_html__( 'Outside Container', 'affiliatebooster' )
            ],
            'active_callback' => [
                [
                    'setting'  => 'aff_single_layout',
                    'operator' => '!==',
                    'value'    => 'layout2',
                ],  
                [   
                    'setting'  => 'aff_single_layout',  
                    'operator' => '!==',    
                    'value'    => 'layout3',    
                ],
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio-buttonset',
            'settings'    => 'aff_single_layout',
            'label'       => esc_html__( 'Single Post Layout', 'affiliatebooster' ),
            'description'   => __(' Choose Layout for Single post.', 'affiliatebooster'),
            'section'     => 'affiliate_booster_singlepost',
            'default'     => 'layout1',
            'priority'    => 30,
            'choices'     => [
                'layout1'   => esc_html__( 'Layout 1', 'affiliatebooster' ),
                'layout2'   => esc_html__( 'Layout 2', 'affiliatebooster' ),
                'layout3'   => esc_html__( 'Layout 3', 'affiliatebooster' ),
            ],
        ] );
        //display if layout2
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'header_singlepost_bgcolor',
            'label'       => __( 'Header Overlay Color', 'affiliatebooster' ),
            'description' => esc_html__( 'Change header overlay color here.', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_singlepost',
            'default'     => '',
            'priority'    => 31,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.single-post-fluid-bg:after',
                    'property' => 'background-color',
                ],
            ],
            'active_callback' => [
                [
                    'setting'  => 'aff_single_layout',
                    'operator' => '===',
                    'value'    => 'layout2',
                ]
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio-buttonset',
            'settings'    => 'header_singlepost_text_algn_pos',
            'label'       => esc_html__( 'Title Text Alignment', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_singlepost',
            'default'     => 'left',
            'priority'    => 33,
            'transport' => 'auto',
            'choices'     => [
                'left'   => esc_html__( 'Left', 'affiliatebooster' ),
                'center' => esc_html__( 'Center', 'affiliatebooster' ),
                'right' => esc_html__( 'Right', 'affiliatebooster' ),
            ],
            'output' => array(
                array(
                    'element'  => '.single-post-fluid-bg .col, .single-post-fluid-bg .col .aff-post-title.entry-header .entry-title, body.single-post .aff-single-content-bg h1.entry-title, .aff-layout3-heading, body.single-post header.entry-header h1',
                    'property' => 'text-align',
                ),
            ),
            /*'active_callback' => [
                [
                    'setting'  => 'aff_single_layout',
                    'operator' => '!==',
                    'value'    => 'layout1',
                ]
            ],*/
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [ 
            'type'        => 'color',   
            'settings'    => 'background_color_settings',   
            'label'       => __( 'Background Color Top', 'affiliatebooster' ),  
            'section'     => 'affiliate_booster_singlepost',    
            'default'     => '#1b54d9', 
            'choices'     => [  
                'alpha' => true,    
            ],  
            'priority'    => 34,    
            'active_callback' => [  
                [   
                    'setting'  => 'aff_single_layout',  
                    'operator' => '===',    
                    'value'    => 'layout3',    
                ]   
            ],  
        ] );    
         Kirki::add_field( $affiliateBoosterTheme, [    
            'type'        => 'color',   
            'settings'    => 'background_color_settings_bottom',    
            'label'       => __( 'Background Color Bottom', 'affiliatebooster' ),   
            'section'     => 'affiliate_booster_singlepost',    
            'default'     => '#1b54d9', 
            'choices'     => [  
                'alpha' => true,    
            ],  
            'priority'    => 34,    
            'active_callback' => [  
                [   
                    'setting'  => 'aff_single_layout',  
                    'operator' => '===',    
                    'value'    => 'layout3',    
                ]   
            ],  
        ] );    
        /* Kirki::add_field( $affiliateBoosterTheme, array( 
            'type'      => 'slider',    
            'settings'  => 'color_top_position',    
            'label'     => esc_attr__( 'Top Color Position', 'affiliatebooster' ),  
            'section'   => 'affiliate_booster_singlepost',  
            'default'   => 0,   
            'priority'  => 35,  
            'choices'   => array(   
                'min'  => 0,    
                'max'  => 100,  
                'step' => 1,    
            ),  
        ) );    
        Kirki::add_field( $affiliateBoosterTheme, array(    
            'type'      => 'slider',    
            'settings'  => 'color_bottom_position', 
            'label'     => esc_attr__( 'Bottom Color Position', 'affiliatebooster' ),   
            'section'   => 'affiliate_booster_singlepost',  
            'default'   => 0,   
            'priority'  => 35,  
            'choices'   => array(   
                'min'  => 0,    
                'max'  => 100,  
                'step' => 1,    
            ),  
        ) );*/  
        Kirki::add_field( $affiliateBoosterTheme, [ 
            'type'        => 'number',  
            'settings'    => 'height_settings', 
            'label'       => esc_html__( 'Background Height', 'affiliatebooster' ), 
            'section'     => 'affiliate_booster_singlepost',    
            'default'     => 250,   
            'choices'     => [  
                'min'  => 150,  
                'max'  => 500,  
                'step' => 1,    
            ],  
            'priority'    => 35,    
            'active_callback' => [  
                [   
                    'setting'  => 'aff_single_layout',  
                    'operator' => '===',    
                    'value'    => 'layout3',    
                ]   
            ],  
        ] );  

        Kirki::add_field( $affiliateBoosterTheme, [ 
            'type'        => 'number',  
            'settings'    => 'width_settings', 
            'label'       => esc_html__( 'Content Area Width', 'affiliatebooster' ), 
            'section'     => 'affiliate_booster_singlepost',    
            'default'     => 1080,   
            'choices'     => [  
                'min'  => 150,  
                'max'  => 4000,  
                'step' => 1,    
            ],  
            'priority'    => 35,    
            'active_callback' => [  
                [   
                    'setting'  => 'aff_single_layout',  
                    'operator' => '===',    
                    'value'    => 'layout3',    
                ]   
            ],  
        ] );  

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio-image',
            'settings'    => 'aff_sidebar',
            'label'       => esc_html__( 'Select Post Sidebar', 'affiliatebooster' ),
            'description'  => 'Choose different options.These options apply to the entire Single layout.',
            'section'     => 'affiliate_booster_singlepost',
            'default'     => 'right-sidebar',
            'priority'    => 40,
            'choices'     => [
                // 'full-width'    => trailingslashit( Kirki::$url ) . 'assets/images/1c.png',
                // 'left-sidebar'  => trailingslashit( Kirki::$url ) . 'assets/images/2cl.png',
                // 'right-sidebar' => trailingslashit( Kirki::$url ) . 'assets/images/2cr.png',
                'full-width'    => trailingslashit( get_template_directory_uri() ) . '/images/1c.png',
                'left-sidebar'  => trailingslashit( get_template_directory_uri() ) . '/images/2cl.png',
                'right-sidebar' => trailingslashit( get_template_directory_uri() ) . '/images/2cr.png',
            ],
             'active_callback' => [ 
                [   
                    'setting'  => 'aff_single_layout',  
                    'operator' => '!==',    
                    'value'    => 'layout3',    
                ]   
            ],
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'number',
            'settings'    => 'single_post_container_width_no_sidebar',
            'label'       => esc_html__( 'Select width for no sidebar layout', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_singlepost',
            'default'     => 1350,
            'priority'    => 41,
            'choices'     => [
                'min'  => 0,
                'max'  => 1450,
                'step' => 1,
            ],
            'active_callback' => [
                [
                    'setting'  => 'aff_sidebar',
                    'operator' => '==',
                    'value'    => 'full-width',
                ]
            ],
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'content_bgcolor',
            'label'       => __( 'Title Color', 'affiliatebooster' ),
            'description' => esc_html__( 'Change Title Color here.', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_singlepost',
            'default'     => '',
            'priority'    => 60,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.single-post-fluid-bg .aff-post-title-container .entry-title, .single-post-fluid-bg .entry-meta .posted-on a, .single-post-fluid-bg .entry-meta .author-name, .single-post-fluid-bg .aff-post-title-container .entry-meta, .aff-post-title.entry-header .entry-title, .single-post-fluid-bg .entry-meta, .entry-meta span',
                    'property' => 'color'
                ],
            ],
            'active_callback' => [  
                [   
                    'setting'  => 'aff_single_layout',  
                    'operator' => '!==',    
                    'value'    => 'layout3',    
                ]   
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'dimensions',
            'settings'    => 'aff_singlepost_padding',
            'label'       => esc_html__( 'Content Padding', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_singlepost',
            'priority'    => 70,
            'transport' => 'auto',
            'default'     => [
                'top'  => '40px',
                'right' => '40px',
                'left' => '40px',
                'bottom' => '40px',
            ],
            'output' => array(
                array(
                    'element'  => '.col-md-8.single-blog-excerpt .aff-single-content-bg, .col-md-12.single-blog-excerpt .aff-single-content-bg, .main-content.single-page',
                    'property' => 'padding',
                ),
            )
        ] );
        // Single post meta info
        kirki::add_field($affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'single_post_meta_info_settings',
            'label'       => esc_html__( 'Meta Typography', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_singlepost',
            'priority'    => 80,
            'default'     => [
                'font-family'    => 'inherit',
                'variant'        => 'regular',
                'font-size'      => '',
                'color'          => '#111111',
                'text-align'     => 'left',
            ],
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => 'body.single-post .aff-post-title-container .entry-meta, body.single-post .single-post-fluid-bg .col span, body.single-post .single-post-fluid-bg .col .entry-meta, body.single .meta-title .aff-post-meta-left',
                ],
            ],
        ]);

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'single_post_meta_link_color_setting',
            'label'       => __( 'Meta link color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_singlepost',
            'default'     => '#e84d15',
            'priority'    => 90,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => 'body.single-post .entry-meta span a, body.single-post .entry-meta span a span, .entry-meta a, .entry-meta a:visited, body.single-post .meta-title a, body.single-post .meta-title a span',
                    'property' => 'color',
                    'suffix'  => ' !important',
                ],
            ],
        ] );
        
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'single_post_meta_link_hover_color_setting',
            'label'       => __( 'Meta link hover color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_singlepost',
            'default'     => '#f18713',
            'priority'    => 91,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => 'body.single-post .entry-meta span a:hover span, body.single-post .entry-meta span a:hover, .entry-meta a:hover, body.single-post .meta-title a:hover, body.single-post .meta-title a span:hover',
                    'property' => 'color',
                    'suffix'  => ' !important',
                ],
            ],
        ] );


         Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'single_post_breadcrumb_color_setting',
            'label'       => __( 'Breadcrumb color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_singlepost',
            'default'     => '#178133',
            'priority'    => 91,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.bread-link-color a',
                    'property' => 'color',
                    'suffix'  => ' !important',
                ],    //aff_single_layout
            ],
            'active_callback' => [
                [
                    'setting'  => 'aff_single_layout',
                    'operator' => '===',
                    'value'    => 'layout2',
                ]
            ],
        ] );

        //Archive Pages layout
        Kirki::add_section( 'affiliate_booster_blog_archive', array(
            'title'    => __( 'Archive Layout', 'affiliatebooster' ),
            'priority' => 80,
            'panel'       => 'affiliate_booster_layouts_all'
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'toggle',
            'settings'    => 'blog_archive_layout_header',
            'label'       => esc_html__( 'Archive Headline (Show - On/Hide - Off)', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_blog_archive',
            'default'     => '1',
            'priority'    => 9,
        ] );
        /*Kirki::add_field(  $affiliateBoosterTheme, [
            'type'        => 'multicheck',
            'settings'    => 'archive_layout_info_multicheck',
            'label'       => esc_html__( 'Post Info', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_blog_archive',
            'default'     => array('option-1', 'option-2'),
            'priority'    => 10,
            'choices'     => [
                'option-1' => esc_html__( 'Show Author Name', 'affiliatebooster' ),
                'option-2' => esc_html__( 'Show Published on', 'affiliatebooster' ),
                'option-3' => esc_html__( 'Show Last Updated', 'affiliatebooster' ),
                'option-4' => esc_html__( 'Show Comment Count', 'affiliatebooster' ),
                'option-5' => esc_html__( 'Show Categories', 'affiliatebooster' ),
            ],
        ] );*/
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'sortable',
            'settings'    => 'sortable_archive_post_info_setting',
            'label'       => esc_html__( 'Post Info', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_blog_archive',
            'default'     => [
                'option1',
                'option2',
            ],
            'choices'     => [
                'option1' => esc_html__( 'Show Author Name', 'affiliatebooster' ),
                'option2' => esc_html__( 'Show Published on', 'affiliatebooster' ),
                'option3' => esc_html__( 'Show Last Updated', 'affiliatebooster' ),
                'option4' => esc_html__( 'Show Comment Count', 'affiliatebooster' ),
                'option5' => esc_html__( 'Show Categories', 'affiliatebooster' ),
            ],
            'priority'    => 10,
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio',
            'settings'    => 'archive_layout',
            'label'       => esc_html__( 'Archive Layout', 'affiliatebooster' ),
            'description'  => 'Select different layouts of Archive page along with sidebar',
            'section'     => 'affiliate_booster_blog_archive',
            'default'     => '1',
            'priority'    => 11,
            'choices'     => [
                '1'   => esc_html__( 'Basic Layout', 'affiliatebooster' ),
                '3'   => esc_html__( 'Basic Layout + Big Featured Image', 'affiliatebooster' ),
                '5'   => esc_html__( 'Wide Featured Images', 'affiliatebooster' ),
                '7'   => esc_html__( 'Grid Layout', 'affiliatebooster' ),
                '8'   => esc_html__( 'Grid Layout + Big Featured Image', 'affiliatebooster' ),
                '10'   => esc_html__( 'Full-width Featured Image', 'affiliatebooster' ),
                '12'   => esc_html__( 'Full-width Grid Layout', 'affiliatebooster' ),
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio-buttonset',
            'settings'    => 'archive_sidebar_settings',
            'label'       => esc_html__( 'Select Sidebar', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_blog_archive',
            'default'     => 'right',
            'priority'    => 12,
            'choices'     => [
                'left' => esc_html__( 'Left', 'affiliatebooster' ),
                'right'   => esc_html__( 'Right', 'affiliatebooster' ),
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'number',
            'settings'    => 'archive_layout_excerpt_length',
            'label'       => esc_html__( 'Excerpt length', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_blog_archive',
            'priority'    => 13,
            'default'     => 120,
            'choices'     => [
                'min'  => 0,
                'max'  => 200,
                'step' => 10,
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'toggle',
            'settings'    => 'archive_layout_featured_image',
            'label'       => esc_html__( 'Enable/Disable featured image', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_blog_archive',
            'default'     => '1',
            'priority'    => 14,
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'dimensions',
            'settings'    => 'blog_archive_padding',
            'label'       => esc_html__( 'Content Padding', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_blog_archive',
            'priority'    => 15,
            'transport' => 'auto',
            'default'     => [
                'top'  => '40px',
                'right' => '40px',
                'left' => '40px',
                'bottom' => '40px',
            ],
            'output' => array(
                array(
                    'element'  => '.archive .col-md-8.main-content, .archive .col-md-12.main-content.full-layout-posts, .archive .col-md-12.main-content.full-layout-page',
                    'property' => 'padding',
                ),
            )
        ] );

        //Discloser layout
        Kirki::add_section( 'affiliate_booster_discloser_layout', array(
            'title'    => __( 'Disclosure Layout', 'affiliatebooster' ),
            'priority' => 80,
            'panel'       => 'affiliate_booster_layouts_all'
        ) );

        //discolser section
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'toggle',
            'settings'    => 'discloser_on_off_settings',
            'label'       => esc_html__( 'Enable/Disable Disclosure', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_discloser_layout',
            'default'     => '0',
            'priority'    => 90,
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio',
            'settings'    => 'discloser_content_alignment',
            'label'       => esc_html__( 'Disclosure Placement(For single post layout 1)', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_discloser_layout',
            'default'     => 'above-title',
            'priority'    => 91,
            'choices'     => [
                'above-title' => esc_html__( 'Above Title', 'affiliatebooster' ),
                'below-title'   => esc_html__( 'Below Title', 'affiliatebooster' ),
                'below-content' => esc_html__( 'Below Content', 'affiliatebooster' )
            ],
            'active_callback' => [
                [
                    'setting'  => 'aff_single_layout',
                    'operator' => '!==',
                    'value'    => 'layout2',
                ]
            ],
        ] );

        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'radio',
            'settings'    => 'discloser_content_alignment_layout_2',
            'label'       => esc_html__( 'Disclosure Placement(For single post layout 2)', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_discloser_layout',
            'default'     => 'above-content',
            'priority'    => 92,
            'choices'     => [
                'above-content' => esc_html__( 'Above Content', 'affiliatebooster' ),
                'below-content' => esc_html__( 'Below Content', 'affiliatebooster' )
            ],
            'active_callback' => [
                [
                    'setting'  => 'aff_single_layout',
                    'operator' => '==',
                    'value'    => 'layout2',
                ]
            ],
        ] );

        //discolser text
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'     => 'textarea',
            'settings' => 'discolser_text_settings',
            'label'    => esc_html__( 'Disclosure Text', 'affiliatebooster' ),
            'section'  => 'affiliate_booster_discloser_layout',
            // 'default'  => esc_html__( 'Disclosure:', 'affiliatebooster' ),
            'priority' => 93,
        ] );

        //discolser trypography
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'discolser_typography_settings',
            'label'       => esc_html__( 'Disclosure Typography', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_discloser_layout',
            'default'     => [
                'font-family'    => 'inherit',
                'variant'        => 'regular',
                'font-size'      => '18px',
                'line-height'    => '',
                'letter-spacing' => '0',
                'color'          => '#333333',
                'text-transform' => 'none',
            ],
            'output'      => [
                [
                    'element' => 'body.single-post .discloser, body.single .discloser',
                ],
            ],  
            'priority'    => 94,
            'transport'   => 'auto',
        ] );

        //discloser background
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'discloser_background_settings',
            'label'       => __( 'Disclosure Background', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_discloser_layout',
            'default'     => '#f7f7f7',
            'priority'    => 95,
        ] );

        //discloser padding
        Kirki::add_field(  $affiliateBoosterTheme, [
            'type'        => 'dimensions',
            'settings'    => 'discolser_dimensions_settings',
            'label'       => esc_html__( 'Disclosure Padding', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_discloser_layout',
            'default'     => [
                'padding-top'    => '20px',
                'padding-bottom' => '20px',
                'padding-left'   => '20px',
                'padding-right'  => '20px',
            ],
            'priority'    => 93,
            'output'      => [
                [
                    'element' => 'body.single-post .discloser, body.single .discloser',
                ],
            ],  
        ] );

        // 404 Layout
        Kirki::add_section( 'affiliate_booster_404_layout', array(
            'title'    => __( '404 Layout', 'affiliatebooster' ),
            'priority' => 90,
            'panel'       => 'affiliate_booster_layouts_all'
        ) );

         Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'image',
            'settings'    => '404_img_settings',
            'label'       => esc_html__( '404 Image', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_404_layout',
            'default'     => '',
            'priority'    => 52,
        ] );
          Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'slider',
            'settings'    => '404_image_width_slider_settings',
            'label'       => esc_html__( 'Image Width (px)', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_404_layout',
            'priority'    => 60,
            'default'     => 500,
            'choices'     => [
                'min'  => 0,
                'max'  => 500,
                'step' => 1,
            ],
        ] );
        /*Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'button_404_typography_setting',
            'label'       => esc_html__( 'Button Typography', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_404_layout',
            'default'     => [
                'font-family'    => 'inherit',
                'variant'        => 'regular',
                'font-size'      => '18px',
                'line-height'    => '',
                'letter-spacing' => '0',
                'color'          => '#ffffff',
                'text-transform' => 'none',
            ],
            'priority'    => 10,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => 'a.btn_404',
                ],
            ],
        ] );*/

       /* Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'dimensions',
            'settings'    => 'button_404_padding_settings',
            'label'       => esc_html__( 'Button Padding', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_404_layout',
            'default'     => [
                'padding-top'    => '15px',
                'padding-bottom' => '15px',
                'padding-left'   => '30px',
                'padding-right'  => '30px',
            ],
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => 'a.btn_404',
                ],
            ],
        ] );

        */
        //Footer option in cutsomizer
        Kirki::add_section( 'affiliate_booster_footer', array(
            'title'    => __( 'Footer Options', 'affiliatebooster' ),
            'description'  => 'Check if you want to include footer widgetized area in your theme. You can manage the footer content in the <a href="%s">Appearance -> Widgets</a> settings.',
            'priority' => 90,
            'panel'       => 'affiliate_booster_options_panel'
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'select',
            'settings'    => 'aff_footer',
            'label'       => esc_html__( 'Footer columns', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer',
            'default'     => '3_4',
            'placeholder' => esc_html__( 'Select an option...', 'affiliatebooster' ),
            'priority'    => 50,
            'multiple'    => 1,
            'choices'     => [
                        '1_12' => esc_html__( '1', 'affiliatebooster' ),
                        '2_6'  => esc_html__( '2', 'affiliatebooster' ),
                        '3_4'  => esc_html__( '3', 'affiliatebooster' ),
                        '4_3'  => esc_html__( '4', 'affiliatebooster' )
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'toggle',
            'settings'    => 'footer_scroll_top',
            'label'       => esc_html__( 'Show Back To Top', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer',
            'default'     => '0',
            'priority'    => 60,
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'footer_scroll_top_color',
            'label'       => __( 'Back To Top Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer',
            'default'     => '#808080;',
            'priority'    => 70,
                'transport'   => 'auto',
                'output'      => [
                    [
                        'element' => '#smoothup .icon-caret-square-up-solid',
                        'property' => 'color',
                    ],
                ],
                'active_callback'  => array(
                    array(
                      'setting'  => 'footer_scroll_top',
                      'operator' => '==',
                      'value'    => '1',
                    ),
                  )
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'slider',
            'settings'    => 'footer_scroll_top_size',
            'label'       => __( 'Back To Top Size', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer',
            'priority'    => 80,
            'transport' => 'auto',
            'default'     => 35,
            'choices'     => [
                'min'  => 0,
                'max'  => 50,
                'step' => 1,
            ],
            'output' => array(
                array(
                    'element'  => '#smoothup .icon-caret-square-up-solid',
                    'property' => 'font-size',
                    'units' => 'px'
                ),
            ),
            'active_callback'  => array(
                array(
                  'setting'  => 'footer_scroll_top',
                  'operator' => '==',
                  'value'    => '1',
                ),
              )
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'background',
            'settings'    => 'footer_bgcolor',
            'label'       => esc_html__( 'Background Control', 'affiliatebooster' ),
            'description' => esc_html__( 'Background conrols are pretty complex - but extremely useful if properly used.', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer',
            'default'     => [
                'background-color'      => '#f3f3f3',
                'background-image'      => '',
                'background-repeat'     => 'repeat',
                'background-position'   => 'center center',
                'background-size'       => 'cover',
                'background-attachment' => 'scroll',
            ],
            'priority'    => 90,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.aff-footer'
                ],
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'footer_fntcolor',
            'label'       => __( 'Font Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer',
            'default'     => '#000000',
            'priority'    => 100,
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.aff-footer, .aff-footer .aff-footer-site-content .aff-post-title, .aff-footer .aff-footer-site-content .widget_categories li a, .aff-footer .aff-footer-site-content .aff-copyright a, .aff-footer .aff-footer-site-content .aff-post-title a, .aff-footer .aff-footer-site-content .aff-post-title a > span, .aff-footer .aff-footer-site-content .post-date, .aff-footer .aff-footer-site-content .page_item a, .aff-footer .aff-footer-site-content .recentcomments a, .aff-footer .aff-footer-site-content .aff-copyright > p, footer .widget_archive li a, footer div.aff-widget a',
                    'property' => 'color',
                    /*'suffix' => '!important'*/
                ],
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'footer_hd_color',
            'label'       => __( 'Heading Font Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer',
            'default'     => '#000000',
            'priority'    => 110,
                'transport'   => 'auto',
                'output'      => [
                    [
                        'element' => '.aff-footer .aff-widget-title, footer#footer .aff-footer-site-content h3.widget-title',
                        'property' => 'color',
                        'suffix' => '!important'
                    ],
                ],

        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'textarea',
            'settings'    => 'footer_copyright_link',
            'label'       => esc_html__( 'Copyright Footer Code', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer',
            'default'     => 'Copyright &copy; [year] &bull; [sitename] &bull; Powered by [affiliatebooster]',
            'priority' => 120,
        ] );

        kirki::add_field($affiliateBoosterTheme, [
            'type'        => 'typography',
            'settings'    => 'bottom_footer_typography',
            'label'       => esc_html__( 'Copyright Footer Typography', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer',
            'priority' => 130,
            'default'     => [
                'font-family'    => 'inherit',
                'variant'        => 'regular',
                'font-size'      => '',
                'line-height'    => '',
                'letter-spacing' => '',
                'color'          => '#111111',
                'text-transform' => '',
                'text-align'     => 'center',
            ],
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.aff-copyright.bottom-footer p, .aff-copyright.bottom-footer p a',
                    'suffix'  => '!important',
                ],
            ],
        ]);
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'bottom_footer_background_color',
            'label'       => __( 'Select Bottom Footer Background Color', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer',
            'default'     => '#fff1ef',
            'priority'    => 140,
        ] );

        
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'footer_link_hover_color',
            'label'       => __( 'Footer widget Link Hover', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer',
            'default'     => '#f18713',
            'priority'    => 170,
            'output'      =>array(
            array(
                    'element' => '.aff-footer-site-content a:hover',
                    'function' => 'css',
                    'property' => 'color',
                    'suffix' => ' !important',
                ),
            ),
        ] );

         Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'color',
            'settings'    => 'copyright_footer_link_hover_color',
            'label'       => __( 'Copyright Link Hover', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer',
            'default'     => '#f18713',
            'priority'    => 170,
            'output'      =>array(
            array(
                    'element' => 'p.aff-copyright-text a:hover, .aff-copyright.bottom-footer p.aff-copyright-text a:hover',
                    'function' => 'css',
                    'property' => 'color',
                    'suffix' => ' !important',
                ),
            ),
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'dimensions',
            'settings'    => 'bottom_footer_padding_settings',
            'label'       => esc_html__( 'Bottom Footer Padding', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_footer',
            'priority'    => 150,
            'default'     => [
                'padding-top'    => '15px',
                'padding-bottom' => '15px',
                'padding-left'   => '35px',
                'padding-right'  => '35px',
            ],
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.aff-copyright.bottom-footer',
                ],
            ],

        ] );

        //Custom Scripts
        Kirki::add_section( 'affiliate_booster_custom_script', array(
            'title'    => __( 'Custom Scripts', 'affiliatebooster' ),
            'priority' => 100,
            'panel'       => 'affiliate_booster_options_panel'
        ) );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'code',
            'settings'    => 'cust_scr_head',
            'label'       => esc_html__( 'Header Script', 'affiliatebooster' ),
            'description' => esc_html__( 'The code will output immediately before the closing head in the document source', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_custom_script',
            'default'     => '',
            'choices'     => [
                'language' => 'js',
            ],
        ] );
        Kirki::add_field( $affiliateBoosterTheme, [
            'type'        => 'code',
            'settings'    => 'cust_scr_foo',
            'label'       => esc_html__( 'Footer Script', 'affiliatebooster' ),
            'description' => esc_html__( 'The code will output immediately before the closing body in the document source', 'affiliatebooster' ),
            'section'     => 'affiliate_booster_custom_script',
            'default'     => '',
            'choices'     => [
                'language' => 'js',
            ],
        ] );

        //Site Identity
        Kirki::add_field( $affiliateBoosterTheme, array(
            'type'        => 'slider',
            'settings' => 'height-logo',
            'label'    => esc_html__( 'Logo Width (px)', 'affiliatebooster' ),
            'section'  => 'title_tagline',
            'default'     => 220,
            'choices'     => array(
              'min'  => '0',
              'max'  => '300',
              'step' => '1',
            ),
            'transport'   => 'auto',
            'output'      => [
                [
                    'element' => '.aff-logo',
                    'property' => 'width',
                    'suffix' => 'px'
                ],
            ],
            'active_callback'  => array(
              array(
                'setting'  => 'aff_logo',
                'operator' => '!==',
                'value'    => '',
              ),
            )
            ) );
    } else {
        add_action( 'customize_controls_print_footer_scripts', 'license_kirki_activation_custom_message_print_templates' );
        add_action( 'customize_controls_enqueue_scripts', 'license_kirki_activation_custom_message_enqueue_scripts' );
    }
} );

/**
 * Custom CSS for Kirki Controls Panel
 */
function my_customizer_styles() { ?>
    <style>
        #input_global_layout label, #input_aff_sidebar label {
            max-width: 25%;
            margin: 0 5px;
        }
        li#customize-control-secondary_menu_hover_color_settings .iris-slider.iris-strip {
            width: 23px !important;
        }
        .customize-control-kirki-radio-image > #input_homepage_layout, .customize-control-kirki-radio-image > #input_archive_layout {
            margin:-10px;
        }
        .customize-control-kirki-radio-image > #input_homepage_layout > label, .customize-control-kirki-radio-image > #input_archive_layout > label {
            margin: 10px;
        }
        .license-kirki-activation-custom-message {
            background-color: #fff;
            padding: 10px;
            font-weight: 700;
            border-left: 4px #ec0e0e solid;
        }
        .btn-activate-theme {
            display: block;
            text-align: center;
            margin: 10px auto;
            border: 1px solid #000;
            text-decoration: none;
            background-color: #f3f3f3;
        }
        
        <?php if (!class_exists('Kirki')) : ?>
            main#content aside ul h4, body.blog aside h4 {
                font-weight: 700 !important;
            }
            .above-header-menu, .top-header-parent {
                background-color: #333;
            }
            .above-header-menu a {
                color: white;
            }
            ul.sub-menu a {
                color: black;
            }
            ul.sub-menu {
                background-color: white;
            }
        <?php endif; ?>
    </style>
    <?php
}
add_action( 'customize_controls_print_styles', 'my_customizer_styles', 999 );

?>
