<?php
/**
 * The template for displaying all pages
 *
 * This is the template that displays all pages by default.
 * Please note that this is the WordPress construct of pages
 * and that other 'pages' on your WordPress site may use a
 * different template.
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/
 *
 * @package Affiliate_Booster
 */
?>

<?php get_header(); ?>
<?php
$layout = get_theme_mod('aff_single_layout', 'layout1');  
if (empty($layout)) { $layout ='layout1'; }
$sidebar = get_post_meta( get_the_ID(), 'aff_booster_sidebar_position_page', true );
$new_container_meta = get_post_meta( $post->ID, '_mymetaboxname', true );
$main_width = get_theme_mod( 'aff_booster_container', '1350' );
$sidebar_width = get_theme_mod( 'sidebar_custom_width_settings', '400' );
$content_width = $main_width - $sidebar_width - 2;

?>
<style>
 	body main#content div.row {flex-wrap: nowrap;}
 	.later-details ul { margin-left: 30px;	}
	div.col-lg-8.main-content{flex: auto;max-width: <?php echo $content_width.'px'; ?>;}
	aside.col-lg-4.sidebars{flex: auto;max-width: <?php echo $sidebar_width.'px'; ?>;}
	@media only screen and (max-width: 1024px) {
		body main#content div.row {flex-wrap: wrap;}
		aside.col-lg-4.sidebars{max-width: 100%;}
		aside.s_right, aside.s_left {padding-left: 0;margin-top: 20px;}
	}
</style>
<!-- <main id="content" class="container-fluid aff-site-content" style="max-width: <?php echo $main_width.'px'; ?>">
	<div class="row"> -->
	<?php
		if ($sidebar == 'global' || $sidebar == 'right-sidebar') { ?>
			<main id="content" class="container-fluid aff-site-content" style="max-width: <?php echo $main_width.'px'; ?>">
				<div class="row">
					<div class="col-lg-8 col-md-12 main-content single-page">
						<div class="aff-content aff-page-layout">
						
							<?php while( have_posts() ) : the_post(); ?>
								
							   <article id="post-<?php the_ID(); ?>">

								   <?php get_template_part( 'templates/page/content','page');  ?>

								</article>

							<?php endwhile; ?>
						</div>
					</div>
					<aside class="col-lg-4 col-md-12 sidebars s_right" <?php aff_do_microdata( 'sidebar' ); ?>>
						<?php get_sidebar(); ?>
					</aside>
				</div><!-- .row -->
			</main><!-- #content -->
					<?php } elseif ($sidebar == 'left-sidebar') { ?>
						<main id="content" class="container-fluid aff-site-content" style="max-width: <?php echo $main_width.'px'; ?>">
							<div class="row">
								<div class="col-lg-8 col-md-12 order-lg-3 main-content single-page">
									<div class="aff-content aff-page-layout">
								
										<?php while( have_posts() ) : the_post(); ?>
										
									   	<article id="post-<?php the_ID(); ?>">

										   	<?php get_template_part( 'templates/page/content','page');  ?>

										</article>

										<?php endwhile; ?>
									</div>
								</div>
								<aside class="col-lg-4 col-md-12 order-lg-2 sidebars s_left" <?php aff_do_microdata( 'sidebar' ); ?>>
									<?php get_sidebar(); ?>
								</aside>
								
							</div><!-- .row -->
						</main><!-- #content -->
					<?php } elseif ($sidebar == 'full-width') { 
						if ($sidebar == 'full-width') {
							if ($new_container_meta == '') {
								$main_width = get_theme_mod( 'aff_booster_container', '1350' );
							}else{
								$main_width = $new_container_meta;
							}
						}else{
							$main_width = get_theme_mod( 'aff_booster_container', '1350' );
						}
						//$main_width = get_theme_mod( 'single_post_container_width_no_sidebar', '1350' ); ?>
				<main id="content" class="container-fluid aff-site-content" style="max-width: <?php echo $main_width.'px'; ?>">
					<div class="row">
						<div class="col-md-12 main-content full-layout-page">
							<div class="aff-content aff-page-layout">
						
								<?php while( have_posts() ) : the_post(); ?>
								
							   	<article id="post-<?php the_ID(); ?>">

								   	<?php get_template_part( 'templates/page/content','page');  ?>

								</article>

								<?php endwhile; ?>
							</div>
						</div>
					</div><!-- .row -->
				</main><!-- #content -->
					<?php } else { ?>
			<main id="content" class="container-fluid aff-site-content" style="max-width: <?php echo $main_width.'px'; ?>">
				<div class="row">
					<div class="col-md-8 main-content single-page">
						<div class="aff-content aff-page-layout">
						
							<?php while( have_posts() ) : the_post(); ?>
								
							   <article id="post-<?php the_ID(); ?>">

								   <?php get_template_part( 'templates/page/content','page');  ?>

								</article>

							<?php endwhile; ?>
						</div>
					</div>
					<aside class="col-md-4 sidebars" <?php aff_do_microdata( 'sidebar' ); ?>>
						<?php get_sidebar(); ?>
					</aside>
				</div><!-- .row -->
			</main><!-- #content -->
					<?php } ?>	
	<!-- </div>
</main> -->

<?php get_footer(); ?>