<?php
/**
 * The template for displaying all single posts
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/#single-post
 *
 * @package Affiliate_Booster
 */
?>
<?php get_header(); ?>

<?php

$classes = get_body_class();
$sidebar = get_post_meta( get_the_ID(), 'aff_booster_sidebar_position', true );
$new_container_meta = get_post_meta( $post->ID, '_mymetaboxname', true );
$layout = get_theme_mod('aff_single_layout', 'layout1');  
if (empty($layout)) { $layout ='layout1'; }

$options = get_post_meta( get_the_ID(), 'aff_booster_options', true );
$container_option = get_theme_mod('aff_container_dropdown_settings', 'full'); 

$feat_image = get_theme_mod('aff_single_post_image', 'below-title');
$title = get_theme_mod('aff_single_title', 'inside');

$remove_featured = $options ? in_array( 'remove-featured', $options ) : false;
$remove_title = $options ? in_array( 'remove-title', $options ) : false;
$breadcrums = $options ? in_array( 'remove-breadcrums', $options ) : false;
$postmeta = $options ? in_array( 'remove-postmeta', $options ) : false;
$author_id = get_post_field ('post_author', get_the_ID());
$display_name = get_the_author_meta( 'display_name' , $author_id );
$user_avatar = get_the_author_meta('email', $author_id );


$date_format = get_option( 'date_format' );
$date = get_the_date( $date_format, get_the_ID());
$updated_date = get_the_modified_date($date_format, get_the_ID());
$comment_count = get_comments_number(get_the_ID());
$separator = get_theme_mod( 'aff_single_post_info_separator_type', '/' );
$template_parts = get_theme_mod( 'sortable_single_post_info_setting', array( 'option1', 'option2' ) );
//$current_categoty = get_the_category_list($separator, get_the_ID());
$current_categoty = get_the_category_list($separator, 'multiple', get_the_ID());
$multicheck_post_info = get_theme_mod( 'aff_single_post_info_multicheck', array( 'option-1', 'option-2' ) );
$fea_img = get_the_post_thumbnail_url( get_the_ID(), 'full' );
if ($fea_img == '') {
	$fea_img = get_template_directory_uri(). '/images/default.webp';
}
$width = '';
if ($container_option == 'contained') {
	$main_width = get_theme_mod( 'aff_booster_container', '1350' );
	$width = 'width:'.$main_width.'px;';
}
?>
<style>
		.meta-title .aff-post-meta > *:not(first-child):after {content: "<?php echo $separator; ?>";font-size: 12px;}
    	.meta-title .aff-post-meta > *:last-child:after{display: none;}
    	.later-details ul { margin-left: 30px;	}
	</style>
<?php if($layout == 'layout2') { ?>
	<style>
		@media only screen and (min-width: 768px){
			.aff-site-content > .row {
			    flex-wrap: nowrap;
			}
		}
	</style>
	<div class="container-fluid justify-content-center single-post-fluid-bg" <?php if(!$remove_featured) { if(( true == get_theme_mod( 'aff_single_post_featured_image', true ) )) { ?> style="<?php echo $width; ?>background-image:url(<?php echo $fea_img; ?>)";<?php } } ?>>
		<div class="container lay_2container">
			<div class="row align-items-center">
				<div class="col">
				<?php
				if(!$breadcrums):
					if ( true == get_theme_mod( 'single_post_breadcrums_settings', true ) ) : 
						custom_breadcrumbs();
					endif;
				endif;
				?>
				<?php if(!$remove_title) { ?>
						<header class="aff-post-title entry-header">
							<?php the_title( '<h1 class="entry-title" itemprop="headline">', '</h1>' ); ?>
						</header>
						<?php }
							if(!$postmeta):
							?>
							<div class="meta-title">
								<div class="aff-post-meta aff-post-meta-c aff-post-meta-left has-below">
								<?php  
								$author_id=$post->post_author;
								foreach ($template_parts as $template_part) {
									
									if($template_part == 'option1'){ ?>
										<?php if(function_exists('get_avatar')) { echo get_avatar( get_the_author_meta('email'), '96' ); } ?>
										<span class="aff-meta-item aff-post-author" itemprop="author">
											<span class="by"> Written by </span>
												<a href="<?php echo get_author_posts_url( $author_id ); ?>" itemprop="url" title="Posts by <?php the_author_meta( 'display_name' , $author_id ); ?>">
												<?php the_author_meta( 'display_name' , $author_id );?>
												</a>
											</span>
									<?php } ?>
									<?php if($template_part == 'option2') { ?>
										<a href="#" class="aff-meta-item date-link" itemprop="url">
											<span class="post-date" itemprop="datePublished"><?php echo " Published on  ". get_the_date(); ?></span>
										</a>
									<?php } ?>
									<?php if($template_part == 'option3') { ?>
										<span class="aff-meta-item aff-post-author" itemprop="dateModified">
											<?php if(function_exists('the_date')) { echo " Last Updated  ". $updated_date;  } ?>
										</span>	
									<?php } ?>
									<?php if($template_part == 'option4') { ?>
										<span class="aff-meta-item aff-post-author">
											<?php echo " Comment Count ".$comment_count; ?>
										</span>	
									<?php } ?>
									<?php if($template_part == 'option5') { 
										$current_category = get_the_category( $post->ID );
										$cat_link = get_category_link($current_category[0]->cat_ID);
										?>
										<span class="aff-meta-item aff-post-author">
											<?php echo " in Categories <a href='".$cat_link."'>".$current_category[0]->name."</a>"; ?>
										</span>
									<?php }

								}
								?>
								</div>
							</div><!-- .meta-title -->
					<?php endif; ?>
				</div>
			</div>
		</div><!-- .container -->
	</div>
<?php } ?>

<?php if($layout == 'layout1' && $title == 'outside' && $feat_image == 'above-title') { ?>
	<?php if(!$remove_featured) {
		if(( true == get_theme_mod( 'aff_single_post_featured_image', true ) )) { ?>
	<div class="container-fluid justify-content-center single-post-fluid-bg" 
		<?php if(!$remove_featured) { 
				if (has_post_thumbnail()) { ?> 
					style="<?php echo $width; ?>background-image:url(<?php echo get_the_post_thumbnail_url( get_the_ID(), 'full' ); ?>)"
		<?php }else{ ?>
					style="<?php echo $width; ?>/*background-image:url(<?php //echo esc_url( get_template_directory_uri(). '/images/default.webp' ); ?>)*/"
		<?php }} ?>>
	</div>
	<?php } } ?>
<?php } ?>
<?php
if ($sidebar == 'full-width') {
	if ($new_container_meta == '') {
		$main_width = get_theme_mod( 'aff_booster_container', '1350' );
	}else{
		$main_width = $new_container_meta;
	}
}else{
	$main_width = get_theme_mod( 'aff_booster_container', '1350' );
}
$customlayout = get_theme_mod('aff_sidebar', '');
if ($customlayout != 'full-width') {
	$rl_class = '';
	if(get_theme_mod('aff_single_title', '') != 'outside' ):
		$rl_class = 'lay_rl';
	endif;
	if ( $layout == 'layout3' ) {$aff_lay_3 = 'aff_lay3_hide';}else{$aff_lay_3 = '';}
	?>
	<style type="text/css">
		.aff_lay3_hide{padding: 0;}
		.aff_lay_3{display: none;}
	</style>
		<main id="content" class="<?php echo $rl_class.' '.$aff_lay_3; ?> container-fluid aff-site-content" style="max-width: <?php echo $main_width.'px'; ?>">
			<div class="row">
				<?php
					while ( have_posts() ) : the_post();
					set_number_views(); //for number of views

					//not used option
					$tempname1 = get_post_meta($post->ID,'aff_bost_temp_value',true);
					if(empty($tempname1)){
						$tempname1 = 'right-sidebar';
					}
				
					$customlayout = get_theme_mod('aff_sidebar', 'right-sidebar');
					$global_layout = get_theme_mod('global_layout', 'right-sidebar');

				if(empty($sidebar)) {
					if(!empty($customlayout))
					{
						get_template_part('templates/post/'.$layout.'/'.$customlayout.'','template');
					}
					else{ 
						get_template_part( 'templates/post/layout2/right-sidebar','template'); 
					}	
				}	
				elseif($sidebar == 'global') {
					if ( true == get_theme_mod( 'affiliate_booster_field_global_layout_flag_switcher', false) ){
						get_template_part('templates/post/'.$layout.'/'.$global_layout.'','template');
						} 
						else {
						if(!empty($customlayout))
						{
							get_template_part('templates/post/'.$layout.'/'.$customlayout.'','template');
						}
						else{ 
							get_template_part( 'templates/post/layout1/right-sidebar','template'); 
						}	
					}
				}
				else {
					get_template_part('templates/post/'.$layout.'/'.$sidebar.'','template');
				}
					endwhile; 
				?>
			</div>
		</main>
	<?php
}else{
	if ($sidebar == 'full-width') {
		if ($new_container_meta == '') {
			$main_width = get_theme_mod( 'aff_booster_container', '1350' );
		}else{
			$main_width = $new_container_meta;
		}
	}else{
		$main_width = get_theme_mod( 'single_post_container_width_no_sidebar', '' );
	}
	// $main_width = get_theme_mod( 'single_post_container_width_no_sidebar', '1350' );
	if ( $layout == 'layout3' ) {$aff_lay_3 = 'aff_lay3_hide';}else{$aff_lay_3 = '';}
	?>
	<style type="text/css">
		.aff_lay3_hide{padding: 0;}
		.aff_lay3_hide{display: none;}
	</style>
		<main id="content" class="<?php echo $rl_class.' '.$aff_lay_3; ?> container-fluid aff-site-content" style="max-width: <?php echo $main_width.'px'; ?>">
			<div class="row">
				<?php
					while ( have_posts() ) : the_post();
					set_number_views(); //for number of views

					//not used option
					$tempname1 = get_post_meta($post->ID,'aff_bost_temp_value',true);
					if(empty($tempname1)){
						$tempname1 = 'right-sidebar';
					}
				
					$customlayout = get_theme_mod('aff_sidebar', 'right-sidebar');
					$global_layout = get_theme_mod('global_layout', 'right-sidebar');

				if(empty($sidebar)) {
					if(!empty($customlayout))
					{
						get_template_part('templates/post/'.$layout.'/'.$customlayout.'','template');
					}
					else{ 
						get_template_part( 'templates/post/layout2/right-sidebar','template'); 
					}	
				}	
				elseif($sidebar == 'global') {
					if ( true == get_theme_mod( 'affiliate_booster_field_global_layout_flag_switcher', false) ){
						get_template_part('templates/post/'.$layout.'/'.$global_layout.'','template');
						} 
						else {
						if(!empty($customlayout))
						{
							get_template_part('templates/post/'.$layout.'/'.$customlayout.'','template');
						}
						else{ 
							get_template_part( 'templates/post/layout1/right-sidebar','template'); 
						}	
					}
				}
				else {
					get_template_part('templates/post/'.$layout.'/'.$sidebar.'','template');
				}
					endwhile; 
				?>
			</div>
		</main>
	<?php
}
if ($layout == 'layout3') {
	get_template_part('templates/post/'.$layout.'/'.$layout.'','template');
}


?>
<?php get_footer();?>