<?php
/*
* Home page layout 3
* Basic Layout + Big Featured Image
*/
?>
<?php 
 global $post;
 $term = get_queried_object();
 $date_format = get_option( 'date_format' );
 $date = get_the_date( $date_format, get_the_ID());
 $updated_date = get_the_modified_date($date_format, get_the_ID());
 $comment_count = get_comments_number(get_the_ID());
 $separator = get_theme_mod( 'homepage_layout_info_separator_type', '/' );
 $current_categoty = get_the_category_list($separator, get_the_ID());
 $multicheck_post_info = get_theme_mod( 'archive_layout_info_multicheck', array( 'option-1', 'option-2' ) );
 $classes = get_body_class();
 $archive_year  = get_the_time('Y');
 $archive_month = get_the_time('m');
 $template_parts = get_theme_mod( 'sortable_archive_post_info_setting', array( 'option1', 'option2' ) );

 $sidebar = get_theme_mod( 'archive_sidebar_settings', 'right' );
 $main_width = get_theme_mod( 'aff_booster_container', '1350' );
 $sidebar_width = get_theme_mod( 'sidebar_custom_width_settings', '400' );
 $content_width = $main_width - $sidebar_width - 2;
?>
<style>
 	body main#content div.row {flex-wrap: nowrap;}
 	.meta-title .aff-post-meta > *:not(first-child):after {content: "<?php echo $separator; ?>";font-size: 12px;}
    .meta-title .aff-post-meta > *:last-child:after{display: none;}
	div.col-lg-8.main-content{flex: auto;max-width: <?php echo $content_width.'px'; ?>;}
	aside.col-lg-4.sidebars{flex: auto;max-width: <?php echo $sidebar_width.'px'; ?>;}
	@media only screen and (max-width: 1024px) {
		body main#content div.row {flex-wrap: wrap;}
		aside.col-lg-4.sidebars{max-width: 100%;}
		aside.s_right, aside.s_left {padding-left: 0;margin-top: 20px;}
	}
</style>

<?php if( $sidebar == 'left' ){$order = 'order-lg-3';} ?>
<div class="col-lg-8 col-md-12 main-content layout_3 <?php echo $order; ?>">
<?php if( is_archive() ){ ?>
<?php if(true == get_theme_mod('blog_archive_layout_header', true)) { ?>
			<header class="page-header">
				<?php
				the_archive_title( '<h1 class="aff-post-meta-c text-center">', '</h1>' );
				the_archive_description( '<div class="archive-description">', '</div>' );
				?>
			</header>
<?php } ?>
<?php } ?>
	<article id="post-<?php the_ID(); ?>" class="aff-post has-post-thumbnail" <?php aff_do_microdata( 'article' ); ?>>
		<?php if ( !in_array('search-no-results', $classes) ): ?>
			<header class="aff-aff-post-header aff-aff-post-header cf">
			<?php if(true == get_theme_mod('archive_layout_featured_image', true)) { ?>
				<div class="featured">
					<a href="<?php echo get_permalink( $post->ID ); ?>" itemprop="url" class="image-link media-ratio ratio-3-2 cat_lay_3 lay_3_img_fea">
						<?php if ( has_post_thumbnail() ) { 
	                		echo get_the_post_thumbnail( $post->ID, 'big-featured-image', array('itemprop'=>'image') );
	                	}else { ?>
	                	<!-- <img src="<?php //echo esc_url( get_template_directory_uri(). '/images/default.webp' ); ?>" width="300" height="162"> -->
	                	<?php } ?>
					</a>
				</div>
			<?php } ?>	
			<div class="aff-post-content cf aff-entry-content has-share-float aff-content-spacious">
				<div class="aff-post-meta aff-post-meta-c aff-post-meta-left has-below">
					<h2 class="is-title aff-post-title-alt" itemprop="headline"><a href="<?php echo get_permalink( $post->ID ); ?>" itemprop="url" title="<?php echo get_the_title(); //apply_filters( 'the_title', $post->post_title, $post->ID ); ?>"><?php echo apply_filters( 'the_title', $post->post_title, $post->ID ); ?></a></h2>

					<div class="meta-title">
						<div class="aff-post-meta aff-post-meta-c aff-post-meta-left has-below">
						<?php  
						$author_id=$post->post_author;
						foreach ($template_parts as $template_part) {
							
							if($template_part == 'option1'){ ?>
								<?php if(function_exists('get_avatar')) { echo get_avatar( $post->post_author, '96' ); } ?>
								<span class="aff-meta-item aff-post-author" itemprop="author">
									<span class="by"> Written by </span>
										<a href="<?php echo get_author_posts_url( $author_id ); ?>" itemprop="url" title="Posts by <?php the_author_meta( 'display_name' , $author_id ); ?>">
										<?php the_author_meta( 'display_name' , $author_id );?>
										</a>
									</span>
							<?php } ?>
							<?php if($template_part == 'option2') { ?>
								<a href="#" class="aff-meta-item date-link" itemprop="url">
									<span class="post-date" itemprop="datePublished"><?php echo " Published on  ". get_the_date(); ?></span>
								</a>
							<?php } ?>
							<?php if($template_part == 'option3') { $updated_date = get_the_modified_date($date_format, $post->ID); ?>
								<span class="aff-meta-item aff-post-author" itemprop="dateModified">
									<?php if(function_exists('the_date')) { echo " Last Updated  ". $updated_date;  } ?>
								</span>	
							<?php } ?>
							<?php if($template_part == 'option4') { ?>
								<span class="aff-meta-item aff-post-author">
									<?php echo " Comment Count ".$comment_count; ?>
								</span>	
							<?php } ?>
							<?php if($template_part == 'option5') { 
								$current_category = get_the_category( $post->ID );
								$cat_link = get_category_link($current_category[0]->cat_ID);
								?>
								<span class="aff-meta-item aff-post-author">
									<?php echo " in Categories <a href='".$cat_link."'>".$current_category[0]->name."</a>"; ?>
								</span>
							<?php }

						}
						?>
						</div>
					</div><!-- .meta-title -->

					<div class="aff-meta-above">
					<?php $categories=get_the_category($post->ID);//$post->ID
					if ( ! empty( $categories ) ) {
					?>
						<span class="aff-cat-labels"><a href="<?php echo esc_url( get_category_link( $categories[0]->term_id ) ); ?>" class="category" rel="category"><?php echo esc_html( $categories[0]->name ); ?></a></span>
					<?php }  ?>
					</div>
				</div>

				<!-- <p><?php // echo get_the_excerpt(); ?></p> -->
				<?php $excerpt_length = get_theme_mod('archive_layout_excerpt_length', '120'); ?>
				<p><?php echo the_excerpt_max_charlength($excerpt_length); ?></p>
				<?php 
				$readmore = get_theme_mod( 'radio_text_and_button_setting', 'text' );
				$readmore_text = get_theme_mod( 'read_more_text_setting', 'Read More' );
				if ($readmore_text == '') {
					$readmore_text = 'Read More';
				}
				if ( true == get_theme_mod( 'homepage_read_more_toggle', '' ) ) : 
					if($readmore == 'text'){
				?>
					<p class="readmore_text"><a href="<?php the_permalink( $post->ID ); ?>"><?php echo $readmore_text; ?></a></p>
				<?php
					}else{
				?>
					<p class="readmore_button"><a href="<?php the_permalink( $post->ID ); ?>"><?php echo $readmore_text; ?></a></p>
				<?php					
					}
				endif; 
				?>
		
			</div>
		</header>
	<?php endif; ?>
		<?php 
		if ( get_query_var( 'paged' ) ) { $paged = get_query_var( 'paged' ); }
		elseif ( get_query_var( 'page' ) ) { $paged = get_query_var( 'page' ); }
		else { $paged = 1; }
		
			if (in_array('search-results', $classes)) {
				$args = array( 
				    'posts_type'      	=> 'post',
				    'paged'          	=> $paged,
				    'post_status'    	=> 'publish',
				    's'					=> get_search_query(),
					'order'				=> 'DESC',
				);
			}elseif (in_array('author', $classes)) {
				$author_id = $post->post_author;
				$args = array( 
				    'post_type'      	=> 'post',
				    'author'			=> $author_id,
				    'post_status'    	=> 'publish',
					'paged'          	=> $paged,
					'category_name' 	=> $term->slug,
					'order'				=> 'DESC',
				);
			}elseif (in_array('date', $classes)) {
				$args = array( 
				    'post_type'      	=> 'post',
				    'post_status'    	=> 'publish',
					'paged'          	=> $paged,
					'year'     			=> $archive_year,
			    	'monthnum' 			=> $archive_month,
					'order'				=> 'DESC',
				);
			}elseif (in_array('search-no-results', $classes)) {
				get_template_part( 'templates/content', 'none' );
			}elseif (in_array('tag', $classes)) {
				$tag = get_query_var('tag');
				$args = array( 
				   'post_type'      	=> 'post',
				   'post_status'    	=> 'publish',
					'paged'          	=> $paged,
					'tag'				=> $tag,
					'order'				=> 'DESC',
				);
			}else{
				$args = array( 
				    'post_type'      	=> 'post',
				    'post_status'    	=> 'publish',
					'paged'          	=> $paged,
					'category_name' 	=> $term->slug,
					'order'				=> 'DESC',
				);
			}
			$query = new WP_Query;
			$myposts = $query->query($args); 
?>
<?php
			if ( !in_array('search-no-results', $classes) ):
			if ( $myposts ) {
				$i = 1;
				foreach ( $myposts as $post ) {
				$author_id = $post->post_author;
				if ( 1 !== $i ) {
				?>
			<div class="aff-post-content cf aff-entry-content has-share-float aff-content-spacious">
			<?php if(true == get_theme_mod('archive_layout_featured_image', true)) { ?>
				<figure id="attachment-<?php the_ID(); ?>" aria-describedby="caption-attachment-<?php the_ID(); ?>" class="aff-wp-caption alignleft">
					<a href="<?php echo get_permalink( $post->ID ); ?>" class="lay_3_img">
						<?php if ( has_post_thumbnail() ) { 
	                		the_post_thumbnail('grid-featured-image', array('itemprop'=>'image')); 
	                	}else { ?>
	                		<!-- <img src="<?php //echo esc_url( get_template_directory_uri(). '/images/default.webp' ); ?>" width="300" height="162"> -->
	                	<?php } ?>
					</a>
					<figcaption id="caption-attachment-<?php the_ID(); ?>" class="aff-wp-caption-text"></figcaption>
				</figure>
			<?php } ?>
				<div class="aff-post-meta aff-post-meta-c aff-post-meta-left has-below">
					<h2 class="is-title aff-post-title-alt inline" itemprop="headline"><a href="<?php echo get_permalink( $post->ID ); ?>" itemprop="url" title="<?php echo get_the_title(); //apply_filters( 'the_title', $post->post_title, $page->ID ); ?>"><?php echo apply_filters( 'the_title', $post->post_title, $post->ID ); ?></a></h2>

					<div class="meta-title">
						<div class="aff-post-meta aff-post-meta-c aff-post-meta-left has-below">
						<?php  
						$author_id=$post->post_author;
						foreach ($template_parts as $template_part) {
							
							if($template_part == 'option1'){ ?>
								<?php if(function_exists('get_avatar')) { echo get_avatar( $post->post_author, '96' ); } ?>
								<span class="aff-meta-item aff-post-author" itemprop="author">
									<span class="by"> Written by </span>
										<a href="<?php echo get_author_posts_url( $author_id ); ?>" itemprop="url" title="Posts by <?php the_author_meta( 'display_name' , $author_id ); ?>">
										<?php the_author_meta( 'display_name' , $author_id );?>
										</a>
									</span>
							<?php } ?>
							<?php if($template_part == 'option2') { ?>
								<a href="#" class="aff-meta-item date-link" itemprop="datePublished">
									<span class="post-date"><?php echo " Published on  ". get_the_date(); ?></span>
								</a>
							<?php } ?>
							<?php if($template_part == 'option3') { $updated_date = get_the_modified_date($date_format, $post->ID); ?>
								<span class="aff-meta-item aff-post-author" itemprop="dateModified">
									<?php if(function_exists('the_date')) { echo " Last Updated  ". $updated_date;  } ?>
								</span>	
							<?php } ?>
							<?php if($template_part == 'option4') { ?>
								<span class="aff-meta-item aff-post-author">
									<?php echo " Comment Count ".$comment_count; ?>
								</span>	
							<?php } ?>
							<?php if($template_part == 'option5') { 
								$current_category = get_the_category( $post->ID );
								$cat_link = get_category_link($current_category[0]->cat_ID);
								?>
								<span class="aff-meta-item aff-post-author">
									<?php echo " in Categories <a href='".$cat_link."'>".$current_category[0]->name."</a>"; ?>
								</span>
							<?php }

						}
						?>
						</div>
					</div><!-- .meta-title -->

					<div class="aff-meta-above">
					<?php $categories=get_the_category($post->ID);//$post->ID
					if ( ! empty( $categories ) ) {
					?>
						<span class="aff-cat-labels"><a href="<?php echo esc_url( get_category_link( $categories[0]->term_id ) ); ?>" class="category" rel="category"><?php echo esc_html( $categories[0]->name ); ?></a></span>
					<?php }  ?>
					</div>
				</div>
				
				<!-- <p><?php // echo get_the_excerpt(); ?></p> -->
				<?php $excerpt_length = get_theme_mod('archive_layout_excerpt_length', '120'); ?>
				<p><?php echo the_excerpt_max_charlength($excerpt_length); ?></p>
				<?php 
				$readmore = get_theme_mod( 'radio_text_and_button_setting', 'text' );
				$readmore_text = get_theme_mod( 'read_more_text_setting', 'Read More' );
				if ($readmore_text == '') {
					$readmore_text = 'Read More';
				}
				if ( true == get_theme_mod( 'homepage_read_more_toggle', '' ) ) : 
					if($readmore == 'text'){
				?>
					<p class="readmore_text"><a href="<?php the_permalink( $post->ID ); ?>"><?php echo $readmore_text; ?></a></p>
				<?php
					}else{
				?>
					<p class="readmore_button"><a href="<?php the_permalink( $post->ID ); ?>"><?php echo $readmore_text; ?></a></p>
				<?php					
					}
				endif; 
				?>

			</div>
			<?php } $i++; } } endif; ?>
		</article>
		<?php
		if ( !in_array('search-no-results', $classes) ):
			// Bottom pagination (pagination arguments)
			echo "<div class='page-nav-container'>" . paginate_links(array(
				'total' => $query->max_num_pages,
				'prev_text' => __('<', 'affiliatebooster'),
				'next_text' => __('>', 'affiliatebooster')
			)) . "</div>";
		endif;
		?>
	</div>
	<?php if ( $sidebar == 'left' ){ ?>
		<aside class="col-lg-4 col-md-12 sidebars s_left order-lg-2" <?php aff_do_microdata( 'sidebar' ); ?>>
		<?php get_template_part('sidebar'); ?>
		</aside>
	<?php } ?>
	<?php if ( $sidebar == 'right' ){ ?>
		<aside class="col-lg-4 col-md-12 sidebars s_right" <?php aff_do_microdata( 'sidebar' ); ?>>
		<?php get_template_part('sidebar'); ?>
		</aside>
	<?php } ?>
</div>



<?php wp_reset_query(); ?>